// Copyright (c) Naiky Company. All rights reserved.
//
// Abstract:
// GļCVTʽݶļ wangwenbo 2010.02.18
//////////////////////////////////////////////////////////////////////
#include "StdAfx.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

using namespace ncmath;

#define DEGREE2RADIAN(deg) ((deg) / 180.0 * c_nPIE)

CS_T s_szFORMATORVERSIONERROR = _DEFCS(_CSV(11400),
	_CHINESE("|E|ӹļʽ汾")
	_ENGLISH("|E|Error file format or version"));
CS_T s_szSUBPROGREPEATED = _DEFCS(_CSV(11401),
	_CHINESE("|E|ӳظ")
	_ENGLISH("|E|Subprogram repeat"));
CS_T s_szSUBPROGFORMATERROR = _DEFCS(_CSV(11402),
	_CHINESE("|E|ӳʽ")
	_ENGLISH("|E|Subprogram format error"));
CS_T s_szERROR_NOSUBPROGRAM_NO = _DEFCS(_CSV(11403),
	_CHINESE("Ҳõӳ(%d)")
	_ENGLISH("Not found the subprogram(%d) invoked"));
CS_T s_szERROR_NOSUBPROGRAM_NAME = _DEFCS(_CSV(11404),
	_CHINESE("Ҳõӳ(%s)")
	_ENGLISH("Not found the Subprogram(%s) invoked"));
CS_T s_szERROR_G51_INSTRUCTION = _DEFCS(_CSV(11405),
	_CHINESE("G51 ָ")
	_ENGLISH("G51 instruction error"));
CS_T s_szERROR_DUPLICATE_CODE_OF_SAME_GROUP = _DEFCS(_CSV(11406),
	_CHINESE("ͬG/Mָظ")
	_ENGLISH("Repeated G/M code in one group"));
CS_T s_szERROR_WCS_OVERRANGE = _DEFCS(_CSV(11407),
	_CHINESE("곬Χ:%c")
	_ENGLISH("Workpiece coordinates are beyond permissible range: axis-%c"));
CS_T s_szERROR_SPECIAL_CIRCLE_CYCLE = _DEFCS(_CSV(11408),
	_CHINESE("G34/35/36/37 ̶ָѭָƥ䣬ָĶ")
	_ENGLISH("G34/35/36/37 instruction error: special fixed cycle instruction mismatched: no motion specified"));
CS_T s_szERROR_SPECIAL_CIRCLE_CYCLE_FORMAT = _DEFCS(_CSV(11409),
	_CHINESE("G34/35/36/37 ̶ָѭָʽ")
	_ENGLISH("G34/35/36/37 instruction error: special fixed cycle instruction format error"));
CS_T s_szERROR_SFC_TOO_MANY_TIMES = _DEFCS(_CSV(11410),
	_CHINESE("G34/35/36/37 ָָѭ̫")
	_ENGLISH("G34/35/36/37 instruction error: too much times specified for loop"));
CS_T s_szERROR_DUPLICATE_L_K_INSTRUCTION = _DEFCS(_CSV(11411),
	_CHINESE("̶ѭָLKָظ")
	_ENGLISH("Repeated L/K codes in fixed cycle command"));
CS_T s_szERROR_MATCH_TAGGEDDATA = _DEFCS(_CSV(11412),
	_CHINESE("޷ҵʵĵַ")
	_ENGLISH("Cannot match the address data"));
CS_T s_szERROR_UNEXPECTED_TAGGEDDATA = _DEFCS(_CSV(11413),
	_CHINESE("Ӧóֵĵַ:%s")
	_ENGLISH("Unexpected address data:%s"));
CS_T s_szERROR_MATCH_BACKWARDRULE = _DEFCS(_CSV(11414),
	_CHINESE("Ǵʽƥʧ")
	_ENGLISH("G code format error: matching rule failed"));
CS_T s_szERROR_INVALID_GCODE = _DEFCS(_CSV(11415),
	_CHINESE("ЧGָ:G%g")
	_ENGLISH("Invalid G code:G%d"));
CS_T s_szERROR_INVALID_MCODE = _DEFCS(_CSV(11416),
	_CHINESE("ЧMָ:M%d")
	_ENGLISH("Invalid M code:M%d"));
CS_T s_szERROR_UNKOWN_TOKEN = _DEFCS(_CSV(11417),
	_CHINESE("Чָ:%s%d")
	_ENGLISH("Invalid instruction:%s%d"));
CS_T s_szERROR_NOENOUGHPARAMETERS = _DEFCS(_CSV(11418),
	_CHINESE("%s:")
	_ENGLISH("%s:Need more parameters"));
CS_T s_szERROR_G51_50_NOTMATCH = _DEFCS(_CSV(11419),
	_CHINESE("G51/G50ָ ")
	_ENGLISH("G51/G50 mismatch"));
CS_T s_szERROR_G51D1_50D1_NOTMATCH = _DEFCS(_CSV(11420),
	_CHINESE("G51.1/G50.1ָ ")
	_ENGLISH("G51.1/G50.1 mismatch"));
CS_T s_szERROR_INVALID_PROGRAM_UNDER_REVOLVING_MODE = _DEFCS(_CSV(11421),
	_CHINESE("ת᷽ʽ²֧ԲǶȱ")
	_ENGLISH("Don't support G2/G3 code whose unit is angle under revolving mode"));
CS_T s_szCHANGE_TOOL_MESSAGE = _DEFCS(_CSV(11422),
	_CHINESE("Ҫһѵֹͣϵ밴ʼ")
	_ENGLISH("Now need to change tool, please press stop to change tool, or directly press 'start' to continue if cutter exchange is no needed"));
CS_T s_szERROR_IJK_ERROR = _DEFCS(_CSV(11423),
	_CHINESE("IJK޸Ĳ")
	_ENGLISH("IJK param. error, please modify it!"));
CS_T s_szERROR_ARC_RADIUS_TOO_SMALL = _DEFCS(_CSV(11424),
	_CHINESE("Բ뾶С0.001<NCSTUDIO_UNIT>")
	_ENGLISH("Too Small Arc Radius value: the minimal value is 0.001 <NCSTUDIO_UNIT>"));
CS_T s_szERROR_ARC_RADIUSERROR = _DEFCS(_CSV(11425),
	_CHINESE("Բ뾶ӹ޸Ĳ")
	_ENGLISH("Too big tolerance of Arc radius: Please check NC-code or revise parameters setting"));
CS_T s_szARCPLANE = _DEFCS(_CSV(11426),
	_CHINESE("תΪ2άʱ֧G17ƽ")
	_ENGLISH("Only Support G17 when convert to 2D"));
CS_T s_szERROR_G904_SPEEDERROR = _DEFCS(_CSV(11427),
	_CHINESE("G904ָָٶȲȷ")
	_ENGLISH("Speed specified by G904 error "));
CS_T s_szERROR_G904_DISTERROR = _DEFCS(_CSV(11428),
	_CHINESE("G904ָָ벻ȷ")
	_ENGLISH("Distance specified by G904 error"));
CS_T s_szERROR_G904_ERROR_MISSADDR = _DEFCS(_CSV(11429),
	_CHINESE("G904ָȷȱٵַ")
	_ENGLISH("G904 instruction error: missing address data"));
CS_T s_szERROR_G51_ZERO_ZOOM_ASPECT = _DEFCS(_CSV(11430),
	_CHINESE("G51 ָűΪ0")
	_ENGLISH("G51 instruction error: scaling is zero"));
CS_T s_szERROR_INCORRECT_ASPECT_FOR_RADIUS = _DEFCS(_CSV(11431),
	_CHINESE("Բ岹ʱűһ")
	_ENGLISH("Inconsistent zoom ratio between the two axes when arc interpolation"));
CS_T s_szERROR_G51_1_NOT1ST_TRANSFORM = _DEFCS(_CSV(11432),
	_CHINESE("G51.1/G50.1 ָ󣺸ָG68G51ģʽʹ")
	_ENGLISH("G51.1/G50.1 instruction error: G50.1 and G51.1 can not be specified under G68 or G51 mode."));
CS_T s_szERROR_G68_69_NOTMATCH = _DEFCS(_CSV(11433),
	_CHINESE("G68/G69ָ")
	_ENGLISH("G68/G69 mismatch"));
CS_T s_szERROR_SPIRALPITCH = _DEFCS(_CSV(11434),
	_CHINESE("֧")
	_ENGLISH("Don't Support Spiralling"));
CS_T s_szCALLTIMES = _DEFCS(_CSV(11435),
	_CHINESE("ѭôΪ%d\nǷʡԣ")
	_ENGLISH("Cycle call time is %d\nOmitted or NOT?"));
CS_T s_csERROR_G65SubProg_Error = _DEFCS(_CSV(11436),
	_CHINESE("õӳСڻ0ע⣺ӳӦ0ʹӳ")
	_ENGLISH("The number of subprograme is less than or equal 0Attention: The number of subprograme must be more than 0, or please use the subprograme's name"));

// гǶʡGֵַ£ӦĵַֿƵGб
// ʡԵGַĿǰG 0, 1, 2, 3, 7, 73, 74, 76, 81, 82, 83, 84, 85, 86, 87, 88, 89
// m_pCodeGenerator->m_ModalData.m_GeneralMotion.m_nGNoʾ±ڼЧԡ
const int CBlockMaker::m_MatchGScope[][32] =
{
	{TK_ADR_FIRST, -1},
	{TK_ADR_A, -1},
	{TK_ADR_B, -1},
	{TK_ADR_C, -1},
	{TK_ADR_D, -1},
	{TK_ADR_E, -1},
	{TK_ADR_F, -1},
	{TK_ADR_G, -1},
	{TK_ADR_H,  7, -1},
	{TK_ADR_I,	2, 3, 76, -1},
	{TK_ADR_J,	2, 3, 76, -1},
	{TK_ADR_K,	2, 3, -1},
	{TK_ADR_L, -1},
	{TK_ADR_M, -1},
	{TK_ADR_N, -1},
	{TK_ADR_O, -1},
	{TK_ADR_P,	74, 76, 82, 84, 89, -1},
	{TK_ADR_Q,	73, 83, -1},
	{TK_ADR_R,	2, 3, -1},
	{TK_ADR_S, -1},
	{TK_ADR_T, -1},
	{TK_ADR_U, -1},
	{TK_ADR_V, -1},
	{TK_ADR_W, -1},
	{TK_ADR_X,	0, 1, 2, 3, 7, 73, 74, 76, 81, 82, 83, 84, 85, 86, 87, 88, 89, -1},
	{TK_ADR_Y,	0, 1, 2, 3, 7, 73, 74, 76, 81, 82, 83, 84, 85, 86, 87, 88, 89, -1},
	{TK_ADR_Z,	0, 1, 2, 3, 7, 73, 74, 76, 81, 82, 83, 84, 85, 86, 87, 88, 89, -1},
	{TK_ADR_FX, -1},
	{TK_ADR_FY, -1},
	{TK_ADR_FZ, -1},
	{TK_ADR_LEVEL, -1},
	{TK_ADR_LX, -1},
	{TK_ADR_LY, -1},
	{TK_ADR_LZ, -1},
	{TK_ADR_MSG, -1},
	{TK_ADR_PLC, -1},
	{TK_ADR_PX, -1},
	{TK_ADR_PY, -1},
	{TK_ADR_PZ, -1},
	{TK_ADR_SYNCPOS, -1},
	{TK_ADR_LAST, -1},
};

// NoteΪ߲ҵЧʣõĹǰߣ
const CBlockMaker::rule_t CBlockMaker::m_RuleList_Pre[] =
{
	// token,			value,	func
	{TK_ADR_G,			53,		&G53},
	{TK_ADR_G,			54,		&SelectWorkCoor},
	{TK_ADR_G,			55,		&SelectWorkCoor},
	{TK_ADR_G,			56,		&SelectWorkCoor},
	{TK_ADR_G,			57,		&SelectWorkCoor},
	{TK_ADR_G,			58,		&SelectWorkCoor},
	{TK_ADR_G,			59,		&SelectWorkCoor},
	{TK_ADR_G,			68,		&G68},
	{TK_ADR_G,			69,		&G69},

	{TK_ADR_G,			90,		&G90_G91},
	{TK_ADR_G,			91,		&G90_G91},

	{TK_ADR_G,			17,		&G17_G18_G19},
	{TK_ADR_G,			18,		&G17_G18_G19},
	{TK_ADR_G,			19,		&G17_G18_G19},

	{TK_ADR_G,			20,		&G20_G21_G70_G71},
	{TK_ADR_G,			21,		&G20_G21_G70_G71},
	{TK_ADR_G,			70,		&G20_G21_G70_G71},
	{TK_ADR_G,			71,		&G20_G21_G70_G71},

	{TK_ADR_S,			-1,		&SpindleRev},
	{TK_ADR_F,			-1,		&FeedRate},

	{TK_ADR_G,			98,		&G98_G99},
	{TK_ADR_G,			99,		&G98_G99},

	{TK_ADR_G,			40,		&G40},
	{TK_ADR_G,			41,		&G41_G42},
	{TK_ADR_G,			42,		&G41_G42},
	{TK_ADR_G,			43,		&G43_G44},
	{TK_ADR_G,			44,		&G43_G44},
	{TK_ADR_G,			49,		&G49},

	{TK_ADR_G,			50,		&G50},
	{TK_ADR_G,			51,		&G51},
	{TK_ADR_G,			50.1,	&G50_1},
	{TK_ADR_G,			51.1,	&G51_1},

	{TK_ADR_G,			92,		&G92},
	{TK_ADR_G,			992,	&G992},
	{TK_ADR_G,			921,	&G921},
	{TK_ADR_G,			922,	&G922},
	{TK_ADR_G,			923,	&G923},

	{TK_ADR_G,			905,	&G905},
	{TK_ADR_G,			907,	&G907},
	{TK_ADR_G,			908,	&G908},
	{TK_ADR_M,			0,		&M0_M1},
	{TK_ADR_M,			1,		&M0_M1},
	{TK_ADR_M,			2,		&M2_M30},
	{TK_ADR_M,			3,		&M3_M4_M5},
	{TK_ADR_M,			4,		&M3_M4_M5},
	{TK_ADR_M,			5,		&M3_M4_M5},
	{TK_ADR_M,			801,	&M801},
	{TK_ADR_M,			802,	&M802},
	{TK_ADR_M,			901,	&M901},
	{TK_ADR_M,			902,	&M902},
	{TK_ADR_M,			903,	&M903},
	{TK_ADR_M,			904,	&M904_M905},
	{TK_ADR_M,			905,	&M904_M905},
};

const CBlockMaker::rule_t CBlockMaker::m_RuleList_Normal[] =
{
	// token,		value,	func
	{TK_ADR_G,			1,		&G0_G1},
	{TK_ADR_G,			0,		&G0_G1},
	{TK_ADR_G,			2,		&G2_G3},
	{TK_ADR_G,			3,		&G2_G3},
	{TK_ADR_G,			4,		&G4},
	{TK_ADR_G,			7,		&G7},
	{TK_ADR_G,			28,		&G28},
	{TK_ADR_G,			65,		&G65_M98},

	{TK_ADR_G,			34,		&G34_G36},
	{TK_ADR_G,			35,		&G35},
	{TK_ADR_G,			36,		&G34_G36},
	{TK_ADR_G,			37,		&G37},

	{TK_ADR_G,			73,		&FixedCycle},
	{TK_ADR_G,			74,		&FixedCycle},
	{TK_ADR_G,			75,		&FixedCycle},
	{TK_ADR_G,			76,		&FixedCycle},
	{TK_ADR_G,			77,		&FixedCycle},
	{TK_ADR_G,			78,		&FixedCycle},
	{TK_ADR_G,			79,		&FixedCycle},
	{TK_ADR_G,			80,		&G80},
	{TK_ADR_G,			81,		&FixedCycle},
	{TK_ADR_G,			82,		&FixedCycle},
	{TK_ADR_G,			83,		&FixedCycle},
	{TK_ADR_G,			84,		&FixedCycle},
	{TK_ADR_G,			85,		&FixedCycle},
	{TK_ADR_G,			86,		&FixedCycle},
	{TK_ADR_G,			87,		&FixedCycle},
	{TK_ADR_G,			88,		&FixedCycle},
	{TK_ADR_G,			89,		&FixedCycle},

	{TK_ADR_G,			903,	&G903},
	{TK_ADR_G,			904,	&G904},
	{TK_ADR_G,			906,	&G906},
	{TK_ADR_G,			925,	&G925_G926},
	{TK_ADR_G,			926,	&G925_G926},
	{TK_ADR_G,          927,    &G927},
	{TK_ADR_SYNCPOS,	-1,		&SyncPos},
	{TK_ADR_G,			9,		&G9},

	{TK_ADR_COMMENT,	0,		&Comment},
};

const CBlockMaker::rule_t CBlockMaker::m_RuleList_Post[] =
{
	{TK_ADR_X,			-1,		&MatchG},
	{TK_ADR_Y,			-1,		&MatchG},
	{TK_ADR_Z,			-1,		&MatchG},
	{TK_ADR_T,			-1,		&M6_T},
	{TK_ADR_H,			-1,		&Rule_Error},
	{TK_ADR_I,			-1,		&MatchG},
	{TK_ADR_J,			-1,		&MatchG},
	{TK_ADR_K,			-1,		&MatchG},
	{TK_ADR_L,			-1,		&Rule_Error},
	{TK_ADR_LX,			-1,		&Rule_Error},
	{TK_ADR_LY,			-1,		&Rule_Error},
	{TK_ADR_LZ,			-1,		&Rule_Error},
	{TK_ADR_M,			6,		&M6_T},
	{TK_ADR_M,			17,		&M17_M99},
	{TK_ADR_M,			98,		&G65_M98},
	{TK_ADR_M,			99,		&M17_M99},
	{TK_ADR_M,			30,		&M2_M30},
	{TK_ADR_MSG,		-1,		&Rule_Error},
	{TK_ADR_P,			-1,		&MatchG},
	{TK_ADR_PX,			-1,		&Rule_Error},
	{TK_ADR_PY,			-1,		&Rule_Error},
	{TK_ADR_PZ,			-1,		&Rule_Error},
	{TK_ADR_Q,			-1,		&MatchG},
	{TK_ADR_R,			-1,		&MatchG},
	{TK_ADR_D,			-1,		&Rule_Error},
	{TK_ADR_FX,			-1,		&Rule_Error},
	{TK_ADR_FY,			-1,		&Rule_Error},
	{TK_ADR_FZ,			-1,		&Rule_Error},
	{TK_ADR_PLC,		-1,		&Ignore},
	{TK_ADR_LEVEL,		-1,		&Ignore},
	{TK_ADR_A,			-1,		&Ignore},
	{TK_ADR_B,			-1,		&Ignore},
	{TK_ADR_C,			-1,		&Ignore},
	{TK_ADR_U,			-1,		&Ignore},
	{TK_ADR_V,			-1,		&Ignore},
	{TK_ADR_W,			-1,		&Ignore},

	{TK_ADR_G,			-1,		&GUnknown},
	{TK_ADR_M,			-1,		&MUnknown},
	{TK_ADR_COMMENT,	-1,		&MatchComment},
};

CBlockMaker::CBlockMaker()
: m_ptCurPosOrig(0.f, 0.f, 0.f)
, m_ptDestPosOrig(0.f, 0.f, 0.f)
, m_ptCurPos(0.f, 0.f, 0.f)
, m_ptDestPos(0.f, 0.f, 0.f)
{
	m_nUnit = 1.0;
	m_nRadiusTolerance = 1.f;
	m_nPreRuleNum = _countof(m_RuleList_Pre);
	m_nNormalRuleNum = _countof(m_RuleList_Normal);
	m_nPostRuleNum = _countof(m_RuleList_Post);
}

CBlockMaker::~CBlockMaker()
{
	for (INT_PTR _i = 0, _Size = m_arrPTransform.GetSize(); _i < _Size; ++_i)
		delete m_arrPTransform[_i];

	m_arrPTransform.RemoveAll();
	m_mapSubIntProgIndex.RemoveAll();
	m_mapSubStrProgIndex.RemoveAll();
}

void CBlockMaker::Reset()
{
	m_Parser.Reset();
	m_ModalData.Reset();
}

const char* CBlockMaker::GetTokenAlias(token_t nToken_) const
{
	return m_Parser.m_TokenAnalyser.GetTokenAlias(nToken_);
}

void CBlockMaker::ReadCode()
{
	m_Parser.m_Entities.Reset();

	do
	{
		if (m_Parser.NextToken() == TK_EOF)
			break;

		m_Parser.Statement();
	} while (m_Parser.m_Entities.GetCount() == 0);

	if (m_Parser.m_Entities.GetCount() > 0)
	{
		AnalyseEntities();
	}
}

void CBlockMaker::AnalyseEntities()
{
	do
	{
		AnalyseCurrentEntity();
	} while(m_Parser.m_Entities.MoveForWard());
}

void CBlockMaker::AnalyseCurrentEntity()
{
	const rule_t* _pRule = NULL;

	CTaggedEntity& _CurEntity = m_Parser.m_Entities.GetCurrentEntity();
	int _nSize = _CurEntity.GetCount();
	ASSERT(_nSize > 0);

	int _i;

	// pre rule
	for (_i = 0; _i < _nSize; _i++)
	{
		if (_CurEntity[_i].m_bDeleted)
			continue;

		_pRule = GetRule_Pre(_CurEntity[_i].m_nToken, _CurEntity[_i].m_nValue);
		if (_pRule)
			(this->*_pRule->pFunction) (&_CurEntity[_i]);
	}

	// normal rule
	for (_i = 0; _i < _nSize; _i++)
	{
		if (_CurEntity[_i].m_bDeleted)
			continue;

		_pRule = GetRule_Normal(_CurEntity[_i].m_nToken, _CurEntity[_i].m_nValue);
		if (_pRule)
			(this->*_pRule->pFunction) (&_CurEntity[_i]);
	}

	// post rule
	for (_i = 0; _i < _nSize; _i++)
	{
		if (_CurEntity[_i].m_bDeleted)
			continue;

		_pRule = GetRule_Post(_CurEntity[_i].m_nToken, _CurEntity[_i].m_nValue);
		if (_pRule)
			(this->*_pRule->pFunction)(&_CurEntity[_i]);
		else
		{
			m_strTemp.Format(_GETCS(s_szERROR_UNKOWN_TOKEN),
				GetTokenAlias(_CurEntity[_i].m_nToken),
				(int)(_CurEntity[_i].m_nValue));
			throw(m_strTemp);
		}
	}

	return;
}

// Forward rules
void CBlockMaker::G0_G1(CTaggedData* pTaggedData_)
{
	if (TK_ADR_G == pTaggedData_->m_nToken)
	{
		//m_ModalData.m_nGNumberG0 G1 ---  2010.3.19
		m_ModalData.m_nGNumber = (int)pTaggedData_->m_nValue;
		MatchTaggedData(TK_ADR_G, m_ModalData.m_nGNumber);
	}

	//ȡĿλ---  2010.3.19
	RetrieveDestPosition();

	//ȡG00G01͹ȡʡƽ桢յλãֱ߽͹Ϊ---  2010.3.19
	//CCvtNode洢Ϣѹ뵽ListUnitsȥ  wudian 2010.07.20
	cvt::CCvtNode* _pNode = new cvt::CCvtNode;
	_pNode->m_nBulge = 0.0;
	_pNode->m_nPlane = m_ModalData.m_nPlane;
	_pNode->m_ptPos.Set(m_ptDestPos.x, m_ptDestPos.y, m_ptDestPos.z);
	//bIsG00G01G00 ---  2010.3.19
	if (m_ModalData.m_nGNumber == 0)
		_pNode->m_bIsG00 = true;
	else
		_pNode->m_bIsG00 = false;
	ListUnits.push_back(_pNode);

	//յΪµ wudian 2010.07.20
	m_ptCurPosOrig = m_ptDestPosOrig;
	m_ptCurPos = m_ptDestPos;
	return;
}

//Բ岹 wudian 2010.07.20
void CBlockMaker::G2_G3(CTaggedData* pTaggedData_)
{
	// wudian 2010.07.20.
	ASSERT(pTaggedData_ != NULL);

	//G2G3Ǹôѱʹù wudian 2010.07.20.
	if (TK_ADR_G == pTaggedData_->m_nToken)
	{
		m_ModalData.m_nGNumber = (int) pTaggedData_->m_nValue;
		MatchTaggedData(TK_ADR_G, m_ModalData.m_nGNumber);
	}

	//յꡣ wudian 2010.07.20.
	RetrieveDestPosition();

	//Բ wudian 2010.07.20.
	DPOINT3 _ptCenter = RetrieveArcParameters();
	//2˳ʱת2ʱ롣 wudian 2010.07.20.
	bool _bClock = (m_ModalData.m_nGNumber == 2);
	//㵽յ㣬תĽǶȡ wudian 2010.07.20.
	double _nAngle = CalAngle3D(m_ptCurPos, m_ptDestPos, _ptCenter, m_ModalData.m_nPlane, _bClock); // ɨĽ

	// ʼ
	int _nAxisX;
	int _nAxisY;
	//ǳ wudian 2010.07.20.
	GetLeftRightAxis(m_ModalData.m_nPlane, _nAxisX, _nAxisY);
	DPOINT2 _vec;
	_vec.x = m_ptCurPos[_nAxisX] - _ptCenter[_nAxisX];
	_vec.y = m_ptCurPos[_nAxisY] - _ptCenter[_nAxisY];
	//ԲĵߣX¼нǡ wudian 2010.07.20.
	double _nStartAngle = _compute_angle(_vec.x, _vec.y);

	if (DOUBLE_LE(fabs(_nAngle), c_nPIE))
	{
		//Żԭ״
		cvt::CCvtNode* _pNode = new cvt::CCvtNode;

		_pNode->m_nBulge = tan(_nAngle / 4.f);
		_pNode->m_nPlane = m_ModalData.m_nPlane;
		_pNode->m_ptPos.Set(m_ptDestPos.x, m_ptDestPos.y, m_ptDestPos.z);
		_pNode->m_bIsG00 = false;

		ListUnits.push_back(_pNode);
	}
	else
	{
		//ӻֳԲĽȵԲ
		double _nAngle2 =  _nAngle / 2.f;

		cvt::CCvtNode* _pNode1 = new cvt::CCvtNode;
		cvt::CCvtNode* _pNode2 = new cvt::CCvtNode;

		_pNode1->m_nBulge = _pNode2->m_nBulge = tan(_nAngle2 / 4.f);
		_pNode1->m_nPlane = _pNode2->m_nPlane = m_ModalData.m_nPlane;
		_pNode1->m_bIsG00 = _pNode2->m_bIsG00 = false;

		DPOINT3 _ptMidArc = _ptCenter;
		_ptMidArc[_nAxisX] = _ptCenter[_nAxisX] + m_ModalData.m_nArcRadius * cos(_nStartAngle + _nAngle2);
		_ptMidArc[_nAxisY] = _ptCenter[_nAxisY] + m_ModalData.m_nArcRadius * sin(_nStartAngle + _nAngle2);

		_pNode1->m_ptPos.Set(_ptMidArc.x, _ptMidArc.y, _ptMidArc.z);
		_pNode2->m_ptPos.Set(m_ptDestPos.x, m_ptDestPos.y ,m_ptDestPos.z);

		ListUnits.push_back(_pNode1);
		ListUnits.push_back(_pNode2);
	}

	m_ptCurPosOrig = m_ptDestPosOrig;
	m_ptCurPos = m_ptDestPos;
	return;
}

// Description:
//	get revise arc's center to fit the start and end point.
//
// Parameters:
// in:
//		ptStart_			start point
//		ptEnd_				end point
//		ptCenter_			old center point
//		pltype_				plane
//		nRadiusTolerance_	arc radius tolerance
// Note:
// Exceptions:
// Algorithm:
//		use projection algorithm: 
//ûԲġ wudian 2010.07.20.
DPOINT3 CBlockMaker::_get_revise_arc_center_(
	const DPOINT3& ptStart_,
	const DPOINT3& ptEnd_,
	const DPOINT3& ptCenter_)
{
	int _nLeftAxis;
	int _nRightAxis;
	GetLeftRightAxis(m_ModalData.m_nPlane, _nLeftAxis, _nRightAxis);

	double _nXe = ptEnd_[_nLeftAxis];
	double _nYe = ptEnd_[_nRightAxis];
	double _nXs = ptStart_[_nLeftAxis];
	double _nYs = ptStart_[_nRightAxis];
	double _nXc = ptCenter_[_nLeftAxis];
	double _nYc = ptCenter_[_nRightAxis];
	double _nXo = (_nXe + _nXs) / 2.0;		//е
	double _nYo = (_nYe + _nYs) / 2.0;

	double _nD = powersum2(_nXs - _nXe, _nYs - _nYe);
	if (DOUBLE_EQU_ZERO(_nD))	//յغϣֱӷأ
		return ptCenter_;

	/////////////////////////////////////////////////////////////////////////////////
	// Բ
	//  㵽Բĵľյ㵽Բĵľ򱨴˳
	double _nRadiusEnd = sqrt(powersum2(fabs(_nXs - _nXc), fabs(_nYs - _nYc)));
	double _nRadiusStart = sqrt(powersum2(fabs(_nXe - _nXc), fabs(_nYe - _nYc)));
	if (m_nRadiusTolerance > 0.0
		&& fabs(_nRadiusEnd - _nRadiusStart) > m_nRadiusTolerance)
	{
		throw(_GETCS(s_szERROR_ARC_RADIUSERROR));
	}

	// 
	//////////////////////////////////////////////////////////////////////////

	// ¼ԲԲģԭԲĵյдϵĴ㣺
	// algorithm1:
	double _nXret1 = 0.0;
	double _nYret1 = 0.0;
	if (DOUBLE_EQU(_nXe, _nXs))
	{
		_nXret1 = _nXc;
		_nYret1 = _nYo;
	}
	else if (DOUBLE_EQU(_nYe, _nYs))
	{
		_nXret1 = _nXo;
		_nYret1 = _nYc;
	}
	else
	{
		double _nK1 = (_nYe - _nYs) / (_nXe - _nXs);
		double _nK2 = -1.0 / _nK1;
		_nXret1 = (_nK1 * _nXc - _nK2 * _nXo - _nYc + _nYo) / (_nK1 - _nK2);
		_nYret1 = _nK1 * (_nXret1 - _nXc) + _nYc;
	}

	//	// algorithm2:
	//	double _nTNumerator = 0.5 * (_nXo - _nXc) * (_nYe - _nYs)
	//				+ 0.5 * (_nYo - _nYc) * (_nXe - _nXs);
	//	double _nT = _nTNumerator / (_nD / 4.0);
	//	double _nXret2 = _nXo - (_nYe - _nYs) * _nT;
	//	double _nYret2 = _nYo - (_nXe - _nXs) * _nT;
	//
	//	ASSERT(_nXret1 == _nXret2 && _nYret1 == _nYret2);

	DPOINT3 _ptCenter = ptCenter_;
	_ptCenter[_nLeftAxis] = (double)_nXret1;
	_ptCenter[_nRightAxis] = (double)_nYret1;
	return _ptCenter;
}


// Description:
//	Calcaulate the arc's center with the radius and start/end point.
// Parameters:
//	ptStart_
//	ptEnd_
//	ptCenter_
//	nRadius_: can be negative or positive
//			negative -- large arc
//			positive -- little arc
//	pltype_
//	nDirection_	:1, clockwise(NCFGARCINTERPCW), -1, anti-clockwise(NCFGARCINTERPCCW)
//	bKnown_: when the nRadius_' sign is not correct for top means, and
//			the initial center has been given.
//	nRadiusTolerance_	arc radius tolerance
// Note:
// Exceptions:
// Algorithm:
DPOINT3 CBlockMaker::_get_arc_center_by_radius(
	const DPOINT3& ptStart_,
	const DPOINT3& ptEnd_,
	const DPOINT3& ptCenter_,
	double nRadius_)
{
	DPOINT3 _ptCenter = ptCenter_;
	if (fabs(nRadius_) < 0.001)
	{
		throw(_GETCS(s_szERROR_ARC_RADIUS_TOO_SMALL));
	}

	int _nLeftAxis = -1;
	int _nRightAxis = -1;
	GetLeftRightAxis(m_ModalData.m_nPlane, _nLeftAxis, _nRightAxis);

	for (int i = 0; i < 3; i++)
	{
		if (i != _nLeftAxis
			&& i != _nRightAxis)
		{
			_ptCenter[i] = ptStart_[i];
		}
	}

	//if (ptStart_ == ptEnd_)
	//{
	//	if (bKnown_)
	//	{
	//		//Բ
	//		return _ptCenter;
	//	}
	//	else
	//	{
	//		//ժFANUC˵飨ܣϣ
	//		//XYZȫʡԣյΪͬһλã
	//		//ʹRʱָ0ȵԲʵϵ߲ƶ
	//		return ptEnd_;
	//	}
	//}

	DPOINT2 _c0(ptCenter_[_nLeftAxis], ptCenter_[_nRightAxis]);
	DPOINT2 _start(ptStart_[_nLeftAxis], ptStart_[_nRightAxis]);
	DPOINT2 _end(ptEnd_[_nLeftAxis], ptEnd_[_nRightAxis]);
	DPOINT2 _center;

	DPOINT3 _vec(ptStart_.x - ptEnd_.x, ptStart_.y - ptEnd_.y, ptStart_.z - ptEnd_.z);
	double _nDistFromStartToEnd = _vec.GetLength();
	if (DOUBLE_GE(_nDistFromStartToEnd, fabs(nRadius_) * 2.f))
	{
		if (fabs(_nDistFromStartToEnd - fabs(nRadius_) * 2.0) < m_nRadiusTolerance)	// ΪǰԲ
		{
			_center.x = (_start.x + _end.x) / 2.f;
			_center.y = (_start.y + _end.y) / 2.f;
		}
		else
		{
			throw(_GETCS(s_szERROR_ARC_RADIUSERROR));
		}
	}
	else
	{
		DPOINT2 _c1, _c2;
		int _select = -1;
		if (DOUBLE_EQU(_start.x, _end.x))
		{
			_c1.y = _c2.y = (_start.y + _end.y) / 2.f;
			double _nTemp = power(nRadius_) - power(_start.y - _end.y)/4.f;
			if (DOUBLE_EQU_ZERO(_nTemp))
				_nTemp = 0.0;
			_nTemp = sqrt(_nTemp);
			_c1.x = _start.x - _nTemp;
			_c2.x = _start.x + _nTemp;
		}
		else if (DOUBLE_EQU(_start.y, _end.y))
		{
			_c1.x = _c2.x = (_start.x + _end.x) / 2.f;
			double _nTemp = power(nRadius_) - power(_start.x - _end.x)/4.f;
			if (DOUBLE_EQU_ZERO(_nTemp))
				_nTemp = 0.0;
			_nTemp = sqrt(_nTemp);
			_c1.y = _start.y - _nTemp;
			_c2.y = _start.y + _nTemp;
		}
		else
		{
			GetCenter(_start, _end, nRadius_, _c1, _c2);
		}
		// end compute

		////ѡԲ
		//if (bKnown_)	//Բʱ
		//{
		//	if (power(_c0.x -_c2.x) + power(_c0.y -_c2.y)
		//		<= power(_c0.x -_c1.x) + power(_c0.y -_c1.y))
		//	{
		//		_select = 2;
		//	}
		//	else
		//	{
		//		_select = 1;
		//	}
		//}	// Update center
		//else	//ѡԲ
		{
			double _sita11, _sita12, _sita21, _sita22;
			_sita11 = _compute_angle(_start.x - _c1.x, _start.y - _c1.y);
			_sita12 = _compute_angle(_end.x - _c1.x, _end.y - _c1.y);
			_sita21 = _compute_angle(_start.x - _c2.x, _start.y - _c2.y);
			_sita22 = _compute_angle(_end.x - _c2.x, _end.y - _c2.y);

			if (m_ModalData.m_nGNumber == 3)
			{
				if (_sita12 < _sita11)
					_sita12 += c_nPIE * 2.0;

				if (nRadius_ > 0)
				{
					if (_sita12 - _sita11 < c_nPIE)
					{
						_select = 1;
					}
					else
					{
						_select = 2;
					}
				}
				else
				{
					if (_sita12 - _sita11 > c_nPIE)
					{
						_select = 1;
					}
					else
					{
						_select = 2;
					}
				}
			}	// end NCFGARCINTERPCCW
			else// NCFGARCINTERPCW
			{
				if (_sita12 > _sita11)
					_sita12 -= c_nPIE * 2.0;

				if (nRadius_ > 0)
				{
					if (_sita11 - _sita12 < c_nPIE)
					{
						_select = 1;
					}
					else
					{
						_select = 2;
					}
				}
				else
				{
					if (_sita11 - _sita12 > c_nPIE)
					{
						_select = 1;
					}
					else
					{
						_select = 2;
					}
				}
			}// end NCFGARCINTERPCW
		}
		switch (_select)
		{
		case 1:
			_center.x = _c1.x;
			_center.y = _c1.y;
			break;
		case 2:
			_center.x = _c2.x;
			_center.y = _c2.y;
			break;
		default:
			ASSERT(false);
		}
	}

	_ptCenter[_nLeftAxis] = _center.x;
	_ptCenter[_nRightAxis] = _center.y;

	return _ptCenter;
}

// Բģ뾶ߵȲ
DPOINT3 CBlockMaker::RetrieveArcParameters()
{
	const token_t _tkTagTokenIJK[] =
	{
		TK_ADR_I, 
		TK_ADR_J, 
		TK_ADR_K,
	};

	int _nAxisX = -1;
	int _nAxisY = -1;
	GetLeftRightAxis(m_ModalData.m_nPlane, _nAxisX, _nAxisY);

	int _nIndex = -1;
	if (SearchTaggedData(&_nIndex, TK_ADR_R))
	{
		m_ModalData.m_bArcIJKMode = false;
	}
	else if (SearchTaggedData(&_nIndex, _tkTagTokenIJK[_nAxisX])
		|| SearchTaggedData(&_nIndex, _tkTagTokenIJK[_nAxisY]))
	{
		m_ModalData.m_bArcIJKMode = true;
	}

	INT_PTR _i, _size;

	// Check m_pCodeGenerator->m_ModalData.m_ptZoomAspect, axis x must be same as y
	for (_i = 0, _size = m_arrPTransform.GetSize(); _i < _size; ++_i)
	{
		CTransform* _pTrans = m_arrPTransform[_i];
		if (_pTrans->m_nTransformType == CTransform::TF_ZOOM)
		{
			DPOINT3 _nxAspect = ((CZoomTransform*)_pTrans)->m_ptAspect;
			if (!DOUBLE_EQU(_nxAspect[_nAxisX], _nxAspect[_nAxisY]))
				throw(_GETCS(s_szERROR_INCORRECT_ASPECT_FOR_RADIUS));
		}
	}

	// Get circle center position
	DPOINT3 _ptCurPos = m_ptCurPosOrig;
	DPOINT3 _ptDestPos = m_ptDestPosOrig;
	DPOINT3 _ptCenter;
	if (m_ModalData.m_bArcIJKMode)
	{
		//[]: "ԲIJKʽЧ"Ϊ
		//			  ·еԲָIJKƽϽһʱG2 Y100 J50,
		//			  ʾIJK޸Ĳʾ⡣
		//[޸ķ]: ĬϵǰΪԲġ
		// ---  2011 1 17
		m_ModalData.m_ptArcCenter = m_ptCurPosOrig;

		// G2/3 X_Y_Z_I_J_K_F_, Find circle center position 
		DPOINT3 _nxArcCenter = m_ptCurPos;
		for (int _axis = 0; _axis < 3; _axis++)
		{
			if (SearchTaggedData(&_nIndex, _tkTagTokenIJK[_axis]))
			{
				MatchTaggedData(_nIndex, _tkTagTokenIJK[_axis]);
				double _nTemp = m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
				_nTemp = TranslateToMM(_nTemp, _axis); // W.Coor.

				if (_nAxisX == _axis || _nAxisY == _axis)
				{
					//if (!_pParamter->m_bIJKIncreaseMode) // Absolute Coor.
					//	//_nxArcCenter[_axis] = m_pCodeGenerator->WorkCoorToMachineCoor(_nTemp, _axis);
					//	_nxArcCenter[_axis] = _nTemp;
					//else 
					_nxArcCenter[_axis] = _ptCurPos[_axis] + (double)_nTemp;
				}
				else // Circle center is equal to start position, whatever what is Spiral Depth 
				{
					throw(_GETCS(s_szERROR_SPIRALPITCH)); // K is SpiralPitch, don't zoom it
				}
			}
			else // if omitted 
			{
				if (_nAxisX == _axis || _nAxisY == _axis)
				{
					if (!m_ModalData.m_bIJKIncreaseMode)
					{
						double _nTemp = m_ModalData.m_ptArcCenter[_axis];
						if (IsInvalidDouble(_nTemp))
							throw(_GETCS(s_szERROR_IJK_ERROR));
						_nxArcCenter[_axis] = _nTemp;
					}
				}
			}
		}
		m_ModalData.m_ptArcCenter = _nxArcCenter;

		DPOINT3 _ptTemp;
		_Transform(_ptCurPos, _ptTemp);
		_ptCurPos = _ptTemp;
		_Transform(_nxArcCenter, _ptTemp);
		_ptCenter = _ptTemp;
		_Transform(_ptDestPos, _ptTemp);
		_ptDestPos = _ptTemp;

		// Բıʱھȵԭ򣬿㵽Բĵľ
		// յ㵽Բĵľ벻ȣ
		// Ϊֹ֣Ҫ¼Բ
		try
		{
			// Use the position after transform 
			_ptCenter= _get_revise_arc_center_(
				_ptCurPos,
				_ptDestPos,
				_ptCenter);
		}
		catch(LPCTSTR pszErr_)
		{
			throw(pszErr_);
		}
	}
	else // G2/3 X_Y_Z_R_F_
	{
		// If NO R existed 
		double _nRadius = m_ModalData.m_nArcRadius;
		if (SearchTaggedData(&_nIndex, TK_ADR_R))
		{
			MatchTaggedData(_nIndex, TK_ADR_R);
			double _nRadiusTemp = m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
			_nRadius = (double)TranslateToMM(_nRadiusTemp, 0);	//תλӢƣƣǶȣ
			m_ModalData.m_nArcRadius = _nRadius;
		}

		//뾶̣ҪԲ
		DPOINT3 _nxCenter = _get_arc_center_by_radius(
			_ptCurPos,
			_ptDestPos,
			_nxCenter,
			_nRadius);

		for (int _axis = 0; _axis < 3; _axis++)
		{
			if (_nAxisX != _axis && _nAxisY != _axis 
				&& SearchTaggedData(&_nIndex, _tkTagTokenIJK[_axis]))
			{
				MatchTaggedData(_nIndex, _tkTagTokenIJK[_axis]);
				throw(_GETCS(s_szERROR_SPIRALPITCH));
			}
		}

		DPOINT3 _ptTemp;
		_Transform(_ptCurPos, _ptTemp);
		_ptCurPos = _ptTemp;
		_Transform(_nxCenter, _ptTemp);
		_ptCenter = _ptTemp;
		_Transform(_ptDestPos, _ptTemp);
		_ptDestPos = _ptTemp;
	}
	CMirrorTransform* _pMirrorTrans = NULL;
	for (_i = 0, _size = m_arrPTransform.GetSize(); _i < _size; ++_i)
	{
		if (m_arrPTransform[_i]->m_nTransformType == CTransform::TF_MIRROR)
		{
			ASSERT(!_pMirrorTrans);
			_pMirrorTrans = (CMirrorTransform*)m_arrPTransform[_i];
#ifdef NDEBUG
			break;
#endif
		}
	}

	if (_pMirrorTrans)
	{
		BOOL _bRevser = _pMirrorTrans->m_bxMirror[_nAxisX] ^ _pMirrorTrans->m_bxMirror[_nAxisY];
		if (_bRevser)
			m_ModalData.m_nGNumber = (m_ModalData.m_nGNumber == 2) ? 2 : 3;
	}

	DPOINT2 _vec(_ptCenter[_nAxisX] - m_ptCurPos[_nAxisX], _ptCenter[_nAxisY] - m_ptCurPos[_nAxisY]);
	m_ModalData.m_nArcRadius = (double)_vec.GetLength();
	m_ModalData.m_ptArcCenter = _ptCenter;
	return _ptCenter;
}

const CBlockMaker::rule_t* CBlockMaker::GetRule_Pre(token_t tkAddr_, double nTagValue_)
{
	for (int _i = 0; _i < m_nPreRuleNum; _i++)
	{
		if (m_RuleList_Pre[_i].tkAddr == tkAddr_)
		{
			if (m_RuleList_Pre[_i].nTagValue == -1
				|| m_RuleList_Pre[_i].nTagValue == nTagValue_)
			{
				return &m_RuleList_Pre[_i];
			}
		}
	}

	return NULL;
}

const CBlockMaker::rule_t* CBlockMaker::GetRule_Normal(token_t tkAddr_, double nTagValue_)
{
	for (int _i = 0; _i < m_nNormalRuleNum; _i++)
	{
		if (m_RuleList_Normal[_i].tkAddr == tkAddr_)
		{
			if (m_RuleList_Normal[_i].nTagValue == -1
				|| m_RuleList_Normal[_i].nTagValue == nTagValue_)
			{
				return &m_RuleList_Normal[_i];
			}
		}
	}

	return NULL;
}

const CBlockMaker::rule_t* CBlockMaker::GetRule_Post(token_t tkAddr_, double nTagValue_)
{
	for (int _i = 0; _i < m_nPostRuleNum; _i++)
	{
		if (m_RuleList_Post[_i].tkAddr == tkAddr_)
		{
			if (m_RuleList_Post[_i].nTagValue == -1
				|| m_RuleList_Post[_i].nTagValue == nTagValue_)
			{
				return &m_RuleList_Post[_i];
			}
		}
	}

	return NULL;
}

void CBlockMaker::MatchG(CTaggedData* pTaggedData_)
{
	int _nGNo = m_ModalData.m_nGNumber;
	int _nIndex = pTaggedData_->m_nToken - TK_ADR_FIRST;
	ASSERT(m_MatchGScope[_nIndex][0] == pTaggedData_->m_nToken);
	bool _bValid = false;
	for (const int*_pMatchNos = &m_MatchGScope[_nIndex][1];
		*_pMatchNos != -1;
		_pMatchNos++)
	{
		if (*_pMatchNos == _nGNo)
		{
			_bValid = true;
			break;
		}
	}

	if (!_bValid)
	{
		throw(_GETCS(s_szERROR_MATCH_BACKWARDRULE));
	}

	const rule_t* _pRule = GetRule(TK_ADR_G, _nGNo);
	if (_pRule)
	{
		(this->*_pRule->pFunction) (pTaggedData_);
	}
	else
	{
		throw(_GETCS(s_szERROR_MATCH_BACKWARDRULE));
	}
}

void CBlockMaker::Ignore(CTaggedData* pTaggedData_)
{
	TRACE("Ignore instruction:%s%f",
		GetTokenAlias(pTaggedData_->m_nToken),
		pTaggedData_->m_nValue);
}

//ȡļеĽٶȸֵָĽٶȳԱ
void CBlockMaker::FeedRate(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_F, c_nINVALID_DOUBLE);
	m_ModalData.m_nProgramSpeed = pTaggedData_->m_nValue;

	cvt::CCvtFeedRat* _pFeedRat = new cvt::CCvtFeedRat;
	_pFeedRat->m_nFeedRat = pTaggedData_->m_nValue;

	ListUnits.push_back(_pFeedRat);
	return;
}

//ȷǾֵֵ̻ wangwenbo 2010.03.22
void CBlockMaker::G90_G91(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	int _nGNumber = (int)pTaggedData_->m_nValue;
	ASSERT(_nGNumber == 90 || _nGNumber == 91);
	m_ModalData.m_bAbsolute = _nGNumber == 90 ? true : false;
	MatchTaggedData(TK_ADR_G, _nGNumber);
}

//ȷӹƽϢ wangwenbo 2010.03.22
void CBlockMaker::G17_G18_G19(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	int _nGNumber = (int) pTaggedData_->m_nValue;
	ASSERT(_nGNumber == 17 || _nGNumber == 18 || _nGNumber == 19);

	//ƽȷ
	switch (_nGNumber)
	{
	case 17:
		m_ModalData.m_nPlane = cvt::plane_xy;
		break;

	case 18:
		m_ModalData.m_nPlane = cvt::plane_zx;
		break;

	case 19:
		m_ModalData.m_nPlane = cvt::plane_yz;
		break;

	default:
		ASSERT(false);
		break;
	}

	MatchTaggedData(TK_ADR_G, _nGNumber);
}

//ȷӹ wangwenbo 2010.03.22
void CBlockMaker::G20_G21_G70_G71(CTaggedData* pTaggedData_)
{
	int _nGNumber = (int) pTaggedData_->m_nValue;
	switch (_nGNumber)
	{
	case 20:
	case 70:
		m_ModalData.m_nUnit = 25.4f / m_nUnit;
		break;

	case 21:
	case 71:
		m_ModalData.m_nUnit = 1.f / m_nUnit;
		break;

	default:
		ASSERT(false);
	}

	MatchTaggedData(TK_ADR_G, _nGNumber);
}

void CBlockMaker::M6_T(CTaggedData* pTaggedData_)
{
	ASSERT((pTaggedData_->m_nToken == TK_ADR_M && pTaggedData_->m_nValue == 6)
		|| pTaggedData_->m_nToken == TK_ADR_T);
	UNREFERENCED_PARAMETER(pTaggedData_);

	int _nIndex;
	if (SearchTaggedData(&_nIndex, TK_ADR_M))
		MatchTaggedData(_nIndex, TK_ADR_M);

	if (SearchTaggedData(&_nIndex, TK_ADR_T))
	{
		m_ModalData.m_nToolIndex = (int)m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
		MatchTaggedData(_nIndex, TK_ADR_T);
	}

	cvt::CCvtToolINo* _pToolNo = new cvt::CCvtToolINo;

	_pToolNo->m_nToolNo = m_ModalData.m_nToolIndex;
	ListUnits.push_back(_pToolNo);

	return;
}

void CBlockMaker::Rule_Error(CTaggedData* pTaggedData_)
{
	TRACE("Rule_Error for Token: %s\n", GetTokenAlias(pTaggedData_->m_nToken));
	m_strTemp.Format(_GETCS(s_szERROR_UNEXPECTED_TAGGEDDATA),
		GetTokenAlias(pTaggedData_->m_nToken));
	throw(m_strTemp);
}

//ѰҵµTaggedDatapnIndex_ָһCurrentEntity±ֵ
//ҵ򷵻true򷵻false  wudian 2010.07.20
bool CBlockMaker::SearchTaggedData(int* pnIndex_, token_t tagToken_,
								   double ntagValue_/* = c_nINVALID_DOUBLE*/) const
{
	//CTaggedEntity͵ָ룬ָ򡱵ǰһCTaggedEntity"
	//m_Parser.m_Entities     wudian 2010.07.20
	const CTaggedEntity* _pTaggedEntity = &m_Parser.m_Entities.GetCurrentEntity();
	//CTaggedEntityҵǰӦһCtaggeData
	//  wudian 2010.07.20
	for (int _i = 0, _nSize = _pTaggedEntity->GetCount(); _i < _nSize; _i++)
	{
		if ((*_pTaggedEntity)[_i].m_bDeleted)
		{
			continue;
		}
		if ((*_pTaggedEntity)[_i].m_nToken == tagToken_)
		{
			if (IsInvalidDouble(ntagValue_) || (*_pTaggedEntity)[_i].m_nValue == ntagValue_)
			{
				if (pnIndex_)
				{
					*pnIndex_ = _i;
				}

				return true;
			}
		}
	}

	return false;
}

// return searched index
int CBlockMaker::MatchTaggedData(token_t tagToken_, double ntagValue_/* = c_nINVALID_DOUBLE*/)
{
	int _nIndex;
	//ûҵȷCTaggedData󣬾׳쳣  wudian 2010.07.20
	if (!SearchTaggedData(&_nIndex, tagToken_, ntagValue_))
	{
		throw(_GETCS(s_szERROR_MATCH_TAGGEDDATA));
	}

	//G0G1Ѿʹ wudian 2010.07.20
	m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_bDeleted = true;
	return _nIndex;
}

void CBlockMaker::MatchTaggedData(int nIndex_, token_t tagToken_, double ntagValue_/* = c_nINVALID_DOUBLE*/)
{
	if (m_Parser.m_Entities.GetCurrentEntity()[nIndex_].m_nToken != tagToken_)
	{
		throw(_GETCS(s_szERROR_MATCH_TAGGEDDATA));
	}

	if (IsValidDouble(ntagValue_)
		&& m_Parser.m_Entities.GetCurrentEntity()[nIndex_].m_nValue != ntagValue_)
	{
		throw(_GETCS(s_szERROR_MATCH_TAGGEDDATA));
	}

	m_Parser.m_Entities.GetCurrentEntity()[nIndex_].m_bDeleted = true;
}

// תΪе
// ԭƫ
// ܳʼλӢ硢ǶȻǺףתΪס
void CBlockMaker::RetrieveDestPosition()
{
	static const token_t _tkTagToken[] =
	{
		TK_ADR_X,
		TK_ADR_Y,
		TK_ADR_Z,
	};
	C_ASSERT(3 == _countof(_tkTagToken));

	m_ptDestPosOrig = m_ptCurPosOrig;
	int _nIndex;
	for (int _axis = 0; _axis < 3; ++_axis)
	{
		if (!SearchTaggedData(&_nIndex, _tkTagToken[_axis]))
			continue;

		MatchTaggedData(_nIndex, _tkTagToken[_axis]);
		double _nTemp = m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
		_nTemp = TranslateToMM(_nTemp, _axis);
		_SetOrigCoorToDestination(m_ptDestPosOrig, (double)_nTemp, _axis);
	}

	_Transform(m_ptDestPosOrig, m_ptDestPos);
	return;
}

void CBlockMaker::_SetOrigCoorToDestination(DPOINT3& nxDest_, double nMCoor_, int nAxis_)
{
	ASSERT(nAxis_ >= 0 && nAxis_ <= 3);
	if (!m_ModalData.m_bAbsolute)
	{
		nxDest_[nAxis_] = m_ptCurPosOrig[nAxis_] + nMCoor_;
		return;
	}

	nxDest_[nAxis_] = nMCoor_ + m_ModalData.m_ptOffset[nAxis_];
	return;
}

double CBlockMaker::TranslateToMM(double nCoordinate_, int nAxis_) const
{
	double _nRet = m_ModalData.m_nUnit * nCoordinate_;
	return _nRet;
}

const CBlockMaker::rule_t* CBlockMaker::GetRule(token_t tkAddr_, double nTagValue_)
{
	const CBlockMaker::rule_t* _pRule = GetRule_Pre(tkAddr_, nTagValue_);
	if (_pRule)
		return _pRule;
	_pRule = GetRule_Normal(tkAddr_, nTagValue_);
	if (_pRule)
		return _pRule;
	_pRule = GetRule_Post(tkAddr_, nTagValue_);
	return _pRule;
}

// Go to machine zero reference through middle point for specified axis.
void CBlockMaker::G28(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 28);
	UNREFERENCED_PARAMETER(pTaggedData_);

	MatchTaggedData(TK_ADR_G, 28);

	__point3<bool> _axFind(false, false, false);
	static const token_t _tkTagToken[] = { TK_ADR_X, TK_ADR_Y, TK_ADR_Z };
	cvt::CCvtG28* _pCCvtG28 = new cvt::CCvtG28;
	//α洢мλ ---  2010.3.19
	for (int _i = 0, _nIndex; _i < _countof(_tkTagToken); _i++)
	{
		if (SearchTaggedData(&_nIndex, _tkTagToken[_i]))
		{
			_axFind[_i] = true;
			//ȡмλõĸıֵ ---  2010.3.19
			switch(_i)
			{
			case 0:
				_pCCvtG28->m_ptMidPos.x = m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
				break;
			case 1:
				_pCCvtG28->m_ptMidPos.y = m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
				break;
			case 2:
				_pCCvtG28->m_ptMidPos.z = m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
				break;
			default:
				ASSERT(false);
			}
		}
	}
	//G28 ---  2010.3.19
	ListUnits.push_back(_pCCvtG28);

	RetrieveDestPosition();
	m_ptDestPos.x = m_ptDestPos.y = m_ptDestPos.z = 0.f;
	m_ptCurPos = m_ptDestPos;
	return;
}

void CBlockMaker::G4(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 4);
	UNREFERENCED_PARAMETER(pTaggedData_);

	MatchTaggedData(TK_ADR_G, 4);

	int _nIndex;
	//ȡG04ͣʱm_Entities洢λ ---  2010.3.19
	if (!SearchTaggedData(&_nIndex, TK_ADR_P))
	{
		m_strTemp.Format(_GETCS(s_szERROR_NOENOUGHPARAMETERS), "G04");
		throw(m_strTemp);
	}

	//ȡͣʱ---  2010.3.19
	cvt::CCvtPause* _pCvtPause = new cvt::CCvtPause;
	_pCvtPause->m_nPauseTime = (int)m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue;

	ListUnits.push_back(_pCvtPause);

	MatchTaggedData(_nIndex, TK_ADR_P);

	return;
}

void CBlockMaker::G9(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 9);
	UNREFERENCED_PARAMETER(pTaggedData_);

	MatchTaggedData(TK_ADR_G, 9);
	return;
}

void CBlockMaker::G40(CTaggedData* pTaggedData_)
{
	int _nGNumber = int(pTaggedData_->m_nValue);
	MatchTaggedData(pTaggedData_->m_nToken, _nGNumber);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(_nGNumber == 40);
	UNREFERENCED_PARAMETER(pTaggedData_);

	//洢뾶ϢListUnits---  2010.3.19
	cvt::CCvtCutCompensate* _pCCvtCutCopmensate = new cvt::CCvtCutCompensate;
	// ---  2010.3.19
	_pCCvtCutCopmensate->m_nCCType = cvt::cc_g40;
	//ȡΪ-1 wangwenbo 2010.03.22
	_pCCvtCutCopmensate->m_nCutNo = -1;
	ListUnits.push_back(_pCCvtCutCopmensate);
}

void CBlockMaker::G41_G42(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	int _nGNumber = (int) pTaggedData_->m_nValue;
	ASSERT(_nGNumber == 41 || _nGNumber == 42);

	MatchTaggedData(TK_ADR_G, _nGNumber);

	// ֲ֧G43/G44ʱɵCCvtCutCompensatem_nCutNoΪ-1
	// ȱٲʱδɵ÷                    ----  2013-06-24
	int _nCutNo = -1;
	int _nIndex = 0;
	if (SearchTaggedData(&_nIndex, TK_ADR_D))
	{
		MatchTaggedData(_nIndex, TK_ADR_D);
		_nCutNo = (int)m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
	}

	//_nGNumberĲֵͬG41G42Ĵ洢---  2010.3.19
	cvt::CCvtCutCompensate* _pCCvtCutCopmensate = new cvt::CCvtCutCompensate;
	if (_nGNumber == 41)
		_pCCvtCutCopmensate->m_nCCType = cvt::cc_g41;
	else
		_pCCvtCutCopmensate->m_nCCType = cvt::cc_g42;
	//߰뾶Ϣ---  2010.3.19
	_pCCvtCutCopmensate->m_nCutNo = _nCutNo;
	ListUnits.push_back(_pCCvtCutCopmensate);
}

void CBlockMaker::G43_G44(CTaggedData* pTaggedData_)
{
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);

	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	int _nGNumber = (int) pTaggedData_->m_nValue;
	ASSERT(_nGNumber == 43 || _nGNumber == 44);
	UNREFERENCED_PARAMETER(pTaggedData_);

	// ֲ֧G43/G44ʱɵCCvtCutCompensatem_nCutNoΪ-1
	// ȱٲʱδɵ÷                    ----  2013-06-24
	int _nCutNo = -1;
	int _nIndex = 0;
	if (SearchTaggedData(&_nIndex, TK_ADR_H))
	{
		MatchTaggedData(_nIndex, TK_ADR_H);
		_nCutNo = (int)m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
	}

	//_nGNumberĲֵͬG43G44Ĵ洢---  2010.3.19
	cvt::CCvtCutCompensate* _pCCvtCutCopmensate = new cvt::CCvtCutCompensate;
	if (_nGNumber == 43)
		_pCCvtCutCopmensate->m_nCCType = cvt::cc_g43;
	else
		_pCCvtCutCopmensate->m_nCCType = cvt::cc_g44;
	//߳Ȳƫú---  2010.3.19
	_pCCvtCutCopmensate->m_nCutNo = _nCutNo;
	ListUnits.push_back(_pCCvtCutCopmensate);
}

void CBlockMaker::G49(CTaggedData* pTaggedData_)
{
	int _nGNumber = int(pTaggedData_->m_nValue);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(_nGNumber == 49);
	MatchTaggedData(TK_ADR_G, _nGNumber);

	int _nIndex;
	//ҵH*,ʾôѾʹù wudian 2010.07.20
	if (SearchTaggedData(&_nIndex, TK_ADR_H))
		MatchTaggedData(_nIndex, TK_ADR_H);

	//洢ȡ߳ȲϢ---  2010.3.19
	cvt::CCvtCutCompensate* _pCCvtCutCopmensate = new cvt::CCvtCutCompensate;
	_pCCvtCutCopmensate->m_nCCType = cvt::cc_g49;
	//ȡ߳ȲΪ-1 wangwenbo 2010.03.22
	_pCCvtCutCopmensate->m_nCutNo = -1;
	ListUnits.push_back(_pCCvtCutCopmensate);
}

//ȡŹ wangwenbo 2010.03.22
//ȡܡ wudian 2010.07.20.
void CBlockMaker::G50(CTaggedData* pTaggedData_)
{
	//ԣָpTaggedData_Ϊգm_nTokenΪGm_nValueΪ50  wudian 2010.07.20.
	ASSERT(pTaggedData_ && pTaggedData_->m_nToken == TK_ADR_G
		&& pTaggedData_->m_nValue == 50);
	//ҵG50ΣѾʹˡ wudian 2010.07.20.
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);

	if (!KillNearTransform(CTransform::TF_ZOOM))
		throw(_GETCS(s_szERROR_G51_50_NOTMATCH));
	//յΪµ㡣 wudian 2010.07.20.
	_MoveCurPosToRespPos();
	return;
}

//趨Ź wangwenbo 2010.03.22
void CBlockMaker::G51(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_ && pTaggedData_->m_nToken == TK_ADR_G
		&& pTaggedData_->m_nValue == 51);
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);

	_StoreZoomInf(pTaggedData_);
	_MoveCurPosToRespPos();
	return;
}

//G50.1 X_Y_Z_:ָЧᡣ
void CBlockMaker::G50_1(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_ && pTaggedData_->m_nToken == TK_ADR_G && pTaggedData_->m_nValue == 50.1);
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);

	// Find out mirror transform
	//һûŪʲôǾܣһ´û wudian 2010.07.20.
	INT_PTR _size = m_arrPTransform.GetSize(); 
	if (0 == _size)
		return;

	int _i;
	CMirrorTransform* _pMirrorTrans = NULL;
	for (_i = 0; _i < _size; ++_i)
	{
		if (m_arrPTransform[_i]->m_nTransformType == CTransform::TF_MIRROR)
		{
			ASSERT(!_pMirrorTrans);
			_pMirrorTrans = (CMirrorTransform*)m_arrPTransform[_i];
		}
	}
	ASSERT(_pMirrorTrans == m_arrPTransform[0]);

	static const token_t _tkTagToken[] =
	{
		TK_ADR_X, 
		TK_ADR_Y,
		TK_ADR_Z,
	};
	bool _bSucess = false;
	int _nIndex;
	int _nSize = _countof(_tkTagToken);
	for (_i = 0; _i < _nSize; _i++)
	{
		if (SearchTaggedData(&_nIndex, _tkTagToken[_i]))
		{
			_bSucess = true;
			MatchTaggedData(_nIndex, _tkTagToken[_i]);
			_pMirrorTrans->m_bxMirror[_i] = false;
		}
	}

	if (!_bSucess ||
		(!_pMirrorTrans->m_bxMirror[0] && !_pMirrorTrans->m_bxMirror[1] && !_pMirrorTrans->m_bxMirror[2]))
	{
		if (!KillNearTransform(CTransform::TF_MIRROR))
			throw(_GETCS(s_szERROR_G51D1_50D1_NOTMATCH));
	}

	_MoveCurPosToRespPos();
}

//G51.1 X_Y_Z_:ָģĿǵ㣬ҲߡָָʾԼӹľмӹ ---  2011 2 23
void CBlockMaker::G51_1(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_ && pTaggedData_->m_nToken == TK_ADR_G && pTaggedData_->m_nValue == 51.1);
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);

	_StoreMirrorInf(pTaggedData_);
	_MoveCurPosToRespPos();

	return;
}

void CBlockMaker::G53(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_ && pTaggedData_->m_nToken == TK_ADR_G
		&& pTaggedData_->m_nValue == 53);
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);
	UNREFERENCED_PARAMETER(pTaggedData_);
}

//G54~G59 ---  2011 2 23
void CBlockMaker::SelectWorkCoor(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	int _nNumber = (int) pTaggedData_->m_nValue;
	ASSERT(_nNumber >= 54 && _nNumber <= 59);
	MatchTaggedData(pTaggedData_->m_nToken, _nNumber);
}

void CBlockMaker::G65_M98(CTaggedData* pTaggedData_)
{
	ASSERT ((pTaggedData_->m_nToken == TK_ADR_G && pTaggedData_->m_nValue == 65)
		|| (pTaggedData_->m_nToken == TK_ADR_M && pTaggedData_->m_nValue == 98));

	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);

	int _nIndex;
	if (!SearchTaggedData(&_nIndex, TK_ADR_P))
	{
		m_strTemp.Format(_GETCS(s_szERROR_NOENOUGHPARAMETERS), "G65/M98");
		throw(m_strTemp);
	}
	MatchTaggedData(_nIndex, TK_ADR_P);

	int _nSubProgramNo = (int) m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
	LPCSTR _pszSubProgramName = m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_pszValue;

	int _nCallingTimes = 1;
	if (SearchTaggedData(&_nIndex, TK_ADR_L))
	{
		MatchTaggedData(_nIndex, TK_ADR_L);
		_nCallingTimes = (int)m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
		if (_nCallingTimes > 1)
		{
			if (m_pGToCvtTranslateParam->m_nSubProgCallTime == 1)
				_nCallingTimes = 1;
			else if (m_pGToCvtTranslateParam->m_nSubProgCallTime == 3)
			{
				CString _str;
				_str.Format(_GETCS(s_szCALLTIMES), _nCallingTimes);
				if (IDYES == AfxMessageBox(_str, MB_YESNO))
					_nCallingTimes = 1;
			}
		}
	}

	if (_nCallingTimes == 0)
		return;

	if (_nSubProgramNo > 0)
		MakeCall(_nSubProgramNo, _nCallingTimes);
	else if (_pszSubProgramName != NULL)
		MakeCall(_pszSubProgramName, _nCallingTimes);
	else
		throw(_GETCS(s_csERROR_G65SubProg_Error));

	//洢G65/M98Ϣ---  2010.3.19
	cvt::CCvtG65* _pCCvtG65 = new cvt::CCvtG65;
	//ѭ---  2010.3.19
	_pCCvtG65->m_nCallingTimes = _nCallingTimes;
	//ӳ÷ʽ---  2010.3.19
	if (_nSubProgramNo > 0)
	{
		_pCCvtG65->m_nCallWay = cvt::callway_no;
		_pCCvtG65->m_nSubPathNo = _nSubProgramNo;
	}
	else
	{
		_pCCvtG65->m_nCallWay = cvt::callway_name;
		_pCCvtG65->m_pszSubPathName = _pszSubProgramName;
	}
	ListUnits.push_back(_pCCvtG65);
}

//תܿ wudian 2010.07.20.
void CBlockMaker::G68(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_ && pTaggedData_->m_nToken == TK_ADR_G
		&& pTaggedData_->m_nValue == 68);
	MatchTaggedData(TK_ADR_G, 68);

	//洢תϢ wudian 2010.07.20.
	_StoreRevInf(pTaggedData_);	
	//µģյ㡣 wudian 2010.07.20.
	_MoveCurPosToRespPos();

	return;
}

//תܹء wudian 2010.07.20.
void CBlockMaker::G69(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_ && pTaggedData_->m_nToken == TK_ADR_G
		&& pTaggedData_->m_nValue == 69);
	MatchTaggedData(TK_ADR_G, 69);

	if (!KillNearTransform(CTransform::TF_REV))
		throw(_GETCS(s_szERROR_G68_69_NOTMATCH));
	_MoveCurPosToRespPos();
	return;
}

//ȡ̶ѭܡ wudian 2010.07.20.
void CBlockMaker::G80(CTaggedData* pTaggedData_)
{
	ASSERT(int(pTaggedData_->m_nValue) == 80);
	MatchTaggedData(TK_ADR_G, 80);
}

//鵽ʼR㡣 wudian 2010.07.20.
void CBlockMaker::G98_G99(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	int _nGNumber = (int)pTaggedData_->m_nValue;
	ASSERT(_nGNumber == 98 ||_nGNumber == 99);

	MatchTaggedData(TK_ADR_G, _nGNumber);
}

//ϵ趨 wangwenbo 2010.03.22
void CBlockMaker::G92(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_G, 92);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(92 == pTaggedData_->m_nValue);

	static const token_t _tkTagToken[] =
	{
		TK_ADR_X, TK_ADR_Y, TK_ADR_Z
	};

	int _nIndex;
	DPOINT3 _nxOffset(0.f, 0.f, 0.f);
	for (int _axis = 0; _axis < 3; ++_axis)
	{
		if (SearchTaggedData(&_nIndex, _tkTagToken[_axis]))
		{
			MatchTaggedData(_nIndex, _tkTagToken[_axis]);
			_nxOffset[_axis] = double(m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue);
			m_ModalData.m_ptOffset[_axis] = m_ptCurPos[_axis] - _nxOffset[_axis];
		}
	}

	return;
}

void CBlockMaker::G992(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_G, 992);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(992 == pTaggedData_->m_nValue);

	static const token_t _tkTagTokenXYZ[] = {TK_ADR_X, TK_ADR_Y, TK_ADR_Z};
	static const token_t _tkTagTokenIJK[] = {TK_ADR_I, TK_ADR_J, TK_ADR_K};
	int _nIndex;
	for (int _axis = 0; _axis < 3; ++_axis)
	{
		if (SearchTaggedData(&_nIndex, _tkTagTokenXYZ[_axis]))
			MatchTaggedData(_nIndex, _tkTagTokenXYZ[_axis]);
		else if (SearchTaggedData(&_nIndex, _tkTagTokenIJK[_axis]))
			MatchTaggedData(_nIndex, _tkTagTokenIJK[_axis]);
	}

	return;
}

//G921 X_Y_Z_:õǰϵĵǰĹ꣬д᲻޸ģͬƫϵ
//ָڲͲ/߽ʱ
//attentionϵͳУG921ָδ ---  2011 2 23
void CBlockMaker::G921(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_G, 921);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(921 == pTaggedData_->m_nValue);

	static const token_t _tkTagToken[] =
	{
		TK_ADR_X, TK_ADR_Y, TK_ADR_Z
	};

	int _nIndex;
	for (int _axis = 0; _axis < 3; ++_axis)
	{
		if (SearchTaggedData(&_nIndex, _tkTagToken[_axis]))
			MatchTaggedData(_nIndex, _tkTagToken[_axis]);
	}

	return;
}

//attentionϵͳδG922ָн ---  2011 2 23
//G922 X_Y_Z_P_⣺P_ָƫõͣ-4ʾⲿƫƣ-1ʾǰϵɺԣ0~5ӦG54~G59
//ָڲͲ/߽ʱ
void CBlockMaker::G922(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_G, 922);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(922 == pTaggedData_->m_nValue);

	static const token_t _tkTagToken[] =
	{
		TK_ADR_X, TK_ADR_Y, TK_ADR_Z
	};

	int _nIndex;
	for (int _axis = 0; _axis < 3; ++_axis)
	{
		if (SearchTaggedData(&_nIndex, _tkTagToken[_axis]))
			MatchTaggedData(_nIndex, _tkTagToken[_axis]);
	}
	if (SearchTaggedData(&_nIndex, TK_ADR_P))
		MatchTaggedData(_nIndex, TK_ADR_P);

	return;
}

void CBlockMaker::G923(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_G, 923);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(923 == pTaggedData_->m_nValue);

	static const token_t _tkTagToken[] =
	{
		TK_ADR_X, TK_ADR_Y, TK_ADR_Z
	};

	int _nIndex;
	for (int _axis = 0; _axis < 3; ++_axis)
	{
		if (SearchTaggedData(&_nIndex, _tkTagToken[_axis]))
			MatchTaggedData(_nIndex, _tkTagToken[_axis]);
	}
	if (SearchTaggedData(&_nIndex, TK_ADR_P))
		MatchTaggedData(_nIndex, TK_ADR_P);

	return;
}

void CBlockMaker::G903(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_G, 903);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 903);
	UNREFERENCED_PARAMETER(pTaggedData_);
}

void CBlockMaker::G904(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 904);
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);

	static const token_t _tkTagToken[][4] =
	{
		{TK_ADR_FX, TK_ADR_PX, TK_ADR_LX, TK_ADR_X},
		{TK_ADR_FY, TK_ADR_PY, TK_ADR_LY, TK_ADR_Y},
		{TK_ADR_FZ, TK_ADR_PZ, TK_ADR_LZ, TK_ADR_Z},
	};

	for (int _loop = 0; _loop < 3; _loop++)
	{
		int _nIndex;
		if (SearchTaggedData(&_nIndex, _tkTagToken[_loop][0]))
		{
			MatchTaggedData(_nIndex, _tkTagToken[_loop][0]);

			if (!SearchTaggedData(&_nIndex, _tkTagToken[_loop][1]))
				throw(_GETCS(s_szERROR_G904_ERROR_MISSADDR));
			MatchTaggedData(_nIndex, _tkTagToken[_loop][1]);

			if (!SearchTaggedData(&_nIndex, _tkTagToken[_loop][2]))
				throw(_GETCS(s_szERROR_G904_ERROR_MISSADDR));
			MatchTaggedData(_nIndex, _tkTagToken[_loop][2]);

			if (SearchTaggedData(&_nIndex, _tkTagToken[_loop][3]))
				MatchTaggedData(_nIndex, _tkTagToken[_loop][3]);
		}
	}

	return;
}

void CBlockMaker::G905(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 905);
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);
}

void CBlockMaker::SyncPos(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_SYNCPOS);
	ASSERT(pTaggedData_->m_nValue == -1);
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);
}

void CBlockMaker::G906(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 906);
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);

	int _nIndex = 0;

	//ȴʱ䣬λΪ
	if (SearchTaggedData(&_nIndex, TK_ADR_P))
	{
		MatchTaggedData(_nIndex, TK_ADR_P);

		//Ҷ˿ں
		if (!SearchTaggedData(&_nIndex, TK_ADR_PLC))
		{
			m_strTemp.Format(_GETCS(s_szERROR_NOENOUGHPARAMETERS), "G906");
			throw(m_strTemp);
		}
		MatchTaggedData(_nIndex, TK_ADR_PLC);

		//˿ڵƽֵ
		if (!SearchTaggedData(&_nIndex, TK_ADR_LEVEL))
		{
			m_strTemp.Format(_GETCS(s_szERROR_NOENOUGHPARAMETERS), "G906");
			throw(m_strTemp);
		}
		MatchTaggedData(_nIndex, TK_ADR_LEVEL);
	}
}

void CBlockMaker::G907(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_G, 907);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 907);
	UNREFERENCED_PARAMETER(pTaggedData_);
	return;
}

void CBlockMaker::G908(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_G, 908);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 908);
	UNREFERENCED_PARAMETER(pTaggedData_);
	return;
}

void CBlockMaker::G925_G926(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	int _nGNumber = (int) pTaggedData_->m_nValue;
	ASSERT(_nGNumber == 925 || _nGNumber == 926);

	MatchTaggedData(TK_ADR_G, _nGNumber);
}

// wudian 2010.07.20
void CBlockMaker::M0_M1(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	int _nNumber = int(pTaggedData_->m_nValue);
	ASSERT(_nNumber == 0 || _nNumber == 1);
	MatchTaggedData(TK_ADR_M, pTaggedData_->m_nValue);
	UNREFERENCED_PARAMETER(pTaggedData_);

	//洢ֹͣϢM0Ϊcvt_m0M1Ϊcvt_m1---  2010.3.19
	cvt::CCvtUnit* _pCCvtUnit = new cvt::CCvtUnit;
	if (_nNumber == 0)
		_pCCvtUnit->m_nType = cvt::cvt_m0;
	else
		_pCCvtUnit->m_nType = cvt::cvt_m1;
	ListUnits.push_back(_pCCvtUnit);
}

// ָӦýӹ񣬲ļָָļͷ
void CBlockMaker::M2_M30(CTaggedData* pTaggedData_)
{
	//ǲǸðŵASSERT wudian 2010.07.20
	MatchTaggedData(TK_ADR_M, pTaggedData_->m_nValue);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	ASSERT(2 == pTaggedData_->m_nValue || 30 == pTaggedData_->m_nValue);

	//洢ֹͣϢM2Ϊcvt_m2M1Ϊcvt_m30---  2010.3.19
	cvt::CCvtUnit* _pCCvtUnit = new cvt::CCvtUnit;
	if (pTaggedData_->m_nValue == 2)
		_pCCvtUnit->m_nType = cvt::cvt_m2;
	else
		_pCCvtUnit->m_nType = cvt::cvt_m30;
	ListUnits.push_back(_pCCvtUnit);

	// 쳣ֹͣ
	THROW("");
}

void CBlockMaker::M3_M4_M5(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_M, pTaggedData_->m_nValue);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	int _nNumber = (int)pTaggedData_->m_nValue;
	ASSERT(3 == _nNumber || _nNumber == 4 || _nNumber == 5);

	//תֹͣȡ
	cvt::CCvtSpindleAct* _pSpindleAct = new cvt::CCvtSpindleAct;
	if (_nNumber == 3)
		_pSpindleAct->m_nSpindleAction = cvt::Spindleaction_Clock;
	else if (_nNumber == 4)
		_pSpindleAct->m_nSpindleAction = cvt::Spindleaction_antiClock;
	else
		_pSpindleAct->m_nSpindleAction = cvt::Spindleaction_stop;
	ListUnits.push_back(_pSpindleAct);
}

//õTransform.hеݣûŪ wudian 2010.07.20
void CBlockMaker::M17_M99(CTaggedData* pTaggedData_)
{
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	ASSERT(pTaggedData_->m_nValue == 17 || pTaggedData_->m_nValue == 99);

	//洢ӳ򷵻Ϣ---  2010.3.19
	cvt::CCvtUnit* _pCCvtUnit = new cvt::CCvtUnit;
	if (pTaggedData_->m_nValue == 17)
		_pCCvtUnit->m_nType = cvt::cvt_m17;
	else
		_pCCvtUnit->m_nType = cvt::cvt_m99;
	ListUnits.push_back(_pCCvtUnit);

	StackItem _si;
	if (!m_Stack.Pop(&_si))
		return;

	if (_si.siLoop == 1)
	{
		if (_si.siMode == StackItem::CIRCYC)
		{
			throw("Don't Support Circyc now");
			//	SFC_ProcStack(&_si);
		}
		else
		{
			ASSERT (_si.siMode == StackItem::NORMAL);
			m_Parser.m_TokenAnalyser.SetPosition(_si.siPos);
		}
	}
	else
	{
		ASSERT(_si.siLoop > 0);
		_si.siLoop--;
		m_Stack.Push(_si);

		long _pos;
		if (_si.siProgNo > 0)
			_pos = GetSubProg(_si.siProgNo);
		else
			_pos = GetSubProg(_si.siProgName);
		ASSERT(_pos >= 0);
		m_Parser.m_TokenAnalyser.SetPosition(_pos);
	}
}

void CBlockMaker::M801(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_M, 801);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	ASSERT(pTaggedData_->m_nValue == 801);
	UNREFERENCED_PARAMETER(pTaggedData_);

	int _nIndex;
	if (!SearchTaggedData(&_nIndex, TK_ADR_MSG))
	{
		m_strTemp.Format(_GETCS(s_szERROR_NOENOUGHPARAMETERS), "M801");
		throw(m_strTemp);
	}

	MatchTaggedData(_nIndex, TK_ADR_MSG);
}

void CBlockMaker::M802(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_M, 802);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	ASSERT(pTaggedData_->m_nValue == 802);
	UNREFERENCED_PARAMETER(pTaggedData_);

	int _nIndex;
	if (!SearchTaggedData(&_nIndex, TK_ADR_P))
	{
		m_strTemp.Format(_GETCS(s_szERROR_NOENOUGHPARAMETERS), "M802");
		throw(m_strTemp);
	}
	MatchTaggedData(_nIndex, TK_ADR_P);
}

void CBlockMaker::M901(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_M, 901);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	ASSERT(pTaggedData_->m_nValue == 901);
	UNREFERENCED_PARAMETER(pTaggedData_);

	int _nIndex;
	if (!SearchTaggedData(&_nIndex, TK_ADR_PLC))
	{
		m_strTemp.Format(_GETCS(s_szERROR_NOENOUGHPARAMETERS), "M901");
		throw(m_strTemp);
	}
	MatchTaggedData(_nIndex, TK_ADR_PLC);

	_nIndex;
	if (!SearchTaggedData(&_nIndex, TK_ADR_LEVEL))
	{
		m_strTemp.Format(_GETCS(s_szERROR_NOENOUGHPARAMETERS), "M901");
		throw(m_strTemp);
	}
	MatchTaggedData(_nIndex, TK_ADR_LEVEL);
}

void CBlockMaker::M902(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_M, 902);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	ASSERT(pTaggedData_->m_nValue == 902);
	UNREFERENCED_PARAMETER(pTaggedData_);

	int _nIndex;
	if (!SearchTaggedData(&_nIndex, TK_ADR_H))
	{
		m_strTemp.Format(_GETCS(s_szERROR_NOENOUGHPARAMETERS), "M902");
		throw(m_strTemp);
	}

	MatchTaggedData(_nIndex, TK_ADR_H);
}

void CBlockMaker::M903(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_M, 903);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	ASSERT(pTaggedData_->m_nValue == 903);
	UNREFERENCED_PARAMETER(pTaggedData_);

	int _nIndex;
	if (!SearchTaggedData(&_nIndex, TK_ADR_H))
	{
		m_strTemp.Format(_GETCS(s_szERROR_NOENOUGHPARAMETERS), "M903");
		throw(m_strTemp);
	}
	MatchTaggedData(_nIndex, TK_ADR_H);
}

void CBlockMaker::M904_M905(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	ASSERT(pTaggedData_->m_nValue == 904 || pTaggedData_->m_nValue == 905);

	MatchTaggedData(TK_ADR_M, pTaggedData_->m_nValue);
	return;
}

void CBlockMaker::G927(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 927);

	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);
}

//ȡGļеϢCVT 
void CBlockMaker::SpindleRev(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_S, pTaggedData_->m_nValue);
	m_ModalData.m_nSpindleRev = int(pTaggedData_->m_nValue);

	cvt::CCvtSpindleRev* _pSpindleRev = new cvt::CCvtSpindleRev;

	_pSpindleRev->m_nSpindleRev = int(pTaggedData_->m_nValue);

	ListUnits.push_back(_pSpindleRev);
}

void CBlockMaker::GInvalid(CTaggedData* pTaggedData_)
{
	int _nIndex;
	SearchTaggedData(&_nIndex, TK_ADR_G);
	MatchTaggedData(_nIndex, TK_ADR_G);
	m_strTemp.Format(_GETCS(s_szERROR_INVALID_GCODE), pTaggedData_->m_nValue);
	throw(m_strTemp);
}

void CBlockMaker::MInvalid(CTaggedData* pTaggedData_)
{
	int _nIndex;
	SearchTaggedData(&_nIndex, TK_ADR_M);
	MatchTaggedData(_nIndex, TK_ADR_M);
	int _nValue = (int) pTaggedData_->m_nValue;
	m_strTemp.Format(_GETCS(s_szERROR_INVALID_MCODE), _nValue);
	//PARSEENGINEWARNING(m_strTemp);
}

void CBlockMaker::GUnknown(CTaggedData* pTaggedData_)
{
	int _nIndex;
	SearchTaggedData(&_nIndex, TK_ADR_G);
	MatchTaggedData(_nIndex, TK_ADR_G);
	return;
}

void CBlockMaker::MUnknown(CTaggedData* pTaggedData_)
{
	int _nIndex;
	SearchTaggedData(&_nIndex, TK_ADR_M);
	MatchTaggedData(_nIndex, TK_ADR_M);
}

void CBlockMaker::Comment(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_ && pTaggedData_->m_nToken == TK_ADR_COMMENT);
	ASSERT(pTaggedData_->m_pszValue && pTaggedData_->m_pszValue[0]);

	cvt::CCvtComment* _pComment = new cvt::CCvtComment;
	strcpy_s(_pComment->m_szText, pTaggedData_->m_pszValue);
	ListUnits.push_back(_pComment);
}

void CBlockMaker::MatchComment(CTaggedData* pTaggedData_)
{
}

void CBlockMaker::FixedCycle(CTaggedData* pTaggedData_)
{
	ASSERT(int(pTaggedData_->m_nValue) != 80);

	int _nIndex;
	if (SearchTaggedData(&_nIndex, TK_ADR_G))
	{
		int _nGNumber = (int)pTaggedData_->m_nValue;
		MatchTaggedData(TK_ADR_G, _nGNumber);
	}

	FC_RetrieveInf(pTaggedData_);

	return;
}

void CBlockMaker::G34_G36(CTaggedData* pTaggedData_)
{
	ASSERT(NULL != pTaggedData_);
	SFC_RetrieveInf(pTaggedData_);
	return;
}

void CBlockMaker::G35(CTaggedData* pTaggedData_)
{
	ASSERT(NULL != pTaggedData_);
	SFC_RetrieveInf(pTaggedData_);
	return;
}

void CBlockMaker::G37(CTaggedData* pTaggedData_)
{
	ASSERT(NULL != pTaggedData_);
	SFC_RetrieveInf(pTaggedData_);
	return;
}

void CBlockMaker::SFC_RetrieveInf(CTaggedData* pTaggedData_)
{
	ASSERT(NULL != pTaggedData_);
	int _nG_Number = (int) pTaggedData_->m_nValue;
	ASSERT(TK_ADR_G == pTaggedData_->m_nToken && (_nG_Number > 33 && _nG_Number < 38));
	MatchTaggedData(TK_ADR_G, _nG_Number);

	// Type
	const static _SFC_Item::_SFCTYPE _s_sfcType[] = 
	{
		_SFC_Item::SFC_34,
		_SFC_Item::SFC_35,
		_SFC_Item::SFC_36,
		_SFC_Item::SFC_37,
	};
	m_SpecialFixCyc.m_nType = _s_sfcType[_nG_Number - 34];

	struct _TokenValue
	{
		token_t nToken;
		double* pValue;
	};
	_TokenValue* _pTVTable = NULL;
	int _nSize = 0;

	switch(m_SpecialFixCyc.m_nType)
	{
	case _SFC_Item::SFC_34: 
		{
			_TokenValue _s_TV34[] =
			{
				{TK_ADR_I, &m_SpecialFixCyc.m_G34.nRadius},
				{TK_ADR_J, &m_SpecialFixCyc.m_G34.nStartAngle},
				{TK_ADR_K, &m_SpecialFixCyc.m_G34.nCount},
			};
			_pTVTable = (_TokenValue*)_alloca(sizeof(_s_TV34));
			memcpy(_pTVTable, _s_TV34, sizeof(_s_TV34));
			_nSize = _countof(_s_TV34);
		}
		break;

	case _SFC_Item::SFC_35: 
		{
			_TokenValue _s_TV35[] =
			{
				{TK_ADR_I, &m_SpecialFixCyc.m_G35.nStep},
				{TK_ADR_J, &m_SpecialFixCyc.m_G35.nAngle},
				{TK_ADR_K, &m_SpecialFixCyc.m_G35.nCount},
			};
			_pTVTable = (_TokenValue*)_alloca(sizeof(_s_TV35));
			memcpy(_pTVTable, _s_TV35, sizeof(_s_TV35));
			_nSize = _countof(_s_TV35);
		}
		break;

	case _SFC_Item::SFC_36: 
		{
			_TokenValue _s_TV36[] =
			{
				{TK_ADR_I, &m_SpecialFixCyc.m_G36.nRadius},
				{TK_ADR_J, &m_SpecialFixCyc.m_G36.nStartAngle},
				{TK_ADR_P, &m_SpecialFixCyc.m_G36.nStep},
				{TK_ADR_K, &m_SpecialFixCyc.m_G36.nCount},
			};
			_pTVTable = (_TokenValue*)_alloca(sizeof(_s_TV36));
			memcpy(_pTVTable, _s_TV36, sizeof(_s_TV36));
			_nSize = _countof(_s_TV36);
		}
		break;

	case _SFC_Item::SFC_37: 
		{
			_TokenValue _s_TV37[] =
			{
				{TK_ADR_I, &m_SpecialFixCyc.m_G37.nStepX},
				{TK_ADR_P, &m_SpecialFixCyc.m_G37.nCountX},
				{TK_ADR_J, &m_SpecialFixCyc.m_G37.nStepY},
				{TK_ADR_K, &m_SpecialFixCyc.m_G37.nCountY},
			};
			_pTVTable = (_TokenValue*)_alloca(sizeof(_s_TV37));
			memcpy(_pTVTable, _s_TV37, sizeof(_s_TV37));
			_nSize = _countof(_s_TV37);
		}
		break;

	default:
		ASSERT(false);
		break;
	}

	for (int _i = 0; _i < _nSize; _i++)
	{
		int _nIndex;
		if(SearchTaggedData(&_nIndex, _pTVTable[_i].nToken))
			MatchTaggedData(_nIndex, _pTVTable[_i].nToken);
		else
			throw(_GETCS(s_szERROR_SPECIAL_CIRCLE_CYCLE_FORMAT));
	}

	return;
}

void CBlockMaker::FC_RetrieveInf(CTaggedData* pTaggedData_)
{
	const token_t _s_tkpCoors[] = 
	{
		TK_ADR_X,
		TK_ADR_Y,
		TK_ADR_Z,
		TK_ADR_R,
	};

	int _i, _size;
	for (_i = 0, _size = _countof(_s_tkpCoors); _i < _size; _i++)
	{
		token_t _tkCur = _s_tkpCoors[_i];

		int _nIndex = -1;
		// Find them out successfully 
		if (SearchTaggedData(&_nIndex, _tkCur)) 
			MatchTaggedData(_nIndex, _tkCur);
	}

	// 2. Times
	const token_t _s_tkpTimes[] = 
	{
		TK_ADR_L,	
		TK_ADR_K,	
	};
	for (_i = 0, _size = _countof(_s_tkpTimes); _i < _size; _i++)
	{
		token_t _tkCur = _s_tkpTimes[_i];

		int _nIndex = -1;
		if (SearchTaggedData(&_nIndex, _tkCur))
			MatchTaggedData(_nIndex, _tkCur);
	}

	// 3. Other information
	const token_t _s_tkpCommon[] = 
	{
		TK_ADR_Q,
		TK_ADR_P,
		TK_ADR_F,
		TK_ADR_I,
		TK_ADR_J,
	};
	for (_i = 0, _size = _countof(_s_tkpCommon); _i < _size; _i++)
	{
		token_t _tkCur = _s_tkpCommon[_i];
		int _nIndex = -1;
		if (SearchTaggedData(&_nIndex, _tkCur))
		{
			MatchTaggedData(_nIndex, _tkCur);
		}
	}

	return;
}

void CBlockMaker::G7(CTaggedData* pTaggedData_)
{
	/////////////////////////////////////////////////////////////////
	// When deal with NORM Rule instruction,
	// The PRE instruction were disappeared all,
	// Only POST && NORM are all right.
	if (TK_ADR_G == pTaggedData_->m_nToken)
	{
		int _nGNumber = (int) pTaggedData_->m_nValue;
		MatchTaggedData(TK_ADR_G, _nGNumber);
	}

	RetrieveDestPosition();

	m_ptCurPos = m_ptDestPos;
	return;
}

// Section transform: 
void CBlockMaker::_StoreZoomInf(CTaggedData* pTaggedData_)
{
	UNREFERENCED_PARAMETER(pTaggedData_);
	CZoomTransform* _pZoomTrans = new CZoomTransform;
	_pZoomTrans->m_ptCenterOrig = m_ptCurPosOrig;

	static const token_t _tkTagToken[] =
	{
		TK_ADR_X, TK_ADR_I, 
		TK_ADR_Y, TK_ADR_J, 
		TK_ADR_Z, TK_ADR_K,
	};

	DPOINT3 _nxCurPos = m_ptCurPosOrig;
	int _nIndex;
	//ȡĺű wangwenbo 2010.03.18
	if (SearchTaggedData(&_nIndex, TK_ADR_P))
	{
		MatchTaggedData(_nIndex, TK_ADR_P);
		double _nAspect = m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
		if (_nAspect == 0.)
			throw(_GETCS(s_szERROR_G51_ZERO_ZOOM_ASPECT));

		for (int _loop = 0; _loop < 3; _loop++)
		{
			if (SearchTaggedData(&_nIndex, _tkTagToken[_loop * 2]))
			{
				MatchTaggedData(_nIndex, _tkTagToken[_loop * 2]);
				double _nTemp = m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue;

				if (SearchTaggedData(&_nIndex, _tkTagToken[_loop * 2 + 1]))
					throw(_GETCS(s_szERROR_G51_INSTRUCTION));

				_pZoomTrans->m_ptAspect[_loop] = double(_nAspect);

				_nTemp = TranslateToMM(_nTemp, _loop);
				_SetOrigCoorToDestination(_pZoomTrans->m_ptCenterOrig, double(_nTemp), _loop);
			}
		}
	}
	else
	{
		for (int _loop = 0; _loop < 3; _loop++)
		{
			//ֱȡĺű wangwenbo 2010 03 18
			if (SearchTaggedData(&_nIndex, _tkTagToken[_loop * 2]))
			{
				MatchTaggedData(_nIndex, _tkTagToken[_loop * 2]);
				double _nTemp = m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
				_nTemp = TranslateToMM(_nTemp, _loop);
				_SetOrigCoorToDestination(_pZoomTrans->m_ptCenterOrig, double(_nTemp), _loop);

				try
				{
					_nIndex = MatchTaggedData(_tkTagToken[_loop * 2 + 1]);
					_pZoomTrans->m_ptAspect[_loop] = double(m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue);
				}
				catch (...)
				{
					throw(_GETCS(s_szERROR_G51_INSTRUCTION));
				}
			}
		}
	}

	// Transform at first then add it to transform queue 
	_Transform(_pZoomTrans->m_ptCenterOrig, _pZoomTrans->m_ptCenter);
	_pZoomTrans->m_bIsValidCenter = true;

	m_arrPTransform.Add(_pZoomTrans);

	return;
}

// m_ptCentre of revolving is the original machine coordinate, NO zoom, NO revolve 
void CBlockMaker::_StoreRevInf(CTaggedData* pTaggedData_)
{
	UNREFERENCED_PARAMETER(pTaggedData_);
	CRevTransform* _pRevTrans = new CRevTransform;
	_pRevTrans->m_ptCenterOrig = m_ptCurPosOrig;
	_pRevTrans->m_nPlane = m_ModalData.m_nPlane;

	static const token_t _tkTagToken[] =
	{
		TK_ADR_X, 
		TK_ADR_Y,
		TK_ADR_Z,
		TK_ADR_R,
	};
	int _nIndex;
	for (int _i = 0, _size = _countof(_tkTagToken); _i < _size; _i++)
	{
		if (SearchTaggedData(&_nIndex, _tkTagToken[_i]))
		{
			MatchTaggedData(_nIndex, _tkTagToken[_i]);
			double _nTemp = m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue;

			if (TK_ADR_R == _tkTagToken[_i])
			{
				// Revolving angle, original unit is degree
				_pRevTrans->m_nAngle = DEGREE2RADIAN(_nTemp);

				// Check whether MirrorTransform exist 
				// There is one MirrorTransform at most
				CMirrorTransform* _pMirrorTrans = NULL;
				for (_i = 0; _i < m_arrPTransform.GetSize(); ++_i)
				{
					if (m_arrPTransform[_i]->m_nTransformType == CTransform::TF_MIRROR)
					{
						ASSERT(!_pMirrorTrans);
						_pMirrorTrans = (CMirrorTransform*)m_arrPTransform[_i];
#ifdef NDEBUG
						break;
#endif
					}
				}

				if (_pMirrorTrans)
					_pRevTrans->m_nAngle *= -1.;

				continue;
			}

			_nTemp = TranslateToMM(_nTemp, _i);
			_SetOrigCoorToDestination(_pRevTrans->m_ptCenterOrig, double(_nTemp), _i);
		}
	}

	_Transform(_pRevTrans->m_ptCenterOrig, _pRevTrans->m_ptCenter);
	_pRevTrans->m_bIsValidCenter = true;
	m_arrPTransform.Add(_pRevTrans);

	return;
}

void CBlockMaker::_StoreMirrorInf(CTaggedData* pTaggedData_)
{
	UNREFERENCED_PARAMETER(pTaggedData_);
	INT_PTR _nSize = m_arrPTransform.GetSize();
	int _i;
	for (_i = 0; _i < _nSize; ++_i)
	{
		if (m_arrPTransform[_i]->m_nTransformType != CTransform::TF_MIRROR)
		{
			throw(_GETCS(s_szERROR_G51_1_NOT1ST_TRANSFORM));
			return; // Not arrive here until implement of ErrorHandler() was changed
		}
	}

	bool _bOverWrite = (_nSize != 0);
	CMirrorTransform* _pMirrorTrans = NULL;
	if (_bOverWrite)
	{
		ASSERT(m_arrPTransform[_nSize - 1]->m_nTransformType == CTransform::TF_MIRROR);
		_pMirrorTrans = (CMirrorTransform*)m_arrPTransform[_nSize - 1];
	}
	else
	{
		_pMirrorTrans = new CMirrorTransform;
		_pMirrorTrans->m_ptCenterOrig = m_ptCurPosOrig;
	}

	static const token_t _tkTagToken[] =
	{
		TK_ADR_X, 
		TK_ADR_Y,
		TK_ADR_Z,
	};
	int _nIndex;
	for (_i = 0, _nSize = _countof(_tkTagToken); _i < _nSize; _i++)
	{
		if (SearchTaggedData(&_nIndex, _tkTagToken[_i]))
		{
			MatchTaggedData(_nIndex, _tkTagToken[_i]);
			double _nTemp = m_Parser.m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
			_nTemp = TranslateToMM(_nTemp, _i);
			_SetOrigCoorToDestination(_pMirrorTrans->m_ptCenterOrig, double(_nTemp), _i);
			_pMirrorTrans->m_bxMirror[_i] = true;
		}
	}

	_pMirrorTrans->m_bIsValidCenter = false;
	if (!_bOverWrite)
		m_arrPTransform.Add(_pMirrorTrans);

	return;
}

void CBlockMaker::_Transform(const DPOINT3& nxBefore_, DPOINT3& nxAfter_) const
{
	nxAfter_ = nxBefore_;

	if (0 == m_arrPTransform.GetSize())
		return;

	DPOINT3 _nxMidBefore = nxBefore_;
	DPOINT3 _nxMidAfter(0.0, 0.0, 0.0);
	for (INT_PTR _i = 0, _size = m_arrPTransform.GetSize(); _i < _size; ++_i)
	{
		CTransform* _pTransForm = m_arrPTransform[_i];

		// If current transform center is not valid, make it valid at first 
		if (!_pTransForm->m_bIsValidCenter)
		{
			DPOINT3 _nxCenterBefore = _pTransForm->m_ptCenterOrig;
			DPOINT3 _nxCenterAfter = _pTransForm->m_ptCenterOrig;
			CTransform* _pTFTemp = NULL;

			for (int _j = 0; _j < _i; ++_j)
			{
				_pTFTemp = m_arrPTransform[_j];
				ASSERT(_pTFTemp->m_bIsValidCenter);
				_pTFTemp->Transform(_nxCenterBefore, _nxCenterAfter);
				_nxCenterBefore = _nxCenterAfter;
			}

			_pTransForm->m_ptCenter = _nxCenterAfter;
			_pTransForm->m_bIsValidCenter = true;
		}

		_pTransForm->Transform(_nxMidBefore, _nxMidAfter);
		_nxMidBefore = _nxMidAfter;
	}
	nxAfter_ = _nxMidAfter;

	return;
}

void CBlockMaker::_MoveCurPosToRespPos()
{
	_Transform(m_ptDestPosOrig, m_ptDestPos);
	m_ptCurPos = m_ptDestPos;
	return;
}

bool CBlockMaker::KillNearTransform(CTransform::transform_t nType_)
{
	// Remove the lastest transform
	for (INT_PTR _size = m_arrPTransform.GetSize(), _i = _size - 1; _i >= 0; --_i)
	{
		CTransform* _pTF = m_arrPTransform[_i];
		if (_pTF->m_nTransformType != nType_)
			continue;

		// Because transforms before it has been changed
		for (INT_PTR _loop = _size - 1; _loop > _i; --_loop)
			m_arrPTransform[_loop]->m_bIsValidCenter = false;

		delete _pTF;
		m_arrPTransform.RemoveAt(_i);
		return true;
	}

	return false;
}

bool CBlockMaker::ScanCodeFileData()
{
	if (!m_Parser.m_TokenAnalyser.m_pBuffer)
	{
		return false;
	}

	m_mapSubStrProgIndex.RemoveAll();
	m_mapSubIntProgIndex.RemoveAll();

	try
	{
		const char* _pData = m_Parser.m_TokenAnalyser.m_pBuffer;
		if (!_pData)
		{
			return false;
		}
		const __int64 _nDataLength = m_Parser.m_TokenAnalyser.m_nLength;
		const char* _p1 = _pData;
		__int64 _count = _nDataLength;
		while (_count)
		{
			const char* _p2 = (char*)memchr(_p1, '\n', (size_t)_count);
			bool _bEnd = (NULL == _p2);
			if (_bEnd)
				_p2 = _pData + _nDataLength - 1;

			const char* _pTemp = _p1;
			while (isspace(*_pTemp) && _pTemp < _p2)
			{
				_pTemp++;
			}

			// search sub-program at this line: "O<number>"
			if (*_pTemp == 'O' || *_pTemp == 'o')
			{
				if (!AddSubProg(_pTemp, _p1))
					return false;
			}

			if (!_bEnd)
			{
				_p1 = _p2 + 1;
				_count = _nDataLength - (_p1 - _pData);
			}
			else
				break;
		}
	}
	catch (CException* e)
	{
		UNREFERENCED_PARAMETER(e);
		throw (_GETCS(s_szFORMATORVERSIONERROR));
		return false;
	}

	return true;
}

bool CBlockMaker::AddSubProg(PCSTR psz_, PCSTR p1_)
{
	ASSERT(*psz_ == 'O' || *psz_ == 'o');

	if (psz_[1] == '\"')
	{
		char _szSubName[256];

		char* _pTo = _szSubName;
		const char* _pFrom = psz_ + 2;
		while (*_pFrom && (*_pFrom != '\"') && (*_pFrom != '\n') && (*_pFrom != '\r'))
		{
			*_pTo++ = *_pFrom++; 
			if (_pTo >= (_szSubName + sizeof(_szSubName) - 1))
				break;
		}
		*_pTo = 0;

		if (!strlen(_szSubName) || (*_pFrom != '\"'))
		{
			TRACE0(_GETCS(s_szSUBPROGFORMATERROR));
			return false;
		}
		else if (GetSubProg(_szSubName) > -1)
		{
			TRACE0(_GETCS(s_szSUBPROGREPEATED));
			return false;
		}

		m_mapSubStrProgIndex[_szSubName] = p1_;
	}
	else
	{
		int _sub_no = atoi(psz_ + 1);
		// Note: 0 is a valid subprogram number
		if (GetSubProg(_sub_no) > -1)
		{
			TRACE0(_GETCS(s_szSUBPROGREPEATED));
			return false;
		}

		m_mapSubIntProgIndex[_sub_no] = p1_;
	}

	return true;
}

int CBlockMaker::GetSubProg(int sub_no_) const
{
	const char* _p = NULL;
	bool _ret = m_mapSubIntProgIndex.Lookup(sub_no_, _p) ? true : false;
	if (!_ret)
		_p = NULL;

	int _nRet = -1; 	 
	if (_p)
	{
		_nRet = (int)(_p - m_Parser.m_TokenAnalyser.m_pBuffer);
	}
	return _nRet;
}

int CBlockMaker::GetSubProg(const char* sub_name_) const
{
	const char* _p = NULL;
	bool _ret = m_mapSubStrProgIndex.Lookup(sub_name_, _p) ? true : false;
	if (!_ret)
		_p = NULL;

	int _nRet = -1; 	 
	if (_p)
	{
		_nRet = (int)(_p - m_Parser.m_TokenAnalyser.m_pBuffer);
	}
	return _nRet;
}

void CBlockMaker::MakeCall(int nSubProgNo_, int nCallTimes_)
{
	long _fp = -1;
	StackItem _si;

	_fp = GetSubProg(nSubProgNo_);
	if (_fp < 0)
		goto MAKE_CALL_ERROR;

	_si.siPos = (int)m_Parser.m_TokenAnalyser.GetPosition();
	_si.siLoop = nCallTimes_;
	_si.siProgNo = nSubProgNo_;
	m_Stack.Push(_si);

	m_Parser.m_TokenAnalyser.SetPosition(_fp);
	return;

MAKE_CALL_ERROR:
	m_strTemp.Format(_GETCS(s_szERROR_NOSUBPROGRAM_NO), nSubProgNo_);
	throw(m_strTemp);
}

// pszSubProgName_		-----	ӳ
// nCallTimes_			-----	ӳô
void CBlockMaker::MakeCall(LPCSTR pszSubProgName_, int nCallTimes_)
{
	long _fp = -1;
	StackItem _si;

	_fp = GetSubProg(pszSubProgName_);
	if (_fp < 0)
		goto MAKE_CALL_ERROR;

	_si.siPos = (int)m_Parser.m_TokenAnalyser.GetPosition();
	_si.siLoop = nCallTimes_;
	_tcsncpy_s(_si.siProgName, pszSubProgName_, sizeof(_si.siProgName) - 1);
	m_Stack.Push(_si);

	m_Parser.m_TokenAnalyser.SetPosition(_fp);
	return;

MAKE_CALL_ERROR:
	m_strTemp.Format(_GETCS(s_szERROR_NOSUBPROGRAM_NAME), pszSubProgName_);
	throw(m_strTemp);
}
