#include "stdafx.h"
#include "ParserModuleHeader.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

using namespace NcInterpAxes3;

// гǶʡGֵַ£ӦĵַֿƵGб
// ʡԵGַĿǰG 0, 1, 2, 3, 7, 73, 74, 76, 81, 82, 83, 84, 85, 86, 87, 88, 89
// m_pParserModule->m_ModalData.m_nGNumberʾ±ڼЧԡ
//
// УV8V9Ļ޸ĹָУ
// TK_ADR_HԭӦ{TK_ADR_H, 7, -1}˵G7ָвHG43G49M902M903һʵбMatch
// TK_ADR_I/TK_ADR_JԭӦ{TK_ADR_I, 2, 3, 76, -1}˵G76ĸʽвI,JG76 X_Y_Z_R_Q_P_F_K_
// TK_ADR_PԭӦ{TK_ADR_P,	74, 76, 82, 84, 89, -1}ζſͬһλظףͣʱ䲻ͬͬG87G88֧
const int CGCodeSemanticAnalyser::m_MatchGScope[][32] =
{
	{TK_ADR_FIRST, -1},
	{TK_ADR_A, -1},
	{TK_ADR_B, -1},
	{TK_ADR_C, -1},
	{TK_ADR_D, -1},
	{TK_ADR_E, -1},
	{TK_ADR_F, -1},
	{TK_ADR_G, -1},
	{TK_ADR_H, -1},
	{TK_ADR_I,	2, 3, -1},
	{TK_ADR_J,	2, 3, -1},
	{TK_ADR_K,	2, 3, -1},
	{TK_ADR_L, -1},
	{TK_ADR_M, -1},
	{TK_ADR_N, -1},
	{TK_ADR_O, -1},
	{TK_ADR_P,	74, 76, 82, 84, 87, 88, 89, -1},
	{TK_ADR_Q,	73, 83, -1},
	{TK_ADR_R,	2, 3, -1},
	{TK_ADR_S, -1},
	{TK_ADR_T, -1},
	{TK_ADR_U, -1},
	{TK_ADR_V, -1},
	{TK_ADR_W, -1},
	{TK_ADR_X,	0, 1, 2, 3, 7, 73, 74, 76, 81, 82, 83, 84, 85, 86, 87, 88, 89, -1},
	{TK_ADR_Y,	0, 1, 2, 3, 7, 73, 74, 76, 81, 82, 83, 84, 85, 86, 87, 88, 89, -1},
	{TK_ADR_Z,	0, 1, 2, 3, 7, 73, 74, 76, 81, 82, 83, 84, 85, 86, 87, 88, 89, -1},
	{TK_ADR_FX, -1},
	{TK_ADR_FY, -1},
	{TK_ADR_FZ, -1},
	{TK_ADR_FA, -1},
	{TK_ADR_FB, -1},
	{TK_ADR_FC, -1},
	{TK_ADR_LEVEL, -1},
	{TK_ADR_LX, -1},
	{TK_ADR_LY, -1},
	{TK_ADR_LZ, -1},
	{TK_ADR_LA, -1},
	{TK_ADR_LB, -1},
	{TK_ADR_LC, -1},
	{TK_ADR_MSG, -1},
	{TK_ADR_PLC, -1},
	{TK_ADR_PX, -1},
	{TK_ADR_PY, -1},
	{TK_ADR_PZ, -1},
	{TK_ADR_PA, -1},
	{TK_ADR_PB, -1},
	{TK_ADR_PC, -1},
	{TK_ADR_SYNCPOS, -1},
	{TK_ADR_LAST, -1},
};

// NoteΪ߲ҵЧʣõĹǰߣ
const CGCodeSemanticAnalyser::rule_t CGCodeSemanticAnalyser::m_RuleList_Pre[] =
{
	// token,			value,	func
	{TK_ADR_G,			53,		&G53},
	{TK_ADR_G,			54,		&SelectWorkCoor},
	{TK_ADR_G,			55,		&SelectWorkCoor},
	{TK_ADR_G,			56,		&SelectWorkCoor},
	{TK_ADR_G,			57,		&SelectWorkCoor},
	{TK_ADR_G,			58,		&SelectWorkCoor},
	{TK_ADR_G,			59,		&SelectWorkCoor},
	{TK_ADR_G,			68,		&G68},
	{TK_ADR_G,			69,		&G69},
	
	{TK_ADR_G,			90,		&G90_G91},
	{TK_ADR_G,			91,		&G90_G91},

	{TK_ADR_G,			17,		&G17_G18_G19},
	{TK_ADR_G,			18,		&G17_G18_G19},
	{TK_ADR_G,			19,		&G17_G18_G19},
		
	{TK_ADR_G,			20,		&G20_G21_G70_G71},
	{TK_ADR_G,			21,		&G20_G21_G70_G71},
	{TK_ADR_G,			70,		&G20_G21_G70_G71},
	{TK_ADR_G,			71,		&G20_G21_G70_G71},
	
	{TK_ADR_S,			-1,		&SpindleRev},
	{TK_ADR_F,			-1,		&FeedRate},
	
	{TK_ADR_G,			98,		&G98_G99},
	{TK_ADR_G,			99,		&G98_G99},
	
	{TK_ADR_G,			40,		&G40},
	{TK_ADR_G,			41,		&G41_G42},
	{TK_ADR_G,			42,		&G41_G42},
	{TK_ADR_G,			43,		&G43_G44},
	{TK_ADR_G,			44,		&G43_G44},
	{TK_ADR_G,			49,		&G49},

	{TK_ADR_G,			50,		&G50},
	{TK_ADR_G,			51,		&G51},
	{TK_ADR_G,			50.1,	&G50_1},
	{TK_ADR_G,			51.1,	&G51_1},
		
	{TK_ADR_G,			92,		&G92},
	{TK_ADR_G,			992,	&G992},
	{TK_ADR_G,			921,	&G921},
	{TK_ADR_G,			922,	&G922},
	{TK_ADR_G,			923,	&G923},
	
	{TK_ADR_G,			905,	&G905},
	{TK_ADR_G,			907,	&G907},
	{TK_ADR_G,			908,	&G908},
	{TK_ADR_M,			0,		&M0_M1},
	{TK_ADR_M,			1,		&M0_M1},
	{TK_ADR_M,			2,		&M2_M30},
	{TK_ADR_M,			3,		&M3_M4_M5},
	{TK_ADR_M,			4,		&M3_M4_M5},
	{TK_ADR_M,			5,		&M3_M4_M5},
	{TK_ADR_M,			801,	&M801},
	{TK_ADR_M,			802,	&M802},
	{TK_ADR_M,			901,	&M901},
	{TK_ADR_M,			902,	&M902},
	{TK_ADR_M,			903,	&M903},
	{TK_ADR_M,			904,	&M904_M905},
	{TK_ADR_M,			905,	&M904_M905},
};

const CGCodeSemanticAnalyser::rule_t CGCodeSemanticAnalyser::m_RuleList_Normal[] =
{
	// token,		value,		func
	{TK_ADR_G,			1,		&G0_G1},
	{TK_ADR_G,			0,		&G0_G1},
	{TK_ADR_G,			2,		&G2_G3},
	{TK_ADR_G,			3,		&G2_G3},
	{TK_ADR_G,			4,		&G4},
	{TK_ADR_G,			7,		&G7},
	{TK_ADR_G,			28,		&G28},
	{TK_ADR_G,			65,		&G65_M98},

	{TK_ADR_G,			34,		&G34_G36},
	{TK_ADR_G,			35,		&G35},
	{TK_ADR_G,			36,		&G34_G36},
	{TK_ADR_G,			37,		&G37},

	{TK_ADR_G,			73,		&FixedCycle},
	{TK_ADR_G,			74,		&FixedCycle},
	{TK_ADR_G,			75,		&FixedCycle},
	{TK_ADR_G,			76,		&FixedCycle},
	{TK_ADR_G,			77,		&FixedCycle},
	{TK_ADR_G,			78,		&FixedCycle},
	{TK_ADR_G,			79,		&FixedCycle},
	{TK_ADR_G,			80,		&G80},
	{TK_ADR_G,			81,		&FixedCycle},
	{TK_ADR_G,			82,		&FixedCycle},
	{TK_ADR_G,			83,		&FixedCycle},
	{TK_ADR_G,			84,		&FixedCycle},
	{TK_ADR_G,			85,		&FixedCycle},
	{TK_ADR_G,			86,		&FixedCycle},
	{TK_ADR_G,			87,		&FixedCycle},
	{TK_ADR_G,			88,		&FixedCycle},
	{TK_ADR_G,			89,		&FixedCycle},

	{TK_ADR_G,			903,	&G903},
	{TK_ADR_G,			904,	&G904},
	{TK_ADR_G,			906,	&G906},
	{TK_ADR_G,			925,	&G925_G926},
	{TK_ADR_G,			926,	&G925_G926},
	{TK_ADR_G,          927,    &G927},
	{TK_ADR_SYNCPOS,	-1,		&SyncPos},
	{TK_ADR_G,			9,		&G9},
};

const CGCodeSemanticAnalyser::rule_t CGCodeSemanticAnalyser::m_RuleList_Post[] =
{
	{TK_ADR_X,			-1,		&MatchG},
	{TK_ADR_Y,			-1,		&MatchG},
	{TK_ADR_Z,			-1,		&MatchG},
	{TK_ADR_T,			-1,		&M6_T},
	{TK_ADR_H,			-1,		&Rule_Error},
	{TK_ADR_I,			-1,		&MatchG},
	{TK_ADR_J,			-1,		&MatchG},
	{TK_ADR_K,			-1,		&MatchG},
	{TK_ADR_L,			-1,		&Rule_Error},
	{TK_ADR_LX,			-1,		&Rule_Error},
	{TK_ADR_LY,			-1,		&Rule_Error},
	{TK_ADR_LZ,			-1,		&Rule_Error},
	{TK_ADR_M,			6,		&M6_T},
	{TK_ADR_M,			17,		&M17_M99},
	{TK_ADR_M,			98,		&G65_M98},
	{TK_ADR_M,			99,		&M17_M99},
	{TK_ADR_M,			30,		&M2_M30},
	{TK_ADR_MSG,		-1,		&Rule_Error},
	{TK_ADR_P,			-1,		&MatchG},
	{TK_ADR_PX,			-1,		&Rule_Error},
	{TK_ADR_PY,			-1,		&Rule_Error},
	{TK_ADR_PZ,			-1,		&Rule_Error},
	{TK_ADR_Q,			-1,		&MatchG},
	{TK_ADR_R,			-1,		&MatchG},
	{TK_ADR_D,			-1,		&Rule_Error},
	{TK_ADR_FX,			-1,		&Rule_Error},
	{TK_ADR_FY,			-1,		&Rule_Error},
	{TK_ADR_FZ,			-1,		&Rule_Error},
	{TK_ADR_PLC,		-1,		&Ignore},
	{TK_ADR_LEVEL,		-1,		&Ignore},
	{TK_ADR_A,			-1,		&Ignore},
	{TK_ADR_B,			-1,		&Ignore},
	{TK_ADR_C,			-1,		&Ignore},
	{TK_ADR_U,			-1,		&Ignore},
	{TK_ADR_V,			-1,		&Ignore},
	{TK_ADR_W,			-1,		&Ignore},

	{TK_ADR_G,			-1,		&GUnknown},
	{TK_ADR_M,			-1,		&MUnknown},
};

CGCodeSemanticAnalyser::CGCodeSemanticAnalyser(CParserModule* pParserModule_, const CCodeBuffer* pCodeBuffer_)
: CGCodeSyntaxAnalyser(pParserModule_, pCodeBuffer_)
, m_bIs1stMovingCode(true)
{
	// set in base-class' construction
	ASSERT(m_pInterpEngine);
	ASSERT(m_pParserModule);
#ifdef G00MOVING
	m_bCallBack = false;
	m_nCurEntityIndex = 0;
#endif

	m_FlagsForCurrentEntity.Reset();
	m_Position.nAnchorType = ANCH_FILEPOS;
	m_Position.nFilePos = 0;
	m_Position.nStatementCount = 0;

	for (int _i = 0, _size = _countof(m_MatchGScope); _i < _size; ++_i)
		ASSERT (m_MatchGScope[_i][0] - TK_ADR_FIRST == _i);
}

CGCodeSemanticAnalyser::~CGCodeSemanticAnalyser()
{
}

void CGCodeSemanticAnalyser::Reset()
{
	CGCodeSyntaxAnalyser::Reset();
	m_FlagsForCurrentEntity.Reset();
	m_bIs1stMovingCode = true;
#ifdef G00MOVING
	m_bCallBack = false;
	m_nCurEntityIndex = 0;
#endif
	m_Position.nAnchorType = ANCH_FILEPOS;
	m_Position.nFilePos = 0;
	m_Position.nStatementCount = 0;
}

// ҪʵֺļλãG룬NcCode
// -fangmin 2010/01/25
void CGCodeSemanticAnalyser::ReadCode()
{
	m_Entities.Reset();

	if (IsMainParser())
	{
		int _nFilePos = (int)GetPosition();
		m_pParserModule->m_CodePosition.nFilePos = _nFilePos;
	}
	do
	{
		if (GetPosition() >= m_nLength)
			break;

		m_Position.nFilePos = (int)GetPosition();
		m_Position.nStatementCount++;
		m_pParserModule->m_CodePosition.nStatementCount++;
		Statement();
	} while (m_Entities.GetCount() == 0);

	if (m_Entities.GetCount() > 0)
	{
#ifdef G00MOVING
		if (m_nCurEntityIndex >= m_Entities.GetCount())
			ASSERT(false);
		m_Entities.SetCurIndex(m_nCurEntityIndex);
#endif
		AnalyseEntities();
	}
}

void CGCodeSemanticAnalyser::AnalyseEntities()
{
	int _nSizeOfListOld = m_pParserModule->m_pNCCodeOutputList->GetCount();
	CFilePosition _FilePosBk = m_pParserModule->m_CodePosition;

	while (true)
	{
#ifdef G00MOVING
		m_nCurEntityIndex = m_Entities.GetCurIndex();
		AnalyseCurrentEntity();
		if (!m_Entities.MoveForWard())
		{
			m_nCurEntityIndex = 0;
			break;
		}
#else
		AnalyseCurrentEntity();
		if (!m_Entities.MoveForWard())
			break;
#endif
	}

	int _nSizeOfListNew = m_pParserModule->m_pNCCodeOutputList->GetCount();
	// ӳǰļλ
	// -fangmin 2010/01/25
	if (!m_pInterpEngine->IsTracking() && (_nSizeOfListNew == _nSizeOfListOld))
	{
		CNcFilePosition _NcFilePos(NCFCFILEPOSITION, _FilePosBk);
		m_pParserModule->AddTailCode(_NcFilePos);
	}
}

void CGCodeSemanticAnalyser::AnalyseCurrentEntity()
{
	CParserModule::_speed _SpeedOld = m_pParserModule->m_SpeedRecord.Speed;
	m_MatchedGroups.Reset();

	const rule_t* _pRule = NULL;

	CTaggedEntity& _CurEntity = m_Entities.GetCurrentEntity();
	int _nSize = _CurEntity.GetCount();
	ASSERT(_nSize > 0);

	int _i;

	// pre rule
	for (_i = 0; _i < _nSize; _i++)
	{
		if (_CurEntity[_i].m_bDeleted)
			continue;
		
		_pRule = GetRule_Pre(_CurEntity[_i].m_nToken, _CurEntity[_i].m_nValue);
		if (_pRule)
		{
			(this->*_pRule->pFunction) (&_CurEntity[_i]);
#ifdef G00MOVING
			if (m_bCallBack)
			{
				ASSERT(false);
				// ﲻӦֱʹõ,ȼߵĹ,һ㲻ӳ
				// -fangmin -2010-02-01
				m_bCallBack = false;
				return;
			}
#endif
		}
	}

	// normal rule
	for (_i = 0; _i < _nSize; _i++)
	{
		if (_CurEntity[_i].m_bDeleted)
			continue;
		
		_pRule = GetRule_Normal(_CurEntity[_i].m_nToken, _CurEntity[_i].m_nValue);
		if (_pRule)
		{
			(this->*_pRule->pFunction) (&_CurEntity[_i]);
#ifdef G00MOVING
			if (m_bCallBack)
			{
				m_bCallBack = false;
				return;
			}
#endif
		}
	}

	// post rule
	for (_i = 0; _i < _nSize; _i++)
	{
		if (_CurEntity[_i].m_bDeleted)
			continue;
		
		_pRule = GetRule_Post(_CurEntity[_i].m_nToken, _CurEntity[_i].m_nValue);
		if (_pRule)
		{
			(this->*_pRule->pFunction) (&_CurEntity[_i]);
#ifdef G00MOVING
			if (m_bCallBack)
			{
				ASSERT(false);
				// Ŀǰʹõ,ǿ֧ʹ
				// ޸G65ĵù,ʹm_nCurEntityIndexͿִָ֧
				// G01 X10; G65 P"TOORG" L1; G01 X10
				// ĿǰڸָĽG01 X10ǲִе
				// -fangmin -2010-02-01
				m_bCallBack = false;
				return;
			}
#endif
		}
		else
		{
			m_strTemp.Format(c_szERROR_UNKOWN_TOKEN,
				GetTokenAlias(_CurEntity[_i].m_nToken),
				(int) (_CurEntity[_i].m_nValue));
			ErrorHandler(m_strTemp);
		}
	}

	// G53G903G905G907G908ԱЧ
	m_FlagsForCurrentEntity.Reset();
	// G905ԱЧָԭٶ
	if(!m_pParserModule->m_SpeedRecord.bModal)
	{
		m_pParserModule->SetSpeed(_SpeedOld);
		m_pParserModule->m_SpeedRecord.bModal = true;
	}

	return;
}

// Forward rules
void CGCodeSemanticAnalyser::G0_G1(CTaggedData* pTaggedData_)
{
	if (!m_MatchedGroups.SetMatched(G_GROUP_MOVE))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	int _nGNumber = m_pParserModule->m_ModalData.GetGNumber(G_GROUP_MOVE);
	NC_FUNCTION_TAG _nTag = (_nGNumber == 1) ? NCFGLINEARINTERP : NCFGRAPIDTRAVERSE;
	if (TK_ADR_G == pTaggedData_->m_nToken)
	{
		int _nGNumberNew = (int) pTaggedData_->m_nValue;
		_nTag = (_nGNumberNew == 1) ? NCFGLINEARINTERP : NCFGRAPIDTRAVERSE;
#ifdef G00MOVING
		// 1ǷֹG00-LEAVEG00-ENTERӳк˶ָظжϣγѭ
		// -fangmin 2010-02-01
		if (m_pParserModule->m_nLastCodeTag == _nGNumber && 
			m_pParserModule->m_nLastCodeTag != _nGNumberNew)
		{
			if (m_pParserModule->m_nLastCodeTag == NCFGRAPIDTRAVERSE)
			{
				m_bCallBack = true;
				m_pParserModule->MakeCall("G00-LEAVE", 1, m_Position.nFilePos, m_nCurEntityIndex);
			}
			else if (_nGNumberNew == NCFGRAPIDTRAVERSE)
			{
				m_bCallBack = true;
				m_pParserModule->MakeCall("G00-ENTER", 1, m_Position.nFilePos, m_nCurEntityIndex);
			}
			m_pParserModule->m_nLastCodeTag = _nGNumberNew;
			if (m_bCallBack)
				return;
		}
#endif
		_nGNumber = _nGNumberNew;
		MatchTaggedData(TK_ADR_G, _nGNumber);
		m_pParserModule->ChangeModal(G_GROUP_MOVE, _nGNumber);
	}

	INTERPDOUBLE _nxStartPos = m_pParserModule->m_nxJumpPos;

	RetrieveDestPosition();
	m_pParserModule->m_nxJumpPos = m_pParserModule->m_nxDestPos;

	double _nSpeed = m_pParserModule->m_SpeedRecord.Speed.nSpeedG00;
	m_pParserModule->m_SpeedRecord.bValidG00 = true;
	if (_nGNumber == 1)
	{
		_nSpeed = m_pParserModule->m_SpeedRecord.Speed.nSpeedGxx;
		m_pParserModule->m_SpeedRecord.bValidG00 = false;
	}

	m_pParserModule->UpdateCutterCompStatus();

	CNcLine _NcLine(_nTag, _nSpeed, m_pParserModule->m_CodePosition);
	_NcLine.OrigSetStartPos(_nxStartPos);
	_NcLine.OrigSetEndPos(m_pParserModule->m_nxDestPos);
	_NcLine.m_bFrpIs100 = m_FlagsForCurrentEntity.m_bFrpIs100;
	_NcLine.m_bTrackShortCut = m_FlagsForCurrentEntity.m_bTrackShortCut;

	if (m_pParserModule->m_bRevolving && m_bIs1stMovingCode && (NCFGRAPIDTRAVERSE == _nTag))
	{
		_NcLine.m_bTrackShortCut = true;
	}
	// V9ͬĴ,ΪǷϸif˱Ϊһָ
	// m_bIs1stMovingCodeжĬûʼӹ󣬼ӹΧ֮ܳڣмĶλҪ·
	m_bIs1stMovingCode = false;
	
	m_pParserModule->AddTailCode(_NcLine);
	return;
}

//˳ʱ루G02ʱ루G03ӹԲ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G2_G3(CTaggedData* pTaggedData_)
{
	if (!m_MatchedGroups.SetMatched(G_GROUP_MOVE))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	int _nGNumber = m_pParserModule->m_ModalData.GetGNumber(G_GROUP_MOVE);
	NC_FUNCTION_TAG _nTag = (_nGNumber == 3) ? NCFGARCINTERPCCW : NCFGARCINTERPCW;
	if (TK_ADR_G == pTaggedData_->m_nToken)
	{
		int _nGNumberNew = (int) pTaggedData_->m_nValue;
		_nTag = (_nGNumberNew == 3) ? NCFGARCINTERPCCW : NCFGARCINTERPCW;
#ifdef G00MOVING
		// 1ǷֹG00-LEAVEG00-ENTERӳк˶ָظжϣγѭ
		// -fangmin 2010-02-01
		if (m_pParserModule->m_nLastCodeTag == _nGNumber && 
			m_pParserModule->m_nLastCodeTag != _nGNumberNew)
		{
			if (m_pParserModule->m_nLastCodeTag == NCFGRAPIDTRAVERSE)
			{
				m_bCallBack = true;
				m_pParserModule->MakeCall("G00-LEAVE", 1, m_Position.nFilePos, m_nCurEntityIndex);
			}
			m_pParserModule->m_nLastCodeTag = _nGNumberNew;
			if (m_bCallBack)
				return;
		}
#endif
		_nGNumber = _nGNumberNew;
		MatchTaggedData(TK_ADR_G, _nGNumber);
		m_pParserModule->ChangeModal(G_GROUP_MOVE, _nGNumber);
	}

	m_pParserModule->UpdateCutterCompStatus();
	INTERPDOUBLE _nxStartPos = m_pParserModule->m_nxJumpPos;

	RetrieveDestPosition();
	m_pParserModule->m_nxJumpPos = m_pParserModule->m_nxDestPos;

	m_pParserModule->m_SpeedRecord.bValidG00 = false;

	CNcArc _NcArc(_nTag,
		m_pParserModule->m_SpeedRecord.Speed.nSpeedGxx,
		m_pParserModule->m_CodePosition);
	try
	{
		RetrieveArcParameters(&_NcArc);
		m_pParserModule->AddTailCode(_NcArc);
	}
	catch (CEngineError pe)
	{
		throw pe;
	}

	m_bIs1stMovingCode = false;
	return;
}

//ӹ δʵ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G7(CTaggedData* pTaggedData_)
{
	if (!m_MatchedGroups.SetMatched(G_GROUP_MOVE))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	ErrorHandler(c_szERROR_DONOTSUPPORTNURBSINTERP);
	/////////////////////////////////////////////////////////////////
	// When deal with NORM Rule instruction,
	// The PRE instruction were disappeared all,
	// Only POST && NORM are all right.
	int _nGNumber = m_pParserModule->m_ModalData.GetGNumber(G_GROUP_MOVE);
	NC_FUNCTION_TAG _nTag = NCFGNURBS;
	if (TK_ADR_G == pTaggedData_->m_nToken)
	{
		_nGNumber = (int) pTaggedData_->m_nValue;
		MatchTaggedData(TK_ADR_G, _nGNumber);
		m_pParserModule->ChangeModal(G_GROUP_MOVE, _nGNumber);
	}

	INTERPDOUBLE _nxStartPos = m_pParserModule->m_nxJumpPos;

	RetrieveDestPosition();

	m_pParserModule->m_SpeedRecord.bValidG00 = false;
	m_pParserModule->m_nxJumpPos = m_pParserModule->m_nxDestPos;

	//CNcNurbs _NcNurbs(m_pInterpEngine, NCFGNURBS, m_pParserModule->m_SpeedRecord.Speed.nSpeedGxx,
	//	m_pParserModule->m_CodePosition);
	//_NcNurbs.SetStartPos(_nxStartPos);
	//_NcNurbs.SetEndPos(m_pParserModule->m_nxDestPos);
	//_NcNurbs.m_bFrpIs100 = m_FlagsForCurrentEntity.m_bFrpIs100;
	//m_pParserModule->AddTailCode(_NcNurbs);
	m_bIs1stMovingCode = false;

	return;
}

//ָͣ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G4(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 4);
	//UNREFERENCED_PARAMETER(pTaggedData_);

	if (!m_MatchedGroups.SetMatched(G_GROUP_PAUSE))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	MatchTaggedData(TK_ADR_G, 4);

	int _nIndex;
	if (!SearchTaggedData(&_nIndex, TK_ADR_P))
	{
		m_strTemp.Format(c_szERROR_NOENOUGHPARAMETERS, "G04");
		ErrorHandler(m_strTemp);
	}
	MatchTaggedData(_nIndex, TK_ADR_P);

	int _nPauseTime = (int)m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
	m_pParserModule->AddPauseCode(_nPauseTime);

	return;
}

void CGCodeSemanticAnalyser::G9(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 9);
	UNREFERENCED_PARAMETER(pTaggedData_);

	if (!m_MatchedGroups.SetMatched(G_GROUP_CORRECTPOSITION))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	MatchTaggedData(TK_ADR_G, 9);

	if (!m_pInterpEngine->IsMachining())
		return;
	if (m_pParserModule->IsJumping())
		return;

	CNcCode _NcCorrectPosition(NCFGCORRECTPOSITION,
		m_pParserModule->m_CodePosition);
	m_pParserModule->AddTailCode(_NcCorrectPosition);

	return;
}

//ȷӹƽ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G17_G18_G19(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	int _nGNumber = (int) pTaggedData_->m_nValue;
	ASSERT(_nGNumber == 17 || _nGNumber == 18 || _nGNumber == 19);

	if (!m_MatchedGroups.SetMatched(G_GROUP_PLANE))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	MatchTaggedData(TK_ADR_G, _nGNumber);
	m_pParserModule->ChangeModal(G_GROUP_PLANE, _nGNumber);
}

//ȷӹλǹƻӢ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G20_G21_G70_G71(CTaggedData* pTaggedData_)
{
	if (!m_MatchedGroups.SetMatched(G_GROUP_UNIT))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	int _nGNumber = (int) pTaggedData_->m_nValue;
	MatchTaggedData(TK_ADR_G, _nGNumber);
	m_pParserModule->ChangeModal(G_GROUP_UNIT, _nGNumber);
}

// Go to machine zero reference through middle point for specified axis.
void CGCodeSemanticAnalyser::G28(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 28);
	UNREFERENCED_PARAMETER(pTaggedData_);

	if (!m_MatchedGroups.SetMatched(G_GROUP_MOVE))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

#ifdef G00MOVING
	if (m_pParserModule->m_nLastCodeTag != NCFGRAPIDTRAVERSE)
	{
		m_bCallBack = true;
		m_pParserModule->MakeCall("G00-ENTER", 1, m_Position.nFilePos, m_nCurEntityIndex);
		m_pParserModule->m_nLastCodeTag = NCFGRAPIDTRAVERSE;
		return;
	}
#endif
	MatchTaggedData(TK_ADR_G, 28);

	INTERPBOOL _axFind(false, false, false);
	for (int _i = 0, _nIndex; _i < c_nNUMOF_AXIS; _i++)
	{
		token_t _token = c_tkAxisToken[_i];
		if (SearchTaggedData(&_nIndex, _token))
			_axFind[_i] = true;
	}

	RetrieveDestPosition();

	if (m_pParserModule->IsJumping() || m_pInterpEngine->IsTracking())
		return;

	INTERPDOUBLE _nxMidPos = m_pParserModule->m_nxDestPos;

	for (int _nAxis = 0; _nAxis < c_nNUMOF_AXIS; _nAxis++)
	{
		if (_axFind[_nAxis])
			m_pParserModule->m_nxDestPosOrig[_nAxis] = m_pParserModule->m_nxRef[_nAxis];
	}
	
	_Transform(m_pParserModule->m_nxDestPosOrig, m_pParserModule->m_nxDestPos);
	CheckWCSLimit(m_pParserModule->m_nxCurPos, m_pParserModule->m_nxDestPos);

	INTERPDOUBLE _nxEndPos = m_pParserModule->m_nxDestPos;
	
	CNcLine _NcLine(NCFGRAPIDTRAVERSE,
		m_pParserModule->m_SpeedRecord.Speed.nSpeedG00,
		m_pParserModule->m_CodePosition);
	_NcLine.OrigSetStartPos(m_pParserModule->m_nxJumpPos);
	_NcLine.OrigSetEndPos(_nxMidPos);
	m_pParserModule->m_nxJumpPos = _nxMidPos;
	_NcLine.m_bFrpIs100 = m_FlagsForCurrentEntity.m_bFrpIs100;
	m_pParserModule->AddTailCode(_NcLine);
	
	_NcLine.OrigSetStartPos(m_pParserModule->m_nxJumpPos);
	_NcLine.OrigSetEndPos(_nxEndPos);
	_NcLine.m_bFrpIs100 = m_FlagsForCurrentEntity.m_bFrpIs100;
	m_pParserModule->AddTailCode(_NcLine);
	m_pParserModule->m_nxJumpPos = _nxEndPos;
	m_bIs1stMovingCode = false;

	return;
}

//ȡ߰뾶 wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G40(CTaggedData* pTaggedData_)
{
	int _nGNumber = int(pTaggedData_->m_nValue);
	MatchTaggedData(pTaggedData_->m_nToken, _nGNumber);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(_nGNumber == 40);
	UNREFERENCED_PARAMETER(pTaggedData_);
	m_pParserModule->ChangeModal(G_GROUP_CRC, _nGNumber);
}

//߰뾶󲹳G41򵶾߰뾶ҲG42 wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G41_G42(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	int _nGNumber = (int) pTaggedData_->m_nValue;
	ASSERT(_nGNumber == 41 || _nGNumber == 42);

	if (!m_MatchedGroups.SetMatched(G_GROUP_CRC))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	MatchTaggedData(TK_ADR_G, _nGNumber);
	m_pParserModule->ChangeModal(G_GROUP_CRC, _nGNumber);

	// ָûָDʱĬʹ1ŵ
	int _nToolIndex;
	int _nIndex;
	if (SearchTaggedData(&_nIndex, TK_ADR_D))
	{
		MatchTaggedData(_nIndex, TK_ADR_D);		
		_nToolIndex = (int) m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
		if (_nToolIndex < 0 || _nToolIndex >= m_pParserModule->m_nToolLibSize)
		{
			ErrorHandler(c_szERROR_TOOLNUMBEROVERFLOW);
		}
	}
	else
	{
		_nToolIndex = 1;
		NcInterpAxes3::ShowMessage(c_szERROR_G41G42D);
	}	
	 
	CNcChangeCRC _NcChangeCRC(m_pParserModule->m_CodePosition);
	_NcChangeCRC.m_nCRCRadius = fabs(m_pParserModule->m_nToolDiameter[_nToolIndex] / 2.);
	m_pParserModule->AddTailCode(_NcChangeCRC);
}

//߳򲹳G43߳ȸ򲹳G44 wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G43_G44(CTaggedData* pTaggedData_)
{
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);

	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	int _nGNumber = (int) pTaggedData_->m_nValue;
	ASSERT(_nGNumber == 43 || _nGNumber == 44);
	UNREFERENCED_PARAMETER(pTaggedData_);

	if (!m_MatchedGroups.SetMatched(G_GROUP_CLC))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	int _nIndex;
	if (!SearchTaggedData(&_nIndex, TK_ADR_H))
	{
		m_strTemp.Format(c_szERROR_NOENOUGHPARAMETERS, "G43/G44");
		ErrorHandler(m_strTemp);
	}
	m_pParserModule->ChangeModal(G_GROUP_CLC, _nGNumber);

	MatchTaggedData(_nIndex, TK_ADR_H);
	int _nToolIndex = (int) m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
	if (_nToolIndex < 0 || _nToolIndex >= m_pParserModule->m_nToolLibSize)
	{
		ErrorHandler(c_szERROR_TOOLNUMBEROVERFLOW);
	}
	double _nLength = m_pParserModule->m_nToolLength[_nToolIndex];
	CNcChangeCLC _NcChangeCLC(m_pParserModule->m_CodePosition);
	_NcChangeCLC.m_nCLCLength = _nLength;
	m_pParserModule->AddTailCode(_NcChangeCLC);
}

//ȡ߳Ȳ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G49(CTaggedData* pTaggedData_)
{
	int _nGNumber = int(pTaggedData_->m_nValue);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(_nGNumber == 49);
	MatchTaggedData(TK_ADR_G, _nGNumber);
	m_pParserModule->ChangeModal(G_GROUP_CLC, _nGNumber);

	int _nIndex;
	if (SearchTaggedData(&_nIndex, TK_ADR_H))
		MatchTaggedData(_nIndex, TK_ADR_H);
}

//ȡ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G50(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_ && pTaggedData_->m_nToken == TK_ADR_G
		&& pTaggedData_->m_nValue == 50);
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);
	m_pParserModule->ChangeModal(G_GROUP_ZOOM, 50);
	
	if (!m_pParserModule->KillNearTransform(CTransform::TF_ZOOM))
		ErrorHandler(c_szERROR_G51_50_NOTMATCH);

	_MoveCurPosToRespPos();
	
	return;
}

//ñ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G51(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_ && pTaggedData_->m_nToken == TK_ADR_G
		&& pTaggedData_->m_nValue == 51);
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);
	if (!m_MatchedGroups.SetMatched(G_GROUP_ZOOM))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);
	m_pParserModule->ChangeModal(G_GROUP_ZOOM, 51);
	
	_StoreZoomInf(pTaggedData_);
	_MoveCurPosToRespPos();
	
	return;
}

//ȡ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G50_1(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_
		&& pTaggedData_->m_nToken == TK_ADR_G
		&& pTaggedData_->m_nValue == 50.1);
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);
	
	// Find out mirror transform
	int _size = m_pParserModule->m_arrPTransform.GetSize(); 
	if (0 == _size)
		return;

	int _i;
	CMirrorTransform* _pMirrorTrans = NULL;
	for (_i = 0; _i < _size; ++_i)
	{
		if (m_pParserModule->m_arrPTransform[_i]->m_nTransformType == CTransform::TF_MIRROR)
		{
			ASSERT(!_pMirrorTrans);
			_pMirrorTrans = (CMirrorTransform*)m_pParserModule->m_arrPTransform[_i];
		}
	}
	ASSERT(_pMirrorTrans == m_pParserModule->m_arrPTransform[0]);
	
	bool _bSucess = false;
	int _nIndex;
	for (int _i = 0; _i < c_nNUMOF_AXIS; _i++)
	{
		token_t _token = c_tkAxisToken[_i];
		if (SearchTaggedData(&_nIndex, _token))
		{
			_bSucess = true;
			MatchTaggedData(_nIndex, _token);
			_pMirrorTrans->m_bxMirror[_i] = false;
		}
	}
	
	if (!_bSucess ||
		(!_pMirrorTrans->m_bxMirror[axis::x]
		&& !_pMirrorTrans->m_bxMirror[axis::y]
		&& !_pMirrorTrans->m_bxMirror[axis::z]))
	{
		if (!m_pParserModule->KillNearTransform(CTransform::TF_MIRROR))
			ErrorHandler(c_szERROR_G51D1_50D1_NOTMATCH);
	}
	
	_MoveCurPosToRespPos();
}

//þ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G51_1(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_ && pTaggedData_->m_nToken == TK_ADR_G
		&& pTaggedData_->m_nValue == 51.1);
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);
	
	if (!m_MatchedGroups.SetMatched(G_GROUP_MIRROR))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);
	
	_StoreMirrorInf(pTaggedData_);
	_MoveCurPosToRespPos();
	
	return;
}

//ʹûϵ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G53(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_ && pTaggedData_->m_nToken == TK_ADR_G
		&& pTaggedData_->m_nValue == 53);
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);
	UNREFERENCED_PARAMETER(pTaggedData_);
	m_FlagsForCurrentEntity.m_bUseMachineOrigin = true;
}

//ѡ񹤼ϵ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::SelectWorkCoor(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	int _nNumber = (int) pTaggedData_->m_nValue;
	ASSERT(_nNumber >= 54 && _nNumber <= 59);
	MatchTaggedData(pTaggedData_->m_nToken, _nNumber);
	m_pParserModule->m_nWorkcoorNo = _nNumber - 54;
	m_pParserModule->ChangeModal(G_GROUP_WORKCOOR, _nNumber);
}

//ӳ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G65_M98(CTaggedData* pTaggedData_)
{
	ASSERT ((pTaggedData_->m_nToken == TK_ADR_G && pTaggedData_->m_nValue == 65)
		|| (pTaggedData_->m_nToken == TK_ADR_M && pTaggedData_->m_nValue == 98));

	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);
	if (!m_MatchedGroups.SetMatched(G_GROUP_CALL))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	int _nIndex;
	if (!SearchTaggedData(&_nIndex, TK_ADR_P))
	{
		m_strTemp.Format(c_szERROR_NOENOUGHPARAMETERS, "G65/M98");
		ErrorHandler(m_strTemp);
	}
	MatchTaggedData(_nIndex, TK_ADR_P);
	int _nSubProgramNo = (int) m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
	LPCTSTR _pszSubProgramName = m_Entities.GetCurrentEntity()[_nIndex].m_pszValue;

	int _nCallingTimes = 1;
	if (SearchTaggedData(&_nIndex, TK_ADR_L))
	{
		MatchTaggedData(_nIndex, TK_ADR_L);
		_nCallingTimes = (int) m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
	}

	if (_nCallingTimes == 0)
		return;

	if (_nSubProgramNo > 0)
		m_pParserModule->MakeCall(_nSubProgramNo, _nCallingTimes);
	else
		m_pParserModule->MakeCall(_pszSubProgramName, _nCallingTimes);
}

//תܿ wangwenbo 2010.01.28
void CGCodeSemanticAnalyser::G68(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_ && pTaggedData_->m_nToken == TK_ADR_G
		&& pTaggedData_->m_nValue == 68);
	MatchTaggedData(TK_ADR_G, 68);
	if (!m_MatchedGroups.SetMatched(G_GROUP_G68G69))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);
	
	_StoreRevInf(pTaggedData_);
	_MoveCurPosToRespPos();
	
	return;
}

//תܹ wangwenbo 2010.01.28
void CGCodeSemanticAnalyser::G69(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_ && pTaggedData_->m_nToken == TK_ADR_G
		&& pTaggedData_->m_nValue == 69);
	MatchTaggedData(TK_ADR_G, 69);
	
	if (!m_pParserModule->KillNearTransform(CTransform::TF_REV))
		ErrorHandler(c_szERROR_G68_69_NOTMATCH);

	_MoveCurPosToRespPos();
	
	return;
}

//ȡ̶ѭ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G80(CTaggedData* pTaggedData_)
{
	ASSERT(int(pTaggedData_->m_nValue) == 80);
	MatchTaggedData(TK_ADR_G, 80);
	m_pParserModule->ChangeModal(G_GROUP_FIXEDCYCLE, 80);
}

// wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G90_G91(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	int _nGNumber = (int)pTaggedData_->m_nValue;
	ASSERT(_nGNumber == 90 || _nGNumber == 91);
	if (!m_MatchedGroups.SetMatched(G_GROUP_ABSREL))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);
	MatchTaggedData(TK_ADR_G, _nGNumber);
	m_pParserModule->ChangeModal(G_GROUP_ABSREL, _nGNumber);
}

//鵽ʼ(G98)鵽R(G99) wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G98_G99(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	int _nGNumber = (int)pTaggedData_->m_nValue;
	ASSERT(_nGNumber == 98 ||_nGNumber == 99);

	if (!m_MatchedGroups.SetMatched(G_GROUP_G98G99))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);
	MatchTaggedData(TK_ADR_G, _nGNumber);
	m_pParserModule->ChangeModal(G_GROUP_G98G99, _nGNumber);
}

// ޸ʵ,ûбҪͬ
// ԭʵּĹƫô,δǹƫ뵶ƫ,ںеʵֲһ
void CGCodeSemanticAnalyser::G92(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_G, 92);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(92 == pTaggedData_->m_nValue);

	int _nGNo = (int)pTaggedData_->m_nValue;

	if (!m_MatchedGroups.SetMatched(G_GROUP_SETWORKCOOR))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	INTERPDOUBLE _nxCurPos = m_pParserModule->m_nxJumpPos;
	int _nWorkCoorNo = m_pParserModule->m_nWorkcoorNo;
	INTERPDOUBLE _nxWorkcoorOffset = m_pParserModule->m_nxWorkcoorOffset[_nWorkCoorNo];
	INTERPDOUBLE _nxOffset = m_pParserModule->GetTempOffset(_nWorkCoorNo);
	INTERPDOUBLE _nxDelta(0., 0., 0.);
	CNcSetWorkCoor_G92 _NcSetWorkCoor_G92(m_pParserModule->m_CodePosition);
	int _nIndex;
	for (int _axis = axis::x; _axis < c_nNUMOF_AXIS; ++_axis)
	{
		token_t _token = c_tkAxisToken[_axis];
		if (SearchTaggedData(&_nIndex, _token))
		{
			MatchTaggedData(_nIndex, _token);
			double _nValue = m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
			_NcSetWorkCoor_G92.m_nxCoordinate[_axis] = _nValue;
			_nxOffset[_axis] = 0.;
			m_pParserModule->m_nxWorkcoorOffset[_nWorkCoorNo][_axis] =
				_nxCurPos[_axis] - _nValue -
				m_pParserModule->m_nxPublicOffset[_axis] -
				m_pParserModule->m_nxToolOffset[_axis];
			_nxDelta[_axis] = m_pParserModule->m_nxWorkcoorOffset[_nWorkCoorNo][_axis] - _nxWorkcoorOffset[_axis];
		}
	}
	for (int _i = CCoorManager::WORKCOOR_G54; _i < CCoorManager::c_nNUMOF_WPCOOR; _i++)
	{
		if (_i == _nWorkCoorNo)
			continue;
		m_pParserModule->m_nxWorkcoorOffset[_i] += _nxDelta;
	}
	m_pParserModule->AddTailCode(_NcSetWorkCoor_G92);
	m_pParserModule->SetTempOffset(_nxOffset, _nWorkCoorNo);

	return;
}

//ʱϵ趨 wangwenbo 2010.01.28
void CGCodeSemanticAnalyser::G992(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_G, 992);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(992 == pTaggedData_->m_nValue);

	int _nGNo = (int)pTaggedData_->m_nValue;

	if (!m_MatchedGroups.SetMatched(G_GROUP_SETWORKCOOR))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	INTERPDOUBLE _nxCurPos = m_pParserModule->m_nxJumpPos;
	int _nWorkCoorNo = m_pParserModule->m_nWorkcoorNo;
	INTERPDOUBLE _nxOffset = m_pParserModule->GetTempOffset(_nWorkCoorNo);
	for (int _axis = axis::x; _axis < c_nNUMOF_AXIS; _axis++)
	{
		token_t _tokenXYZ = c_tkAxisToken[_axis];
		token_t _tokenIJK = c_tkIJKToken[_axis];

		int _nIndex;
		if (SearchTaggedData(&_nIndex, _tokenXYZ))
		{
			MatchTaggedData(_nIndex, _tokenXYZ);
			double _nValue = m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
			double _nOriginCoor =
				m_pParserModule->m_nxWorkcoorOffset[_nWorkCoorNo][_axis] + 
				m_pParserModule->m_nxPublicOffset[_axis] + 
				m_pParserModule->m_nxToolOffset[_axis];
			_nxOffset[_axis] = _nxCurPos[_axis] - _nOriginCoor - _nValue;
		}
		else if (SearchTaggedData(&_nIndex, _tokenIJK))
		{
			MatchTaggedData(_nIndex, _tokenIJK);
			double _nValue = m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
			_nxOffset[_axis] += _nValue;
		}
	}
	m_pParserModule->SetTempOffset(_nxOffset, _nWorkCoorNo);
	return;
}

//ָǰϵǰֵ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G921(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_G, 921);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(921 == pTaggedData_->m_nValue);

	int _nGNo = (int)pTaggedData_->m_nValue;

	if (!m_MatchedGroups.SetMatched(G_GROUP_SETWORKCOOR))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	INTERPDOUBLE _nxCurPos = m_pParserModule->m_nxJumpPos;
	int _nWorkcoorNo = m_pParserModule->m_nWorkcoorNo;
	int _nToolIndex = m_pParserModule->m_nToolIndex;
	INTERPDOUBLE _nxOffset = m_pParserModule->GetTempOffset(_nWorkcoorNo);

	CNcSetWorkCoor_G921 _NcSetWorkCoor_G921(m_pParserModule->m_CodePosition);
	int _nIndex;
	for (int _axis = axis::x; _axis < c_nNUMOF_AXIS; ++_axis)
	{
		token_t _token = c_tkAxisToken[_axis];
		if (SearchTaggedData(&_nIndex, _token))
		{
			MatchTaggedData(_nIndex, _token);
			double _nValue = m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
			_NcSetWorkCoor_G921.m_nxCoordinate[_axis] = _nValue;
			_nxOffset[_axis] = 0.;
			m_pParserModule->m_nxWorkcoorOffset[_nWorkcoorNo][_axis] =
				_nxCurPos[_axis] - _nValue -
				m_pParserModule->m_nxPublicOffset[_axis] -
				m_pParserModule->m_nxToolOffset[_axis];
		}
	}
	m_pParserModule->AddTailCode(_NcSetWorkCoor_G921);
	m_pParserModule->SetTempOffset(_nxOffset, _nWorkcoorNo);
	return;
}

// ֱùƫû򹫹ƫ
void CGCodeSemanticAnalyser::G922(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_G, 922);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(922 == pTaggedData_->m_nValue);

	int _nGNo = (int)pTaggedData_->m_nValue;

	if (!m_MatchedGroups.SetMatched(G_GROUP_SETWORKCOOR))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	//// ʵַѡԸķȽϱ׾Modify later[calf]
	INTERPDOUBLE _nxCurPos = m_pParserModule->IsJumping() 
		? m_pParserModule->m_nxJumpPos 
		: m_pParserModule->m_nxCurPos;

	CNcSetWorkCoor_G922 _NcSetWorkCoor_G922(m_pParserModule->m_CodePosition);

	int _nIndex;
	for (int _axis = axis::x; _axis < c_nNUMOF_AXIS; ++_axis)
	{
		token_t _token = c_tkAxisToken[_axis];
		if (SearchTaggedData(&_nIndex, _token))
		{
			MatchTaggedData(_nIndex, _token);
			double _nValue = m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
			_NcSetWorkCoor_G922.m_nxOrg[_axis] = _nValue;
		}
	}
	if (SearchTaggedData(&_nIndex, TK_ADR_P))
	{
		MatchTaggedData(_nIndex, TK_ADR_P);
		int _nWCNo = (int)m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
		
		if (_nWCNo != CCoorManager::_WORKCOOR_CURRENT
			&& _nWCNo != CCoorManager::WORKCOOR_EXT
			&& _nWCNo != CCoorManager::WORKCOOR_G54
			&& _nWCNo != CCoorManager::WORKCOOR_G55
			&& _nWCNo != CCoorManager::WORKCOOR_G56
			&& _nWCNo != CCoorManager::WORKCOOR_G57
			&& _nWCNo != CCoorManager::WORKCOOR_G58
			&& _nWCNo != CCoorManager::WORKCOOR_G59)
		{
			ASSERT(false);
			m_strTemp.Format(c_szERROR_INVALID_WORKCOORNO, _nWCNo);
			ErrorHandler(m_strTemp);
		}

		_NcSetWorkCoor_G922.m_nWorkcoorNo = _nWCNo;
	}

	for (int _axis = axis::x; _axis < c_nNUMOF_AXIS; ++_axis)
	{
		if (IsInvalidDouble(_NcSetWorkCoor_G922.m_nxOrg[_axis]))
			continue;
		if (_NcSetWorkCoor_G922.m_nWorkcoorNo == CCoorManager::WORKCOOR_EXT)
			m_pParserModule->m_nxPublicOffset[_axis] = _NcSetWorkCoor_G922.m_nxOrg[_axis];
		else
		{
			int _nWorkcoorNo = _NcSetWorkCoor_G922.m_nWorkcoorNo;
			if (_nWorkcoorNo == CCoorManager::_WORKCOOR_CURRENT)
				_nWorkcoorNo = m_pParserModule->m_nWorkcoorNo;
			m_pParserModule->m_nxWorkcoorOffset[_nWorkcoorNo][_axis] = _NcSetWorkCoor_G922.m_nxOrg[_axis];
		}
	}	
	m_pParserModule->AddTailCode(_NcSetWorkCoor_G922);

	return;
}

// ʵϿָһдڳ󣬻ߺָͬ
void CGCodeSemanticAnalyser::G923(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_G, 923);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(923 == pTaggedData_->m_nValue);
	int _nGNo = (int)pTaggedData_->m_nValue;
	
	if (!m_MatchedGroups.SetMatched(G_GROUP_SETWORKCOOR))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	CNcSetToolOffset _NcSetToolOffset(m_pParserModule->m_CodePosition);
	int _nIndex;
	for (int _axis = axis::x; _axis < c_nNUMOF_AXIS; ++_axis)
	{
		token_t _token = c_tkAxisToken[_axis];
		if (SearchTaggedData(&_nIndex, _token))
		{
			MatchTaggedData(_nIndex, _token);
			double _nValue = m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
			_NcSetToolOffset.m_nxOffset[_axis] = _nValue;
		}
	}
	if (SearchTaggedData(&_nIndex, TK_ADR_P))
	{
		MatchTaggedData(_nIndex, TK_ADR_P);
		int _nToolIndex = (int)m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
		if (_nToolIndex < 0 || _nToolIndex >= CTool::NUMOFTOOL)
		{
			ErrorHandler(c_szERROR_TOOLNUMBEROVERFLOW);
		}
		else
		{
			_NcSetToolOffset.m_nToolNo = _nToolIndex;
		}
	}
	else
		_NcSetToolOffset.m_nToolNo = m_pParserModule->m_nToolIndex;
	m_pParserModule->AddTailCode(_NcSetToolOffset);
	
	return;
}

//ǿƽָ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G903(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_G, 903);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 903);
	UNREFERENCED_PARAMETER(pTaggedData_);
	m_FlagsForCurrentEntity.m_bFrpIs100 = true;
}

//ƶָ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G904(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 904);
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);

	if (!m_MatchedGroups.SetMatched(G_GROUP_MOVE))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	CNcConditionMoveXYZ _NcConditionMoveXYZ(m_pParserModule->m_CodePosition);
	for (int _loop = 0; _loop < c_nNUMOF_AXIS; _loop++)
	{
		int _nIndex;
		if (SearchTaggedData(&_nIndex, c_tkConditionTagToken[_loop][0]))
		{
			double _nSpeed = m_Entities.GetCurrentEntity()[_nIndex].m_nValue / 60.0;
			if (DOUBLE_EQU_ZERO(_nSpeed))
				ErrorHandler(c_szERROR_G904_SPEEDERROR);
			_NcConditionMoveXYZ.m_nxSpeed[_loop] = _nSpeed;
			MatchTaggedData(_nIndex, c_tkConditionTagToken[_loop][0]);

			if (!SearchTaggedData(&_nIndex, c_tkConditionTagToken[_loop][1]))
				ErrorHandler(c_szERROR_G904_ERROR_MISSADDR);
			MatchTaggedData(_nIndex, c_tkConditionTagToken[_loop][1]);
			_NcConditionMoveXYZ.m_nxCondIndex[_loop] = (BYTE)_round(m_Entities.GetCurrentEntity()[_nIndex].m_nValue);

			if (!SearchTaggedData(&_nIndex, c_tkConditionTagToken[_loop][2]))
				ErrorHandler(c_szERROR_G904_ERROR_MISSADDR);
			MatchTaggedData(_nIndex, c_tkConditionTagToken[_loop][2]);
			_NcConditionMoveXYZ.m_nxCondValue[_loop] = (m_Entities.GetCurrentEntity()[_nIndex].m_nValue != 0.0);

			if (SearchTaggedData(&_nIndex, c_tkConditionTagToken[_loop][3]))
			{
				MatchTaggedData(_nIndex, c_tkConditionTagToken[_loop][3]);
				double _nDist = m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
				if (DOUBLE_LESS_ZERO(_nDist))
					ErrorHandler(c_szERROR_G904_DISTERROR);
				_NcConditionMoveXYZ.m_nxDistance[_loop] = _nDist;
			}
		}
	}

	if (m_pInterpEngine->IsSimulating() || m_pInterpEngine->IsTracking())
		return;

	m_pParserModule->AddTailCode(_NcConditionMoveXYZ);

	// Sync pos automatically, so need not to change public.dat
	CNcSyncPos _NcSyncPos(m_pParserModule->m_CodePosition);
	m_pParserModule->AddTailCode(_NcSyncPos);
	return;
}

//ǿƽָ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G905(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 905);
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);
	m_FlagsForCurrentEntity.m_bForcedFeedrate = true;
	m_pParserModule->m_SpeedRecord.bModal = false;
}

//ͬλ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::SyncPos(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_SYNCPOS);
	ASSERT(pTaggedData_->m_nValue == -1);
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);

	if (!m_pInterpEngine->IsMachining())
		return;

	CNcSyncPos _NcSyncPos(m_pParserModule->m_CodePosition);
	m_pParserModule->AddTailCode(_NcSyncPos);
}

//ָͬ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::G906(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 906);
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);

	int _nIndex = 0;
	int _nPlcAddress = 0;
	bool _nPortValue = false;
	int _nWaitTime = INT_MAX;

	bool _bWaitPort = SearchTaggedData(&_nIndex, TK_ADR_PLC);
	if (_bWaitPort)
	{
		MatchTaggedData(_nIndex, TK_ADR_PLC);
		_nPlcAddress = int(m_Entities.GetCurrentEntity()[_nIndex].m_nValue);

		//˿ڵƽֵ
		if (!SearchTaggedData(&_nIndex, TK_ADR_LEVEL))
		{
			m_strTemp.Format(c_szERROR_NOENOUGHPARAMETERS, "G906");
			ErrorHandler(m_strTemp);
		}
		MatchTaggedData(_nIndex, TK_ADR_LEVEL);
		int _val = _round(m_Entities.GetCurrentEntity()[_nIndex].m_nValue);
		_nPortValue = _val ? true : false;

		if (SearchTaggedData(&_nIndex, TK_ADR_P))
		{
			MatchTaggedData(_nIndex, TK_ADR_P);
			_nWaitTime = _round(m_Entities.GetCurrentEntity()[_nIndex].m_nValue);
		}
	}

	if (!m_pInterpEngine->IsMachining())
		return;
	
	if (_bWaitPort)
	{
		CNcWaitPort _NcWaitPort(m_pParserModule->m_CodePosition);
		_NcWaitPort.m_nPlcAddress = _nPlcAddress;
		_NcWaitPort.m_bPortValue = _nPortValue;
		_NcWaitPort.m_nTimeOut = _nWaitTime;
		m_pParserModule->AddTailCode(_NcWaitPort);
	}
	else
	{
		CNcG906 _NcG906(m_pParserModule->m_CodePosition);
		m_pParserModule->AddTailCode(_NcG906);
	}
}

//·˶ָ wangwenbo 2010.01.28
void CGCodeSemanticAnalyser::G907(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_G, 907);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 907);
	UNREFERENCED_PARAMETER(pTaggedData_);
	m_FlagsForCurrentEntity.m_bTrackShortCut = true;
	return;
}

//ǿԽǶΪλ wangwenbo 2010.01.28
void CGCodeSemanticAnalyser::G908(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_G, 908);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 908);
	UNREFERENCED_PARAMETER(pTaggedData_);
	m_FlagsForCurrentEntity.m_bUnitIsDegree = true;
	return;
}

void CGCodeSemanticAnalyser::G925_G926(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	int _nGNumber = (int) pTaggedData_->m_nValue;
	ASSERT(_nGNumber == 925 || _nGNumber == 926);

	if (!m_MatchedGroups.SetMatched(G_GROUP_COUNT))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	MatchTaggedData(TK_ADR_G, _nGNumber);
	if (_nGNumber == 926)
	{
		CNcTakeCount _NcTakeCount(m_pParserModule->m_CodePosition);
		m_pParserModule->AddTailCode(_NcTakeCount);
	}
	m_pParserModule->ChangeModal(G_GROUP_COUNT, _nGNumber);
}

//ֹͣƻֹͣ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::M0_M1(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	int _nNumber = int(pTaggedData_->m_nValue);
	ASSERT(_nNumber == 0 || _nNumber == 1);
	MatchTaggedData(TK_ADR_M, pTaggedData_->m_nValue);
	UNREFERENCED_PARAMETER(pTaggedData_);
	if (!m_MatchedGroups.SetMatched(M_GROUP_PLAN))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	if (!m_pInterpEngine->IsMachining())
		return;

	if (!m_pParserModule->IsJumping())
	{
		SetPositionToNextEntity();
		CNcCode _NcStop((_nNumber == 0) ? NCFMSTOP : NCFMSTOPPLAN,
			m_pParserModule->m_CodePosition);
		m_pParserModule->AddTailCode(_NcStop);
	}
}

// ָӦýӹ񣬲ļָָļͷ
void CGCodeSemanticAnalyser::M2_M30(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_M, pTaggedData_->m_nValue);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	ASSERT(2 == pTaggedData_->m_nValue || 30 == pTaggedData_->m_nValue);
	if (!m_MatchedGroups.SetMatched(M_GROUP_ROUTINE))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	if (m_pParserModule->m_ModalData.m_bTakeCount)
	{
		// ʱӹ
		CNcTakeCount _NcTakeCount(m_pParserModule->m_CodePosition);
		m_pParserModule->AddTailCode(_NcTakeCount);
	}
	m_pParserModule->SetFinished();
}

//˳ʱתʱתֹͣ wangwenbo 2010.01.28
void CGCodeSemanticAnalyser::M3_M4_M5(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_M, pTaggedData_->m_nValue);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	int _nNumber = (int)pTaggedData_->m_nValue;
	ASSERT(3 == _nNumber || _nNumber == 4 || _nNumber == 5);
	if (!m_MatchedGroups.SetMatched(M_GROUP_PRIAXIS))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	if (!m_pInterpEngine->IsMachining())
		return;

	//if (m_pParserModule->IsJumping())
	//{
	//	m_pParserModule->m_nJumpM345 = _nNumber;
	//}
	//else
	if (!m_pParserModule->IsJumping())
	{
		m_strTemp.Format("M%d", _nNumber);
		m_pParserModule->MakeCall(m_strTemp, 1);
	}
}

// [calf, 2008/09/08]
//	ôһ: ʱЩָӦ֧֣ЩӦ֧֡
void CGCodeSemanticAnalyser::M6_T(CTaggedData* pTaggedData_)
{
	ASSERT((pTaggedData_->m_nToken == TK_ADR_M && pTaggedData_->m_nValue == 6)
		|| pTaggedData_->m_nToken == TK_ADR_T);
	UNREFERENCED_PARAMETER(pTaggedData_);

	int _nIndex;
	if (SearchTaggedData(&_nIndex, TK_ADR_M))
	{
		MatchTaggedData(_nIndex, TK_ADR_M);
	}

	int _nToolIndex = m_pParserModule->m_nToolIndex;
	if (SearchTaggedData(&_nIndex, TK_ADR_T))
	{
		_nToolIndex = (int)m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
		MatchTaggedData(_nIndex, TK_ADR_T);
	}
	
	if (_nToolIndex < 0 || _nToolIndex >= m_pParserModule->m_nToolLibSize)
	{
		ErrorHandler(c_szERROR_TOOLNUMBEROVERFLOW);
	}

	if (!m_pParserModule->IsJumping())
	{
		SetPositionToNextEntity();

		if (m_pParserModule->m_bPromptingToolChanger)
		{
			CNcSendRawString _NcSendRawString(m_pParserModule->m_CodePosition);
			_NcSendRawString.m_strString = c_szCHANGE_TOOL_MESSAGE;
			m_pParserModule->AddTailCode(_NcSendRawString);
			
			// ˴֪ͨںҪʹµĵλƫù
			CNcChangeTool _NcChangeTool(m_pParserModule->m_CodePosition);
			_NcChangeTool.m_nToolIndexNew = _nToolIndex;
			m_pParserModule->AddTailCode(_NcChangeTool);

			CNcCode _NcStop(NCFMSTOP, m_pParserModule->m_CodePosition);
			m_pParserModule->AddTailCode(_NcStop);
		}
		else
		{
			if (0 < m_pParserModule->m_pParserPublic->GetSubProg("CHANGETOOL"))
			{
				// ¾ɵ
				m_pParserModule->SetNamedVariable("#1", _nToolIndex);
				m_pParserModule->SetNamedVariable("#2", m_pParserModule->m_nToolIndex);
				
				int _nAbsolute = 1;
				if (!m_pParserModule->m_ModalData.m_bAbsolute)
					_nAbsolute = 0;
				m_pParserModule->SetNamedVariable("#3", _nAbsolute);

				m_pParserModule->MakeCall("CHANGETOOL", 1);
			}
			else
			{
				// ˴֪ͨںҪʹµĵλƫù
				CNcChangeTool _NcChangeTool(m_pParserModule->m_CodePosition);
				_NcChangeTool.m_nToolIndexNew = _nToolIndex;
				m_pParserModule->AddTailCode(_NcChangeTool);

				// ȴɣָͬ
				CNcG906 _NcG906(m_pParserModule->m_CodePosition);
				m_pParserModule->AddTailCode(_NcG906);
			}
		}
	}

	return;
}

static int s_FixedCycName[] = 
{
	'37G',
	'47G',
	'57G',
	'67G',
	'77G',
	'87G',
	'97G',
	'18G',
	'28G',
	'38G',
	'48G',
	'58G',
	'68G',
	'78G',
	'88G',
	'98G',
};

//ӳ򷵻 wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::M17_M99(CTaggedData* pTaggedData_)
{
	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	ASSERT(pTaggedData_->m_nValue == 17 || pTaggedData_->m_nValue == 99);
	if (!m_MatchedGroups.SetMatched(M_GROUP_ROUTINE))
		ErrorHandler(c_szERROR_DUPLICATE_CODE_OF_SAME_GROUP);

	StackItem _si;
	if (!m_pParserModule->m_Stack.Pop(&_si))
	{
		if (m_pParserModule->GetActiveParser() == m_pParserModule->m_pParserTask
			&& !m_pInterpEngine->IsTracking())	// ȡ켣ʱ
		{
			// ˴ΪʹM99صĿͷִ
			//	μFANUC 0i -MC ˵ (B-64124CM/01)

			if (m_pParserModule->m_ModalData.m_bTakeCount)
			{
				// ʱӹ
				CNcTakeCount _NcTakeCount(m_pParserModule->m_CodePosition);
				m_pParserModule->AddTailCode(_NcTakeCount);
			}

			// [calf, 2008/06/26]
			// ûڼӹļĩβM17ָʱڵĴЩ⣺
			//	1ǶϵǴļͷǴӶϵλÿʼӹ
			//	2ѡļӹΧֹһǷôͷ
			//	3ͬʱδ
			//	4õļͷӹΧͷϡ

			// ûڼӹļĩβM17ָʱ򣬴£
			// õļͷϣӹΧҲõļͷ
			// ԭǣѡӹļ󼸾䣬ÿηصӹΧͷϣ
			// ӹΧǰָҪļнڼӹΧڣ
			// ʵʹãô˴CPU
			// fangmin -2009.7.24
			m_pInterpEngine->m_FieldList.RemoveAll();
			__int64 _nStartFilePos = 0;
			__int64 _nEndFilePos = m_pInterpEngine->m_pCodeBuffer->GetLength();
			m_pInterpEngine->m_FieldList.AddHead(LCRO_FIELD(_nStartFilePos, _nEndFilePos));
			m_pParserModule->GetActiveParser()->Reset();
		}
		else
			m_pParserModule->SetFinished();

		return;
	}

	if (_si.siLoop == 1)
	{
		if (_si.siMode == StackItem::CIRCYC)
		{
			SFC_ProcStack(&_si);
		}
		else
		{
			ASSERT (_si.siMode == StackItem::NORMAL);
			m_pParserModule->SetActiveParser(_si.siParserPointer);
			m_pParserModule->GetActiveParser()->SetPosition(_si.siPos);
#ifdef G00MOVING
			if (m_pParserModule->m_CodePosition.nAnchorType == ANCH_FILEPOS)
				((CGCodeSemanticAnalyser*)m_pParserModule->GetActiveParser())->m_nCurEntityIndex = _si.siIndex;
#endif
		}

		// G73~G89Ϊ̶ѭӳ򣬴˴Թ̶ѭӳע
		C_ASSERT(sizeof(int) == 4);
		union
		{
			int nValue;
			TCHAR szBuf[4];
		} _test;
		memset(&_test, 0, sizeof(_test));

		_tcsupr_s(_si.siProgName);
		if (3 == _tcslen(_si.siProgName))
		{
			_tcsncpy_s(_test.szBuf, _countof(_test.szBuf), _si.siProgName, 3);
			for (int _i = 0, _size = _countof(s_FixedCycName); _i < _size; ++_i)
			{
				if (s_FixedCycName[_i] == _test.nValue)
				{
					ASSERT(_si.siProgNo == 0);
					m_pParserModule->m_bInFixedCycle = false;
					m_pParserModule->m_ModalData.SetMotionType(CGModalData::MT_FIXEDCYC);
				}
			}
		}
	}
	else
	{
		ASSERT(_si.siLoop > 0);
		_si.siLoop--;
		m_pParserModule->m_Stack.Push(_si);

		//˴ԭд
		//	öʱһμӹϺӦٴηصӳͷ
		//	ǰɵģʵӦڴ

		long _pos;
		if (_si.siProgNo > 0)
			_pos = GetSubProg(_si.siProgNo);
		else
			_pos = GetSubProg(_si.siProgName);
		ASSERT(_pos >= 0);
		SetPosition(_pos);
	}
}

//ģ䴫ַϢ wangwenbo 2010.01.28
void CGCodeSemanticAnalyser::M801(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_M, 801);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	ASSERT(pTaggedData_->m_nValue == 801);
	UNREFERENCED_PARAMETER(pTaggedData_);

	int _nIndex;
	if (!SearchTaggedData(&_nIndex, TK_ADR_MSG))
	{
		m_strTemp.Format(c_szERROR_NOENOUGHPARAMETERS, "M801");
		ErrorHandler(m_strTemp);
	}
	MatchTaggedData(_nIndex, TK_ADR_MSG);

	CNcSendRawString _NcSendRawString(m_pParserModule->m_CodePosition);
	_NcSendRawString.m_strString = m_Entities.GetCurrentEntity()[_nIndex].m_pszValue;
	m_pParserModule->AddTailCode(_NcSendRawString);
}

//ģ䴫Ϣ wangwenbo 2010.01.27
void CGCodeSemanticAnalyser::M802(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_M, 802);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	ASSERT(pTaggedData_->m_nValue == 802);
	UNREFERENCED_PARAMETER(pTaggedData_);

	int _nIndex;
	if (!SearchTaggedData(&_nIndex, TK_ADR_P))
	{
		m_strTemp.Format(c_szERROR_NOENOUGHPARAMETERS, "M802");
		ErrorHandler(m_strTemp);
	}
	MatchTaggedData(_nIndex, TK_ADR_P);
	UINT _nValue = (UINT) m_Entities.GetCurrentEntity()[_nIndex].m_nValue;

	CNcSendRawInt _NcSendRawInt(m_pParserModule->m_CodePosition);
	_NcSendRawInt.m_nInteger = _nValue;
	m_pParserModule->AddTailCode(_NcSendRawInt);
}

//ֱָ wangwenbo 2010.01.28
void CGCodeSemanticAnalyser::M901(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_M, 901);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	ASSERT(pTaggedData_->m_nValue == 901);
	UNREFERENCED_PARAMETER(pTaggedData_);

	int _nIndex;
	if (!SearchTaggedData(&_nIndex, TK_ADR_PLC))
	{
		m_strTemp.Format(c_szERROR_NOENOUGHPARAMETERS, "M901");
		ErrorHandler(m_strTemp);
	}
	MatchTaggedData(_nIndex, TK_ADR_PLC);
	int _nPlcAddress = int(m_Entities.GetCurrentEntity()[_nIndex].m_nValue);

	_nIndex;
	if (!SearchTaggedData(&_nIndex, TK_ADR_LEVEL))
	{
		m_strTemp.Format(c_szERROR_NOENOUGHPARAMETERS, "M901");
		ErrorHandler(m_strTemp);
	}
	MatchTaggedData(_nIndex, TK_ADR_LEVEL);

	if (!m_pInterpEngine->IsMachining())
		return;

	int _val = _round(m_Entities.GetCurrentEntity()[_nIndex].m_nValue);
	bool _nPortValue = _val ? true : false;
	CNcDirectPort _NcDirectPort(m_pParserModule->m_CodePosition);
	_NcDirectPort.m_nPlcAddress = _nPlcAddress;
	_NcDirectPort.m_bPortValue = _nPortValue;
	m_pParserModule->AddTailCode(_NcDirectPort);
}

//ָ wangwenbo 2010.01.28
void CGCodeSemanticAnalyser::M902(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_M, 902);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	ASSERT(pTaggedData_->m_nValue == 902);
	UNREFERENCED_PARAMETER(pTaggedData_);

	int _nIndex;
	if (!SearchTaggedData(&_nIndex, TK_ADR_H))
	{
		m_strTemp.Format(c_szERROR_NOENOUGHPARAMETERS, "M902");
		ErrorHandler(m_strTemp);
	}
	MatchTaggedData(_nIndex, TK_ADR_H);

	if (!m_pInterpEngine->IsMachining())
		return;

	int _nAxisNo = (int) m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
	if (_nAxisNo < 0 || _nAxisNo >= c_nNUMOF_AXIS)
	{
		m_strTemp.Format(c_szERROR_M902_AXISNO, _nAxisNo);
		ErrorHandler(m_strTemp);
	}
	CNcToRefFinished _NcToRefFinished(m_pParserModule->m_CodePosition);
	_NcToRefFinished.m_nAxis = _nAxisNo;
	m_pParserModule->AddTailCode(_NcToRefFinished);
}

//ĵǰ wangwenbo 2010.01.28
void CGCodeSemanticAnalyser::M903(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_M, 903);
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	ASSERT(pTaggedData_->m_nValue == 903);
	UNREFERENCED_PARAMETER(pTaggedData_);
	
	int _nIndex;
	if (!SearchTaggedData(&_nIndex, TK_ADR_H))
	{
		m_strTemp.Format(c_szERROR_NOENOUGHPARAMETERS, "M903");
		ErrorHandler(m_strTemp);
	}
	MatchTaggedData(_nIndex, TK_ADR_H);
	
	int _nToolIndex = (int) m_Entities.GetCurrentEntity()[_nIndex].m_nValue;
	if (_nToolIndex < 0 || _nToolIndex >= m_pParserModule->m_nToolLibSize)
	{
		ErrorHandler(c_szERROR_TOOLNUMBEROVERFLOW);
	}
	CNcChangeTool _NcChangeTool(m_pParserModule->m_CodePosition);
	_NcChangeTool.m_nToolIndexNew = _nToolIndex;
	m_pParserModule->AddTailCode(_NcChangeTool);
}

void CGCodeSemanticAnalyser::M904_M905(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_M);
	ASSERT(pTaggedData_->m_nValue == 904 || pTaggedData_->m_nValue == 905);

	MatchTaggedData(TK_ADR_M, pTaggedData_->m_nValue);
	m_pParserModule->ChangeModal(G_GROUP_G00LEAVEENTER, _round(pTaggedData_->m_nValue));
	return;
}

//йѹʱ
//ӳTrackEnd
//ӳʵֵĹǣ
//ˮиӹһļȹصķţʱһʱٹصˮ
//ͨһļϺG927
//---------------------------------------------xiangyanjun
void CGCodeSemanticAnalyser::G927(CTaggedData* pTaggedData_)
{
	ASSERT(pTaggedData_->m_nToken == TK_ADR_G);
	ASSERT(pTaggedData_->m_nValue == 927);

	MatchTaggedData(pTaggedData_->m_nToken, pTaggedData_->m_nValue);
	if(0 < m_pParserModule->m_pParserPublic->GetSubProg("TrackEnd"))
	{
		m_pParserModule->MakeCall("TrackEnd", 1);
	}	
}

void CGCodeSemanticAnalyser::FeedRate(CTaggedData* pTaggedData_)
{
 	MatchTaggedData(TK_ADR_F, c_nINVALID_DOUBLE);
	if (m_pInterpEngine->IsTracking())
		return;

	CGCodeMeaning::assignspeed_t _nAssignSpeedType = m_pParserModule->m_nAssignSpeedType;
	if (m_FlagsForCurrentEntity.m_bForcedFeedrate)
		_nAssignSpeedType = CGCodeMeaning::AS_FILE;

	// If speed of file is invalid, user can change paramter from AS_FILE/AS_PRORATION
	//	to AS_DEFAULT to working. [calf]
	switch (_nAssignSpeedType)
	{
	case CGCodeMeaning::AS_FILE:
	//case CGCodeMeaning::AS_PRORATION:
		{
			double _nSpeed = MMPerMin_To_MMPerSec(pTaggedData_->m_nValue);	// from mm/min to mm/s
			if (!_IsValidSpeed(_nSpeed))
			{
				m_strTemp.Format(c_szERR_SPEED_OUTOFRANGE, pTaggedData_->m_nValue);
				ErrorHandler(m_strTemp);

				ASSERT(false); // Maye ErrorHandler will be changed
				return;	
			}
			
			// Not CMemoryCodeBuffer
			//if (CGCodeMeaning::AS_PRORATION == _nAssignSpeedType /*&& m_pCodeBuffer == &GetNcKernel()->m_FileCodeBuffer*/)
			//{
			//	CGFileCodeBuffer* _pFileCodeBuff = (CGFileCodeBuffer*)m_pCodeBuffer;
			//	double _nMaxSpeedSetting = max(m_pParserModule->m_nSpeedGxx, m_pParserModule->m_nSpeedG00);
			//	double _nMaxSpeedScan = _pFileCodeBuff->m_nMaxSpeedScan;
			//	if (_nMaxSpeedScan > _nMaxSpeedSetting)
			//		_nSpeed *= _nMaxSpeedSetting / _nMaxSpeedScan;
			//}
			
			if (_IsCurSpeedBelongToG00())
				m_pParserModule->m_SpeedRecord.Speed.nSpeedG00 = _nSpeed;
			else
				m_pParserModule->m_SpeedRecord.Speed.nSpeedGxx = _nSpeed;
		}

		break;

	case CGCodeMeaning::AS_DEFAULT:
		m_pParserModule->m_SpeedRecord.Speed.nSpeedG00 = m_pParserModule->m_nSpeedG00;
		m_pParserModule->m_SpeedRecord.Speed.nSpeedGxx = m_pParserModule->m_nSpeedGxx;
		break;

	default:
		ASSERT(false);
		break;
	};
	return;
}

void CGCodeSemanticAnalyser::SpindleRev(CTaggedData* pTaggedData_)
{
	MatchTaggedData(TK_ADR_S, pTaggedData_->m_nValue);
	if (!m_pParserModule->m_bIgnoreProgSpindleRev)
	{
		int _nSpindleRev = int(pTaggedData_->m_nValue);
		CNcChangSpindleRev _NcChangSpindleRev(m_pParserModule->m_CodePosition);
		_NcChangSpindleRev.m_nSpindleRev = _nSpindleRev;
		_NcChangSpindleRev.m_nType = 0;
		m_pParserModule->AddTailCode(_NcChangSpindleRev);
	}
}

void CGCodeSemanticAnalyser::GUnknown(CTaggedData* pTaggedData_)
{
	if (m_pInterpEngine->IsTracking())
	{
		int _nIndex;
		SearchTaggedData(&_nIndex, TK_ADR_G);
		MatchTaggedData(_nIndex, TK_ADR_G);
		return;
	}

	m_strTemp.Format("G%d", int(pTaggedData_->m_nValue));
	if (0 > m_pParserModule->m_pParserPublic->GetSubProg(m_strTemp))
	{
		GInvalid(pTaggedData_);
	}
	else
	{
		m_pParserModule->MakeCall(m_strTemp, 1);
	}
}

void CGCodeSemanticAnalyser::MUnknown(CTaggedData* pTaggedData_)
{
	if (m_pInterpEngine->IsTracking())
	{
		int _nIndex;
		SearchTaggedData(&_nIndex, TK_ADR_M);
		MatchTaggedData(_nIndex, TK_ADR_M);
		return;
	}

	m_strTemp.Format("M%d", int(pTaggedData_->m_nValue));
	if (0 > m_pParserModule->m_pParserPublic->GetSubProg(m_strTemp))
	{
		MInvalid(pTaggedData_);
	}
	else
	{
		m_pParserModule->MakeCall(m_strTemp, 1);
	}
}

void CGCodeSemanticAnalyser::MatchG(CTaggedData* pTaggedData_)
{
	// ȼЧ
	int _nGNo = m_pParserModule->m_ModalData.GetGNumber(G_GROUP_MOVE);
	if (m_pParserModule->m_ModalData.GetMotionType() == CGModalData::MT_FIXEDCYC)
		_nGNo = m_pParserModule->m_ModalData.GetGNumber(G_GROUP_FIXEDCYCLE);
	
	int _nIndex = pTaggedData_->m_nToken - TK_ADR_FIRST;
	ASSERT(m_MatchGScope[_nIndex][0] == pTaggedData_->m_nToken);
	bool _bValid = false;
	for (const int*_pMatchNos = &m_MatchGScope[_nIndex][1];
		*_pMatchNos != -1;
		_pMatchNos++)
	{
		if (*_pMatchNos == _nGNo)
		{
			_bValid = true;
			break;
		}
	}

	if (!_bValid)
	{
		ErrorHandler(c_szERROR_MATCH_BACKWARDRULE);
	}

	const rule_t* _pRule = GetRule(TK_ADR_G, _nGNo);
	if (_pRule)
	{
		(this->*_pRule->pFunction) (pTaggedData_);
	}
	else
	{
		ErrorHandler(c_szERROR_MATCH_BACKWARDRULE);
	}
}

void CGCodeSemanticAnalyser::Ignore(CTaggedData* pTaggedData_)
{
	TRACE2("Ignore instruction:%s%f",
		GetTokenAlias(pTaggedData_->m_nToken),
		pTaggedData_->m_nValue);
}

void CGCodeSemanticAnalyser::Rule_Error(CTaggedData* pTaggedData_)
{
	TRACE1("Rule_Error for Token: %s\n", GetTokenAlias(pTaggedData_->m_nToken));
	m_strTemp.Format(c_szERROR_UNEXPECTED_TAGGEDDATA,
						GetTokenAlias(pTaggedData_->m_nToken));
	ErrorHandler(m_strTemp);
}

void CGCodeSemanticAnalyser::GInvalid(CTaggedData* pTaggedData_)
{
	int _nIndex;
	SearchTaggedData(&_nIndex, TK_ADR_G);
	MatchTaggedData(_nIndex, TK_ADR_G);
	m_strTemp.Format(c_szERROR_INVALID_GCODE, pTaggedData_->m_nValue);
	ErrorHandler(m_strTemp);
}

void CGCodeSemanticAnalyser::MInvalid(CTaggedData* pTaggedData_)
{
	int _nIndex;
	SearchTaggedData(&_nIndex, TK_ADR_M);
	MatchTaggedData(_nIndex, TK_ADR_M);
	int _nValue = (int) pTaggedData_->m_nValue;
	m_strTemp.Format(c_szERROR_INVALID_MCODE, _nValue);
	PARSEENGINEWARNING(m_strTemp);
}

const CGCodeSemanticAnalyser::rule_t* CGCodeSemanticAnalyser::GetRule_Pre(token_t tkAddr_, double nTagValue_)
{
	for (int _i = 0; _i < _countof(m_RuleList_Pre); _i++)
	{
		if (m_RuleList_Pre[_i].tkAddr == tkAddr_)
		{
			if (m_RuleList_Pre[_i].nTagValue == -1
				|| m_RuleList_Pre[_i].nTagValue == nTagValue_)
			{
				return &m_RuleList_Pre[_i];
			}
		}
	}

	return NULL;
}

const CGCodeSemanticAnalyser::rule_t* CGCodeSemanticAnalyser::GetRule_Normal(token_t tkAddr_, double nTagValue_)
{
	for (int _i = 0; _i < _countof(m_RuleList_Normal); _i++)
	{
		if (m_RuleList_Normal[_i].tkAddr == tkAddr_)
		{
			if (m_RuleList_Normal[_i].nTagValue == -1
				|| m_RuleList_Normal[_i].nTagValue == nTagValue_)
			{
				return &m_RuleList_Normal[_i];
			}
		}
	}

	return NULL;
}

const CGCodeSemanticAnalyser::rule_t* CGCodeSemanticAnalyser::GetRule_Post(token_t tkAddr_, double nTagValue_)
{
	for (int _i = 0; _i < _countof(m_RuleList_Post); _i++)
	{
		if (m_RuleList_Post[_i].tkAddr == tkAddr_)
		{
			if (m_RuleList_Post[_i].nTagValue == -1
				|| m_RuleList_Post[_i].nTagValue == nTagValue_)
			{
				return &m_RuleList_Post[_i];
			}
		}
	}

	return NULL;
}

const CGCodeSemanticAnalyser::rule_t* CGCodeSemanticAnalyser::GetRule(token_t tkAddr_, double nTagValue_)
{
	const CGCodeSemanticAnalyser::rule_t* _pRule = GetRule_Pre(tkAddr_, nTagValue_);
	if (_pRule)
		return _pRule;
	_pRule = GetRule_Normal(tkAddr_, nTagValue_);
	if (_pRule)
		return _pRule;
	_pRule = GetRule_Post(tkAddr_, nTagValue_);
	return _pRule;
}

//ȷǰӹ wangwenbo 2010.01.28
CCodeParser::fieldpos_t CGCodeSemanticAnalyser::GetCurPosField()
{
	__int64 _nPos = GetPosition();
	codeparser_t _type = GetParserType();

	ASSERT(_type == CM_G);
	// left closed right open
	fieldpos_t _filepos = FP_MIDDLE;
	if (_nPos < m_CurField.from)
		_filepos = FP_LEFT;
	else if (_nPos >= m_CurField.to)
		_filepos = FP_RIGHT;

	return _filepos;
}