// ************************************************************************** //
// LayerParamDlg.cpp : implementation of the CLayerParamDlg class
// Copyright(c)2014 WeiHong Company. All rights reserved.
//
// Abstract:
//   ļʵCLayerParamDlgࡣ
// *********************************************** ---- ƺ 2014-12-14***** //
#include "stdafx.h"
#include <direct.h>
#include "LayerControls.h"
using namespace nce;
using namespace spline;
#include "LayerParamDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const char c_szSection[] = "ParamGroup";

CS_T s_szTECHNICPARAMETERS = _DEFCS(_CSV(16560),
	_CHINESE("ղ")
	_ENGLISH("Technic Parameters"));
CS_T s_szSPECIALPARAMETERS = _DEFCS(_CSV(16561),
	_CHINESE("⹤")
	_ENGLISH("Special Technic Parameters"));
CS_T s_szSPEEDPOWERCURVE = _DEFCS(_CSV(16562),
	_CHINESE("")
	_ENGLISH("Power Curve"));
CS_T s_szRAMARKS = _DEFCS(_CSV(16563),
	_CHINESE("ûע")
	_ENGLISH("Remarks"));
CS_T s_szMACHMODE = _DEFCS(_CSV(16564),
	_CHINESE("׷ʽ")
	_ENGLISH("Pierce Mode:"));
CS_T s_szCUTSPEED = _DEFCS(_CSV(16565),
	_CHINESE("иٶȣ")
	_ENGLISH("Cut Speed:"));
CS_T s_szCUTPOWER = _DEFCS(_CSV(16566),
	_CHINESE("и")
	_ENGLISH("Cut Current:"));
CS_T s_szCUTFREQUENCY = _DEFCS(_CSV(16567),
	_CHINESE("иƵʣ")
	_ENGLISH("Cut Frequency:"));
CS_T s_szDUTYCYCLERATIO = _DEFCS(_CSV(16568),
	_CHINESE("иʣ")
	_ENGLISH("Cut Power:"));
CS_T s_szCUTGAS = _DEFCS(_CSV(16569),
	_CHINESE("и壺")
	_ENGLISH("Cut Gas:"));
CS_T s_szCUTPRESSURE = _DEFCS(_CSV(16570),
	_CHINESE("иѹ")
	_ENGLISH("Cut Pressure:"));
CS_T s_szFOLLOWINGHEIGHT = _DEFCS(_CSV(16571),
	_CHINESE("и߶ȣ")
	_ENGLISH("Cut Height:"));
CS_T s_szBERTHPOSITION = _DEFCS(_CSV(16572),
	_CHINESE("ͣλã")
	_ENGLISH("Berth Position:"));
CS_T s_szBEFORELIGHTONDELAY = _DEFCS(_CSV(16573),
	_CHINESE("ǰʱ")
	_ENGLISH("PreLaserOn:"));
CS_T s_szPOSTLASERONDELAY = _DEFCS(_CSV(16574),
	_CHINESE("ʱ")
	_ENGLISH("PostLaserOn:"));
CS_T s_szCUTFOCUS = _DEFCS(_CSV(16701),
	_CHINESE("и㣺")
	_ENGLISH("Cut Focus:"));

CS_T s_szPIERCEHEIGHT = _DEFCS(_CSV(16575),
	_CHINESE("׸߶ȣ")
	_ENGLISH("Pierce Height:"));
CS_T s_szPIERCESEGMENT = _DEFCS(_CSV(16576),
	_CHINESE("׶")
	_ENGLISH("Pierce Segments:"));
CS_T s_szPREINCPIERCEDELAY = _DEFCS(_CSV(16577),
	_CHINESE("ǰʱ")
	_ENGLISH("Pre-Inc-Pierce Delay:"));
CS_T s_szPIERCEPOWER = _DEFCS(_CSV(16578),
	_CHINESE("׵")
	_ENGLISH("Pierce Current:"));
CS_T s_szPIERCEFREQUENCY = _DEFCS(_CSV(16579),
	_CHINESE("Ƶʣ")
	_ENGLISH("Pierce Frequency:"));
CS_T s_szPIERCEDUTYCYCLERATIO = _DEFCS(_CSV(16580),
	_CHINESE("׹ʣ")
	_ENGLISH("Pierce Power:"));
CS_T s_szPIERCEGAS = _DEFCS(_CSV(16581),
	_CHINESE("壺")
	_ENGLISH("Pierce Gas:"));
CS_T s_szPIERCEPRESSURE = _DEFCS(_CSV(16582),
	_CHINESE("ѹ")
	_ENGLISH("Pierce Pressure:"));
CS_T s_szPOSTLAEROFFDELAY = _DEFCS(_CSV(16583),
	_CHINESE("عǰʱ")
	_ENGLISH("PreLaserOff:"));
CS_T s_szPIERCEDIRECTLY = _DEFCS(_CSV(16584),
	_CHINESE("ֱӴ")
	_ENGLISH("Directly"));
CS_T s_szINCREMENGTPIERCE = _DEFCS(_CSV(16585),
	_CHINESE("")
	_ENGLISH("Increment"));
CS_T s_szPIERCEBYSECTION = _DEFCS(_CSV(16586),
	_CHINESE("ֶδ")
	_ENGLISH("By-section"));
CS_T s_szPIERCETIME = _DEFCS(_CSV(16595),
	_CHINESE("ʱ")
	_ENGLISH("Pierce Delay:"));
CS_T s_szPUNCHFOCUS = _DEFCS(_CSV(16702),
	_CHINESE("׽㣺")
	_ENGLISH("Punch Focus:"));

CS_T s_szPREPERFORATE = _DEFCS(_CSV(16604),
	_CHINESE("Ԥ")
	_ENGLISH("Prepierce"));
CS_T s_szNEGLECTTHISLAYER = _DEFCS(_CSV(16587),
	_CHINESE("ͼ㲻ӹ")
	_ENGLISH("Neglect This Layer"));
CS_T s_szLOWSPEEDSTARTUP = _DEFCS(_CSV(16588),
	_CHINESE("")
	_ENGLISH("Low-speed Startup"));
CS_T s_szSTARTUPDIS = _DEFCS(_CSV(16589),
	_CHINESE("𲽾룺")
	_ENGLISH("Distance:"));
CS_T s_szSTARTUPSPEED= _DEFCS(_CSV(16590),
	_CHINESE("ٶȣ")
	_ENGLISH("Speed:"));
CS_T s_szPREPIERCE = _DEFCS(_CSV(16591),
	_CHINESE("Ԥ")
	_ENGLISH("Prepierce"));
CS_T s_szOXYGEN = _DEFCS(_CSV(16592),
	_CHINESE("")
	_ENGLISH("O2"));
CS_T s_szNITROGEN = _DEFCS(_CSV(16593),
	_CHINESE("")
	_ENGLISH("N2"));
CS_T s_szAIR = _DEFCS(_CSV(16594),
	_CHINESE("")
	_ENGLISH("Air"));
CS_T s_szDEFAULTGAS = _DEFCS(_CSV(16596),
	_CHINESE("Ĭ")
	_ENGLISH("Default Gas"));
CS_T s_szPREPERLIFTHEIGHT = _DEFCS(_CSV(16633),
	_CHINESE("Ԥ̧߶ȣ")
	_ENGLISH("Prepierce Lift H:"));

CS_T s_szSPEED = _DEFCS(_CSV(16597),
	_CHINESE("F")
	_ENGLISH("F"));
CS_T s_szPOWER = _DEFCS(_CSV(16598),
	_CHINESE("P")
	_ENGLISH("P"));
CS_T s_szENABLEFPMAPPING = _DEFCS(_CSV(16605),
	_CHINESE("ٶȹʵ")
	_ENGLISH("Enable Auto Adjust"));
CS_T s_szEDITFPMAP = _DEFCS(_CSV(16694),
	_CHINESE("༭")
	_ENGLISH("Edit"));

CS_T s_szCUTGASNAME = _DEFCS(_CSV(16559),
	_CHINESE("CutGas%d_CHN")
	_ENGLISH("CutGas%d_ENG"));
CS_T s_szPERGASNAME = _DEFCS(_CSV(16599),
	_CHINESE("PerGas%d_CHN")
	_ENGLISH("PerGas%d_ENG"));
CS_T s_szLIFTHEIGHT = _DEFCS(_CSV(16606),
	_CHINESE("̧߶ȣ")
	_ENGLISH("Lifting Height:"));
CS_T s_szZUPDELAY = _DEFCS(_CSV(16608),
	_CHINESE("Zʱ")
	_ENGLISH("Z Up Delay:"));
CS_T s_szFOLLOWDELAY = _DEFCS(_CSV(16609),
	_CHINESE("涯ʱ")
	_ENGLISH("Follow Delay:"));
CS_T s_szCONPERSPEED = _DEFCS(_CSV(16611),
	_CHINESE("ٶȣ")
	_ENGLISH("Increment S:"));

CS_T s_szIMPORTPARAM = _DEFCS(_CSV(16616),
	_CHINESE("빤")
	_ENGLISH("Import"));
CS_T s_szSAVEPARAM = _DEFCS(_CSV(16617),
	_CHINESE("湤")
	_ENGLISH("Save"));
CS_T s_szPARAMFILEEXIST = _DEFCS(_CSV(16612),
	_CHINESE("ļѾڣǷ񸲸ǣ")
	_ENGLISH("Parameter file has existed, replace it?"));
CS_T s_szPARAMFILENOTEXIST = _DEFCS(_CSV(16613),
	_CHINESE("ļڣ")
	_ENGLISH("Parameter file dose not existed!"));
CS_T s_szPARAMOVERWRITEPROMT = _DEFCS(_CSV(16614),
	_CHINESE("ǵǰͼǷ")
	_ENGLISH("Current technic parameters will be overwrite, continue or not?"));
CS_T s_szDEFUALTPARAMFILENAME = _DEFCS(_CSV(16615),
	_CHINESE("1.ltp")
	_ENGLISH("Material1.ltp"));

CS_T s_szPATHCOOL = _DEFCS(_CSV(16619),
	_CHINESE("ȴ")
	_ENGLISH("Path Cool"));
CS_T s_szEXPLODEPUNCH= _DEFCS(_CSV(16620),
	_CHINESE("")
	_ENGLISH("3-Segment"));
CS_T s_szCIRCLEOVERCUT = _DEFCS(_CSV(16621),
	_CHINESE("")
	_ENGLISH("Circle Overcut"));
CS_T s_szOVERCUTLENGTH = _DEFCS(_CSV(16622),
	_CHINESE("гȣ")
	_ENGLISH("Overcut Len:"));
CS_T s_szOVERCUTANGLE= _DEFCS(_CSV(16623),
	_CHINESE("Ƕȣ")
	_ENGLISH("Bypass Angle:"));
CS_T s_szSPECIALTENICH = _DEFCS(_CSV(16631),
	_CHINESE("⹤")
	_ENGLISH("Special Technic"));
CS_T s_szFIXEDHEIGHTCUT = _DEFCS(_CSV(16632),
	_CHINESE("и")
	_ENGLISH("Fixed Height Cut"));
CS_T s_szTECHNICLIBRARY = _DEFCS(_CSV(16639),
	_CHINESE("տ")
	_ENGLISH("TechnicLibrary"));
CS_T s_szCUTTINGFROMOUTSIDE = _DEFCS(_CSV(16656),
	_CHINESE("")
	_ENGLISH("Outside Cutting"));
CS_T s_szNOTSAVEOUTSIDEHEIGHT = _DEFCS(_CSV(16654),
	_CHINESE("δðи߶ȣܰ棡")
	_ENGLISH("Outside cutting is unavailable before saving the outside height!"));
CS_T s_szNOTCLOSEBLOW = _DEFCS(_CSV(16656),
	_CHINESE("ͼ㲻")
	_ENGLISH("Not Close Gas"));
CS_T s_szCOOLDELAY = _DEFCS(_CSV(16656),
	_CHINESE("ȴʱ")
	_ENGLISH("Cool Delay:"));
CS_T s_szCOOLINGAIR = _DEFCS(_CSV(16656),
	_CHINESE("ȴ")
	_ENGLISH("Cooling Air:"));
CS_T s_szPIECESIDEBLOW = _DEFCS(_CSV(16656),
	_CHINESE("ʱവ")
	_ENGLISH("Side Blow When Pierce"));
CS_T s_szMACHSIDEBLOW = _DEFCS(_CSV(16656),
	_CHINESE("ӹʱവ")
	_ENGLISH("Side Blow When Mach"));
CS_T s_szENABLELEADSPEED = _DEFCS(_CSV(16656),
	_CHINESE("ٶ")
	_ENGLISH("Enable Lead Speed"));
CS_T s_szLEADINSPEED = _DEFCS(_CSV(16656),
	_CHINESE("ٶȣ")
	_ENGLISH("Lead-in Speed:"));
CS_T s_szLEADOUTSPEED = _DEFCS(_CSV(16656),
	_CHINESE("ٶȣ")
	_ENGLISH("Lead-out Speed:"));
CS_T s_szLAYERNAME = _DEFCS(_CSV(16710),
	_CHINESE("Name_CHN")
	_ENGLISH("Name_ENG"));
CS_T s_csINVALIDINPUT = _DEFCS(_CSV(16760),
	_CHINESE("ʽȷ롣")
	_ENGLISH("The input parameter is invalid, please reset again."));

const int c_nOffset = 5;
const int c_nEffectHeight = 150;
const int c_nEffectWeight = 200;
const double c_nMaxPower = 100;
const double c_nMaxSpeed = 100;
const int c_nSelectTolerance = 2;
const COLORREF c_nLineColor = 16711680;
const COLORREF c_nPointNoSelected = 16711680;
const COLORREF c_nPointSelected = RGB(128, 128, 255);
const int c_nRadiusNoSelected = 2;
const int c_nRadiusSelected = 3;
const char c_szEnableFPMap[] = "FPMapEnable";
const char c_szRemarks[] = "Remarks";
const char c_szThreeSegPunch[] = "EnableThreeSegPunch";
const char c_szFirstSegPunch[] = "FirstSegPunch";
const char c_szSecondSegPunch[] = "SecondSegPunch";
const char c_szThirdSegPunch[] = "ThirdSegPunch";
const char c_szThreeSegPunchRemarks[] = "ThreeSegPunchRemarks";

const char c_szParamGroupUnit[] = "ParamGroupUnit";
const char c_szSpeedUnit[] = "SpeedUnit";
const char c_szAccUnit[] = "AccUnit";
const char c_szTimeUnit[] = "TimeUnit";
const char c_szPressureUnit[] = "PressureUnit";

static void FormatDoubleParamer(CString& pSrc_)
{
	pSrc_.TrimRight('0');
	if (pSrc_.IsEmpty())
		pSrc_ = _T("0");
	if (pSrc_[pSrc_.GetLength() - 1] == _T('.'))
		pSrc_.Delete(pSrc_.GetLength() - 1);
}

IMPLEMENT_DYNAMIC(CLayerParamDlg, CDialog)
BEGIN_MESSAGE_MAP(CLayerParamDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_CONTROL_RANGE(EN_KILLFOCUS, IDC_EDIT_CUTTINGSPEED, IDC_EDIT_PUNCHFOCUS, OnKillFocusEdit)
	ON_CONTROL_RANGE(EN_SETFOCUS, IDC_EDIT_CUTTINGSPEED, IDC_EDIT_PUNCHFOCUS, OnSetFocusEdit)
	ON_COMMAND_RANGE(IDC_RADIO_DIRPERFORATE, IDC_RADIO_THREESEGPUNCH, OnClickPerType)
	ON_COMMAND(IDC_CHECK_ISIGNORE, OnClickNeglect)
	ON_COMMAND(IDC_CHECK_NOTCLOSEBLOW, OnClickNotCloseBlow)
	ON_COMMAND(IDC_CHECK_PUNCHSIDEBLOW, OnClickPunchSideBlow)
	ON_COMMAND(IDC_CHECK_CUTTINGSIDEBLOW, OnClickCuttingSideBlow)
	ON_COMMAND(IDC_CHECK_PREPERFORATE, OnClickPrePerforate)
	ON_COMMAND(IDC_CHECK_ISSTARTUPSLOWLY, OnClickSlowlyStartup)
	ON_CBN_SELCHANGE(IDC_COMBO_CUTTINGAIR, OnSelectCutGas)
	ON_CBN_SELCHANGE(IDC_COMBO_PERFORATEAIR, OnSelectPerGas)
	ON_CBN_SELCHANGE(IDC_COMBO_COOLINGAIR, OnSelectCoolingGas)
	ON_EN_KILLFOCUS(IDC_EDIT_UESEREMARK, OnKillFocusRemarks)
	ON_COMMAND(IDC_CHECK_ENABLEINTROSPEED, OnEnableIntroSpeed)
	ON_COMMAND(IDC_CHECK_CIRCLEOVERCUT, OnClickOvercut)
	ON_COMMAND(IDC_CHECK_ENABLEFPMAPPING, OnClickEnableFP)
	ON_COMMAND(IDC_CHECK_FIXHEIGHTCUT, OnClickFixedHeightCut)
	ON_COMMAND(IDC_CHECK_CUTTINGFROMOUTSIDE, OnCutFromOutside)
	ON_COMMAND(IDC_BTN_EDITFPMAP, OnClickEditFPMap)
END_MESSAGE_MAP()

CLayerParamDlg::CLayerParamDlg(CParam* pParam_, CWnd* pParent_)
	: CDialog(IDD_DLG_LAYERPARAM, pParent_), m_pParam(pParam_)
{
	m_bSelectPoint = FALSE;
	m_nMode = t_valid;
	m_bFPEnable = TRUE;
	m_nFTCType = 0;

	// ʼЧ ----  2016-07-20
	m_bDataValid = true;
	m_bCancelData = false;
	CString _strFTCType = NceGetPrivateProfileString("FTCInfo", "FTCType");
	if (!_strFTCType.IsEmpty())
	{
		m_nFTCType = atoi(_strFTCType);
	}

	_BuildEditInfo();

	// ʼи塣÷ʽ
	//	CutGasCount=1
	//	CutGas0_Value=0
	//	CutGas0_CHN=""
	//	CutGas0_ENG="Air"
	// CutGasXX_CHNCutGasXX_ENGӢCutGasXX_ValueǶӦLayerParam.lua
	// BlowTypeTableĵһֵ---- ƺ 2015-02-28
	CString _strCount = NceGetPrivateProfileString(c_szSection, _T("CutGasCount"), "0");
	int _nCount = atoi(_strCount);
	for (int _i = 0; _i < _nCount; _i++)
	{
		CombItem _item;
		CString _strKey;
		_strKey.Format(_T("CutGas%d_Value"), _i);
		_item.strValue = NceGetPrivateProfileString(c_szSection, _strKey, "");
		_strKey.Format(_GETCS(s_szCUTGASNAME), _i);
		_item.strText = NceGetPrivateProfileString(c_szSection, _strKey, "");
		m_vectCutGas.push_back(_item);
	}

	_strCount = NceGetPrivateProfileString(c_szSection, _T("CutGasCount"), "0");
	_nCount = atoi(_strCount);
	for (int _i = 0; _i < _nCount; _i++)
	{
		CombItem _item;
		CString _strKey;
		_strKey.Format(_T("PerGas%d_Value"), _i);
		_item.strValue = NceGetPrivateProfileString(c_szSection, _strKey, "");
		_strKey.Format(_GETCS(s_szPERGASNAME), _i);
		_item.strText = NceGetPrivateProfileString(c_szSection, _strKey, "");
		m_vectPerGas.push_back(_item);
	}

	// ǰװĻڰװĿ¼ġWeihongļ£ݷD̵ġWeihong£ǽѹķ롰configͬĿ¼¡ ---- ƺ 2015-06-15
	CString _strPath = NceGetActiveUserDir();
	int _nIndex = _strPath.Find(_T("\\Weihong"));
	if (_nIndex != -1)
	{
		_strPath = _strPath.Left(_nIndex + 8);
		_strPath += _T("\\");
		_strPath += _GETCS(s_szTECHNICLIBRARY);
		m_strDefaultFilePath = _strPath;
	}
	else
	{
		_nIndex = _strPath.Find(_T("\\config"));
		ASSERT(_nIndex >= 0);
		_strPath = _strPath.Left(_nIndex + 1);
		_strPath += _GETCS(s_szTECHNICLIBRARY);
		m_strDefaultFilePath = _strPath;
	}

	m_bEnableFocusCtrl = NceGetPrivateProfileString(_T("FocusControl"), _T("Enable")) == _T("1");
}

void CLayerParamDlg::_BuildEditInfo()
{
	// ʼûע֮ı༭ ---- ƺ 2015-01-23
	bool _bNoF = m_nFTCType == 2;
	const EditInfo _s_Edits[] = 
	{
		{"Feedrate",			IDC_EDIT_CUTTINGSPEED,		1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("Feedrate")) ? 1000 : m_pParam->GetKey_DBL("Feedrate"),							1,		100000,	true, Speed_MMperMin, 0},
		{"FollowHeight",		IDC_EDIT_FOLLOWHEIGHT,		1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("FollowHeight")) ? 1 : m_pParam->GetKey_DBL("FollowHeight"),						0.01,	100,		m_nFTCType != 2, Length_MM, 1},
		{"CutPower",			IDC_EDIT_CUTTINGPOWER,		0,	IsInvalidDouble(m_pParam->GetKey_DBL("CutPower")) ? 100 : int(m_pParam->GetKey_DBL("CutPower")), NULL,						0,		100,	true, Percent, 0},
		{"CutFrequency",		IDC_EDIT_CUTTINGFREQ,		0,	IsInvalidDouble(m_pParam->GetKey_DBL("CutFrequency")) ? 5000 : int(m_pParam->GetKey_DBL("CutFrequency")), NULL,				0,		100000,	true, Frequece, 0},
		{"CutDutyCycle",		IDC_EDIT_CUTTINGCYCLE,		0,	IsInvalidDouble(m_pParam->GetKey_DBL("CutDutyCycle")) ? 100 : int(m_pParam->GetKey_DBL("CutDutyCycle")), NULL,				0,		100,	true, Percent, 0},
		{"CutPressure",			IDC_EDIT_CUTTINGPRESSURE,	1,	NULL, IsInvalidDouble(m_pParam->GetKey_DBL("CutPressure")) ? 100 : m_pParam->GetKey_DBL("CutPressure"),						0,		100,	true, Pressure_Percent, 1},
		{"BeforeLightOnDelay",	IDC_EDIT_BEFORELINGHTONDELAY,1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("BeforeLightOnDelay")) ? 100 : m_pParam->GetKey_DBL("BeforeLightOnDelay"),		0,		1800000,true, Time_MS, 0},
		{"AfterLightOnDelay",	IDC_EDIT_AFTERLIGHTONDELAY,	1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("AfterLightOnDelay")) ? 200 : m_pParam->GetKey_DBL("AfterLightOnDelay"),			0,		1800000,true, Time_MS, 0},
		{"PerHeight",			IDC_EDIT_PERFORATEHEIGHT,	1,	NULL,	IsInvalidDouble(m_pParam->GetKey_DBL("PerHeight")) ? 5 : m_pParam->GetKey_DBL("PerHeight"),							0.01,	100,	true, Length_MM, 1},
		{"PerTime",				IDC_EDIT_PERFORATETIME,		1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("PerTime")) ? 200 : m_pParam->GetKey_DBL("PerTime"),								100,	180000,	true, Time_MS, 0},
		{"PerPower",			IDC_EDIT_PERFORATEPOWER,	0,	IsInvalidDouble(m_pParam->GetKey_DBL("PerPower")) ? 50 : int(m_pParam->GetKey_DBL("PerPower")), NULL,						0,		100,	true, Percent, 0},
		{"PerFrequency",		IDC_EDIT_PERFORATEFREQ,		0,	IsInvalidDouble(m_pParam->GetKey_DBL("PerFrequency")) ? 1000 : int(m_pParam->GetKey_DBL("PerFrequency")), NULL,				0,		100000,	true, Frequece, 0},
		{"PerDutyCycle",		IDC_EDIT_PERFORATECYCLE,	0,	IsInvalidDouble(m_pParam->GetKey_DBL("PerDutyCycle")) ? 50 : int(m_pParam->GetKey_DBL("PerDutyCycle")), NULL,				0,		100,	true, Percent, 0},
		{"PerPressure",			IDC_EDIT_PERFORATEPRESSURE,	1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("PerPressure")) ? 100 : m_pParam->GetKey_DBL("PerPressure"),						0,		100,	true, Pressure_Percent, 1},
		{"BeforeLightOffDelay",	IDC_EDIT_AFTERLIGHTOFFDELAY,1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("BeforeLightOffDelay")) ? 100 : m_pParam->GetKey_DBL("BeforeLightOffDelay"),		0,		1800000,true, Time_MS, 0},
		{"SlowlyStartupDis",	IDC_EDIT_STARTUPDIS,		1,	NULL,	IsInvalidDouble(m_pParam->GetKey_DBL("SlowlyStartupDis")) ? 2 : m_pParam->GetKey_DBL("SlowlyStartupDis"),			0,		10000,	true, Length_MM, 1},
		{"SlowlyStartupSpeed",	IDC_EDIT_STARTUPSPEED,		0,	IsInvalidDouble(m_pParam->GetKey_DBL("SlowlyStartupSpeed")) ? 180 : int(m_pParam->GetKey_DBL("SlowlyStartupSpeed")),NULL,	0,		100000,	true, Speed_MMperMin, 0},
		{"LiftHeight",			IDC_EDIT_LIFTHEIGHT,		1,	NULL, IsInvalidDouble(m_pParam->GetKey_DBL("LiftHeight")) ? 10 : m_pParam->GetKey_DBL("LiftHeight"),						0,		1000,	true, Length_MM, 1},
		{"ZupDelay",			IDC_EDIT_ZUPDELAY,			1,	NULL,!_bNoF || IsInvalidDouble(m_pParam->GetKey_DBL("ZupDelay")) ? 300 : m_pParam->GetKey_DBL("ZupDelay"), 					0,		1800000,m_nFTCType == 2, Time_MS, 0},
		{"FollowDelay",			IDC_EDIT_FOLLOWDELAY,		1,	NULL,!_bNoF || IsInvalidDouble(m_pParam->GetKey_DBL("FollowDelay")) ? 100 : m_pParam->GetKey_DBL("FollowDelay"), 			0,		1800000,m_nFTCType == 2, Time_MS, 0},
		{"ConPerSpeed",			IDC_EDIT_CONPERSPEED,		1,	NULL, IsInvalidDouble(m_pParam->GetKey_DBL("ConPerSpeed")) ? 5 : m_pParam->GetKey_DBL("ConPerSpeed"),						0.1,	100,	true, Speed_MMperS, 1},
		{"OvercutAngle",		IDC_EDIT_CIRCLEANGLE,		0,	IsInvalidDouble(m_pParam->GetKey_DBL("OvercutAngle")) ? 120 : int(m_pParam->GetKey_DBL("OvercutAngle")),NULL,				0,		150,	true, degree, 0},
		{"OvercutLength",		IDC_EDIT_OVERCUTLENGTH,		1,	NULL, IsInvalidDouble(m_pParam->GetKey_DBL("OvercutLength")) ? 2 : m_pParam->GetKey_DBL("OvercutLength"),					0.1,	100.0,	true, Length_MM, 1},
		{"PrePerLiftHeight",	IDC_EDIT_PREPERFORATEHEIGHT,1,	NULL, IsInvalidDouble(m_pParam->GetKey_DBL("PrePerLiftHeight")) ? 2 : m_pParam->GetKey_DBL("PrePerLiftHeight"),				0,		1000.0,	m_nFTCType != 2, Length_MM, 1},
		{"EnterIntroSpeed",		IDC_EDIT_INSPEED,			1,	NULL, IsInvalidDouble(m_pParam->GetKey_DBL("EnterIntroSpeed")) ? 200 : m_pParam->GetKey_DBL("EnterIntroSpeed"),				1,		100000,	true, Speed_MMperMin, 0},
		{"ExitIntroSpeed",		IDC_EDIT_OUTSPEED,			1,	NULL, IsInvalidDouble(m_pParam->GetKey_DBL("ExitIntroSpeed")) ? 200 : m_pParam->GetKey_DBL("ExitIntroSpeed"),				1,		100000,	true, Speed_MMperMin, 0},
		{"CutFocusPos",			IDC_EDIT_CUTFOCUS,			1,	NULL, IsInvalidDouble(m_pParam->GetKey_DBL("CutFocusPos")) ? 0 : m_pParam->GetKey_DBL("CutFocusPos"),						-100,	100,		true, Length_MM, 1},
		{"PerFocusPos",			IDC_EDIT_PUNCHFOCUS,		1,	NULL, IsInvalidDouble(m_pParam->GetKey_DBL("PerFocusPos")) ? 0 : m_pParam->GetKey_DBL("PerFocusPos"),						-100,	100,		true, Length_MM, 1},
		{"StopCornerDelay",		IDC_EDIT_STOPCORNERDELAY, 1, NULL,IsInvalidDouble(m_pParam->GetKey_DBL("StopCornerDelay")) ? 400 : m_pParam->GetKey_DBL("StopCornerDelay"),		0,		1800000,true, Time_MS, 0},
	};

	// ʼֵȥ ---- ƺ 2015-05-05
	m_listEdits.clear();
	for (size_t _i = 0; _i < _countof(_s_Edits); _i++)
	{
		EditInfo _item = _s_Edits[_i];
		Units _nCurUnit = GetCurSpeedUnit();
		if ((_item.nUnit == Speed_INperMin
			|| _item.nUnit == Speed_MMperMin
			|| _item.nUnit == Speed_MMperS
			|| _item.nUnit == Speed_MperMin)
			&& _item.nUnit != _nCurUnit)
		{
			ConverUnit(_item.nUnit, _nCurUnit, _s_Edits[_i], _item);
		}

		_nCurUnit = GetCurAccUnit();
		if ((_item.nUnit == Acc_MMperS2
			|| _item.nUnit == ACC_MperMin2
			|| _item.nUnit == Acc_10MperS2)
			&& _item.nUnit !=_nCurUnit)
		{
			ConverUnit(_item.nUnit, _nCurUnit, _s_Edits[_i], _item);
		}

		_nCurUnit = GetCurTimeUnit();
		if ((_item.nUnit == Time_MS
			|| _item.nUnit == Time_S)
			&& _item.nUnit != _nCurUnit)
		{
			ConverUnit(_item.nUnit, _nCurUnit, _s_Edits[_i], _item);
		}

		_nCurUnit = GetCurPressureUnit();
		if ((_item.nUnit == Pressure_Percent
			|| _item.nUnit == Pressure_MPa)
			&& _item.nUnit != _nCurUnit)
		{
			ConverUnit(_item.nUnit, _nCurUnit, _s_Edits[_i], _item);
		}

		m_listEdits.push_back(_item);

		double _nValue = _s_Edits[_i].nDataType == 0 ? _s_Edits[_i].iValue : _s_Edits[_i].dValue;
		if (m_pParam->GetKey_DBL(_s_Edits[_i].strKey) != _nValue)
			m_pParam->SetKey_DBL(_s_Edits[_i].strKey, _nValue);
	}
}
CLayerParamDlg::~CLayerParamDlg()
{
}

CParam* CLayerParamDlg::GetParam()
{
	return m_pParam;
}

void CLayerParamDlg::SetParam(CParam* pParam_)
{
	m_pParam = pParam_;

	// Enable
	CString _strEnableFP = m_pParam->GetKey(LPSTR(c_szEnableFPMap));
	m_bFPEnable = _strEnableFP == "1" ? TRUE : FALSE;

	// 
	m_vectCurLine.clear();
	CString _strFTemp = "FF%d";
	CString _strPTemp = "FP%d";
	for (int _it = 0; _it <= 100; _it++)
	{
		CString _strF;
		_strF.Format(_strFTemp, _it);
		CString _strP;
		_strP.Format(_strPTemp, _it);

		CStringA _strFValue = m_pParam->GetKey(_strF);
		CStringA _strPValue = m_pParam->GetKey(_strP);
		if (_strFValue.IsEmpty() || _strPValue.IsEmpty())
		{
			break;
		}

		FPPoint _FPPoint;
		_FPPoint.nSpeed = atoi(_strFValue);
		_FPPoint.nPower = atoi(_strPValue);
		m_vectCurLine.push_back(_FPPoint);
	}
	ASSERT(m_vectCurLine.size() >=2
			&& m_vectCurLine.front().nSpeed == 0
			&& m_vectCurLine.back().nSpeed == 100
		);

	UpdateData(FALSE);
	InvalidateRect(m_rectCoorCanvas, FALSE);
}

void CLayerParamDlg::BuildDefaultParam(nce::CParam* pParam_)
{
	if (!pParam_)
	{
		ASSERT(FALSE);
		return;
	}

	struct DVItem
	{
		CStringA strKey;
		CStringA strDefualtValue;
	};
	DVItem _DVItems[] =
	{
		{"PerforateType", "0"},
		{"Output", "1"},
		{"PrePerforate", "0"},
		{"FixedHeightCut", "0"},
		{"OutsideCutFollow", "0"},
		{"SlowlyStartup", "0"},
		{"CutBlowType", "0"},
		{"PerBlowType", "0"},
		{"Overcut", "0"},
		{"EnableIntroSpeed", "0"},
		{"Feedrate", "1000"},
		{"FollowHeight", "1"},
		{"CutPower", "100"},
		{"CutFrequency", "5000"},
		{"CutDutyCycle", "100"},
		{"CutPressure", "100"},
		{"BeforeLightOnDelay", "100"},
		{"AfterLightOnDelay", "200"},
		{"PerHeight", "5"},
		{"PerTime", "200"},
		{"PerPower", "50"},
		{"PerFrequency", "1000"},
		{"PerDutyCycle", "50"},
		{"PerPressure", "100"},
		{"BeforeLightOffDelay", "100"},
		{"SlowlyStartupDis", "2"},
		{"SlowlyStartupSpeed", "180"},
		{"LiftHeight", "10"},
		{"ZupDelay", "300"},
		{"FollowDelay", "100"},
		{"ConPerSpeed", "5"},
		{"OvercutAngle", "120"},
		{"OvercutLength", "2"},
		{"PrePerLiftHeight", "2"},
		{"EnterIntroSpeed", "200"},
		{"ExitIntroSpeed", "200"},
		{"CutFocusPos", "0"},
		{"PerFocusPos", "0"},
	};
	for (int _i = 0; _i < _countof(_DVItems); _i++)
	{
		CStringA _strCurValue = pParam_->GetKey(_DVItems[_i].strKey);
		if (_strCurValue.IsEmpty())
			pParam_->SetKey(_DVItems[_i].strKey, _DVItems[_i].strDefualtValue);
	}
}

void CLayerParamDlg::SaveFPCurve()
{
	// Ƿٶȹ ---- DingQiang 2014-12-31
	CString _strFPMapEnable;
	_strFPMapEnable += m_bFPEnable ? "1" : "0";
	m_pParam->SetKey(LPSTR(c_szEnableFPMap),_strFPMapEnable);

	// ɾ֮ǰ㣬涨ֻ101 ---- DingQiang 2015-01-28
	CString _strParam = m_pParam->GetParamString();
	for (int _i = 0; _i < 101; _i++)
	{
		CString _strKey;
		_strKey.Format("FF%d=", _i);
		int _nS = _strParam.Find(_strKey);
		if (_nS < 0)
		{
			continue;
		}

		int _nE = _strParam.Find(";", _nS);
		ASSERT(_nE >= 0);
		_strParam.Delete(_nS, _nE - _nS + 1);

		_strKey.Format("FP%d", _i);
		_nS = _strParam.Find(_strKey);
		ASSERT(_nS >= 0);
		_nE = _strParam.Find(";", _nS);
		ASSERT(_nE > 0);
		_strParam.Delete(_nS, _nE - _nS + 1);
	}
	m_pParam->SetParamString(_strParam);

	// дµ ---- DingQiang 2015-01-28
	for (size_t _it = 0; _it < m_vectCurLine.size(); _it++)
	{
		int _nSpeed = m_vectCurLine[_it].nSpeed;
		int _nPower = m_vectCurLine[_it].nPower;
		ASSERT(_nSpeed >= 0 && _nPower >= 0 && _nSpeed <= 100 && _nPower <= 100);
		CString _strKey;
		_strKey.Format("FF%d", _it);
		CString _strValue;
		_strValue.Format("%d", _nSpeed);
		m_pParam->SetKey(_strKey, _strValue);

		_strKey.Format("FP%d", _it);
		_strValue.Format("%d", _nPower);
		m_pParam->SetKey(_strKey, _strValue);
	}
	// CutPower  Power һԡ
	double _nCutPower = m_pParam->GetKey_DBL("CutPower");
	m_pParam->SetKey_DBL("Power", _nCutPower);
}

BOOL CLayerParamDlg::Create(UINT nIDTemplate_, CWnd* pParentWnd_ /* = NULL */)
{
	::AfxInitRichEdit2();
	return __super::Create(nIDTemplate_, pParentWnd_);
}

void CLayerParamDlg::DoDataExchange(CDataExchange* pDX_)
{
	//ûȡ ----  2016-07-21
	if (m_bCancelData)
	{
		return;
	}

	__super::DoDataExchange(pDX_);
	DDX_Check(pDX_, IDC_CHECK_ENABLEFPMAPPING, m_bFPEnable);

	for (EditItems::iterator _it = m_listEdits.begin(); _it != m_listEdits.end(); _it++)
	{
		// õľͲ¡ ---- ƺ 2015-03-17
		if (!_it->bEnable)
			continue;

		if (_it->nDataType == 0)
		{
			DDX_Text(pDX_, _it->nID, _it->iValue);
			DDV_MinMaxInt(pDX_, _it->iValue, int(_it->nMinValue), int(_it->nMaxValue));
		}
		else
		{
			ASSERT(_it->nDataType == 1);
			DDX_Text(pDX_, _it->nID, _it->dValue);
			DDV_MinMaxDouble(pDX_, _it->dValue, _it->nMinValue, _it->nMaxValue);
		}
	}
}

BOOL CLayerParamDlg::OnInitDialog()
{
	BOOL _bRet = __super::OnInitDialog();

	CHARFORMAT _cf;
	memset(&_cf, 0, sizeof(CHARFORMAT));
	_cf.cbSize = sizeof(CHARFORMAT);
	_cf.dwMask = CFM_FACE | CFM_OFFSET | CFM_SIZE | CFM_COLOR;
	_cf.yOffset = 0;
	_cf.yHeight = 180;
	_cf.crTextColor = RGB(0, 0, 255);
	 strcpy(_cf.szFaceName, "");
	CRichEditCtrl* _pRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_EDIT_UESEREMARK);
	if (!_pRichEdit->SetDefaultCharFormat(_cf))
	{
		ASSERT(FALSE);
	}
	SetTimer(1, 100,NULL);

	CWnd* _pWnd = GetDlgItem(IDC_STC_FPCANVAS);
	_pWnd->GetClientRect(&m_rectCanvas);
	_pWnd->GetWindowRect(&m_rectCoorCanvas);
	ScreenToClient(&m_rectCoorCanvas);
	m_rcEffectRect.left = m_rectCanvas.left + c_nOffset;
	m_rcEffectRect.right = m_rectCanvas.left + c_nEffectWeight + c_nOffset;
	m_rcEffectRect.top = m_rectCanvas.bottom - c_nOffset - c_nEffectHeight;
	m_rcEffectRect.bottom = m_rectCanvas.bottom - c_nOffset;

	CComboBox* _pComb = (CComboBox*)GetDlgItem(IDC_COMBO_CUTTINGAIR);
	for (int _i = 0; _i < (int)m_vectCutGas.size(); _i++)
	{
		_pComb->InsertString(_i, m_vectCutGas[_i].strText);
	}

	_pComb = (CComboBox*)GetDlgItem(IDC_COMBO_PERFORATEAIR);
	for (int _i = 0; _i < (int)m_vectPerGas.size(); _i++)
	{
		_pComb->InsertString(_i, m_vectPerGas[_i].strText);
	}

	_pComb = (CComboBox*)GetDlgItem(IDC_COMBO_COOLINGAIR);
	for (int _i = 0; _i < (int)m_vectPerGas.size(); _i++)
	{
		_pComb->InsertString(_i, m_vectPerGas[_i].strText);
	}

	GetDlgItem(IDC_STATIC_STARTUPDIS)->EnableWindow(FALSE);
	GetDlgItem(IDC_STATIC_STARTUPSPEED)->EnableWindow(FALSE);
	GetDlgItem(IDC_STATIC_STARTUPDISUNIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_STATIC_STARTUPSPEEDUNIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_STARTUPDIS)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_STARTUPSPEED)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK_PATHCOOL)->EnableWindow(FALSE);

	// 涯ǣֻͨ涯Z˿ڿ涯ǣʾZʱ涯ʱ
	// ߶ȡͣλá,ʾ̧߶ȡ ---- ƺ 2015-03-13
	GetDlgItem(IDC_STATIC_ZUPDELAY)->ShowWindow(m_nFTCType == 2 ? SW_NORMAL : SW_HIDE);
	GetDlgItem(IDC_EDIT_ZUPDELAY)->ShowWindow(m_nFTCType == 2 ? SW_NORMAL : SW_HIDE);
	GetDlgItem(IDC_STATIC_ZUPDELAYUNIT)->ShowWindow(m_nFTCType == 2 ? SW_NORMAL : SW_HIDE);

	GetDlgItem(IDC_STATIC_FOLLOWDELAYUNIT)->ShowWindow(m_nFTCType == 2 ? SW_NORMAL : SW_HIDE);
	GetDlgItem(IDC_STATIC_FOLLOWDELAY)->ShowWindow(m_nFTCType == 2 ? SW_NORMAL : SW_HIDE);
	GetDlgItem(IDC_EDIT_FOLLOWDELAY)->ShowWindow(m_nFTCType == 2 ? SW_NORMAL : SW_HIDE);

	GetDlgItem(IDC_STATIC_LIFTHEIGHT)->ShowWindow(m_nFTCType != 2 ? SW_NORMAL : SW_HIDE);
	GetDlgItem(IDC_EDIT_LIFTHEIGHT)->ShowWindow(m_nFTCType != 2 ? SW_NORMAL : SW_HIDE);
	GetDlgItem(IDC_STATIC_LIFTHEIGHTUNIT)->ShowWindow(m_nFTCType != 2 ? SW_NORMAL : SW_HIDE);

	GetDlgItem(IDC_STATIC_FOLLOWHEIGHT)->EnableWindow(m_nFTCType != 2);
	GetDlgItem(IDC_EDIT_FOLLOWHEIGHT)->EnableWindow(m_nFTCType != 2);
	GetDlgItem(IDC_STATIC_FOLLOWHEIGHTUNIT)->EnableWindow(m_nFTCType != 2);

	GetDlgItem(IDC_STATIC_IMPORTAREA)->GetWindowRect(m_rcImportBtn);
	GetDlgItem(IDC_STATIC_SAVEBTNRECT)->GetWindowRect(m_rcSaveBtn);
	GetDlgItem(IDC_STATIC_IMPORTAREA)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_STATIC_SAVEBTNRECT)->ShowWindow(SW_HIDE);
	ScreenToClient(m_rcImportBtn);
	ScreenToClient(m_rcSaveBtn);

	// INIп<ͼ㲻><വ>Ƿ ----  2016-01-12
	CString _strENCB = NceGetPrivateProfileString(_T("PGLayerDlg"), _T("EnableNotCloseBlow"), _T("0"));
	CString _strESB = NceGetPrivateProfileString(_T("PGLayerDlg"), _T("EnableSideBlow"), _T("0"));
	bool _bEnableNotCloseBlow = (atoi(_strENCB) != 0);
	bool _bEnableSideBlow = (atoi(_strESB) != 0);
	GetDlgItem(IDC_CHECK_NOTCLOSEBLOW)->EnableWindow(_bEnableNotCloseBlow ? TRUE : FALSE);
	GetDlgItem(IDC_CHECK_PUNCHSIDEBLOW)->EnableWindow(_bEnableSideBlow ? TRUE : FALSE);
	GetDlgItem(IDC_CHECK_CUTTINGSIDEBLOW)->EnableWindow(_bEnableSideBlow ? TRUE : FALSE);

	// ǷǼ򻯰汾LALT汾ͼ<Ԥ><><ȴʱ><ȴ>Ƿ ---- ߿ϼ 2016-11-28
	CString _strSV = NceGetPrivateProfileString(_T("PGLayerDlg"), _T("SimplifiedVersion"), _T("0"));
	bool _bSimplifiedVersion = (atoi(_strSV) != 0);
	GetDlgItem(IDC_CHECK_PREPERFORATE)->ShowWindow(_bSimplifiedVersion ? FALSE : TRUE);
	GetDlgItem(IDC_RADIO_THREESEGPUNCH)->ShowWindow(_bSimplifiedVersion ? FALSE : TRUE);
	GetDlgItem(IDC_STATIC_COOLDELAY)->ShowWindow(_bSimplifiedVersion ? FALSE : TRUE);
	GetDlgItem(IDC_EDIT_STOPCORNERDELAY)->ShowWindow(_bSimplifiedVersion ? FALSE : TRUE);
	GetDlgItem(IDC_STATIC_STOPCORNERDELAY)->ShowWindow(_bSimplifiedVersion ? FALSE : TRUE);
	GetDlgItem(IDC_STATIC_COOLINGAIR)->ShowWindow(_bSimplifiedVersion ? FALSE : TRUE);
	GetDlgItem(IDC_COMBO_COOLINGAIR)->ShowWindow(_bSimplifiedVersion ? FALSE : TRUE);

	SetParam(m_pParam);
	SetText();
	Update();
	UpFocusCtrls();
	return _bRet;
}

void CLayerParamDlg::OnOK()
{
}

void CLayerParamDlg::InitCancelData()
{
	m_bCancelData = false;
}

void CLayerParamDlg::OnCancel()
{
	m_bCancelData = true;
}

void CLayerParamDlg::SetText()
{
	SetDlgItemText(IDC_CHECK_PREPERFORATE, _GETCS(s_szPREPERFORATE));
	SetDlgItemText(IDC_RADIO_DIRPERFORATE, _GETCS(s_szPIERCEDIRECTLY));
	SetDlgItemText(IDC_RADIO_CONPERORATE, _GETCS(s_szINCREMENGTPIERCE));
	SetDlgItemText(IDC_RADIO_SEGPERFORATE, _GETCS(s_szPIERCEBYSECTION));
	SetDlgItemText(IDC_CHECK_ISIGNORE, _GETCS(s_szNEGLECTTHISLAYER));
	SetDlgItemText(IDC_CHECK_ISSTARTUPSLOWLY, _GETCS(s_szLOWSPEEDSTARTUP));
	SetDlgItemText(IDC_STATIC_TECHNICPARAM, _GETCS(s_szTECHNICPARAMETERS));
	SetDlgItemText(IDC_STATIC_PERFORATETYPE, _GETCS(s_szMACHMODE));
	SetDlgItemText(IDC_STATIC_CUTTINGSPEED, _GETCS(s_szCUTSPEED));
	SetDlgItemText(IDC_STATIC_CUTTINGPOWER, _GETCS(s_szCUTPOWER));
	SetDlgItemText(IDC_STATIC_CUTTINGFREQ, _GETCS(s_szCUTFREQUENCY));
	SetDlgItemText(IDC_STATIC_CUTTINGCYCLE, _GETCS(s_szDUTYCYCLERATIO));
	SetDlgItemText(IDC_STATIC_CUTTINGPRESSURE, _GETCS(s_szCUTPRESSURE));
	SetDlgItemText(IDC_STATIC_CUTTINGAIR, _GETCS(s_szCUTGAS));
	SetDlgItemText(IDC_STATIC_FOLLOWHEIGHT, _GETCS(s_szFOLLOWINGHEIGHT));
	SetDlgItemText(IDC_STATIC_BEFORELIGHTONDELAY, _GETCS(s_szBEFORELIGHTONDELAY));
	SetDlgItemText(IDC_STATIC_AFTERLIGHTONDELAY, _GETCS(s_szPOSTLASERONDELAY));
	SetDlgItemText(IDC_STATIC_CUTFOCUS, _GETCS(s_szCUTFOCUS));

	SetDlgItemText(IDC_STATIC_PERFORATEHEIGHT, _GETCS(s_szPIERCEHEIGHT));
	SetDlgItemText(IDC_STATIC_PERFORATETIME, _GETCS(s_szPIERCETIME));
	SetDlgItemText(IDC_STATIC_PERFORATEPOWER, _GETCS(s_szPIERCEPOWER));
	SetDlgItemText(IDC_STATIC_PERFORATEFREQ, _GETCS(s_szPIERCEFREQUENCY));
	SetDlgItemText(IDC_STATIC_PERCYCLE, _GETCS(s_szPIERCEDUTYCYCLERATIO));
	SetDlgItemText(IDC_STATIC_PERFORATEAIR, _GETCS(s_szPIERCEGAS));
	SetDlgItemText(IDC_STATIC_PERFORATEPRESSURE, _GETCS(s_szPIERCEPRESSURE));
	SetDlgItemText(IDC_STATIC_AFTERLIGHTOFFDELAY, _GETCS(s_szPOSTLAEROFFDELAY));
	SetDlgItemText(IDC_STATIC_PUNCHFOCUS, _GETCS(s_szPUNCHFOCUS));

	SetDlgItemText(IDC_STATIC_SPEEDPOWERCURVE, _GETCS(s_szSPEEDPOWERCURVE));
	SetDlgItemText(IDC_STATIC_USERREMARK, _GETCS(s_szRAMARKS));
	SetDlgItemText(IDC_STATIC_SPECIALTECHNICPARAM, _GETCS(s_szSPECIALPARAMETERS));
	SetDlgItemText(IDC_STATIC_STARTUPDIS, _GETCS(s_szSTARTUPDIS));
	SetDlgItemText(IDC_STATIC_STARTUPSPEED, _GETCS(s_szSTARTUPSPEED));
	SetDlgItemText(IDC_STATIC_LIFTHEIGHT, _GETCS(s_szLIFTHEIGHT));
	SetDlgItemText(IDC_STATIC_FOLLOWDELAY, _GETCS(s_szFOLLOWDELAY));
	SetDlgItemText(IDC_STATIC_ZUPDELAY, _GETCS(s_szZUPDELAY));
	SetDlgItemText(IDC_STATIC_CONPERSPEED, _GETCS(s_szCONPERSPEED));
	SetDlgItemText(IDC_STATIC_IMPORTLAYERPARAM, _GETCS(s_szIMPORTPARAM));
	SetDlgItemText(IDC_STATIC_LAYERPARAMSAVE, _GETCS(s_szSAVEPARAM));

	SetDlgItemText(IDC_CHECK_PATHCOOL, _GETCS(s_szPATHCOOL));
	SetDlgItemText(IDC_RADIO_THREESEGPUNCH, _GETCS(s_szEXPLODEPUNCH));
	SetDlgItemText(IDC_CHECK_CIRCLEOVERCUT, _GETCS(s_szCIRCLEOVERCUT));
	SetDlgItemText(IDC_STATIC_CIRCLEANGLE, _GETCS(s_szOVERCUTANGLE));
	SetDlgItemText(IDC_STATIC_OVERCUTLENGTH, _GETCS(s_szOVERCUTLENGTH));
	SetDlgItemText(IDC_STATIC_SPECIALTENICH, _GETCS(s_szSPECIALTENICH));
	SetDlgItemText(IDC_CHECK_FIXHEIGHTCUT, _GETCS(s_szFIXEDHEIGHTCUT));
	SetDlgItemText(IDC_STATIC_PREPERFORATEHEIGHT, _GETCS(s_szPREPERLIFTHEIGHT));
	SetDlgItemText(IDC_CHECK_CUTTINGFROMOUTSIDE, _GETCS(s_szCUTTINGFROMOUTSIDE));

	SetDlgItemText(IDC_CHECK_ENABLEFPMAPPING, _GETCS(s_szENABLEFPMAPPING));
	SetDlgItemText(IDC_BTN_EDITFPMAP, _GETCS(s_szEDITFPMAP));
	SetDlgItemText(IDC_CHECK_NOTCLOSEBLOW, _GETCS(s_szNOTCLOSEBLOW));
	SetDlgItemText(IDC_STATIC_COOLDELAY, _GETCS(s_szCOOLDELAY));
	SetDlgItemText(IDC_STATIC_COOLINGAIR, _GETCS(s_szCOOLINGAIR));
	SetDlgItemText(IDC_CHECK_PUNCHSIDEBLOW, _GETCS(s_szPIECESIDEBLOW));
	SetDlgItemText(IDC_CHECK_CUTTINGSIDEBLOW, _GETCS(s_szMACHSIDEBLOW));
	SetDlgItemText(IDC_CHECK_ENABLEINTROSPEED, _GETCS(s_szENABLELEADSPEED));
	SetDlgItemText(IDC_STC_INSPEED, _GETCS(s_szLEADINSPEED));
	SetDlgItemText(IDC_STC_OUTSPEED, _GETCS(s_szLEADOUTSPEED));
}

// ûעͼУΪûͼĳһԼַLuaĽ
// ؽ'\\'';''=''\"''\'''\r''\n'ֱ滻ΪASCIIΪ0x160x070x1D0x1E0x1F0x060x10
// PS:0x16 SYSһ豸ָͬеġ
//    0x07 ҲǸ豸
//    0x06 ȷϣҪȫ˫˫ıͨš
//    0x10 ·ת壬紫
//    0x1D0x1E0x1FֱLinxUnixƽ̨AWKıеķ¼ָԪָǶõWindowsġ
//    Ͻ۾磬Ľ滻ַӦûʲôӰ죬ִ󣬷֪¡
// ---- ƺ 2015-02-04
CString CLayerParamDlg::Normative(LPCTSTR pszValue_)
{
	CString _strRet(pszValue_);
	_strRet.Replace('\\', 0x16);
	_strRet.Replace(';', 0x07);
	_strRet.Replace('=', 0x1D);
	_strRet.Replace('\"', 0x1E);
	_strRet.Replace('\'', 0x1F);
	_strRet.Replace('\r', 0x06);
	_strRet.Replace('\n', 0x10);
	return _strRet;
}

// 0x160x070x1D0x1E0x1Fֱ滻Ϊ'\\'';''=''\"''\''Normative̡
// ---- ƺ 2015-02-04
CString CLayerParamDlg::ReverseNormative(LPCTSTR pszValue_)
{
	CString _strRet(pszValue_);
	_strRet.Replace(0x16, '\\');
	_strRet.Replace(0x07, ';');
	_strRet.Replace(0x1D, '=');
	_strRet.Replace(0x1E, '\"');
	_strRet.Replace(0x1F, '\'');
	_strRet.Replace(0x06, '\r');
	_strRet.Replace(0x10, '\n');
	return _strRet;
}

// ǷЧ ----  2016-07-20
bool CLayerParamDlg::IsNumberValid(LPCTSTR pszText_)
{
	if (!pszText_)
	{
		return false;
	}

	CString _strText(pszText_);
	if (_strText.IsEmpty())
	{
		return false;
	}

	int _nDotCount = 0;
	for (int _i = 0; _i < _strText.GetLength(); _i++)
	{
		if (_i == 0 && (_strText[_i] == '-' || _strText[_i] == '+'))
		{
			continue;
		}

		if (!isdigit(_strText[_i]) && _strText[_i] != '.')
		{
			return false;
		}

		if (_strText[_i] == '.')
		{
			_nDotCount++;
		}
	}

	if (_nDotCount > 1)
	{
		return false;
	}

	return true;
}

bool CLayerParamDlg::GetInputValid()
{
	if (this->GetFocus() != NULL)
	{
		if (!IsInputValid(this->GetFocus()->GetDlgCtrlID()))
		{
			return false;
		}
	}

	return true;
}

bool CLayerParamDlg::IsInputValid(UINT nID_)
{
	bool _bDataValid = true;
	for (EditItems::iterator _it = m_listEdits.begin(); _it != m_listEdits.end(); _it++)
	{
		if (_it->nID != nID_)
			continue;

		// ҵFocusEdit֤Ч ----  2016-07-20
		m_bDataValid = false;
		_bDataValid = false;
		bool _bTempDataValid = true;

		// ǷЧ 
		CString _strText = _T("");
		GetDlgItemText(_it->nID, _strText);
		if (!IsNumberValid(_strText))
		{
			_bTempDataValid = false;
		}

		if (!_bTempDataValid)
		{
			m_bCancelData = true;
			AfxMessageBox(_GETCS(s_csINVALIDINPUT));
			m_bCancelData = false;
		}

		// ݡ
		if (_bTempDataValid && UpdateData(TRUE))
		{
			m_bDataValid = true;
			_bDataValid = true;
			double _nValue = _it->nDataType == 0 ? _it->iValue : _it->dValue;
			Units _nCurUnit = GetCurSpeedUnit();
			if ((_it->nUnit == Speed_INperMin
				|| _it->nUnit == Speed_MMperMin
				|| _it->nUnit == Speed_MMperS
				|| _it->nUnit == Speed_MperMin)
				&& _it->nUnit != _nCurUnit)
			{
				ConverUnit(_nCurUnit, _it->nUnit, _nValue, _nValue);
			}

			_nCurUnit = GetCurAccUnit();
			if ((_it->nUnit == Acc_MMperS2
				|| _it->nUnit == ACC_MperMin2
				|| _it->nUnit == Acc_10MperS2)
				&& _it->nUnit !=_nCurUnit)
			{
				ConverUnit(_nCurUnit, _it->nUnit, _nValue, _nValue);
			}

			_nCurUnit = GetCurTimeUnit();
			if ((_it->nUnit == Time_MS
				|| _it->nUnit == Time_S)
				&& _it->nUnit != _nCurUnit)
			{
				ConverUnit(_nCurUnit, _it->nUnit, _nValue, _nValue);
			}

			_nCurUnit = GetCurPressureUnit();
			if ((_it->nUnit == Pressure_Percent
				|| _it->nUnit == Pressure_MPa)
				&& _it->nUnit != _nCurUnit)
			{
				ConverUnit(_nCurUnit, _it->nUnit, _nValue, _nValue);
			}

			// ת ---- ƺ 2015-09-23
			if (_it->nInitDataType == 0)
				_nValue = (int)_nValue;

			if (m_pParam->GetKey_DBL(_it->strKey) != _nValue)
			{
				m_pParam->SetKey_DBL(_it->strKey, _nValue);
			}
		}

		// ʽʾ
		double _nValue = m_pParam->GetKey_DBL(_it->strKey);
		Units _nCurUnit = GetCurSpeedUnit();
		if ((_it->nUnit == Speed_INperMin
			|| _it->nUnit == Speed_MMperMin
			|| _it->nUnit == Speed_MMperS
			|| _it->nUnit == Speed_MperMin)
			&& _it->nUnit != _nCurUnit)
		{
			ConverUnit(_it->nUnit, _nCurUnit, _nValue, _nValue);
		}

		_nCurUnit = GetCurAccUnit();
		if ((_it->nUnit == Acc_MMperS2
			|| _it->nUnit == ACC_MperMin2
			|| _it->nUnit == Acc_10MperS2)
			&& _it->nUnit !=_nCurUnit)
		{
			ConverUnit(_it->nUnit, _nCurUnit, _nValue, _nValue);
		}

		_nCurUnit = GetCurTimeUnit();
		if ((_it->nUnit == Time_MS
			|| _it->nUnit == Time_S)
			&& _it->nUnit != _nCurUnit)
		{
			ConverUnit(_it->nUnit, _nCurUnit, _nValue, _nValue);
		}

		_nCurUnit = GetCurPressureUnit();
		if ((_it->nUnit == Pressure_Percent
			|| _it->nUnit == Pressure_MPa)
			&& _it->nUnit != _nCurUnit)
		{
			ConverUnit(_it->nUnit, _nCurUnit, _nValue, _nValue);
		}

		if (_it->nDataType == 0)
		{
			CStringA _str;
			_str.Format("%d", int(_nValue));
			SetDlgItemText(_it->nID, _str);
			GetDlgItem(_it->nID)->SetFocus();
		}
		else
		{
			CStringA _str;
			_str.Format("%.3f", _nValue);
			FormatDoubleParamer(_str);
			SetDlgItemText(_it->nID, _str);
			GetDlgItem(_it->nID)->SetFocus();
		}

		break;
	}

	return _bDataValid;
}

void CLayerParamDlg::OnKillFocusEdit(UINT nID_)
{
	//ûȡ ----  2016-07-21
	if (m_bCancelData)
	{
		return;
	}

	for (EditItems::iterator _it = m_listEdits.begin(); _it != m_listEdits.end(); _it++)
	{
		if (_it->nID != nID_)
			continue;

		// ҵFocusEdit֤Ч ----  2016-07-20
		m_bDataValid = false;
		bool _bTempDataValid = true;

		// ǷЧ 
		CString _strText = _T("");
		GetDlgItemText(_it->nID, _strText);
		if (!IsNumberValid(_strText))
		{
			_bTempDataValid = false;
		}

		// ûбø¡ ---- ƺ 2015-09-18
		for (int _i = 0; _bTempDataValid && (_i < _countof(m_LastTextItems)); _i++)
		{
			if (m_LastTextItems[_i].nID != nID_)
				continue;

			if (m_LastTextItems[_i].strLastText == _strText)
			{
				m_bDataValid = true;
				return;
			}

			break;
		}

		if (!m_bCancelData)
		{
			if (!_bTempDataValid)
			{
				m_bCancelData = true;
				AfxMessageBox(_GETCS(s_csINVALIDINPUT));
				m_bCancelData = false;
			}
		}

		// ݡ
		if (_bTempDataValid && UpdateData(TRUE))
		{
			m_bDataValid = true;
			double _nValue = _it->nDataType == 0 ? _it->iValue : _it->dValue;
			Units _nCurUnit = GetCurSpeedUnit();
			if ((_it->nUnit == Speed_INperMin
				|| _it->nUnit == Speed_MMperMin
				|| _it->nUnit == Speed_MMperS
				|| _it->nUnit == Speed_MperMin)
				&& _it->nUnit != _nCurUnit)
			{
				ConverUnit(_nCurUnit, _it->nUnit, _nValue, _nValue);
			}

			_nCurUnit = GetCurAccUnit();
			if ((_it->nUnit == Acc_MMperS2
				|| _it->nUnit == ACC_MperMin2
				|| _it->nUnit == Acc_10MperS2)
				&& _it->nUnit !=_nCurUnit)
			{
				ConverUnit(_nCurUnit, _it->nUnit, _nValue, _nValue);
			}

			_nCurUnit = GetCurTimeUnit();
			if ((_it->nUnit == Time_MS
				|| _it->nUnit == Time_S)
				&& _it->nUnit != _nCurUnit)
			{
				ConverUnit(_nCurUnit, _it->nUnit, _nValue, _nValue);
			}

			_nCurUnit = GetCurPressureUnit();
			if ((_it->nUnit == Pressure_Percent
				|| _it->nUnit == Pressure_MPa)
				&& _it->nUnit != _nCurUnit)
			{
				ConverUnit(_nCurUnit, _it->nUnit, _nValue, _nValue);
			}

			// ת ---- ƺ 2015-09-23
			if (_it->nInitDataType == 0)
				_nValue = (int)_nValue;

			if (m_pParam->GetKey_DBL(_it->strKey) != _nValue)
			{
				m_pParam->SetKey_DBL(_it->strKey, _nValue);
			}
		}

		// ʽʾ
		double _nValue = m_pParam->GetKey_DBL(_it->strKey);
		Units _nCurUnit = GetCurSpeedUnit();
		if ((_it->nUnit == Speed_INperMin
			|| _it->nUnit == Speed_MMperMin
			|| _it->nUnit == Speed_MMperS
			|| _it->nUnit == Speed_MperMin)
			&& _it->nUnit != _nCurUnit)
		{
			ConverUnit(_it->nUnit, _nCurUnit, _nValue, _nValue);
		}

		_nCurUnit = GetCurAccUnit();
		if ((_it->nUnit == Acc_MMperS2
			|| _it->nUnit == ACC_MperMin2
			|| _it->nUnit == Acc_10MperS2)
			&& _it->nUnit !=_nCurUnit)
		{
			ConverUnit(_it->nUnit, _nCurUnit, _nValue, _nValue);
		}

		_nCurUnit = GetCurTimeUnit();
		if ((_it->nUnit == Time_MS
			|| _it->nUnit == Time_S)
			&& _it->nUnit != _nCurUnit)
		{
			ConverUnit(_it->nUnit, _nCurUnit, _nValue, _nValue);
		}

		_nCurUnit = GetCurPressureUnit();
		if ((_it->nUnit == Pressure_Percent
			|| _it->nUnit == Pressure_MPa)
			&& _it->nUnit != _nCurUnit)
		{
			ConverUnit(_it->nUnit, _nCurUnit, _nValue, _nValue);
		}

		if (_it->nDataType == 0)
		{
			CStringA _str;
			_str.Format("%d", int(_nValue));
			SetDlgItemText(_it->nID, _str);
			if (!m_bDataValid)
			{
				GetDlgItem(_it->nID)->SetFocus();
			}
		}
		else
		{
			CStringA _str;
			_str.Format("%.3f", _nValue);
			FormatDoubleParamer(_str);
			SetDlgItemText(_it->nID, _str);
			if (!m_bDataValid)
			{
				GetDlgItem(_it->nID)->SetFocus();
			}
		}

		break;
	}
}

void CLayerParamDlg::OnSetFocusEdit(UINT nID_)
{
	ASSERT(_countof(m_LastTextItems) >= 2);
	m_LastTextItems[1].nID = m_LastTextItems[0].nID;
	m_LastTextItems[1].strLastText = m_LastTextItems[0].strLastText;
	m_LastTextItems[0].nID = nID_;
	GetDlgItemText(nID_, m_LastTextItems[0].strLastText);
}

void CLayerParamDlg::OnClickPerType(UINT nID_)
{
	int _nType = 0;
	if (nID_ == IDC_RADIO_DIRPERFORATE)
	{
		_nType = 0;
	}
	else if (nID_ == IDC_RADIO_CONPERORATE)
	{
		_nType = 1;
	}
	else if(nID_ == IDC_RADIO_SEGPERFORATE)
	{
		_nType = 2;
	}
	else if (nID_ == IDC_RADIO_THREESEGPUNCH)
	{
		_nType = 3;
	}
	else
	{
		return;
	}

	if (_nType != m_pParam->GetKey_DBL("PerforateType"))
	{
		m_pParam->SetKey_DBL("PerforateType", _nType);
		m_pParam->SetKey(c_szFirstSegPunch, _nType == 3 ? "1" : "0");
		m_pParam->SetKey(c_szSecondSegPunch, _nType == 3 ? "1" : "0");
		m_pParam->SetKey(c_szThirdSegPunch, _nType == 3 ? "1" : "0");
	}

	// ֶδ׺ͽ򶨸и治á ---- ƺ 2015-06-08
	if (_nType == 1 || _nType == 2 || _nType == 3)
	{
		if (m_pParam->GetKey_DBL("FixedHeightCut") == 1)
			m_pParam->SetKey_DBL("FixedHeightCut", 0);
		GetDlgItem(IDC_CHECK_FIXHEIGHTCUT)->EnableWindow(FALSE);
		if (m_pParam->GetKey_DBL("OutsideCutFollow") == 1)
			m_pParam->SetKey_DBL("OutsideCutFollow", 0);
		GetDlgItem(IDC_CHECK_CUTTINGFROMOUTSIDE)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_CHECK_FIXHEIGHTCUT)->EnableWindow(TRUE);
		GetDlgItem(IDC_CHECK_CUTTINGFROMOUTSIDE)->EnableWindow(TRUE);
	}

	Update();
}

void CLayerParamDlg::OnClickNeglect()
{
	CString _strUserStyle = NceGetPrivateProfileString(_T("Theme"), _T("UserStyle"), _T("None"));
	bool _bIsDNE = (_strUserStyle == _T("DNE"));

	int _nCurIndex = (int)m_pParam->GetKey_DBL("Index");
	if (_bIsDNE && _nCurIndex == 5)
	{
		// ͼΪӹͼ
		m_pParam->SetKey_DBL("Output", false);
	}
	else
	{
		bool _bOutput = m_pParam->GetKey_DBL("Output") != 0;
		_bOutput = !_bOutput;
		m_pParam->SetKey_DBL("Output", _bOutput);
	}
}

void CLayerParamDlg::OnClickNotCloseBlow()
{
	double _nNCB = m_pParam->GetKey_DBL("NotCloseBlow");
	int _nNewNCB = (IsInvalidDouble(_nNCB) || _nNCB == 0.0) ? 1 : 0;
	m_pParam->SetKey_DBL("NotCloseBlow", _nNewNCB);
}

void CLayerParamDlg::OnClickPunchSideBlow()
{
	// һλʾ״
	double _nSB = m_pParam->GetKey_DBL("SideBlow");
	int _nValue = IsInvalidDouble(_nSB) ? 0 : (int)_nSB;
	// ȡ
	_nValue ^= 1;
	m_pParam->SetKey_DBL("SideBlow", _nValue);
}

void CLayerParamDlg::OnClickCuttingSideBlow()
{
	// ڶλʾи
	double _nSB = m_pParam->GetKey_DBL("SideBlow");
	int _nValue = IsInvalidDouble(_nSB) ? 0 : (int)_nSB;
	// ȡ
	_nValue ^= 2;
	m_pParam->SetKey_DBL("SideBlow", _nValue);
}

// Ԥף
// ȡͼһֵĴ׶ΪͼԤ׶ͼεļӹ㹹һϵCCamHole
// CCamHoleCamGroupǰ档PrePerforateֵʶӹʱǷִԤԼЩ
// ԭͼЩǹͼΡ
// Ԥױ־壺
// PrePerforate=0 ---- ûԤ
// PrePerforate=1 ---- Ԥ
// PrePerforate=2 ---- ʾͼ㶯ģͼϵͼζǿףͼ㶯ҲǸصĶ
// ---- ƺ 2014-07-19
void CLayerParamDlg::OnClickPrePerforate()
{
	bool _bPrePer = m_pParam->GetKey_DBL("PrePerforate") == 1;
	_bPrePer = !_bPrePer;
	m_pParam->SetKey_DBL("PrePerforate", _bPrePer);

	GetDlgItem(IDC_STATIC_PREPERFORATEHEIGHT)->EnableWindow(_bPrePer);
	GetDlgItem(IDC_EDIT_PREPERFORATEHEIGHT)->EnableWindow(_bPrePer);
	GetDlgItem(IDC_STATIC_PREPERFORATEHEIGHTUNIT)->EnableWindow(_bPrePer);
}

void CLayerParamDlg::OnClickSlowlyStartup()
{
	bool _bSlowly = m_pParam->GetKey_DBL("SlowlyStartup") == 1;
	_bSlowly = !_bSlowly;

	GetDlgItem(IDC_EDIT_STARTUPDIS)->EnableWindow(_bSlowly);
	GetDlgItem(IDC_EDIT_STARTUPSPEED)->EnableWindow(_bSlowly);
	GetDlgItem(IDC_STATIC_STARTUPDIS)->EnableWindow(_bSlowly);
	GetDlgItem(IDC_STATIC_STARTUPDISUNIT)->EnableWindow(_bSlowly);
	GetDlgItem(IDC_STATIC_STARTUPSPEED)->EnableWindow(_bSlowly);
	GetDlgItem(IDC_STATIC_STARTUPSPEEDUNIT)->EnableWindow(_bSlowly);
	m_pParam->SetKey_DBL("SlowlyStartup", _bSlowly);
}

void CLayerParamDlg::OnSelectCutGas()
{
	CComboBox* _pComb = (CComboBox*)GetDlgItem(IDC_COMBO_CUTTINGAIR);
	int _nIndex = _pComb->GetCurSel();
	ASSERT(_nIndex < (int)m_vectCutGas.size());
	if (_nIndex > -1)
		m_pParam->SetKey("CutBlowType", m_vectCutGas[_nIndex].strValue);
}

void CLayerParamDlg::OnSelectPerGas()
{
	CComboBox* _pComb = (CComboBox*)GetDlgItem(IDC_COMBO_PERFORATEAIR);
	int _nIndex = _pComb->GetCurSel();
	ASSERT(_nIndex < (int)m_vectPerGas.size());
	if (_nIndex > -1)
		m_pParam->SetKey("PerBlowType", m_vectPerGas[_nIndex].strValue);
}

void CLayerParamDlg::OnSelectCoolingGas()
{
	CComboBox* _pComb = (CComboBox*)GetDlgItem(IDC_COMBO_COOLINGAIR);
	int _nIndex = _pComb->GetCurSel();
	ASSERT(_nIndex < (int)m_vectCutGas.size());
	if (_nIndex > -1)
		m_pParam->SetKey("CoolBlowType", m_vectCutGas[_nIndex].strValue);
}

void CLayerParamDlg::OnKillFocusRemarks()
{
	CStringA _strRemarks;
	GetDlgItem(IDC_EDIT_UESEREMARK)->GetWindowText(_strRemarks);
	_strRemarks = Normative(_strRemarks);

	// עŰΧLuaͰһַչ ---- ƺ 2015-02-04
	_strRemarks.Insert(0, "\"");
	_strRemarks += "\"";

	if (m_pParam->GetKey(LPSTR(c_szRemarks)) != _strRemarks)
		m_pParam->SetKey(LPSTR(c_szRemarks), _strRemarks);
}

void CLayerParamDlg::OnPaint()
{
	__super::OnPaint();
	_PaintImages();
	CWnd* _pWnd = GetDlgItem(IDC_STC_FPCANVAS);

	CPaintDC _PaintDC(_pWnd);
	CDC _MemDC;
	_MemDC.CreateCompatibleDC(&_PaintDC);

	CBitmap _bmpMemDC;
	_bmpMemDC.CreateCompatibleBitmap(&_PaintDC, m_rectCanvas.Width(),m_rectCanvas.Height());
	CBitmap* _pOldBitmap = _MemDC.SelectObject(&_bmpMemDC);
	ASSERT(_pOldBitmap);
	_MemDC.Rectangle(0, 0, m_rectCanvas.Width(), m_rectCanvas.Height());

	// ɫʶ󣬻
	CPen _PenRed;
	_PenRed.CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
	CPen* _pOldPen = _MemDC.SelectObject(&_PenRed);
	BOOL _nRet = DrawCoor(&_MemDC);

	_nRet &= DrawLine(&_MemDC, m_vectCurLine);
	_nRet &= DrawPoint(&_MemDC, m_vectCurLine);
	_nRet &= DrawMouseMoveCoor(&_MemDC);
	_PaintDC.BitBlt(0, 0, m_rectCanvas.Width(), m_rectCanvas.Height(), &_MemDC, 0, 0, SRCCOPY);
	_MemDC.SelectObject(_pOldBitmap);
	_MemDC.DeleteDC();
	_bmpMemDC.DeleteObject();
}

void CLayerParamDlg::Update()
{
	UpdateData(FALSE);

	// ´׷ʽʾ ---- ƺ 2015-01-23
	double _nPerType = m_pParam->GetKey_DBL("PerforateType");
	UINT _nID = -1;
	if (_nPerType == 0 || _nPerType == 3)
	{
		GetDlgItem(IDC_EDIT_PERFORATEHEIGHT)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_PERFORATETIME)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_PERFORATEPOWER)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_PERFORATEFREQ)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_PERFORATECYCLE)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_PERFORATEPRESSURE)->EnableWindow(FALSE);
		GetDlgItem(IDC_COMBO_PERFORATEAIR)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_CONPERSPEED)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_PUNCHFOCUS)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_PUNCHFOCUS)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_PUNCHFOCUSUNIT)->EnableWindow(FALSE);

		GetDlgItem(IDC_STATIC_CONPERSPEED)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_CONPERSPEEDUNIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_PERFORATEPOWER)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_PERPOWERUNIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_PERFORATEFREQ)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_PERFREQUNIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_PERCYCLE)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_PERCYCLEUNIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_PERFORATEPRESSURE)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_PERPRESSUREUNIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_PERFORATEAIR)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_PERFORATEHEIGHT)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_PERHEIGHTUNIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_PERFORATETIME)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_PERDELAYUNIT)->EnableWindow(FALSE);
		if (_nPerType == 0) _nID = IDC_RADIO_DIRPERFORATE;
		else _nID = IDC_RADIO_THREESEGPUNCH;
	}
	else if (_nPerType == 1)
	{
		GetDlgItem(IDC_EDIT_PERFORATEHEIGHT)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_PERFORATETIME)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_PERFORATEPOWER)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_PERFORATEFREQ)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_PERFORATECYCLE)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_PERFORATEPRESSURE)->EnableWindow(TRUE);
		GetDlgItem(IDC_COMBO_PERFORATEAIR)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_CONPERSPEED)->EnableWindow(TRUE);
		if (m_bEnableFocusCtrl)
		{
			GetDlgItem(IDC_STATIC_PUNCHFOCUS)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDIT_PUNCHFOCUS)->EnableWindow(TRUE);
			GetDlgItem(IDC_STATIC_PUNCHFOCUSUNIT)->EnableWindow(TRUE);
		}

		GetDlgItem(IDC_STATIC_CONPERSPEED)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_CONPERSPEEDUNIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERFORATEPOWER)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERPOWERUNIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERFORATEFREQ)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERFREQUNIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERCYCLE)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERCYCLEUNIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERFORATEPRESSURE)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERPRESSUREUNIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERFORATEAIR)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERFORATEHEIGHT)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERHEIGHTUNIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERFORATETIME)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERDELAYUNIT)->EnableWindow(TRUE);
		_nID = IDC_RADIO_CONPERORATE;
	}
	else if (_nPerType = 2)
	{
		GetDlgItem(IDC_EDIT_PERFORATEHEIGHT)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_PERFORATETIME)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_PERFORATEPOWER)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_PERFORATEFREQ)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_PERFORATECYCLE)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_PERFORATEPRESSURE)->EnableWindow(TRUE);
		GetDlgItem(IDC_COMBO_PERFORATEAIR)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_CONPERSPEED)->EnableWindow(FALSE);
		if (m_bEnableFocusCtrl)
		{
			GetDlgItem(IDC_STATIC_PUNCHFOCUS)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDIT_PUNCHFOCUS)->EnableWindow(TRUE);
			GetDlgItem(IDC_STATIC_PUNCHFOCUSUNIT)->EnableWindow(TRUE);
		}

		GetDlgItem(IDC_STATIC_CONPERSPEED)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_CONPERSPEEDUNIT)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_PERFORATEPOWER)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERPOWERUNIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERFORATEFREQ)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERFREQUNIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERCYCLE)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERCYCLEUNIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERFORATEPRESSURE)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERPRESSUREUNIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERFORATEAIR)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERFORATEHEIGHT)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERHEIGHTUNIT)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERFORATETIME)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_PERDELAYUNIT)->EnableWindow(TRUE);
		_nID = IDC_RADIO_SEGPERFORATE;
	}

	static const UINT _s_cBtnIDs[]=
							{IDC_RADIO_DIRPERFORATE,
							 IDC_RADIO_CONPERORATE,
							 IDC_RADIO_SEGPERFORATE,
							 IDC_RADIO_THREESEGPUNCH};
	CButton* _pBtn = NULL;
	int _nCheck = BST_UNCHECKED;
	for (int _i = 0; _i < _countof(_s_cBtnIDs); _i++)
	{
		_pBtn = (CButton*)GetDlgItem(_s_cBtnIDs[_i]);
		int _nCheck = _nID == _s_cBtnIDs[_i] ? BST_CHECKED : BST_UNCHECKED;
		if (_pBtn->GetCheck() != _nCheck)
			_pBtn->SetCheck(_nCheck);
	}

	// ͼ㲻ӹ ---- ƺ 2015-01-23
	CString _strUserStyle = NceGetPrivateProfileString(_T("Theme"), _T("UserStyle"), _T("None"));
	bool _bIsDNE = (_strUserStyle == _T("DNE"));

	_pBtn = (CButton*)GetDlgItem(IDC_CHECK_ISIGNORE);
	int _nCurIndex = (int)m_pParam->GetKey_DBL("Index");

	if (_nCurIndex == 5 && _bIsDNE)
	{
		_pBtn->SetCheck(TRUE);
		_pBtn->EnableWindow(FALSE);
		m_pParam->SetKey_DBL("Output", false);
	}
	else
	{
		_pBtn->EnableWindow(TRUE);
		_nCheck = m_pParam->GetKey_DBL("Output") == 0 ? BST_CHECKED : BST_UNCHECKED;
		if (_pBtn->GetCheck() != _nCheck)
			_pBtn->SetCheck(_nCheck);
	}

	// ͼ㲻 ---- DingQiang 2015-12-04
	_pBtn = (CButton*)GetDlgItem(IDC_CHECK_NOTCLOSEBLOW);
	double _nValueDbl = m_pParam->GetKey_DBL("NotCloseBlow");
	int _nValue = IsInvalidDouble(_nValueDbl) ? 0 : (int)_nValueDbl;
	_nCheck = (_nValue == 0) ? BST_UNCHECKED : BST_CHECKED;
	if (_pBtn->IsWindowEnabled() && _pBtn->GetCheck() != _nCheck)
		_pBtn->SetCheck(_nCheck);

	// ׿വ ---- DingQiang 2015-12-04
	_pBtn = (CButton*)GetDlgItem(IDC_CHECK_PUNCHSIDEBLOW);
	_nValueDbl = m_pParam->GetKey_DBL("SideBlow");
	_nValue = IsInvalidDouble(_nValueDbl) ? 0 : (int)_nValueDbl;
	_nCheck = (_nValue & 1) ? BST_CHECKED : BST_UNCHECKED;
	if (_pBtn->IsWindowEnabled() && _pBtn->GetCheck() != _nCheck)
		_pBtn->SetCheck(_nCheck);

	// ӹവ ---- DingQiang 2015-12-04
	_pBtn = (CButton*)GetDlgItem(IDC_CHECK_CUTTINGSIDEBLOW);
	_nCheck = (_nValue & 2) ? BST_CHECKED : BST_UNCHECKED;
	if (_pBtn->IsWindowEnabled() && _pBtn->GetCheck() != _nCheck)
		_pBtn->SetCheck(_nCheck);

	// Ԥס򻯰汾нԤ̧߶Ȼҵ ---- ߿ϼ 2016-12-02
	_pBtn = (CButton*)GetDlgItem(IDC_CHECK_PREPERFORATE);
	CString _strSV = NceGetPrivateProfileString(_T("PGLayerDlg"), _T("SimplifiedVersion"), _T("0"));
	bool _bSimplifiedVersion = (atoi(_strSV) != 0);
	bool _bPrePer = m_pParam->GetKey_DBL("PrePerforate") == 1;
	bool _bShow = _bPrePer && !_bSimplifiedVersion;

	_nCheck = _bShow ? BST_CHECKED : BST_UNCHECKED;
	if (_pBtn->GetCheck() != _nCheck)
		_pBtn->SetCheck(_nCheck);
	GetDlgItem(IDC_STATIC_PREPERFORATEHEIGHT)->EnableWindow(_bShow);
	GetDlgItem(IDC_EDIT_PREPERFORATEHEIGHT)->EnableWindow(_bShow);
	GetDlgItem(IDC_STATIC_PREPERFORATEHEIGHTUNIT)->EnableWindow(_bShow);

	// и ---- ƺ 2015-06-01
	_pBtn = (CButton*)GetDlgItem(IDC_CHECK_FIXHEIGHTCUT);
	_nCheck = m_pParam->GetKey_DBL("FixedHeightCut") == 1 ? BST_CHECKED : BST_UNCHECKED;
	if (_pBtn->GetCheck() != _nCheck)
		_pBtn->SetCheck(_nCheck);
	_pBtn->EnableWindow(_nPerType == 0);

	//  ---- ƺ 2015-07-01
	_pBtn = (CButton*)GetDlgItem(IDC_CHECK_CUTTINGFROMOUTSIDE);
	_nCheck = m_pParam->GetKey_DBL("OutsideCutFollow") == 1 ? BST_CHECKED : BST_UNCHECKED;
	if (_pBtn->GetCheck() != _nCheck)
		_pBtn->SetCheck(_nCheck);
	_pBtn->EnableWindow(_nPerType == 0);

	// 𲽡 ---- ƺ 2015-01-23
	_pBtn = (CButton*)GetDlgItem(IDC_CHECK_ISSTARTUPSLOWLY);
	_nCheck = m_pParam->GetKey_DBL("SlowlyStartup") == 1 ? BST_CHECKED : BST_UNCHECKED;
	if (_pBtn->GetCheck() != _nCheck)
		_pBtn->SetCheck(_nCheck);
	GetDlgItem(IDC_EDIT_STARTUPDIS)->EnableWindow(_nCheck == BST_CHECKED);
	GetDlgItem(IDC_EDIT_STARTUPSPEED)->EnableWindow(_nCheck == BST_CHECKED);
	GetDlgItem(IDC_STATIC_STARTUPDIS)->EnableWindow(_nCheck == BST_CHECKED);
	GetDlgItem(IDC_STATIC_STARTUPDISUNIT)->EnableWindow(_nCheck == BST_CHECKED);
	GetDlgItem(IDC_STATIC_STARTUPSPEED)->EnableWindow(_nCheck == BST_CHECKED);
	GetDlgItem(IDC_STATIC_STARTUPSPEEDUNIT)->EnableWindow(_nCheck == BST_CHECKED);

	// и塣 ---- ƺ 2015-01-23
	CString _strGas = m_pParam->GetKey("CutBlowType");
	CComboBox* _pCob = (CComboBox*)GetDlgItem(IDC_COMBO_CUTTINGAIR);
	int _nIndex = -1;
	for (int _i = 0; _i < (int)m_vectCutGas.size(); _i++)
	{
		if (m_vectCutGas[_i].strValue == _strGas)
		{
			_nIndex = _i;
			break;
		}
	}
	if (_pCob->GetCurSel() != _nIndex)
		_pCob->SetCurSel((int)_nIndex);

	// 塣 ---- ƺ 2015-01-23
	_strGas = m_pParam->GetKey("PerBlowType");
	_pCob = (CComboBox*)GetDlgItem(IDC_COMBO_PERFORATEAIR);
	_nIndex = -1;
	for (int _i = 0; _i < (int)m_vectCutGas.size(); _i++)
	{
		if (m_vectPerGas[_i].strValue == _strGas)
		{
			_nIndex = _i;
			break;
		}
	}
	if (_pCob->GetCurSel() != _nIndex)
		_pCob->SetCurSel((int)_nIndex);

	// ȴ ----  2016-03-09
	_strGas = m_pParam->GetKey("CoolBlowType");
	_pCob = (CComboBox*)GetDlgItem(IDC_COMBO_COOLINGAIR);
	_nIndex = 0;
	for (int _i = 0; _i < (int)m_vectCutGas.size(); _i++)
	{
		if (m_vectCutGas[_i].strValue == _strGas)
		{
			_nIndex = _i;
			break;
		}
	}
	if (_pCob->GetCurSel() != _nIndex)
		_pCob->SetCurSel((int)_nIndex);

	// ûעNormativeжӵȥ ---- ƺ 2015-01-23
	CStringA _strRemarks = m_pParam->GetKey(LPSTR(c_szRemarks));
	if (!_strRemarks.IsEmpty() && _strRemarks[0] == '\"')
		_strRemarks.Delete(0);
	int _nLength = _strRemarks.GetLength();
	if (_nLength > 0 && _strRemarks[_nLength - 1] == '\"')
		_strRemarks.Delete(_nLength - 1);
	_strRemarks = ReverseNormative(_strRemarks);
	SetDlgItemText(IDC_EDIT_UESEREMARK, _strRemarks);

	// С ---- ƺ 2015-04-30
	_pBtn = (CButton*)GetDlgItem(IDC_CHECK_CIRCLEOVERCUT);
	_nCheck = m_pParam->GetKey_DBL("Overcut") == 1 ? BST_CHECKED : BST_UNCHECKED;
	if (_pBtn->GetCheck() != _nCheck)
		_pBtn->SetCheck(_nCheck);
	GetDlgItem(IDC_STATIC_CIRCLEANGLE)->EnableWindow(_nCheck == BST_CHECKED);
	GetDlgItem(IDC_EDIT_CIRCLEANGLE)->EnableWindow(_nCheck == BST_CHECKED);
	GetDlgItem(IDC_STATIC_CIRCLEANGLEUNIT)->EnableWindow(_nCheck == BST_CHECKED);
	GetDlgItem(IDC_STATIC_OVERCUTLENGTH)->EnableWindow(_nCheck == BST_CHECKED);
	GetDlgItem(IDC_EDIT_OVERCUTLENGTH)->EnableWindow(_nCheck == BST_CHECKED);
	GetDlgItem(IDC_STATIC_OVERCUTLENGTHUNIT)->EnableWindow(_nCheck == BST_CHECKED);

	// ٶ ---- DingQiang 2015-09-28
	_pBtn = (CButton*)GetDlgItem(IDC_CHECK_ENABLEINTROSPEED);
	_nCheck = m_pParam->GetKey("EnableIntroSpeed") == "1" ? BST_CHECKED : BST_UNCHECKED;
	if (_pBtn->GetCheck() != _nCheck)
		_pBtn->SetCheck(_nCheck);
	GetDlgItem(IDC_STC_INSPEED)->EnableWindow(_nCheck == BST_CHECKED);
	GetDlgItem(IDC_EDIT_INSPEED)->EnableWindow(_nCheck == BST_CHECKED);
	GetDlgItem(IDC_STATIC_INSPEEDUNIT)->EnableWindow(_nCheck == BST_CHECKED);
	GetDlgItem(IDC_STC_OUTSPEED)->EnableWindow(_nCheck == BST_CHECKED);
	GetDlgItem(IDC_EDIT_OUTSPEED)->EnableWindow(_nCheck == BST_CHECKED);
	GetDlgItem(IDC_STATIC_OUTSPEEDUNIT)->EnableWindow(_nCheck == BST_CHECKED);

	// ༭¡ ---- ƺ 2015-01-23
	_BuildEditInfo();
	UpDateEdits();
}

void CLayerParamDlg::UpDateEdits()
{
	for (EditItems::iterator _it = m_listEdits.begin(); _it != m_listEdits.end(); _it++)
	{
		if (_it->nDataType == 0)
		{
			CStringA _strNew;
			_strNew.Format(_T("%d"), _it->iValue);

			CStringA _strOrg;
			GetDlgItemText(_it->nID, _strOrg);
			if (_strOrg != _strNew)
				SetDlgItemText(_it->nID, _strNew);
		}
		else
		{
			ASSERT(_it->nDataType  == 1);
			CStringA _strNew;
			_strNew.Format(_T("%.3f"), _it->dValue);

			FormatDoubleParamer(_strNew);
			CStringA _strOrg;
			GetDlgItemText(_it->nID, _strOrg);;
			if (_strOrg != _strNew)
				SetDlgItemText(_it->nID, _strNew);
		}
	}

	CString _strNewUnit = GetUnitName(GetCurSpeedUnit());
	CString _strOldUnit;
	GetDlgItemText(IDC_STATIC_CUTSPEEDUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_CUTSPEEDUNIT, _strNewUnit);
	GetDlgItemText(IDC_STATIC_CONPERSPEEDUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_CONPERSPEEDUNIT, _strNewUnit);
	GetDlgItemText(IDC_STATIC_STARTUPSPEEDUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_STARTUPSPEEDUNIT, _strNewUnit);
	GetDlgItemText(IDC_STATIC_INSPEEDUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_INSPEEDUNIT, _strNewUnit);
	GetDlgItemText(IDC_STATIC_OUTSPEEDUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_OUTSPEEDUNIT, _strNewUnit);

	_strNewUnit = GetUnitName(GetCurTimeUnit());
	GetDlgItemText(IDC_STATIC_PRELASEROFFDELAY, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_PRELASEROFFDELAY, _strNewUnit);
	GetDlgItemText(IDC_STATIC_PRELASERONDELAY, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_PRELASERONDELAY, _strNewUnit);
	GetDlgItemText(IDC_STATIC_ZUPDELAYUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_ZUPDELAYUNIT, _strNewUnit);
	GetDlgItemText(IDC_STATIC_FOLLOWDELAYUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_FOLLOWDELAYUNIT, _strNewUnit);
	GetDlgItemText(IDC_STATIC_POSTLASERONDELAY, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_POSTLASERONDELAY, _strNewUnit);
	GetDlgItemText(IDC_STATIC_STOPCORNERDELAY, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_STOPCORNERDELAY, _strNewUnit);
	GetDlgItemText(IDC_STATIC_PERDELAYUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_PERDELAYUNIT, _strNewUnit);

	_strNewUnit = GetUnitName(GetCurPressureUnit());
	GetDlgItemText(IDC_STATIC_PERPRESSUREUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_PERPRESSUREUNIT, _strNewUnit);
	GetDlgItemText(IDC_STATIC_CUTPRESSUREUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_CUTPRESSUREUNIT, _strNewUnit);
}

void CLayerParamDlg::UpFocusCtrls()
{
	GetDlgItem(IDC_STATIC_CUTFOCUS)->EnableWindow(m_bEnableFocusCtrl);
	GetDlgItem(IDC_EDIT_CUTFOCUS)->EnableWindow(m_bEnableFocusCtrl);
	GetDlgItem(IDC_STATIC_CUTFOCUSUNIT)->EnableWindow(m_bEnableFocusCtrl);
	CWnd* _pwndDlgItem = GetDlgItem(IDC_STATIC_PUNCHFOCUS);
	if (_pwndDlgItem->IsWindowEnabled() && !m_bEnableFocusCtrl)
		_pwndDlgItem->EnableWindow(FALSE);
	_pwndDlgItem = GetDlgItem(IDC_EDIT_PUNCHFOCUS);
	if (_pwndDlgItem->IsWindowEnabled() && !m_bEnableFocusCtrl)
		_pwndDlgItem->EnableWindow(FALSE);
	_pwndDlgItem = GetDlgItem(IDC_STATIC_PUNCHFOCUSUNIT);
	if (_pwndDlgItem->IsWindowEnabled() && !m_bEnableFocusCtrl)
		_pwndDlgItem->EnableWindow(FALSE);
}

void CLayerParamDlg::ConverUnit(Units nFrom_, Units nTo_, double IN nOrg_, double& OUT nTarget_)
{
	if (nFrom_ == nTo_)
	{
		nTarget_ = nOrg_;
		return;
	}

	if (nFrom_ == Speed_MMperS && nTo_ == Speed_MMperMin)
	{
		nTarget_ = nOrg_ * 60.0;
		return;
	}

	if (nFrom_ == Speed_MMperS && nTo_ == Speed_MperMin)
	{
		nTarget_ = nOrg_ * 60.0 / 1000.0;
		return;
	}

	if (nFrom_ == Speed_MMperS && nTo_ == Speed_INperMin)
	{
		nTarget_ = nOrg_ * 60 / 25.39999918;
		return;
	}

	if (nFrom_ == Speed_MMperMin && nTo_ == Speed_MMperS)
	{
		nTarget_ = nOrg_ / 60.0;
		return;
	}

	if (nFrom_ == Speed_MMperMin && nTo_ == Speed_MperMin)
	{
		nTarget_ = nOrg_ / 1000.0;
		return;
	}

	if (nFrom_ == Speed_MMperMin && nTo_ == Speed_INperMin)
	{
		nTarget_ = nOrg_ / 25.39999918;
		return;
	}

	if (nFrom_ == Speed_INperMin && nTo_ == Speed_MMperS)
	{
		nTarget_ = nOrg_ * 25.39999918 / 60.0;
		return;
	}

	if (nFrom_ == Speed_INperMin && nTo_ == Speed_MMperMin)
	{
		nTarget_ = nOrg_ * 25.39999918;
		return;
	}

	if (nFrom_ == Speed_INperMin && nTo_ == Speed_MperMin)
	{
		nTarget_ = nOrg_ * 25.39999918 / 1000.0;
		return;
	}

	if (nFrom_ == Speed_MperMin && nTo_ == Speed_MMperS)
	{
		nTarget_ = nOrg_ * 1000.0 / 60.0;
		return;
	}

	if (nFrom_ == Speed_MperMin && nTo_ == Speed_MMperMin)
	{
		nTarget_ = nOrg_ * 1000.0;
		return;
	}

	if (nFrom_ == Speed_MperMin && nTo_ == Speed_INperMin)
	{
		nTarget_ = nOrg_ * 1000.0 / 25.39999918;
		return;
	}

	if (nFrom_ == Time_MS && nTo_ == Time_S)
	{
		nTarget_ = nOrg_ / 1000.0;
		return;
	}

	if (nFrom_ == Time_S && nTo_ ==Time_MS)
	{
		nTarget_  = nOrg_ * 1000.0;
		return;
	}

	if (nFrom_ == Acc_MMperS2 && nTo_ == ACC_MperMin2)
	{
		nTarget_ = nOrg_ * 3600 /1000.0;
		return;
	}

	if (nFrom_ == Acc_MMperS2 && nTo_ == Acc_10MperS2)
	{
		nTarget_ = nOrg_ / 10000;
		return;
	}

	if (nFrom_ == ACC_MperMin2 && nTo_ == Acc_MMperS2)
	{
		nTarget_ = nOrg_ * 1000.0 / 3600;
		return;
	}

	if (nFrom_ == ACC_MperMin2 && nTo_ == Acc_10MperS2)
	{
		nTarget_ = nOrg_ / 36000;
		return;
	}

	if (nFrom_ == Acc_10MperS2 && nTo_ == Acc_MMperS2)
	{
		nTarget_ = nOrg_ * 10 * 1000;
		return;
	}

	if (nFrom_ == Acc_10MperS2 && nTo_ == ACC_MperMin2)
	{
		nTarget_ = nOrg_ * 10 * 3600;
		return;
	}

	if (nFrom_ == Speed_DperMin && nTo_ == Speed_RperMin)
	{
		nTarget_ = nOrg_ / 360;
		return;
	}

	if (nFrom_ == Speed_RperMin && nTo_ == Speed_DperMin)
	{
		nTarget_ = nOrg_ * 360;
		return;
	}

	if (nFrom_ == Pressure_Percent && nTo_ == Pressure_MPa)
	{
		CString _strIdentifer("4_0_MaxPressureMPa");
		double _nMaxMpa = 0.0;
		SendTargetMessage(ID_TARGET_PARAMMANAGER, TM_GET_PARAMVALUE, WPARAM(_strIdentifer.GetBuffer()), (WPARAM)&_nMaxMpa);
		_strIdentifer.ReleaseBuffer();
		if (_nMaxMpa <= 0.0)
			_nMaxMpa = 3;
		double _nRatio = _nMaxMpa / 100.f;
		nTarget_ = nOrg_ * _nRatio;
		return;
	}

	if (nFrom_ == Pressure_MPa && nTo_ == Pressure_Percent)
	{
		CString _strIdentifer("4_0_MaxPressureMPa");
		double _nMaxMpa = 0.0;
		SendTargetMessage(ID_TARGET_PARAMMANAGER, TM_GET_PARAMVALUE, WPARAM(_strIdentifer.GetBuffer()), (WPARAM)&_nMaxMpa);
		_strIdentifer.ReleaseBuffer();
		if (_nMaxMpa <= 0.0)
			_nMaxMpa = 3;
		double _nRatio = _nMaxMpa / 100.f;
		nTarget_ = nOrg_ / _nRatio;
		return;
	}

	// ûת ---- ƺ 2015-09-02
	ASSERT(FALSE);
	nTarget_ = nOrg_;
}

void CLayerParamDlg::ConverUnit(Units nFrom_, Units nTo_, const EditInfo& Org_, EditInfo& Target_)
{
	double _nShowValue = 0;
	if (Org_.nDataType == 0)
	{
		ConverUnit(nFrom_, nTo_, Org_.iValue, _nShowValue);
	}
	else
	{
		ConverUnit(nFrom_, nTo_, Org_.dValue, _nShowValue);
	}
	// лλĲһҪʱdouble͵ġ
	Target_.nDataType = 1;
	Target_.dValue = _nShowValue;
	ConverUnit(nFrom_, nTo_, Org_.nMinValue, Target_.nMinValue);
	ConverUnit(nFrom_, nTo_, Org_.nMaxValue, Target_.nMaxValue);
}

CLayerParamDlg::Units CLayerParamDlg::GetCurSpeedUnit()
{
	// μREM20160412195307 ----  2016-04-12
	static CLayerParamDlg::Units _s_nCSU = None;
	static DWORD _s_nCSU_LU = 0;
	DWORD _nTC = ::GetTickCount();
	if (_s_nCSU == None || _s_nCSU_LU > _nTC || _nTC > _s_nCSU_LU + 284)
	{
		_s_nCSU_LU = _nTC;
		CString _strSpeedUnit = NceGetPrivateProfileString(c_szParamGroupUnit, c_szSpeedUnit, "0");
		if (_strSpeedUnit == "0")
			_s_nCSU = Speed_MMperMin;
		else if (_strSpeedUnit == "1")
			_s_nCSU = Speed_MMperS;
		else if (_strSpeedUnit == "2")
			_s_nCSU = Speed_MperMin;
		else if (_strSpeedUnit == "3")
			_s_nCSU = Speed_INperMin;
		else
			_s_nCSU = None;
	}

	return _s_nCSU;
}

CLayerParamDlg::Units CLayerParamDlg::GetCurAccUnit()
{
	// μREM20160412195307 ----  2016-04-12
	static CLayerParamDlg::Units _s_nCAU = None;
	static DWORD _s_nCAU_LU = 0;
	DWORD _nTC = ::GetTickCount();
	if (_s_nCAU == None || _s_nCAU_LU > _nTC || _nTC > _s_nCAU_LU + 284)
	{
		_s_nCAU_LU = _nTC;
		CString _strAccUnit = NceGetPrivateProfileString(c_szParamGroupUnit, c_szAccUnit, "0");
		if (_strAccUnit == "0")
			_s_nCAU = Acc_MMperS2;
		else if (_strAccUnit == "1")
			_s_nCAU = ACC_MperMin2;
		else if (_strAccUnit == "2")
			_s_nCAU = Acc_10MperS2;
		else
			_s_nCAU = None;
	}

	return _s_nCAU;
}

CLayerParamDlg::Units CLayerParamDlg::GetCurTimeUnit()
{
	// μREM20160412195307 ----  2016-04-12
	static CLayerParamDlg::Units _s_nCTU = None;
	static DWORD _s_nCTU_LU = 0;
	DWORD _nTC = ::GetTickCount();
	if (_s_nCTU == None || _s_nCTU_LU > _nTC || _nTC > _s_nCTU_LU + 284)
	{
		_s_nCTU_LU = _nTC;
		CString _strTimeUnit = NceGetPrivateProfileString(c_szParamGroupUnit, c_szTimeUnit, "0");
		if (_strTimeUnit == "0")
			_s_nCTU = Time_MS;
		else if (_strTimeUnit == "1")
			_s_nCTU = Time_S;
		else
			_s_nCTU = None;
	}

	return _s_nCTU;
}

CLayerParamDlg::Units CLayerParamDlg::GetCurPressureUnit()
{
	// μREM20160412195307 ----  2016-04-12
	static CLayerParamDlg::Units _s_nCTU = None;
	static DWORD _s_nCTU_LU = 0;
	DWORD _nTC = ::GetTickCount();
	if (_s_nCTU == None || _s_nCTU_LU > _nTC || _nTC > _s_nCTU_LU + 284)
	{
		_s_nCTU_LU = _nTC;
		CString _strTimeUnit = NceGetPrivateProfileString(c_szParamGroupUnit, c_szPressureUnit, "0");
		if (_strTimeUnit == "0")
			_s_nCTU = Pressure_Percent;
		else if (_strTimeUnit == "1")
			_s_nCTU = Pressure_MPa;
		else
			_s_nCTU = None;
	}

	return _s_nCTU;
}

CString CLayerParamDlg::GetUnitName(const Units nUnit_)
{
	CString _strUnit;
	switch(nUnit_)
	{
		case Length_MM:
			_strUnit = "mm";
			break;
		case Length_M:
			_strUnit = "m";
			break;
		case Speed_MMperS:
			_strUnit = "mm/s";
			break;
		case Speed_MMperMin:
			_strUnit = "mm/min";
			break;
		case Speed_MperMin:
			_strUnit = "m/min";
			break;
		case Speed_INperMin:
			_strUnit = "in/min";
			break;
		case Acc_MMperS2:
			_strUnit = "mm/s^2";
			break;
		case ACC_MperMin2:
			_strUnit = "m/min^2";
			break;
		case Acc_10MperS2:
			_strUnit = "G";
			break;
		case Time_MS:
			_strUnit = "ms";
			break;
		case Time_S:
			_strUnit = "s";
			break;
		case Pressure_Percent:
			_strUnit = "%";
			break;
		case Pressure_MPa:
			_strUnit = "MPa";
			break;
		default:
			_strUnit = "";
			break;
	}

	return _strUnit;
}

// ᣬX1c_nOffsetյ2c_nOffsetY1c_nOffset
// յ2c_nOffset ---- DingQiang 2014-12-29
BOOL CLayerParamDlg::DrawCoor(CDC* pDC_)
{
	if (!pDC_)
	{
		ASSERT(FALSE);
		return FALSE;
	}

	BOOL _bRet = true;
	// ƴֱˮƽ
	CPoint _ptTopLeft(m_rcEffectRect.left, m_rcEffectRect.top - c_nOffset - 3);
	CPoint _ptBottomLeft(m_rcEffectRect.left, m_rcEffectRect.bottom);
	CPoint _ptRightBottom(m_rcEffectRect.right + c_nOffset + 3, m_rcEffectRect.bottom);
	pDC_->MoveTo(_ptTopLeft);
	_bRet &= pDC_->LineTo(_ptBottomLeft);
	_bRet &= pDC_->LineTo(_ptRightBottom);
	// X᷽ͷ
	pDC_->MoveTo(_ptRightBottom.x - 5, _ptRightBottom.y - 4);
	_bRet &= pDC_->LineTo(_ptRightBottom);
	pDC_->MoveTo(_ptRightBottom.x - 5, _ptRightBottom.y + 4);
	_bRet &= pDC_->LineTo(_ptRightBottom);
	// Y᷽ͷ
	pDC_->MoveTo(_ptTopLeft.x - 4, _ptTopLeft.y + 5);
	_bRet &= pDC_->LineTo(_ptTopLeft);
	pDC_->MoveTo(_ptTopLeft.x + 4, _ptTopLeft.y + 5);
	_bRet &= pDC_->LineTo(_ptTopLeft);

	// X̶
	double _nXNumPerScale = m_rcEffectRect.Width() / 20.0;
	int _nScaleSize = 3;
	const int _nBigScale = 3;
	for (int _i = 1; _i <= 20; ++_i)
	{
		if ((_i % 5) == 0)
		{
			// 5ı
			pDC_->MoveTo((int)(_ptBottomLeft.x + _i * _nXNumPerScale), _ptBottomLeft.y);
			_bRet &= pDC_->LineTo((int)(_ptBottomLeft.x + _i * _nXNumPerScale), _ptBottomLeft.y - _nScaleSize - _nBigScale);
		}
		else
		{
			pDC_->MoveTo((int)(_ptBottomLeft.x + _i * _nXNumPerScale), _ptBottomLeft.y);
			_bRet &= pDC_->LineTo((int)(_ptBottomLeft.x + _i * _nXNumPerScale), _ptBottomLeft.y - _nScaleSize);
		}
	}
	// Y̶
	double _nYNumPerScale = m_rcEffectRect.Height() / 20.0;
	for (int _i = 1; _i <= 20; ++_i)
	{
		if ((_i % 5) == 0)
		{
			// 5ı
			pDC_->MoveTo(_ptBottomLeft.x, (int)(_ptBottomLeft.y - _i * _nYNumPerScale));
			_bRet &= pDC_->LineTo(_ptBottomLeft.x + _nScaleSize + _nBigScale, (int)(_ptBottomLeft.y - _i * _nYNumPerScale));
		}
		else
		{
			pDC_->MoveTo(_ptBottomLeft.x,(int)(_ptBottomLeft.y - _i * _nYNumPerScale));
			_bRet &= pDC_->LineTo(_ptBottomLeft.x + _nScaleSize, (int)(_ptBottomLeft.y - _i * _nYNumPerScale));
		}
	}

	LOGFONT _logfont;
	memset(&_logfont, 0, sizeof(LOGFONT));
	_logfont.lfHeight = 14;
	_logfont.lfWidth = 5;
	CFont _font;
	_font.CreateFontIndirect(&_logfont);
	CFont* _pOldFont = pDC_->SelectObject(&_font);
	pDC_->TextOut(m_rectCanvas.right -c_nOffset - 6, m_rectCanvas.bottom - 28, _GETCS(s_szSPEED));
	pDC_->TextOut(c_nOffset + 8, c_nOffset - 2, _GETCS(s_szPOWER));
	pDC_->SelectObject(_pOldFont);
	_font.DeleteObject();
	ASSERT(_bRet);
	return _bRet;
}

BOOL CLayerParamDlg::DrawLine(CDC* pDC_, FPLine pFPLine_)
{
	if (!pDC_)
	{
		ASSERT(FALSE);
		return FALSE;
	}

	CSpline _Spline;
	unsigned int _nFPSize = (unsigned int)pFPLine_.size();
	unsigned char _pBuffer[64 * 1024];
	ParameterI3BH* _pParam = (ParameterI3BH*)_pBuffer;
	_pParam->nSize = sizeof(ParameterI3BH) + (_nFPSize - 1) * 2 * sizeof(double);
	_pParam->nVersion = 'I3BH';
	_pParam->nN = _nFPSize;
	for (unsigned int _i = 0; _i < _nFPSize; _i++)
	{
		_pParam->nPoints[_i][0] = pFPLine_[_i].nSpeed;
		_pParam->nPoints[_i][1] = pFPLine_[_i].nPower;
	}
	_Spline.Initialize(_pParam);

	double _nTemp = 0.0;
	double _nPower;
	_Spline.GetValue(_nTemp, &_nPower);
	CPoint _ptRet;
	_ptRet.x = (int)(_nTemp / c_nMaxSpeed * m_rcEffectRect.Width() + m_rcEffectRect.left + 0.5);
	_ptRet.y = (int)((100 - _nPower) / c_nMaxPower * m_rcEffectRect.Height() + m_rcEffectRect.top - 0.5);
	pDC_->MoveTo(_ptRet);
	_nTemp += 1;
	while(_nTemp <= 100)
	{
		double _nPower;
		_Spline.GetValue(_nTemp, &_nPower);
		CPoint _ptRet;
		_ptRet.x = (int)(_nTemp / c_nMaxSpeed * m_rcEffectRect.Width() + m_rcEffectRect.left + 0.5);
		_ptRet.y = (int)((100 - _nPower) / c_nMaxPower * m_rcEffectRect.Height() + m_rcEffectRect.top - 0.5);
		_ptRet.y = _ptRet.y > m_rcEffectRect.bottom ? m_rcEffectRect.bottom : _ptRet.y;
		_ptRet.y = _ptRet.y < m_rcEffectRect.top ? m_rcEffectRect.top : _ptRet.y;

		pDC_->LineTo(_ptRet);
		_nTemp += 1;
	}

	return TRUE;
}

BOOL CLayerParamDlg::DrawMouseMoveCoor(CDC* pDC_)
{
	if (!m_bMouseInCoorCanvas)
	{
		return TRUE;
	}

	CFont _font;
	_font.CreateFont(15, 0, 0, 0, FW_NORMAL,
		FALSE, FALSE, 0, ANSI_CHARSET,
		OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
		DEFAULT_PITCH | FF_SWISS, _T("Arial"));

	CString _str;
	FPPoint _ptFP = Point2FPPoint(m_ptCurMouse);
	_str.Format("(%d,%d)", _ptFP.nSpeed, _ptFP.nPower);
	CFont* _pOldFont = pDC_->SelectObject(&_font);

	int nPrevMode = pDC_->SetBkMode( TRANSPARENT );

	BOOL _bRet = TRUE;
	if (_ptFP.nSpeed >= 92 && _ptFP.nPower < 92)
	{
		_bRet &= pDC_->DrawText(_str, CRect(m_ptCurMouse.x - 50, m_ptCurMouse.y - 15, 0, 0), DT_NOCLIP);
	}
	else if (_ptFP.nSpeed >= 92 && _ptFP.nPower >= 92)
	{
		_bRet &= pDC_->DrawText(_str, CRect(m_ptCurMouse.x - 50, m_ptCurMouse.y + 15, 0, 0), DT_NOCLIP);
	}
	else if (_ptFP.nSpeed < 92 && _ptFP.nPower >= 92)
	{
		_bRet &= pDC_->DrawText(_str, CRect(m_ptCurMouse.x, m_ptCurMouse.y + 15, 0, 0), DT_NOCLIP);
	}
	else
	{
		ASSERT(_ptFP.nSpeed < 92 && _ptFP.nPower < 92);
		_bRet &= pDC_->DrawText(_str, CRect(m_ptCurMouse.x, m_ptCurMouse.y - 15, 0, 0), DT_NOCLIP);
	}
	pDC_->SelectObject(_pOldFont);
	pDC_->SetBkMode( nPrevMode );

	return _bRet;
}

BOOL CLayerParamDlg::DrawPoint(CDC* pDC_, FPLine pFPLine_)
{
	ASSERT(pDC_);
	if (pFPLine_.size() < 1)
	{
		return TRUE;
	}

	BOOL _bRet = TRUE;
	for (FPLine::iterator _it = pFPLine_.begin(); _it != pFPLine_.end(); _it++)
	{
		CPoint _pt = FPPoint2Point(*_it);
		CPen _pen;
		if (_it->bSelected)
		{
			_bRet &= _pen.CreatePen(PS_SOLID, 1, c_nPointSelected);
			CPen* _pOldPent = pDC_->SelectObject(&_pen);
			_bRet &= pDC_->Ellipse(_pt.x - c_nRadiusSelected, _pt.y - c_nRadiusSelected, _pt.x + c_nRadiusSelected, _pt.y + c_nRadiusSelected);
			pDC_->SelectObject(_pOldPent);
			_pen.DeleteObject();
		}
		else
		{
			_bRet &= _pen.CreatePen(PS_SOLID, 1, c_nPointNoSelected);
			CPen* _pOldPent = pDC_->SelectObject(&_pen);
			_bRet &= pDC_->Ellipse(_pt.x - c_nRadiusNoSelected, _pt.y - c_nRadiusNoSelected, _pt.x + c_nRadiusNoSelected, _pt.y + c_nRadiusNoSelected);
			pDC_->SelectObject(_pOldPent);
			_pen.DeleteObject();
		}
	}

	return _bRet;
}

void CLayerParamDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	// Ƶ롢水ťʾ ---- ƺ 2015-05-07
	if (m_rcImportBtn.PtInRect(point))
	{
		GetDlgItem(IDC_STATIC_IMPORTAREA)->ShowWindow(SW_SHOW);
	}
	else
	{
		GetDlgItem(IDC_STATIC_IMPORTAREA)->ShowWindow(SW_HIDE);
	}
	if (m_rcSaveBtn.PtInRect(point))
	{
		GetDlgItem(IDC_STATIC_SAVEBTNRECT)->ShowWindow(SW_SHOW);
	}
	else
	{
		GetDlgItem(IDC_STATIC_SAVEBTNRECT)->ShowWindow(SW_HIDE);
	}
	_PaintImages();

	// ӳ䵽ڵĵxyֱ0~100
	m_ptCurMouse = point;
	TranslatePoint(m_ptCurMouse);
	CWnd* _pWnd = GetDlgItem(IDC_STC_FPCANVAS);
	ASSERT(_pWnd);
	CRect _rc;
	_pWnd->GetWindowRect(_rc);
	ScreenToClient(_rc);
	BOOL _bMouseInCoorCanvas = FALSE;
	if (point.x <= _rc.left || point.x >= _rc.right || point.y >= _rc.bottom || point.y <= _rc.top)
	{
		_bMouseInCoorCanvas = FALSE;
	}
	else
	{
		_bMouseInCoorCanvas = TRUE;
	}
	if (_bMouseInCoorCanvas != m_bMouseInCoorCanvas)
	{
		InvalidateRect(m_rectCoorCanvas, FALSE);
		m_bMouseInCoorCanvas = _bMouseInCoorCanvas;
	}

	if (!_bMouseInCoorCanvas)
	{
		return;
	}

	FPPoint _fpPoint = Point2FPPoint(m_ptCurMouse);
	//ѡһ㣬ƶ϶ģʽ ---- DingQiang 2013-05-16
	if (m_bSelectPoint && _fpPoint != m_fpTemp)
	{
		m_nMode = t_move;
		size_t _nTemp = -1;
		for (size_t _it = 0; _it < m_vectCurLine.size(); ++_it)
		{
			if (m_fpTemp.nPower == m_vectCurLine[_it].nPower && m_fpTemp.nSpeed == m_vectCurLine[_it].nSpeed)
			{
				_nTemp = _it;
			}
		}

		if (_nTemp != -1)
		{
			if (m_fpTemp.nSpeed == 0 || m_fpTemp.nSpeed == 100)
			{
				// β㵥 ---- DingQiang 2013-05-15
				m_vectCurLine[_nTemp].nPower = _fpPoint.nPower;
				m_fpTemp = m_vectCurLine[_nTemp];
			}
			else
			{
				if (_fpPoint.nSpeed > m_vectCurLine[_nTemp - 1].nSpeed && _fpPoint.nSpeed < m_vectCurLine[_nTemp + 1].nSpeed)
				{
					m_vectCurLine[_nTemp] = _fpPoint;
				}
				m_fpTemp = _fpPoint;
			}
		}
		else
		{
			//ASSERT(FALSE);
		}
	}

	InvalidateRect(m_rectCoorCanvas, FALSE);
}

void CLayerParamDlg::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	TranslatePoint(point);

	if (!m_rectCanvas.PtInRect(point))
	{
		return;
	}

	FPPoint _ptFP;
	_ptFP.nSpeed = int((point.x - m_rcEffectRect.left) * c_nMaxSpeed / double(m_rcEffectRect.Width()));
	_ptFP.nPower = int(100 - (point.y - m_rcEffectRect.top) * c_nMaxPower / double(m_rcEffectRect.Height()));
	_ptFP.nPower = _ptFP.nPower > 100 ? 100 : _ptFP.nPower;
	_ptFP.nPower = _ptFP.nPower < 0 ? 0 : _ptFP.nPower;
	_ptFP.nSpeed = _ptFP.nSpeed > 100 ? 100 : _ptFP.nSpeed;
	_ptFP.nSpeed = _ptFP.nSpeed < 0 ? 0 : _ptFP.nSpeed;

	BOOL _bRet = FALSE;
	FPLine::iterator _itEnd = m_vectCurLine.end();
	_itEnd--;
	// ݲΧѡĵɾ ---- ƺ 2015-05-15
	for (int _i = 0; _i <= c_nSelectTolerance; _i++)
	{
		for (FPLine::iterator _it = m_vectCurLine.begin(); _it != m_vectCurLine.end(); _it++)
		{
			if (_it->bSelected
				&& (abs(_it->nPower - _ptFP.nPower) <= _i)
				&& (abs(_it->nSpeed - _ptFP.nSpeed) <= _i)
				&& _it != m_vectCurLine.begin()
				&& _it != _itEnd)
			{
				_it = m_vectCurLine.erase(_it);
				_bRet = TRUE;
				break;
			}
		}

		if (_bRet)
			break;
	}

	if (!_bRet)
	{
		InsertFPPoint(_ptFP);
		SortFPLine(m_vectCurLine);
	}
	InvalidateRect(m_rectCoorCanvas, FALSE);
}

void CLayerParamDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	if (m_rcImportBtn.PtInRect(point))
	{
		GetDlgItem(IDC_STATIC_IMPORTAREA)->SetFocus();
		return;
	}
	if (m_rcSaveBtn.PtInRect(point))
	{
		GetDlgItem(IDC_STATIC_SAVEBTNRECT)->SetFocus();
		return;
	}

	TranslatePoint(point);
	if(m_rectCanvas.PtInRect(point))
	{
		GetDlgItem(IDC_STC_FPCANVAS)->SetFocus();
	}

	CRect _rect = m_rcEffectRect;
	if (point.x >= _rect.left - 1 && point.x <= _rect.right + 1 && point.y >= _rect.top - 1 && point.y <= _rect.bottom + 1)
	{
		FPPoint _fpPoint = Point2FPPoint(point);
		FPPoint _fpPointHit;
		if (!TrySetSelect(&_fpPoint, &_fpPointHit))
		{
			m_bSelectPoint = FALSE;
			return;
		}

		m_fpTemp = _fpPointHit;
		m_bSelectPoint = TRUE;
		InvalidateRect(m_rectCoorCanvas, FALSE);
	}
}

void CLayerParamDlg::OnLButtonUp(UINT nFlags, CPoint point)
{
	__super::OnLButtonUp(nFlags, point);

	if (m_nMode == t_move)
	{
		m_nMode = t_valid;
	}

	m_bSelectPoint = false;
	InvalidateRect(m_rectCoorCanvas, FALSE);

	// 롢򵯳Ի ---- ƺ 2015-05-07
	if (m_rcImportBtn.PtInRect(point))
	{
		OnImportParam();
		return;
	}
	if (m_rcSaveBtn.PtInRect(point))
	{
		OnSaveParam();
		return;
	}
}

void CLayerParamDlg::OnRButtonDown(UINT nFlags, CPoint point)
{
	if (m_nMode == t_move)
	{
		m_nMode = t_valid;
		InvalidateRect(m_rectCoorCanvas, FALSE);
	}
	m_bSelectPoint = FALSE;
}

void CLayerParamDlg::OnClickEnableFP()
{
	UpdateData(TRUE);
}

void CLayerParamDlg::OnClickFixedHeightCut()
{
	bool _bFixedHeightCut = m_pParam->GetKey_DBL("FixedHeightCut") == 1;
	_bFixedHeightCut = !_bFixedHeightCut;
	m_pParam->SetKey_DBL("FixedHeightCut", _bFixedHeightCut);

	// иͰΪ⹦ܡ ---- ƺ 2015-07-02
	if (_bFixedHeightCut && m_pParam->GetKey_DBL("OutsideCutFollow") == 1)
	{
		m_pParam->SetKey_DBL("OutsideCutFollow", 0);
		((CButton*)GetDlgItem(IDC_CHECK_CUTTINGFROMOUTSIDE))->SetCheck(BST_UNCHECKED);
	}
}

void CLayerParamDlg::OnCutFromOutside()
{
	bool _bCutFromOutside = m_pParam->GetKey_DBL("OutsideCutFollow") == 1;
	_bCutFromOutside = !_bCutFromOutside;
	CString _strOutsideHeight = NceGetPrivateProfileString(_T("OutsideCutting"), _T("OutsideHeight"));
	if (_strOutsideHeight.IsEmpty() && _bCutFromOutside)
	{
		AfxMessageBox(_GETCS(s_szNOTSAVEOUTSIDEHEIGHT));
		((CButton*)GetDlgItem(IDC_CHECK_CUTTINGFROMOUTSIDE))->SetCheck(BST_UNCHECKED);
		return;
	}

	m_pParam->SetKey_DBL("OutsideCutFollow", _bCutFromOutside);
	if (_bCutFromOutside && m_pParam->GetKey_DBL("FixedHeightCut") == 1)
	{
		m_pParam->SetKey_DBL("FixedHeightCut", 0);
		((CButton*)GetDlgItem(IDC_CHECK_FIXHEIGHTCUT))->SetCheck(BST_UNCHECKED);
	}
}

BOOL CLayerParamDlg::CPointToCoorCanvasPoint(IN CPoint pPointIn_, OUT CPoint& pPointOut_)
{
	CWnd* _pWnd = GetDlgItem(IDC_STC_FPCANVAS);
	ASSERT(_pWnd);
	CRect _rc;
	_pWnd->GetWindowRect(_rc);
	ScreenToClient(_rc);
	if (pPointIn_.x <= _rc.left || pPointIn_.x >= _rc.right || pPointIn_.y >= _rc.bottom || pPointIn_.y <= _rc.top)
	{
		return FALSE;
	}

	_rc.left += c_nOffset;
	_rc.right -= 2 * c_nOffset;
	_rc.bottom -= c_nOffset;
	_rc.top += 2 * c_nOffset;
	// ֵӦ÷ֱ32Իʱƺˣxһ̶3أ
	// yһ̶2                         ---- DingQiang 2014-12-30
	int _nPelsXOneScale = _rc.Width() / 100;
	int _nPelsYOneScale = _rc.Height() / 100;

	pPointOut_.x = (pPointIn_.x - _rc.left) / _nPelsXOneScale;
	pPointOut_.y = 100 - (pPointIn_.y - _rc.top) / _nPelsXOneScale;

	return TRUE;
}

FPPoint CLayerParamDlg::Point2FPPoint(CPoint point_)
{
	double _nPelsXOneScale = m_rcEffectRect.Width() / c_nMaxSpeed;
	double _nPelsYOneScale =m_rcEffectRect.Height() / c_nMaxPower;

	FPPoint _ptFP;
	_ptFP.nSpeed = int((point_.x - m_rcEffectRect.left) / _nPelsXOneScale);
	_ptFP.nPower = int(100 - (point_.y - m_rcEffectRect.top) / _nPelsYOneScale);
	_ptFP.nSpeed = _ptFP.nSpeed > 100 ? 100 : _ptFP.nSpeed;
	_ptFP.nPower = _ptFP.nPower > 100 ? 100 : _ptFP.nPower;
	_ptFP.nSpeed = _ptFP.nSpeed < 0 ? 0 : _ptFP.nSpeed;
	_ptFP.nPower = _ptFP.nPower < 0 ? 0 : _ptFP.nPower;
	return _ptFP;
}

void CLayerParamDlg::TranslatePoint(CPoint& point_)
{
	CWnd* _pWnd = GetDlgItem(IDC_STC_FPCANVAS);
	ASSERT(_pWnd);

	MapWindowPoints(_pWnd, &point_, 1);
}

void CLayerParamDlg::SortFPLine(FPLine& FPLine_)
{
	// 01 ---- DingQiang 2013-04-12
	if (FPLine_.size() < 2)
	{
		return;
	}

	// ٶֵС ---- DingQiang 2013-04-12
	for (FPLine::iterator _it = FPLine_.begin(); _it != FPLine_.end(); _it++)
	{
		for (FPLine::iterator _item = _it + 1; _item != FPLine_.end(); _item++)
		{
			if (_it->nSpeed > _item->nSpeed)
			{
				int _nSpeedTemp = _item->nSpeed;
				int _nPowerTemp = _item->nPower;
				bool _bTemp = _item->bSelected;

				_item->nSpeed = _it->nSpeed;
				_item->nPower = _it->nPower;
				_item->bSelected = _it->bSelected;
				_it->nSpeed = _nSpeedTemp;
				_it->nPower = _nPowerTemp;
				_it->bSelected = _bTemp;
			}
		}
	}
}

BOOL CLayerParamDlg::InsertFPPoint(FPPoint fppoint_)
{
	ASSERT(fppoint_.nSpeed >= 0 && fppoint_.nSpeed <= 100 && fppoint_.nPower >= 0 && fppoint_.nPower <= 100);

	for (FPLine::iterator _it = m_vectCurLine.begin(); _it != m_vectCurLine.end();)
	{
		if (_it->nSpeed == fppoint_.nSpeed)
		{
			_it = m_vectCurLine.erase(_it);
		}
		else
		{
			_it++;
		}
	}

	m_vectCurLine.push_back(fppoint_);
	return TRUE;
}

CPoint CLayerParamDlg::FPPoint2Point(FPPoint ptFP_)
{
	CPoint _ptRet;
	_ptRet.x = (int)(ptFP_.nSpeed / 100. * m_rcEffectRect.Width() + m_rcEffectRect.left + 0.5);
	_ptRet.y = (int)((100 - ptFP_.nPower) / 100. * m_rcEffectRect.Height() + m_rcEffectRect.top - 0.5);

	return _ptRet;
}

BOOL CLayerParamDlg::TrySetSelect(IN FPPoint* fppoint_, OUT FPPoint* fpPointHit_)
{
	ASSERT(fppoint_->nSpeed >= 0 && fppoint_->nSpeed <= 100 && fppoint_->nPower >= 0 && fppoint_->nPower <= 100);

	// һһĵ㣬ҲٷŴΧңֱҵǳݲΧ ---- ƺ 2015-05-15
	bool _bFind = false;
	for (int _i = 0; _i <= c_nSelectTolerance; _i++)
	{
		for (FPLine::iterator _it = m_vectCurLine.begin(); _it != m_vectCurLine.end(); _it++)
		{
			if (abs(_it->nSpeed - fppoint_->nSpeed) <= _i && abs(_it->nPower - fppoint_->nPower) <= _i && !_bFind)
			{
				// ҵһ򷵻أǰֻͬʱѡһ ---- DingQiang 2013-04-11
				_it->bSelected = true;
				_bFind = true;
				fpPointHit_->nPower = _it->nPower;
				fpPointHit_->nSpeed = _it->nSpeed;
			}
			else
			{
				_it->bSelected = false;
			}
		}

		if (_bFind)
			break;
	}

	return _bFind;
}

// ͼ ---- ƺ 2015-04-17
void CLayerParamDlg::OnSaveParam()
{
	if (!m_pParam)
	{
		ASSERT(FALSE);
		return;
	}

	CStringA _strName = m_pParam->GetKey("Name");
	if (!_strName.IsEmpty() && _strName[0] == '\"') _strName.Delete(0);
	if (!_strName.IsEmpty() && _strName[_strName.GetLength() - 1] == '\"') _strName.Delete(_strName.GetLength() - 1);
	if (_strName.FindOneOf("\\//:*?\"<>| ") != -1)
	{
		_strName = _GETCS(s_szDEFUALTPARAMFILENAME);
	}
	else
	{
		_strName += ".ltp";
	}

	// ļԻ
	TCHAR _szFileFilter[] = _T("ltp File(*.ltp) |*.ltp");
	CFileDialog _dlg(FALSE, _T(".ltp"),
		_strName,
		OFN_HIDEREADONLY | OFN_NOCHANGEDIR,
		_szFileFilter, this, 0);

	CString _strDefaultFolder = m_strDefaultFilePath;
	if (!_strDefaultFolder.IsEmpty())
	{
		if (!::PathFileExists(_strDefaultFolder))
			_tmkdir(_strDefaultFolder);
			_dlg.GetOFN().lpstrInitialDir = _strDefaultFolder;
	}
	if (_dlg.DoModal() != IDOK)
	{
		return;
	}

	CString _strDir = _dlg.GetPathName();
	if (_strDir.Right(4) != _T(".ltp"))
		_strDir += _T(".ltp");

	// ļ
	_SaveParam(_strDir);
}

// ļʽΪ
// [UserRemarks]
// Remarks=""
// [PowerCurve]
// FPMapEnable=0
// FF0=0
// FP0=0
// FF1=100
// FP1=100
// ...
// [TechnicParam]
// Index=0
// ...
// ---- ƺ 2015-04-17
void CLayerParamDlg::_SaveParam(LPCTSTR pszFilePath_)
{
	if (!m_pParam)
	{
		ASSERT(FALSE);
		return;
	}

	// ļǷѴڣѴھʾǷ񸲸ǣûоʹһ
	if (::PathFileExists(pszFilePath_) 
		&& AfxMessageBox(_GETCS(s_szPARAMFILEEXIST), MB_YESNO | MB_ICONINFORMATION) != IDYES)
	{
		return;
	}

	CFile _file;
	if (!_file.Open(pszFilePath_, CFile::modeCreate | CFile::modeReadWrite | CFile::shareExclusive))
	{
		ASSERT(FALSE);
		return;
	}


	CString _strWriteParamString;
	// ûע
	CString _strRemarks = m_pParam->GetKey(LPSTR(c_szRemarks));
	_strWriteParamString += "[UserRemarks]\r\n";
	_strWriteParamString += _GetLine(c_szRemarks, _strRemarks);

	// ٶȹ
	SaveFPCurve();
	_strWriteParamString += "[PowerCurve]\r\n";
	_strWriteParamString += _GetLine(c_szEnableFPMap, m_pParam->GetKey(LPSTR(c_szEnableFPMap)));
	for (int _i = 0; _i <= 100; _i++)
	{
		CStringA _strFFKey;
		_strFFKey.Format("FF%d", _i);
		CStringA _strFFValue = m_pParam->GetKey(_strFFKey);
		CStringA _strFPKey;
		_strFPKey.Format("FP%d", _i);
		CStringA _strFPValue = m_pParam->GetKey(_strFPKey);
		if (_strFFValue.IsEmpty() || _strFPValue.IsEmpty())
			break;
		_strWriteParamString += _GetLine(_strFFKey, _strFFValue);
		_strWriteParamString += _GetLine(_strFPKey, _strFPValue);
	}

	// Ĺղ
	_strWriteParamString += "[TechnicParam]\r\n";
	CStringA _strParam = m_pParam->GetParamString();
	for (int _i = 0; _i < _strParam.GetLength() - 3; )
	{
		int _nSemicIndex = _strParam.Find(';', _i);
		CStringA _strUnit = _strParam.Mid(_i, _nSemicIndex == -1 ? _strParam.GetLength() : _nSemicIndex - _i);
		if (_strUnit.IsEmpty())
			break;
		int _nEQIndex = _strUnit.Find('=');
		CStringA _strKey = _nEQIndex == -1 ? "" : _strUnit.Left(_nEQIndex);
		CStringA _strValue = _nEQIndex == -1 ? "" : _strUnit.Right(_strUnit.GetLength() - _nEQIndex - 1);
		if (_strKey.IsEmpty())
		{
			_i = _nSemicIndex + 1;
			continue;
		}

		bool _bIgnore = false;
		// Եٶȹ߲
		if (!_strKey.IsEmpty() && (_strKey.Left(2) == "FF" || _strKey.Left(2) == "FP"))
		{
			for (int _j = 0; _j <= 100; _j++)
			{
				CStringA _strFF, _strFP;
				_strFF.Format("FF%d", _j);
				_strFP.Format("FP%d", _j);
				if (_strKey == _strFF || _strKey == _strFP)
				{
					_bIgnore = true;
					break;
				}
			}
		}
		if (_strKey == CStringA(c_szEnableFPMap))
			_bIgnore = true;

		// ûע
		if (_strKey == CStringA(c_szRemarks))
			_bIgnore = true;

		if (!_bIgnore)
			_strWriteParamString += _GetLine(_strKey, _strValue);
		_i = _nSemicIndex + 1;
	}

	try
	{
		_file.Write(_strWriteParamString.GetBuffer(), _strWriteParamString.GetLength() * sizeof(TCHAR));
		_strWriteParamString.ReleaseBuffer();
	}
	catch(...)
	{
		ASSERT(FALSE);
	}
	_file.Close();
}

CString CLayerParamDlg::_GetLine(LPCTSTR pszKey_, LPCTSTR pszValue_)
{
	if (!pszValue_ || !pszKey_)
	{
		ASSERT(FALSE);
		return "";
	}

	CString _strLine;
	_strLine += pszKey_;
	_strLine += '=';
	_strLine += pszValue_;
	_strLine += "\r\n";
	return _strLine;
}

// ͼ ---- ƺ 2015-04-17
void CLayerParamDlg::OnImportParam()
{
	if (!m_pParam)
	{
		ASSERT(FALSE);
		return;
	}

	// ļ򿪶Ի
	TCHAR _szFileFilter[] = _T("ltp File(*.ltp) |*.ltp");
	CFileDialog _dlg(TRUE, _T(".ltp"), NULL,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_NOCHANGEDIR,
		_szFileFilter, this, 0);

	CString _strDefaultFolder = m_strDefaultFilePath;
	if (!_strDefaultFolder.IsEmpty())
	{
		if (!::PathFileExists(_strDefaultFolder))
			_tmkdir(_strDefaultFolder);
			_dlg.GetOFN().lpstrInitialDir = _strDefaultFolder;
	}
	if (_dlg.DoModal() != IDOK)
		return;

	// ѡļ֮ǰʾǷ񸲸ͼ
	CString _strDir = _dlg.GetPathName();
	if (!::PathFileExists(_strDir.GetBuffer()))
	{
		AfxMessageBox(_GETCS(s_szPARAMFILENOTEXIST));
		return;
	}

	if (AfxMessageBox(_GETCS(s_szPARAMOVERWRITEPROMT), MB_YESNO) != IDYES)
		return;

	_LoadParam(_strDir);
}

void CLayerParamDlg::_LoadParam(LPCTSTR pszFilePath_)
{
	if (!m_pParam)
	{
		ASSERT(FALSE);
		return;
	}

	TCHAR _szBuffer[64 * 1024] = {0};	// 64K͹ˡ
	DWORD _nCount = ::GetPrivateProfileString(NULL, NULL, NULL, _szBuffer, sizeof(_szBuffer), pszFilePath_);
	std::list<CString> _listSections;
	CString _strSection;
	for(DWORD _i = 0; _i < _nCount; _i++)
	{
		if (_szBuffer[_i] != '\0') _strSection += _szBuffer[_i];
		if (_szBuffer[_i] == '\0')
		{
			_listSections.push_back(_strSection);
			_strSection = "";
			if (_szBuffer[_i + 1] == '\0')
				break;
		}
	}

	if (_listSections.empty())
		return;

	_ClearFPMapPoints(m_pParam);
	memset(_szBuffer, 0, sizeof(_szBuffer));
	for (std::list<CString>::iterator _it = _listSections.begin(); _it != _listSections.end(); _it++)
	{
		DWORD _nKeyCount = ::GetPrivateProfileString((*_it), NULL, NULL, _szBuffer, sizeof(_szBuffer), pszFilePath_);
		CString _strKey;
		for (DWORD _i = 0; _i < _nKeyCount; _i++)
		{
			if (_szBuffer[_i] != '\0') _strKey += _szBuffer[_i];
			if (_szBuffer[_i] == '\0')
			{
				if (!_strKey.IsEmpty())
				{
					// ͼɫϢͼš
					if (_strKey != _T("Color") && _strKey != _T("Index"))
					{
						TCHAR _szValue[64 * 1024] = {0};
						::GetPrivateProfileString((*_it), _strKey, "", _szValue, sizeof(_szValue), pszFilePath_);

						// ƺͱעĻ⵼Luaн ---- ƺ 2015-05-21
						CString _strValue(_szValue);
						if (_strKey == c_szRemarks
							|| _strKey == _T("Name")
							|| _strKey == _GETCS(s_szLAYERNAME)
							|| _strKey == c_szThreeSegPunchRemarks)
						{
							if (!_strValue.IsEmpty() && _strValue[0] != _T('\"')) _strValue.Insert(0, _T('\"'));
							if (!_strValue.IsEmpty() && _strValue[_strValue.GetLength() - 1] != _T('\"')) _strValue += _T('\"');
						}

						if (m_pParam->GetKey(_strKey) != _strValue)
							m_pParam->SetKey(_strKey, _strValue);
					}
					_strKey = "";
				}

				if (_szBuffer[_i + 1] == '\0')
					break;
			}
		}
	}

	Update();
	SetParam(m_pParam);
	((CParamGroupDlg_R3*)GetParent())->Update();
	((CParamGroupDlg_R3*)GetParent())->UpdateLoadLayer(m_pParam);
}

void CLayerParamDlg::_ClearFPMapPoints(nce::CParam* pParam_)
{
	if (!pParam_)
	{
		ASSERT(FALSE);
		return;
	}

	CString _strFTemp = "FF%d";
	CString _strPTemp = "FP%d";
	for (int _it = 0; _it <= 100; _it++)
	{
		CString _strF;
		_strF.Format(_strFTemp, _it);
		CString _strP;
		_strP.Format(_strPTemp, _it);

		CStringA _strFValue = m_pParam->GetKey(_strF);
		CStringA _strPValue = m_pParam->GetKey(_strP);
		if (!_strFValue.IsEmpty())
			pParam_->SetKey(_strF, "");
		if (!_strPValue.IsEmpty())
			pParam_->SetKey(_strP, "");
	}
}

void CLayerParamDlg::OnEnableIntroSpeed()
{
	bool _bIntroSpeed = m_pParam->GetKey("EnableIntroSpeed") == "1";

	_bIntroSpeed = !_bIntroSpeed;

	GetDlgItem(IDC_STC_INSPEED)->EnableWindow(_bIntroSpeed);
	GetDlgItem(IDC_EDIT_INSPEED)->EnableWindow(_bIntroSpeed);
	GetDlgItem(IDC_STATIC_INSPEEDUNIT)->EnableWindow(_bIntroSpeed);
	GetDlgItem(IDC_STC_OUTSPEED)->EnableWindow(_bIntroSpeed);
	GetDlgItem(IDC_EDIT_OUTSPEED)->EnableWindow(_bIntroSpeed);
	GetDlgItem(IDC_STATIC_OUTSPEEDUNIT)->EnableWindow(_bIntroSpeed);
	m_pParam->SetKey("EnableIntroSpeed", _bIntroSpeed ? "1" : "0");
}

void CLayerParamDlg::OnClickOvercut()
{
	bool _bOvercut = m_pParam->GetKey_DBL("Overcut") == 1;
	_bOvercut = !_bOvercut;

	GetDlgItem(IDC_STATIC_CIRCLEANGLE)->EnableWindow(_bOvercut);
	GetDlgItem(IDC_EDIT_CIRCLEANGLE)->EnableWindow(_bOvercut);
	GetDlgItem(IDC_STATIC_CIRCLEANGLEUNIT)->EnableWindow(_bOvercut);
	GetDlgItem(IDC_STATIC_OVERCUTLENGTH)->EnableWindow(_bOvercut);
	GetDlgItem(IDC_EDIT_OVERCUTLENGTH)->EnableWindow(_bOvercut);
	GetDlgItem(IDC_STATIC_OVERCUTLENGTHUNIT)->EnableWindow(_bOvercut);
	m_pParam->SetKey_DBL("Overcut", _bOvercut);
}

// 桢밴ťͼ ---- ƺ 2015-05-16
void CLayerParamDlg::_PaintImages()
{
	CDC* _pDestDC = GetDC();
	CDC _SrcDC;
	_SrcDC.CreateCompatibleDC(_pDestDC);
	CBitmap _bmpImpot;
	_bmpImpot.LoadBitmap(IDB_BITMAP_LAYERPARAMIMPORT);
	CBitmap* _pOldBmp = _SrcDC.SelectObject(&_bmpImpot);
	CRect _rcPaint;
	GetDlgItem(IDC_STATIC_IMPORTIMAGE)->GetWindowRect(_rcPaint);
	ScreenToClient(_rcPaint);
	_pDestDC->BitBlt(_rcPaint.left, _rcPaint.top, _rcPaint.Width() - 2, _rcPaint.Height() - 2, &_SrcDC, 1, 5, SRCCOPY);
	CBitmap _bmpSave;
	_bmpSave.LoadBitmap(IDB_BITMAP_LAYERPARAMSAVE);
	_SrcDC.SelectObject(&_bmpSave);
	GetDlgItem(IDC_STATIC_SAVEIMAGE)->GetWindowRect(_rcPaint);
	ScreenToClient(_rcPaint);
	_pDestDC->BitBlt(_rcPaint.left, _rcPaint.top, _rcPaint.Width() - 2, _rcPaint.Height() - 1, &_SrcDC, 1, 1, SRCCOPY);
	_SrcDC.SelectObject(_pOldBmp);
	_SrcDC.DeleteDC();
	_bmpImpot.DeleteObject();
	ReleaseDC(_pDestDC);
}

void CLayerParamDlg::OnTimer(UINT_PTR nIDEvent_)
{
	_PaintImages();
}

void CLayerParamDlg::OnClickEditFPMap()
{
	CFPMappingEditDlg _dlg(m_vectCurLine);
	if(_dlg.DoModal() == IDOK)
	{
		m_vectCurLine = _dlg.m_FPLine;
		InvalidateRect(m_rectCoorCanvas, FALSE);
	}
}
