// ************************************************************************** //
// MachineControlDlg.cpp : implementation of the CMachineControlDlg_Bottom class
// Copyright(c)2011 Naiky Company. All rights reserved.
//
// Abstract:
//   ļʵCMachineControlDlg_Bottomࡣ
// ********************************************* ----  2011-10-31 ***** //
#include "stdafx.h"
#include "MachineControlDlg_Bottom.h"
#include "EditItem.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

CS_T s_csRapidJog = _DEFCS(_CSV(18552),
	_CHINESE("")
	_ENGLISH("Rapid\nJog"));
CS_T s_csSlowJog = _DEFCS(_CSV(18553),
	_CHINESE("")
	_ENGLISH("Jog"));
CS_T s_csJOG = _DEFCS(_CSV(18554),
	_CHINESE("㶯")
	_ENGLISH("Jog"));
CS_T s_csLANGUAGE = _DEFCS(_CSV(18555),
	_CHINESE("CHN")
	_ENGLISH("ENG"));
CS_T s_csNotInputPrompt = _DEFCS(_CSV(18556),
	_CHINESE("ϵͳæǰӹ״̬޷޸ĸò")
	_ENGLISH("System is busy, can not change the parameters!"));
CS_T s_csIntDataError = _DEFCS(_CSV(18557),
	_CHINESE("ĲЧֻ룡")
	_ENGLISH("Data error, it should be a positive integer, Please enter again!"));
CS_T s_csFloatDataError = _DEFCS(_CSV(18558),
	_CHINESE("ĲЧ룡")
	_ENGLISH("Data error, it should be a number, Please enter again!"));
CS_T s_csFloatDataBoundError = _DEFCS(_CSV(18559),
	_CHINESE("Χһ%.1f~%.1f֮")
	_ENGLISH("Please enter a number between %f~%f"));

CS_T s_csAXES = _DEFCS(_CSV(18560),
	_CHINESE("")
	_ENGLISH("Axes"));
CS_T s_csMACHINECOORDINATE = _DEFCS(_CSV(18561),
	_CHINESE("е")
	_ENGLISH("MachCoor"));
CS_T s_csWORKPIECECOORDINATE = _DEFCS(_CSV(18562),
	_CHINESE("")
	_ENGLISH("WorkCoor"));

CS_T s_csRESUME = _DEFCS(_CSV(18563),
	_CHINESE("ϵ\n")
	_ENGLISH("Resume"));
CS_T s_csSIMU = _DEFCS(_CSV(18564),
	_CHINESE("")
	_ENGLISH("Simu"));
CS_T s_csDIRRUN = _DEFCS(_CSV(18565),
	_CHINESE("")
	_ENGLISH("DryRun"));
CS_T s_csSIMUCUTBOUNDRECT = _DEFCS(_CSV(18566),
	_CHINESE("߱߿")
	_ENGLISH("Frame"));
CS_T s_csTipSETWORKORG = _DEFCS(_CSV(18567),
	_CHINESE("ùԭ")
	_ENGLISH("Set WorkOrg"));
CS_T s_csTipMOVETOWORKORIGIN = _DEFCS(_CSV(18568),
	_CHINESE("عԭ")
	_ENGLISH("Work Origin"));
CS_T s_csTipSIMUCUTBOUNDRECT = _DEFCS(_CSV(18569),
	_CHINESE("߱߿")
	_ENGLISH("Frame"));
CS_T s_csTipSTART = _DEFCS(_CSV(18570),
	_CHINESE("ʼ")
	_ENGLISH("Start"));
CS_T s_csTipPAUSE = _DEFCS(_CSV(18571),
	_CHINESE("ͣ")
	_ENGLISH("Pause"));
CS_T s_csTipSTOP = _DEFCS(_CSV(18572),
	_CHINESE("ֹͣ")
	_ENGLISH("Stop"));
CS_T s_csTipGoBackward = _DEFCS(_CSV(18573),
	_CHINESE("")
	_ENGLISH("GoBackward"));
CS_T s_csTipGoForward = _DEFCS(_CSV(18574),
	_CHINESE("ǰ")
	_ENGLISH("GoForward"));
CS_T s_csTipFollowSample = _DEFCS(_CSV(18575),
	_CHINESE("궨")
	_ENGLISH("Sample"));
CS_T s_csTipBackAll = _DEFCS(_CSV(18576),
	_CHINESE("ȫػеԭ")
	_ENGLISH("BackAll"));

CS_T s_csDistanceSet = _DEFCS(_CSV(18577),
	_CHINESE("ǰ˾趨")
	_ENGLISH("Distance Set"));

CS_T s_szPortNameKey = _DEFCS(_CSV(18578),
	_CHINESE("Port%d_ChnName")
	_ENGLISH("Port%d_EngName"));
CS_T s_szMUNU_MARKPOINT1 = _DEFCS(_CSV(18640),
	_CHINESE("ǵ1")
	_ENGLISH("Mark point1"));
CS_T s_szMUNU_MARKPOINT2 = _DEFCS(_CSV(18641),
	_CHINESE("ǵ2")
	_ENGLISH("Mark point2"));
CS_T s_szMUNU_MARKPOINT3 = _DEFCS(_CSV(18642),
	_CHINESE("ǵ3")
	_ENGLISH("Mark point3"));
CS_T s_szMUNU_MARKPOINT4 = _DEFCS(_CSV(18643),
	_CHINESE("ǵ4")
	_ENGLISH("Mark point4"));
CS_T s_szMUNU_MARKPOINT5 = _DEFCS(_CSV(18644),
	_CHINESE("ǵ5")
	_ENGLISH("Mark point5"));
CS_T s_szMUNU_MARKPOINT6 = _DEFCS(_CSV(18645),
	_CHINESE("ǵ6")
	_ENGLISH("Mark point6"));
CS_T s_szMUNU_MARKPOINT7 = _DEFCS(_CSV(18646),
	_CHINESE("ǵ7")
	_ENGLISH("Mark point7"));
CS_T s_szMUNU_MARKPOINT8 = _DEFCS(_CSV(18647),
	_CHINESE("ǵ8")
	_ENGLISH("Mark point8"));

using namespace mach;
using namespace ncmath;

struct CRunReportTarget::CCache
{
	mach::CStateManager::State State;
	mach::CStateManager::Speed Speed;
	mach::CStateManager::FileInformation FileInfo;
	mach::CStateManager::CLInformation CLInfo;
};
////////////////////////////////////////////////////////////////////////////////
// CtrlID
enum
{
	CTRLID_BTN_F						= psh1,
	CTRLID_BTN_CENTER,
	CTRLID_BTN_XP,
	CTRLID_BTN_XN,
	CTRLID_BTN_YP,
	CTRLID_BTN_YN,
	CTRLID_BTN_ZP,
	CTRLID_BTN_ZN,
	CTRLID_BTN_WP,
	CTRLID_BTN_WN,
	CTRLID_BTN_GOFORWARD,
	CTRLID_BTN_GOBACKWARD,
	CTRLID_BTN_GODISTANCE,
	CTRLID_BTN_CHANGECOOR,
	CTRLID_BTN_MACHSELECTED,
	CTRLID_BTN_JOGLASER,
	CTRLID_BTN_AUTOCYC,
	CTRLID_BTN_SELMARKPOINT,
	CTRLID_BTN_MARKPOINT1,
	CTRLID_BTN_MARKPOINT2,
	CTRLID_BTN_MARKPOINT3,
	CTRLID_BTN_MARKPOINT4,
	CTRLID_BTN_MARKPOINT5,
	CTRLID_BTN_MARKPOINT6,
	CTRLID_BTN_MARKPOINT7,
	CTRLID_BTN_MARKPOINT8,
	CTRLID_BTN_AUTOEXCHANGE,
	CTRLID_BTN_CYC,

	CTRLID_STC_AXES					= stc1,
	CTRLID_STC_COOR,
	CTRLID_STC_PORT0,
	CTRLID_STC_PORT1,
	CTRLID_STC_PORT2,
	CTRLID_STC_PORT3,
	CTRLID_STC_PORT4,
	CTRLID_STC_PORT5,
	CTRLID_STC_PORT6,
	CTRLID_STC_PORT7,
	CTRLID_STC_PORT8,
	CTRLID_STC_PORT9,
	CTRLID_STC_PORT10,
	CTRLID_STC_PORT11,
	CTRLID_STC_PORT12,
	CTRLID_STC_PORT13,
	CTRLID_STC_PORT14,
	CTRLID_STC_PORT15,
	CTRLID_STC_XVALUE,
	CTRLID_STC_YVALUE,
	CTRLID_STC_ZVALUE,
	CTRLID_STC_WVALUE,
	CTRLID_STC_MACHCOOR,
	CTRLID_STC_WORKCOOR,
	//CTRLID_STC_SELMARKPOINT,

	CTRLID_EDIT_GODISTANCE				= edt1,

	CTRLID_SLD_SETF						= ctl1,
	CTRLID_SLD_SETP,
	CTRLID_SLD_SETFH
};
////////////////////////////////////////////////////////////////////////////////
// Local function declarations ---- DingQiang 2012-06-25
static double _FormatInputData(double nInputData_);

////////////////////////////////////////////////////////////////////////////////
// CMachineControlDlg_Bottom
// 
// ֻҪ󣬲Ҫл汾ơ ----  2011-10-31
IMPLEMENT_SERIAL(CMachineControlDlg_Bottom, CAgileDialog, 0xFFFF)

BEGIN_MESSAGE_MAP(CMachineControlDlg_Bottom, CAgileDialog)
	ON_WM_HSCROLL()
	ON_WM_LBUTTONDOWN()
	ON_MESSAGE(WM_MYDLGMESSAGE, OnEndSpeedDlg)
	ON_CONTROL_RANGE(BN_PUSHED, CTRLID_BTN_XP, CTRLID_BTN_WN, OnDirectionBtnPushed)
	ON_CONTROL_RANGE(BN_UNPUSHED, CTRLID_BTN_XP, CTRLID_BTN_WN, OnDirectionBtnUnpushed)
	ON_CONTROL_RANGE(BN_PUSHED, CTRLID_BTN_GOFORWARD, CTRLID_BTN_GOBACKWARD, OnGFOBBtnPushed)
	ON_CONTROL_RANGE(BN_UNPUSHED, CTRLID_BTN_GOFORWARD, CTRLID_BTN_GOBACKWARD, OnGFOBBtnUnpushed)
	ON_MESSAGE(WM_IDLEUPDATECMDUI, OnIdleUpdateCmdUI)
	ON_CONTROL(STN_DBLCLK, CTRLID_STC_COOR, OnChangeCoorMode)
	ON_MESSAGE(WM_MYEIDTMESSAGE, OnEndEditDistance)
	ON_COMMAND(CTRLID_BTN_CHANGECOOR, OnChangeCoorMode)
	ON_CONTROL(BN_CLICKED, CTRLID_BTN_CENTER, OnSetManuMode)
	ON_CONTROL(BN_DOUBLECLICKED, CTRLID_BTN_CENTER, OnDblClickCenter)
	ON_MESSAGE(WM_BITMAPSLIDER_MOVING, OnSliderMoving)
	ON_CONTROL(BN_CLICKED, CTRLID_BTN_MACHSELECTED, OnClickMachSelected)
	ON_CONTROL(BN_CLICKED, CTRLID_BTN_JOGLASER, OnClickJogLaser)
	ON_CONTROL(BN_CLICKED, CTRLID_BTN_AUTOCYC, OnClickAutoCyc)
	ON_CONTROL(BN_CLICKED, CTRLID_BTN_AUTOEXCHANGE, OnClickAutoExchange)
	ON_CONTROL(BN_CLICKED, CTRLID_BTN_CYC, OnClickCyc)
	ON_COMMAND(CTRLID_BTN_SELMARKPOINT, OnSelMarkPoint)
	ON_COMMAND_RANGE(CTRLID_BTN_MARKPOINT1, CTRLID_BTN_MARKPOINT8, OnMarkPointChange)
END_MESSAGE_MAP()

CMachineControlDlg_Bottom::CMachineControlDlg_Bottom(CWnd* pParentWnd_/* = NULL*/)
: CMachineControlDlg_Imp(pParentWnd_)
{
	m_pwndSliderF = NULL;
	m_pwndBtnXP = NULL;
	m_pwndBtnXN = NULL;
	m_pwndBtnYP = NULL;
	m_pwndBtnYN = NULL;
	m_pwndBtnZP = NULL;
	m_pwndBtnZN = NULL;
	m_pwndBtnWP = NULL;
	m_pwndBtnWN = NULL;
	m_pwndBtnCenter = NULL;
	m_pwndStcValueWorkX = NULL;
	m_pwndStcValueWorkY = NULL;
	m_pwndStcValueWorkZ = NULL;
	m_pwndStcValueWorkW= NULL;
	m_pwndStcValueMachX = NULL;
	m_pwndStcValueMachY= NULL;
	m_pwndStcValueMachZ = NULL;
	m_pwndStcValueMachW = NULL;
	m_pwndStcSpeed = NULL;
	m_pwndStcPower = NULL;
	m_pwndStcFollowHeight = NULL;
	m_pSetSpeedDlg = NULL;
	m_pwndSliderSetF = NULL;
	m_pwndSliderSetP = NULL;
	m_pwndSliderSetFH = NULL;
	m_pDistanceEdit = NULL;
	m_pwndRunBtn = NULL;
	m_pwndDirRunBtn = NULL;

	m_pMenu = new CMenu;

	memset(m_pwndPortButtons, 0, sizeof(CPortButton*) * _countof(m_pwndPortButtons));

	m_nCoorMode = 0x00;
	m_bSelectMach = FALSE;

	for (int _i = 0; _i < _countof(m_nFValues); _i++)
	{
		m_nFValues[_i] = _i;
	}

	m_strShowAllBKMark = "0";
	m_strBKMarkAttachAxis = "0,1";

	m_nArcSliderFHMax = 15;

	m_bSliderCtrlG00 = NceGetPrivateProfileString(_T("ControlTarget"), _T("SliderCtrlG00"), _T("0")) == _T("1");
	// ͬGXXG00ıʡ ---- ƺ 2016-04-19
	if (m_bSliderCtrlG00)
	{
		if (CParamManager* _pParamManager = GetParamManager())
		{
			int _nFrp = 100;
			ParameterValue _FrpParamValue;
			if (_pParamManager->GetParameterValue("SpeedGxx_Frp", &_FrpParamValue)
				&& _FrpParamValue.nType == ParameterValue::VT_INT)
			{
				_nFrp = _FrpParamValue.iValue;
			}

			if (_pParamManager->GetParameterValue("SpeedG00_Frp", &_FrpParamValue)
				&& _FrpParamValue.nType == ParameterValue::VT_INT)
			{
				_FrpParamValue.iValue = _nFrp;
				bool _bRet = _pParamManager->SetParameterValue("SpeedG00_Frp", &_FrpParamValue);
				ASSERT(_bRet);
			}
		}
	}

	m_bShowSelectMach = FALSE;
	m_bShowJogLaser = FALSE;
	m_bShowAutoCyc = FALSE;
	m_bSelectMach = FALSE;
	m_nCurIndex = 1;
	m_bShowCurValue = NceGetPrivateProfileString(_T("ControlTarget"), _T("ShowCurValue"), _T("0")) == _T("1");

	LOAD_PARAM(this, CMachineControlDlg_Bottom);
}

CMachineControlDlg_Bottom::~CMachineControlDlg_Bottom()
{
	if (m_pSetSpeedDlg)
	{
		delete m_pSetSpeedDlg;
		m_pSetSpeedDlg = NULL;
	}

	if (m_pMenu)
	{
		delete m_pMenu;
		m_pMenu = NULL;
	}

	SAVE_PARAM(this, CMachineControlDlg_Bottom);
}

BOOL CMachineControlDlg_Bottom::Create(CWnd* pParentWnd_ /* = NULL */)
{
	// ĴڷΪӴڣԱNcEditorҲϡ ----  2011-10-31
	static struct { DLGTEMPLATE dt; SHORT n1; SHORT n2; SHORT n3; }
	_s_EmptyDialogTemplate = { WS_CHILD };
	return CreateIndirect(&_s_EmptyDialogTemplate.dt, pParentWnd_);
}

void CMachineControlDlg_Bottom::Update()
{
	UpdateBRFlag();
	UpdateMachCoor();
	UpdateF();
	UpdateP();
	UpdateFH();
	UpdateSpeed();
	UpdateManuCenter();
	UpdateGFOBInfo();
	UpdateEnableJogLaser();
	UpdateEnableAutoCyc();
	UpdateEnableAutoExchange();
	UpdateEnableCyc();
	
	UpdateEnableBoardSupport();
	for (int _i = 0; _i < _countof(m_pwndPortButtons); _i++)
	{
		if (m_pwndPortButtons[_i])
		{
			// ʱ ----  2013-03-11
			m_pwndPortButtons[_i]->Update();
		}
	}
	m_pwndDirRunBtn->Update();
	m_pwndRunBtn->Update();
}

BOOL CMachineControlDlg_Bottom::OnInitDialog()
{
	__super::OnInitDialog();

	// עȡøؼָ롣 ----  2011-10-31
	Register("stcWorkCoor", m_pwndStcWorkCoor);
	Register("stcMachCoor", m_pwndStcMachCoor);
	RegisterID("stcWorkCoor", CTRLID_STC_WORKCOOR);
	RegisterID("stcMachCoor", CTRLID_STC_MACHCOOR);
	RegisterID("stcAxes", CTRLID_STC_AXES);
	RegisterID("stcCoor", CTRLID_STC_COOR);
	Register("stcBR", m_pwndStcBR);
	Register("stcBRX", m_pwndStcBRX);
	Register("stcBRY", m_pwndStcBRY);
	Register("stcBRZ", m_pwndStcBRZ);
	Register("stcBRW", m_pwndStcBRW);
	Register("stcXValue_Work", m_pwndStcValueWorkX);
	Register("stcYValue_Work", m_pwndStcValueWorkY);
	Register("stcZValue_Work", m_pwndStcValueWorkZ);
	Register("stcWValue_Work", m_pwndStcValueWorkW);
	Register("stcXValue_Mach", m_pwndStcValueMachX);
	Register("stcYValue_Mach", m_pwndStcValueMachY);
	Register("stcZValue_Mach", m_pwndStcValueMachZ);
	Register("stcWValue_Mach", m_pwndStcValueMachW);
	Register("stcSpeedValue", m_pwndStcSpeed);
	Register("stcPowerValue", m_pwndStcPower);
	Register("stcFollowHeightValue", m_pwndStcFollowHeight);
	Register("sliderF", m_pwndSliderF);
	Register("sliderP", m_pwndSliderP);
	Register("sliderFH", m_pwndSliderFH);
	Register("sliderSetF", m_pwndSliderSetF);
	Register("sliderSetP", m_pwndSliderSetP);
	Register("sliderSetFH", m_pwndSliderSetFH);
	RegisterID("sliderSetF", CTRLID_SLD_SETF);
	RegisterID("sliderSetP", CTRLID_SLD_SETP);
	RegisterID("sliderSetFH", CTRLID_SLD_SETFH);
	RegisterID("btnF", CTRLID_BTN_F);
	RegisterID("stcXValue", CTRLID_STC_XVALUE);
	RegisterID("stcYValue", CTRLID_STC_YVALUE);
	RegisterID("stcZValue", CTRLID_STC_ZVALUE);
	RegisterID("stcWValue", CTRLID_STC_WVALUE);
	Register("btnXP", m_pwndBtnXP);
	Register("btnXN", m_pwndBtnXN);
	Register("btnYP", m_pwndBtnYP);
	Register("btnYN", m_pwndBtnYN);
	Register("btnZP", m_pwndBtnZP);
	Register("btnZN", m_pwndBtnZN);
	Register("btnWP", m_pwndBtnWP);
	Register("btnWN", m_pwndBtnWN);
	Register("stcGoDistance", m_pwndStcGoDistance);
	RegisterID("stcGoDistance", CTRLID_BTN_GODISTANCE);
	Register("btnCenter", m_pwndBtnCenter);
	RegisterID("btnCenter", CTRLID_BTN_CENTER);
	RegisterID("btnXP", CTRLID_BTN_XP);
	RegisterID("btnXN", CTRLID_BTN_XN);
	RegisterID("btnYP", CTRLID_BTN_YP);
	RegisterID("btnYN", CTRLID_BTN_YN);
	RegisterID("btnZP", CTRLID_BTN_ZP);
	RegisterID("btnZN", CTRLID_BTN_ZN);
	RegisterID("btnWP", CTRLID_BTN_WP);
	RegisterID("btnWN", CTRLID_BTN_WN);
	RegisterID("btnGoForward", CTRLID_BTN_GOFORWARD);
	RegisterID("btnGoBackward", CTRLID_BTN_GOBACKWARD);
	RegisterID("stcPort0", CTRLID_STC_PORT0);
	RegisterID("stcPort1", CTRLID_STC_PORT1);
	RegisterID("stcPort2", CTRLID_STC_PORT2);
	RegisterID("stcPort3", CTRLID_STC_PORT3);
	RegisterID("stcPort4", CTRLID_STC_PORT4);
	RegisterID("stcPort5", CTRLID_STC_PORT5);
	RegisterID("stcPort6", CTRLID_STC_PORT6);
	RegisterID("stcPort7", CTRLID_STC_PORT7);
	RegisterID("stcPort8", CTRLID_STC_PORT8);
	RegisterID("stcPort9", CTRLID_STC_PORT9);
	RegisterID("stcPort10", CTRLID_STC_PORT10);
	RegisterID("stcPort11", CTRLID_STC_PORT11);
	RegisterID("stcPort12", CTRLID_STC_PORT12);
	RegisterID("stcPort13", CTRLID_STC_PORT13);
	RegisterID("stcPort14", CTRLID_STC_PORT14);
	RegisterID("stcPort15", CTRLID_STC_PORT15);
	RegisterID("btnSelMarkPoint", CTRLID_BTN_SELMARKPOINT);
	//RegisterID("stcSelMarkPoint", CTRLID_STC_SELMARKPOINT);
	Register("btnRun", m_pwndRunBtn);
	Register("btnDirrun", m_pwndDirRunBtn);

#define RegisterBtnID(szName_, nID_) {	\
	CAgileImageButton* _pwndBtn = NULL;	\
	Register(szName_, _pwndBtn);		\
	ASSERT(_pwndBtn);					\
	ASSERT(IsCmdID(nID_));				\
	_pwndBtn->SetCmdID(nID_);			\
	}
	CString _strEnable = NceGetPrivateProfileString(_T("Tube"), _T("Enable"), _T(""));
	BOOL _bIsTube = _strEnable == _T("True");
	if (_bIsTube)
	{
		RegisterBtnID("FindMid4Face", IDCMD_TUBECTRLTARGET_FINDMIDFOURSIDE);
		RegisterBtnID("AdjustFindMid", IDCMD_TUBECTRLTARGET_ADJUSTHORANDFINDMID);
	}

	// ǵѡťʼ ---- ߿ϼ 2017-03-15
	CString _strCurIndex;
	_strCurIndex.Format("%u", m_nCurIndex);

	// ǵѡ˵
	m_pMenu->CreatePopupMenu();
	m_pMenu->AppendMenu(MF_STRING, CTRLID_BTN_MARKPOINT1, _GETCS(s_szMUNU_MARKPOINT1));
	m_pMenu->AppendMenu(MF_STRING, CTRLID_BTN_MARKPOINT2, _GETCS(s_szMUNU_MARKPOINT2));
	m_pMenu->AppendMenu(MF_STRING, CTRLID_BTN_MARKPOINT3, _GETCS(s_szMUNU_MARKPOINT3));
	m_pMenu->AppendMenu(MF_STRING, CTRLID_BTN_MARKPOINT4, _GETCS(s_szMUNU_MARKPOINT4));
	m_pMenu->AppendMenu(MF_STRING, CTRLID_BTN_MARKPOINT5, _GETCS(s_szMUNU_MARKPOINT5));
	m_pMenu->AppendMenu(MF_STRING, CTRLID_BTN_MARKPOINT6, _GETCS(s_szMUNU_MARKPOINT6));
	m_pMenu->AppendMenu(MF_STRING, CTRLID_BTN_MARKPOINT7, _GETCS(s_szMUNU_MARKPOINT7));
	m_pMenu->AppendMenu(MF_STRING, CTRLID_BTN_MARKPOINT8, _GETCS(s_szMUNU_MARKPOINT8));


	// ʾʹbuttonϲʾ ---- ߿ϼ 2017-03-15
	CString _strShowIndex = _strCurIndex + '\n';
	SetDlgItemText(CTRLID_BTN_SELMARKPOINT, _strShowIndex);

	m_bShowSelectMach = NceGetPrivateProfileString(_T("ControlTarget"), _T("ShowSelectMach")) == _T("1");
	RegisterID("btnMachSelected", CTRLID_BTN_MACHSELECTED);
	CButton* _pBtnSelMach = (CButton*)GetDlgItem(CTRLID_BTN_MACHSELECTED);
	_pBtnSelMach->ShowWindow(m_bShowSelectMach ? SW_SHOWNORMAL : SW_HIDE);

	if (_pBtnSelMach)
	{
		_pBtnSelMach->EnableWindow(m_bShowSelectMach);
		_pBtnSelMach->SetCheck(m_bSelectMach ? BST_CHECKED : BST_UNCHECKED);
		CStateManager* _pStateManager = GetStateManager();
		ASSERT(_pStateManager);
		_pStateManager->SetSelectedMach(m_bSelectMach);
	}

	// 㶯 ---- ߿ϼ 2016-12-26
	m_bShowJogLaser = NceGetPrivateProfileString(_T("ControlTarget"), _T("ShowJogLaser")) == _T("1");
	RegisterID("btnJogWithLaser", CTRLID_BTN_JOGLASER);
	CButton* _pBtnJogLaser = (CButton*)GetDlgItem(CTRLID_BTN_JOGLASER);
	if (_pBtnJogLaser)
	{
		_pBtnJogLaser->EnableWindow(m_bShowJogLaser);
		_pBtnJogLaser->SetCheck(m_bShowJogLaser ? BST_CHECKED : BST_UNCHECKED);
	}
	
	BOOL _bIsTJNK = NceGetPrivateProfileString(_T("User"), _T("User")) == _T("TJNK");
	if (_bIsTJNK)
	{
		// ѭӹ ----  2017-06-22
		m_bShowCyc = NceGetPrivateProfileString(_T("ControlTarget"), _T("ShowAutoCyc")) == _T("1");
		if (m_bShowCyc)
		{
			RegisterID("btnCyc", CTRLID_BTN_CYC);
		}
		CButton* _pBtnAutoCyc = (CButton*)GetDlgItem(CTRLID_BTN_CYC);
		if (_pBtnAutoCyc)
		{
			_pBtnAutoCyc->EnableWindow(m_bShowCyc);
		}

		// Զ ----  2017-06-22
		m_bShowAutoExchange = NceGetPrivateProfileString(_T("ControlTarget"), _T("ShowAutoExchange")) == _T("1");
		if (m_bShowAutoExchange)
		{
			RegisterID("btnAutoExchange", CTRLID_BTN_AUTOEXCHANGE);
		}
		CButton* _pBtnAutoExchange = (CButton*)GetDlgItem(CTRLID_BTN_AUTOEXCHANGE);
		if (_pBtnAutoExchange)
		{
			_pBtnAutoExchange->EnableWindow(m_bShowAutoExchange);
		}
	}
	else
	{
		// Զѭ ---- ˼ 2017-1-10
		m_bShowAutoCyc = NceGetPrivateProfileString(_T("ControlTarget"), _T("ShowAutoCyc")) == _T("1");
		RegisterID("btnAutoCycle", CTRLID_BTN_AUTOCYC);
		CButton* _pBtnAutoCyc = (CButton*)GetDlgItem(CTRLID_BTN_AUTOCYC);
		if (_pBtnAutoCyc)
		{
			_pBtnAutoCyc->EnableWindow(m_bShowAutoCyc);
			_pBtnAutoCyc->SetCheck(m_bShowAutoCyc ? BST_CHECKED : BST_UNCHECKED);
		}
	}

	m_pwndRunBtn->SetMotionEndType(CCycMachiningTarget::TaskEndNormal);
	m_pwndDirRunBtn->SetMotionEndType(CCycMachiningTarget::DryRunEndNormal);

	// PortButton ---- DingQiang 2013-07-23
	for (size_t _i = 0; _i < _countof(m_pwndPortButtons); _i++)
	{
		// ע:xamlûעʧܣӦָΪNULL ---- DingQiang 2013-07-24
		CString _strPortButtonName;
		_strPortButtonName.Format(_T("btnPort%d"), _i);
		Register(_strPortButtonName, m_pwndPortButtons[_i]);

		// ʼؼ ---- DingQiang 2016-07-14
		CString _strPortIndex;
		_strPortIndex.Format(_T("Port%d"), _i);
		if (!m_pwndPortButtons[_i] || !m_pwndPortButtons[_i]->Initialize(_T("ControlTarget"), _strPortIndex))
		{
			continue;
		}

		// ӦĶ˿ ----  2012-07-05
		CString _strDescriptionNameKey;
		_strDescriptionNameKey.Format(_GETCS(s_szPortNameKey), _i);
		CString _strDescriptionName = NceGetPrivateProfileString(_T("ControlTarget"), _strDescriptionNameKey);
		SetDlgItemText(CTRLID_STC_PORT0 + (int)_i, _strDescriptionName);
	}

	// еĻػеԭ־-----2015-02-08
	m_pwndStcBR->ShowWindow(SW_HIDE);
	m_pwndStcBRX->ShowWindow(SW_HIDE);
	m_pwndStcBRY->ShowWindow(SW_HIDE);
	m_pwndStcBRZ->ShowWindow(SW_HIDE);
	if (m_pwndStcBRW)
	{
		m_pwndStcBRW->ShowWindow(SW_HIDE);
	}

	//ãǷʾػеԭ־Լػеԭ
	//ԶʹöģʹĬϵ-----2015-02-08
	CString _strShowAllBKMark = NceGetPrivateProfileString(_T("ControlTarget"), _T("ShowAllBKMark"));
	CString _strBKMarkAttachAxis = NceGetPrivateProfileString(_T("ControlTarget"), _T("BKMarkAttachAxis"));
	if (!_strShowAllBKMark.IsEmpty())
	{
		m_strShowAllBKMark = _strShowAllBKMark;
	}
	if (!_strBKMarkAttachAxis.IsEmpty())
	{
		m_strBKMarkAttachAxis = _strBKMarkAttachAxis;
	}
	
	//ֻʾһԭ־ʱ----2015-02-08
	if (m_strShowAllBKMark == "0")
	{
		CString _strBKMarkAttachAxis = m_strBKMarkAttachAxis;
		// ֵзǷַֻһַ
		if (_strBKMarkAttachAxis.IsEmpty()
			||_strBKMarkAttachAxis.SpanIncluding(_T(",012")).GetLength() != _strBKMarkAttachAxis.GetLength()
			|| _strBKMarkAttachAxis.GetLength() == 1 && _strBKMarkAttachAxis.FindOneOf(_T("012")) == -1)
		{
			_strBKMarkAttachAxis.Empty();
		}
		m_strVecAxis.clear();
		while(!_strBKMarkAttachAxis.IsEmpty())
		{
			_strBKMarkAttachAxis.TrimLeft(",");
			_strBKMarkAttachAxis.TrimRight(",");
			int _Index = _strBKMarkAttachAxis.Find(",");
			if(_Index == -1)
			{
				m_strVecAxis.push_back(_strBKMarkAttachAxis);
				break;
			}
			m_strVecAxis.push_back( _strBKMarkAttachAxis.Left(_Index));
			_strBKMarkAttachAxis = _strBKMarkAttachAxis.Right(_strBKMarkAttachAxis.GetLength() - _Index);
		}
	}

#define RegisterBtnID(szName_, nID_) {	\
	CAgileImageButton* _pwndBtn = NULL;	\
	Register(szName_, _pwndBtn);		\
	ASSERT(_pwndBtn);					\
	ASSERT(IsCmdID(nID_));				\
	_pwndBtn->SetCmdID(nID_);			\
	}
	RegisterBtnID("btnSetW", IDCMD_CONTROLTARGET_CLEARW);
	RegisterBtnID("btnBW", IDCMD_CONTROLTARGET_BACKW);
	RegisterBtnID("btnSimuCut", IDCMD_CONTROLTARGET_SIMUCUT);
	RegisterBtnID("btnRun", IDCMD_CONTROLTARGET_START);
	RegisterBtnID("btnPause", IDCMD_CONTROLTARGET_PAUSE);
	RegisterBtnID("btnStop", IDCMD_CONTROLTARGET_STOP);
	RegisterBtnID("btnBreakpointResume", IDCMD_CONTROLTARGET_BREAKPOINTRESUME);
	RegisterBtnID("btnSimulate", IDCMD_CONTROLTARGET_SIMULATE);
	RegisterBtnID("btnDirrun", IDCMD_CONTROLTARGET_DIRRUN);

	RegisterBtnID("btnBackFixed", IDCMD_CONTROLTARGET_BACKWZ);

	if((NceGetPrivateProfileString(_T("ControlTarget"), _T("ShowCleanJet")) == _T("1")))
	{
		RegisterBtnID("btnCleanJet", IDCMD_AUTOCLEANTARGET_STARTAUTOCLEAN);
	}
	RegisterBtnID("btnMarkPoint", IDCMD_MARKPOINTTARGET_MARKTHISPOINT);
	RegisterBtnID("btnBackMarkPoint", IDCMD_MARKPOINTTARGET_MOVETOMARKPOINT);
	CString _strCutBoundText;
	if (NceGetPrivateProfileString(_T("ControlTarget"), _T("ShowSampleBtn")) == _T("1"))
	{
		RegisterBtnID("btnSample", IDCMD_FOLLOWCTRLTARGET_SAMPLE);
		// ߱߿ŵһţťʾ֡ ---- ƺ 2015-09-10
		_strCutBoundText = _GETCS(s_csSIMUCUTBOUNDRECT);
	}
	if (NceGetPrivateProfileString(_T("ControlTarget"), _T("ShowBackOrgBtn")) == _T("1"))
		RegisterBtnID("btnBackOrg", IDCMD_CONTROLTARGET_BACKR);
#undef RegisterBtnID

	SetDlgItemText(CTRLID_STC_AXES, _GETCS(s_csAXES));
	SetDlgItemText(CTRLID_STC_MACHCOOR, _GETCS(s_csMACHINECOORDINATE));		// е ---- η 2016-10-27
	SetDlgItemText(CTRLID_STC_WORKCOOR, _GETCS(s_csWORKPIECECOORDINATE));	//  ---- η 2016-10-27
	SetDlgItemText(CTRLID_STC_COOR, m_nCoorMode == 0x00 ? _GETCS(s_csWORKPIECECOORDINATE) : _GETCS(s_csMACHINECOORDINATE));
	//SetDlgItemText(IDCMD_CONTROLTARGET_BREAKPOINTRESUME, _GETCS(s_csRESUME));
	//SetDlgItemText(IDCMD_CONTROLTARGET_SIMULATE, _GETCS(s_csSIMU));
	//SetDlgItemText(IDCMD_CONTROLTARGET_DIRRUN, _GETCS(s_csDIRRUN));
	//SetDlgItemText(IDCMD_CONTROLTARGET_SIMUCUT, _strCutBoundText);

	// ùʻΧ---- DingQiang 2012-04-28
	CString _strIsGrayBottom = NceGetPrivateProfileString(_T("ControlTarget"), _T("IsGrayBottom"), _T(0));
	BOOL _bIsGrayBottom = atoi(_strIsGrayBottom);

	CString _strSliderStyle = NceGetPrivateProfileString(_T("Theme"), _T("SliderStyle"), _T("None"));
	bool _bIsBD = (_strSliderStyle == _T("BD"));

	m_pwndSliderSetF->SetCustomerSetSize();
	if (_bIsGrayBottom)
	{
		// ػɫɫ ---- ߿ϼ 2017-01-11
		m_pwndSliderSetF->SetBitmapChannel( IDB_BMP_GRAY_CHANNELBACK, IDB_BMP_GRAY_CHANNELFORE);
		m_pwndSliderSetF->SetBitmapThumb( IDB_BMP_GRAY_THUMBNORMAL, IDB_BMP_GRAY_THUMBPRESS, IDB_BMP_GRAY_THUMBHOVER);
	}
	else
	{
		m_pwndSliderSetF->SetBitmapChannel( IDB_BMP_CHANNELBACK, IBP_BMP_CHANNELFORE);
		m_pwndSliderSetF->SetBitmapThumb( IDB_BMP_THUMBNORMAL, IDB_BMP_THUMBPRESS, IDB_BMP_THUMBHOVER);
	}
	m_pwndSliderSetF->SetRange( 0, 100);
	m_pwndSliderSetF->SetPos( 0 );

	m_pwndSliderSetP->SetCustomerSetSize();
	if (_bIsGrayBottom)
	{
		// ػɫɫ ---- ߿ϼ 2017-01-11
		m_pwndSliderSetP->SetBitmapChannel( IDB_BMP_GRAY_CHANNELBACK, IDB_BMP_GRAY_CHANNELFORE);
		m_pwndSliderSetP->SetBitmapThumb( IDB_BMP_GRAY_THUMBNORMAL, IDB_BMP_GRAY_THUMBPRESS, IDB_BMP_GRAY_THUMBHOVER);
	}
	else
	{
		m_pwndSliderSetP->SetBitmapChannel( IDB_BMP_CHANNELBACK, IBP_BMP_CHANNELFORE);
		m_pwndSliderSetP->SetBitmapThumb( IDB_BMP_THUMBNORMAL, IDB_BMP_THUMBPRESS, IDB_BMP_THUMBHOVER);
	}
	m_pwndSliderSetP->SetRange( 0, 100);
	m_pwndSliderSetP->SetPos( 0 );

	m_pwndSliderSetFH->SetCustomerSetSize();
	if (_bIsGrayBottom)
	{
		// ػɫɫ ---- ߿ϼ 2017-01-11
		m_pwndSliderSetFH->SetBitmapChannel( IDB_BMP_GRAY_CHANNELBACK, IDB_BMP_GRAY_CHANNELFORE);
		m_pwndSliderSetFH->SetBitmapThumb( IDB_BMP_GRAY_THUMBNORMAL, IDB_BMP_GRAY_THUMBPRESS, IDB_BMP_GRAY_THUMBHOVER);
	}	
	else
	{
		m_pwndSliderSetFH->SetBitmapChannel( IDB_BMP_CHANNELBACK, IBP_BMP_CHANNELFORE);
		m_pwndSliderSetFH->SetBitmapThumb( IDB_BMP_THUMBNORMAL, IDB_BMP_THUMBPRESS, IDB_BMP_THUMBHOVER);
	}
	m_pwndSliderSetFH->SetRange( 0, 80);
	m_pwndSliderSetFH->SetPos( 0 );

	// Ǳ ---- η 2017-04-12
	if (_bIsGrayBottom)
	{
		m_pwndSliderF->SetRange(0, 100);
		m_pwndSliderF->Init(2, 90, 260, IDB_BMP_ARCSLIDERBK_GRAY_FEED, RGB(255, 255, 255));
		m_pwndSliderP->Init(2, 90, 260, IDB_BMP_ARCSLIDERBK_GRAY_POWER, RGB(255, 255, 255));
	}
	else if (_bIsBD)
	{
		m_pwndSliderF->SetRange(0, 100);
		m_pwndSliderF->Init(2, 90, 255, IDB_BMP_ARCSLIDERBK_FEED_BD, RGB(255, 255, 255));
		m_pwndSliderP->Init(2, 90, 255, IDB_BMP_ARCSLIDERBK_POWER_BD, RGB(255, 255, 255));
	}
	else
	{
		m_pwndSliderF->SetRange(0, 120);
		m_pwndSliderF->Init(2, 142, 257, IDB_BMP_ARCSLIDERBK_FEED, RGB(255, 255, 255));
		m_pwndSliderP->Init(2, 142, 257, IDB_BMP_ARCSLIDERBK_POWER, RGB(255, 255, 255));
	}
	m_pwndSliderSetFH->SetRange(0, 80);

	_BuildFHIVMap();
	m_pwndSliderFH->SetRange(0, 80);
	if (_bIsGrayBottom)
	{
		m_pwndSliderFH->Init(2, 90, 260, IDB_BMP_ARCSLIDERBK_GRAY_FOLLOWHEIGHT, RGB(255, 255, 255));
	}
	else if (_bIsBD)
	{
		m_pwndSliderFH->Init(2, 90, 260, IDB_BMP_ARCSLIDERBK_FOLLOWHEIGHT_BD, RGB(255, 255, 255));
	}
	else
	{
		m_pwndSliderFH->Init(2, 142, 257, IDB_BMP_ARCSLIDERBK_FOLLOWHEIGHT, RGB(255, 255, 255));
	}
	// ֶļΪԲΰťֶΪԲиɣX-ΪX+Ϊ
	// Y-ΪY+Ϊ
	//   ļ뾶Ϊ34pxԲ⾶Ϊ80pxھΪ40pxΪ
	// 8px
	//   ˴ֵΪһԱȷȫͼ߽
	// иݳݡ                                        ----  2011-11-02
	ASSERT(m_pwndBtnCenter && m_pwndBtnXP && m_pwndBtnXN && m_pwndBtnYP && m_pwndBtnYN);

	if (_bIsBD)
	{
		bool _bEnableW = IsEnableWUpDown();
		if (!_bEnableW)
		{
			m_pwndBtnCenter->SetShape(::CreateEllipticRgn(-1, -1, 77, 77));
			CDC _dc;
			CDC* _pDC = GetDC();
			_dc.CreateCompatibleDC(_pDC);
			ReleaseDC(_pDC);
			_pDC = NULL;
			_dc.BeginPath();
			_dc.MoveTo(147, 28);
			_dc.SetArcDirection(AD_CLOCKWISE);
			_dc.ArcTo(-1, -1, 170, 170, 147, 28, 147, 143);
			_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
			_dc.ArcTo(40, 40, 128, 128, 118, 113, 118, 57);
			_dc.LineTo(147, 28);
			_dc.EndPath();
			CRgn _rgn;
			_rgn.CreateFromPath(&_dc);
			_rgn.OffsetRgn(-120, -27);
			m_pwndBtnXP->SetShape((HRGN)_rgn.Detach());

			_dc.BeginPath();
			_dc.MoveTo(52, 114);
			_dc.SetArcDirection(AD_CLOCKWISE);
			_dc.ArcTo(40, 40, 130, 130, 52, 114, 52, 58);
			_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
			_dc.ArcTo(-1, -1, 170, 170, 22, 30, 22, 142);
			_dc.LineTo(52, 114);
			_dc.EndPath();
			_rgn.CreateFromPath(&_dc);
			_rgn.OffsetRgn(18, -27);
			m_pwndBtnXN->SetShape((HRGN)_rgn.Detach());

			_dc.BeginPath();
			_dc.MoveTo(26, 23);
			_dc.SetArcDirection(AD_CLOCKWISE);
			_dc.ArcTo(-3, -3, 170, 170, 26, 23, 143, 23);
			_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
			_dc.ArcTo(45, 45, 130, 130, 115, 56, 54, 56);
			_dc.LineTo(26, 23);
			_dc.EndPath();
			_rgn.CreateFromPath(&_dc);
			_rgn.OffsetRgn(-1, 16);
			m_pwndBtnYP->SetShape((HRGN)_rgn.Detach());

			_dc.BeginPath();
			_dc.MoveTo(140, 148);
			_dc.SetArcDirection(AD_CLOCKWISE);
			_dc.ArcTo(-1, -1, 173, 173, 140, 148, 28, 148);
			_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
			_dc.ArcTo(39, 39, 129, 129, 57, 116, 112, 116);
			_dc.LineTo(140, 148);
			_dc.EndPath();
			_rgn.CreateFromPath(&_dc);
			_rgn.OffsetRgn(0, -117);
			m_pwndBtnYN->SetShape((HRGN)_rgn.Detach());
		}
		else
		{
			m_pwndBtnCenter->SetShape(::CreateEllipticRgn(-1, -1, 67, 67));
			CDC _dc;
			CDC* _pDC = GetDC();
			_dc.CreateCompatibleDC(_pDC);
			ReleaseDC(_pDC);
			_pDC = NULL;
			_dc.BeginPath();
			_dc.MoveTo(130, 16);
			_dc.SetArcDirection(AD_CLOCKWISE);
			_dc.ArcTo(-1, -1, 152, 152, 130, 19, 133, 129);
			_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
			_dc.ArcTo(39, 38, 107, 107, 98, 98, 101, 45);
			_dc.LineTo(130, 16);
			_dc.EndPath();
			CRgn _rgn;
			_rgn.CreateFromPath(&_dc);
			_rgn.OffsetRgn(-99, -22);
			m_pwndBtnXP->SetShape((HRGN)_rgn.Detach());

			_dc.BeginPath();
			_dc.MoveTo(49, 96);
			_dc.SetArcDirection(AD_CLOCKWISE);
			_dc.ArcTo(42, 40, 112, 110, 49, 96, 49, 49);
			_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
			_dc.ArcTo(-1, -1, 152, 152, 17, 17, 18, 127);
			_dc.LineTo(49, 96);
			_dc.EndPath();
			_rgn.CreateFromPath(&_dc);
			_rgn.OffsetRgn(8, -24);
			m_pwndBtnXN->SetShape((HRGN)_rgn.Detach());

			_dc.BeginPath();
			_dc.MoveTo(21, 17);
			_dc.SetArcDirection(AD_CLOCKWISE);
			_dc.ArcTo(-1, -1, 150, 150, 21, 17, 125, 18);
			_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
			_dc.ArcTo(44, 42, 110, 108, 100, 47, 48, 47);
			_dc.LineTo(21, 17);
			_dc.EndPath();
			_rgn.CreateFromPath(&_dc);
			_rgn.OffsetRgn(-24, 8);
			m_pwndBtnYP->SetShape((HRGN)_rgn.Detach());

			_dc.BeginPath();
			_dc.MoveTo(125, 126);
			_dc.SetArcDirection(AD_CLOCKWISE);
			_dc.ArcTo(1, -1, 150, 150, 125, 126, 26, 127);
			_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
			_dc.ArcTo(36, 32, 112, 108, 51, 98, 100, 100);
			_dc.LineTo(125, 126);
			_dc.EndPath();
			_rgn.CreateFromPath(&_dc);
			_rgn.OffsetRgn(-26, -100);
			m_pwndBtnYN->SetShape((HRGN)_rgn.Detach());
		}
	}
	else
	{
		m_pwndBtnCenter->SetShape(::CreateEllipticRgn(-1, -1, 77, 77));
		CDC _dc;
		CDC* _pDC = GetDC();
		_dc.CreateCompatibleDC(_pDC);
		ReleaseDC(_pDC);
		_pDC = NULL;
		_dc.BeginPath();
		_dc.MoveTo(165, 41);
		_dc.SetArcDirection(AD_CLOCKWISE);
		_dc.ArcTo(-1, -1, 205, 205, 165, 41, 165, 164);
		_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
		_dc.ArcTo(72, 72, 132, 132, 132, 132, 132, 73);
		_dc.LineTo(165, 41);
		_dc.EndPath();
		CRgn _rgn;
		_rgn.CreateFromPath(&_dc);
		_rgn.OffsetRgn(-136, -43);
		m_pwndBtnXP->SetShape((HRGN)_rgn.Detach());

		_dc.BeginPath();
		_dc.MoveTo(72, 132);
		_dc.SetArcDirection(AD_CLOCKWISE);
		_dc.ArcTo(72, 72, 132, 132, 72, 132, 72, 73);
		_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
		_dc.ArcTo(-1, -1, 205, 205, 39, 41, 39, 164);
		_dc.LineTo(72, 132);
		_dc.EndPath();
		_rgn.CreateFromPath(&_dc);
		_rgn.OffsetRgn(0, -43);
		m_pwndBtnXN->SetShape((HRGN)_rgn.Detach());

		_dc.BeginPath();
		_dc.MoveTo(39, 41);
		_dc.SetArcDirection(AD_CLOCKWISE);
		_dc.ArcTo(-1, -1, 205, 205, 39, 41, 165, 41);
		_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
		_dc.ArcTo(72, 72, 132, 132, 132, 73, 72, 73);
		_dc.LineTo(39, 41);
		_dc.EndPath();
		_rgn.CreateFromPath(&_dc);
		_rgn.OffsetRgn(-20, 0);
		m_pwndBtnYP->SetShape((HRGN)_rgn.Detach());

		_dc.BeginPath();
		_dc.MoveTo(165, 164);
		_dc.SetArcDirection(AD_CLOCKWISE);
		_dc.ArcTo(-1, -1, 205, 205, 165, 164, 39, 164);
		_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
		_dc.ArcTo(72, 72, 132, 132, 72, 132, 132, 132);
		_dc.LineTo(135, 139);
		_dc.EndPath();
		_rgn.CreateFromPath(&_dc);
		_rgn.OffsetRgn(-8, -134);
		m_pwndBtnYN->SetShape((HRGN)_rgn.Detach());
	}

	m_pSetSpeedDlg = new CSetSpeedDlg(this);
	((CSetSpeedDlg*)m_pSetSpeedDlg)->Create(this);

	// һUpdateΪֹһ⣬ʱĽʾ
	// Сһ²ųNcStudio⣬NcEditorû⡣
	// ûвԭֻǾ鷢UpdateһξͺˣǾôɡԺ
	// ޸ġ                          ----  2012-05-02
	Update();

	bool _bEnableZ = IsEnableZUpDown();
	m_pwndBtnZP->EnableWindow(_bEnableZ ? TRUE : FALSE);
	m_pwndBtnZN->EnableWindow(_bEnableZ ? TRUE : FALSE);
	m_pwndBtnZP->ShowWindow(_bEnableZ ? TRUE : FALSE);
	m_pwndBtnZN->ShowWindow(_bEnableZ ? TRUE : FALSE);
	SetMachineCtrlTips();
	return TRUE;
}

void CMachineControlDlg_Bottom::SetMachineCtrlTips()
{
	m_MachineCtrlTips.Create(this);
	m_MachineCtrlTips.Activate(TRUE);
	m_MachineCtrlTips.SetTipTextColor(RGB(0, 0, 0));
	m_MachineCtrlTips.SetDelayTime(1000);

	m_MachineCtrlTips.AddTool(GetDlgItem(IDCMD_CONTROLTARGET_CLEARW), _GETCS(s_csTipSETWORKORG));
	m_MachineCtrlTips.AddTool(GetDlgItem(IDCMD_CONTROLTARGET_BACKW), _GETCS(s_csTipMOVETOWORKORIGIN));
	m_MachineCtrlTips.AddTool(GetDlgItem(IDCMD_CONTROLTARGET_START), _GETCS(s_csTipSTART));
	m_MachineCtrlTips.AddTool(GetDlgItem(IDCMD_CONTROLTARGET_PAUSE), _GETCS(s_csTipPAUSE));
	m_MachineCtrlTips.AddTool(GetDlgItem(IDCMD_CONTROLTARGET_STOP), _GETCS(s_csTipSTOP));
	m_MachineCtrlTips.AddTool(GetDlgItem(CTRLID_BTN_GOBACKWARD), _GETCS(s_csTipGoBackward));
	m_MachineCtrlTips.AddTool(GetDlgItem(CTRLID_BTN_GOFORWARD), _GETCS(s_csTipGoForward));
	CWnd* _pwndBtn = GetDlgItem(IDCMD_FOLLOWCTRLTARGET_SAMPLE);
	if (_pwndBtn)
		m_MachineCtrlTips.AddTool(_pwndBtn, _GETCS(s_csTipFollowSample));
	_pwndBtn = GetDlgItem(IDCMD_CONTROLTARGET_BACKR);
	if (_pwndBtn)
		m_MachineCtrlTips.AddTool(_pwndBtn, _GETCS(s_csTipBackAll));
}

bool CMachineControlDlg_Bottom::IsEnableZUpDown()
{
	return true;
	CString _strEnableZ = NceGetPrivateProfileString(_T("ControlTarget"), _T("EnableZ"));

	if ("1" == _strEnableZ)
	{
		return true;
	}
	else
	{
		return false;
	}
}

bool CMachineControlDlg_Bottom::IsEnableWUpDown()
{
	CString _strEnableW = NceGetPrivateProfileString(_T("ControlTarget"), _T("EnableW"));

	if ("1" == _strEnableW)
	{
		return true;
	}
	else
	{
		return false;
	}
}

BOOL CMachineControlDlg_Bottom::PreTranslateMessage(MSG* pMsg_)
{
	// Ӵ˾ڻʾʾ ---- ׿ 2012.05.17
	m_MachineCtrlTips.RelayEvent(pMsg_);

	// Let go of Keyboard Message => ˴ôмĿģһEnterEsc
	// OnOKOnCancelرմڣǷֹڴʱϵĿݼ
	// Ρ                                            ----  2012-04-08
	if (WM_KEYFIRST <= pMsg_->message && pMsg_->message <= WM_KEYLAST)
	{
		return FALSE;
	}

	if (pMsg_->message == WM_LBUTTONDOWN)
	{
		UINT _nCtrlID = ::GetDlgCtrlID(pMsg_->hwnd);
		if (_nCtrlID == CTRLID_BTN_GODISTANCE)
		{
			if (OnDistanceLButtonDown(pMsg_->pt))
			{
				// returnĻDialogӦϢʱnewı༭
				// ӦOnKillFocus±༭һʧ ---- DingQiang 2012-07-19
				return TRUE;
			}
		}
	}

	return __super::PreTranslateMessage(pMsg_);
}

// ֶģʽ ---- С 2013-11-07
void CMachineControlDlg_Bottom::OnSetManuMode()
{
	DWORD _nBegin = GetTickCount();
	while(true)
	{
		MSG _msg;
		if (::PeekMessage(&_msg, NULL, NULL, NULL, PM_REMOVE))
		{
			::TranslateMessage(&_msg);
			::DispatchMessage(&_msg);

			if (_msg.message == WM_LBUTTONDBLCLK)
			{
				return;
			}
		}

		if (GetTickCount() - _nBegin > 200)
		{
			break;
		}
	}

	static int _s_nManuMode;
	int _nManuMode = _s_nManuMode % 3;

	CManualTarget* _pManualTarget = GetManualTarget();
	ASSERT(_pManualTarget);
	if (_nManuMode == 0)
	{
		_pManualTarget->SetManuMode(0);
		_pManualTarget->SetJogState(false);
	}
	else if (_nManuMode == 1)
	{
		_pManualTarget->SetManuMode(0);
		_pManualTarget->SetJogState(true);
	}
	else if (_nManuMode == 2)
	{
		_pManualTarget->SetManuMode(1);
	}

	_s_nManuMode ++;
}

void CMachineControlDlg_Bottom::UpdateMachCoor()
{
	CParamManager* _pParamManager = GetParamManager();
	if (!_pParamManager)
	{
		return;
	}

	// ؼӦؼĲʶһṹ---- DingQiang 2012-01-12
	const struct MachItem
	{
		CAgileLabel* pwndStcValue;
		CString strIdentifier;
	} _s_MachItems[] =
	{
		{ m_pwndStcValueWorkX, "State_Axis0_WorkcoorPos" },
		{ m_pwndStcValueWorkY, "State_Axis1_WorkcoorPos" },
		{ m_pwndStcValueWorkZ, "State_Axis2_WorkcoorPos" },
		{ m_pwndStcValueWorkW, "State_Axis3_WorkcoorPos" },
		{ m_pwndStcValueMachX, "Dyn_Axis0_Pos"},
		{ m_pwndStcValueMachY, "Dyn_Axis1_Pos"},
		{ m_pwndStcValueMachZ, "Dyn_Axis2_Pos"},
		{ m_pwndStcValueMachW, "Dyn_Axis3_Pos"},
	};

	for(int _i = 0; _i < _countof(_s_MachItems); _i++)
	{
		const MachItem& _item = _s_MachItems[_i];
		if (!_item.pwndStcValue || !_item.pwndStcValue->IsWindowVisible())
		{
			continue;
		}

		ParameterValue _PV;
		if (!_pParamManager->GetParameterValue(_item.strIdentifier, &_PV) || _PV.nType != ParameterValue::VT_DOUBLE)
		{
			ASSERT(FALSE);
			continue;
		}

		CString _strMachCoor;
		_strMachCoor.Format("%.3f", _PV.dValue);
		if (_strMachCoor == "-0.000")
		{
			_strMachCoor = "0.000";
		}

		// ǰº򲻸 ---- DingQiang 2012-01-12
		CString _strBeforeUpdate;
		_item.pwndStcValue->GetWindowText(_strBeforeUpdate);
		if (_strMachCoor != _strBeforeUpdate)
		{
			_s_MachItems[_i].pwndStcValue->SetWindowText(_strMachCoor);
		}
	}
}
// ػеԭ־÷ʽ£
// [ControlTarget]
// ShowAllBKMark=1
// BKMarkAttachAxis=0,1,2
void CMachineControlDlg_Bottom::UpdateBRFlag()
{
	// ԭ־ؼӦؼĲԼһṹ壬Ժչ-----2015-02-08
	const struct AxisItems
	{
		CAgileImageLabel* pwndStcBR;
		CString strIdentifier;
		CString strIndex;
	} _s_AxisItems[] =
	{
		{ m_pwndStcBRX, "State_Axis0_IsReferenced", "0" },
		{ m_pwndStcBRY, "State_Axis1_IsReferenced", "1" },
		{ m_pwndStcBRZ, "State_Axis2_IsReferenced", "2" },
		//{ m_pwndStcBRW, "State_Axis3_IsReferenced", "3" },
	};

	CParamManager* _pParamManager = GetParamManager();
	if(!_pParamManager)
		return;

	//ʾĻػеԭ־ֱʾĻػеԭ־----2015-02-08
	if (m_strShowAllBKMark == _T("1"))
	{
		int _nAllAxis = _countof(_s_AxisItems);
		bool _bEnableW = IsEnableWUpDown();
		//int _nCount = _bEnableW ? (_nAllAxis - 1) : _nAllAxis;
		for(int _i = 0; _i < _nAllAxis; _i++)
		{
			const AxisItems& _item = _s_AxisItems[_i];
			ParameterValue _PV;
			memset(&_PV, 0, sizeof(ParameterValue));
			if (!_pParamManager->GetParameterValue(_item.strIdentifier, &_PV) || _PV.nType != ParameterValue::VT_BOOL)
			{
				ASSERT(FALSE);
				continue;
			}
			_item.pwndStcBR->ShowWindow(_PV.bValue ? SW_SHOW : SW_HIDE);
		}
	}
	// ʾĻػеԭ־ݹֻʾһػеԭ־----2015-02-08
	else if(m_strShowAllBKMark == _T("0"))
	{
		bool _bIsRef = m_strVecAxis.empty()? false : true;
		for (std::vector<CString>::iterator _it = m_strVecAxis.begin(); _it != m_strVecAxis.end();_it++)
		{
			int _nCount = 0;
			CString _strAxis = *_it;
			for(int _j = 0; _j < _countof(_s_AxisItems); _j++)
			{
				const AxisItems& _item = _s_AxisItems[_j];
				ParameterValue _PV;
				memset(&_PV, 0, sizeof(ParameterValue));
				if (!_pParamManager->GetParameterValue(_item.strIdentifier, &_PV) || _PV.nType != ParameterValue::VT_BOOL)
				{
					ASSERT(FALSE);
					continue;
				}
				if (_item.strIndex == _strAxis)
				{
					_bIsRef &= _PV.bValue;
					break;
				}
				else
				{
					_nCount++;
					continue;
				}
			}
			//ûƥ
			if (_nCount == _countof(_s_AxisItems))
			{
				_bIsRef = false;
			}
		}
		m_pwndStcBR->ShowWindow(_bIsRef ? SW_SHOW : SW_HIDE);
	}
}


void CMachineControlDlg_Bottom::OnDirectionBtnPushed(UINT nID_)
{
	ASSERT(nID_ >= CTRLID_BTN_XP && nID_ <= CTRLID_BTN_WN);

	// ֶťģɿݼCManualTarget
	C_ASSERT(CTRLID_BTN_XP == CTRLID_BTN_XP + 0
		&& CTRLID_BTN_XN == CTRLID_BTN_XP + 1
		&& CTRLID_BTN_YP == CTRLID_BTN_XP + 2
		&& CTRLID_BTN_YN == CTRLID_BTN_XP + 3
		&& CTRLID_BTN_ZP == CTRLID_BTN_XP + 4
		&& CTRLID_BTN_ZN == CTRLID_BTN_XP + 5
		&& CTRLID_BTN_WP == CTRLID_BTN_XP + 6
		&& CTRLID_BTN_WN == CTRLID_BTN_XP + 7);
	static const UINT _s_nKeys[] =
	{
		VK_NUMPAD6,
		VK_NUMPAD4,
		VK_NUMPAD8,
		VK_NUMPAD2,
		VK_NUMPAD9,
		VK_NUMPAD3,
		VK_NUMPAD7,
		VK_NUMPAD1,
	};

	// ûWᣬWݼ ---- η 2016-12-30
	bool _bEnableW = IsEnableWUpDown();
	if (!_bEnableW && (nID_ == CTRLID_BTN_WP || nID_ == CTRLID_BTN_WN))
	{
		return;
	}

	MSG _msg = { NULL, WM_KEYDOWN, WPARAM(_s_nKeys[nID_ - CTRLID_BTN_XP]), LPARAM(1) };
	CManualTarget* _pManualTarget = GetManualTarget();
	ASSERT(_pManualTarget);
	_pManualTarget->OnKeyMessage(&_msg);
}

void CMachineControlDlg_Bottom::OnDirectionBtnUnpushed(UINT nID_)
{
	ASSERT(nID_ >= CTRLID_BTN_XP && nID_ <= CTRLID_BTN_WN);

	// ֶťģɿݼCManualTarget
	C_ASSERT(CTRLID_BTN_XP == CTRLID_BTN_XP + 0
		&& CTRLID_BTN_XN == CTRLID_BTN_XP + 1
		&& CTRLID_BTN_YP == CTRLID_BTN_XP + 2
		&& CTRLID_BTN_YN == CTRLID_BTN_XP + 3
		&& CTRLID_BTN_ZP == CTRLID_BTN_XP + 4
		&& CTRLID_BTN_ZN == CTRLID_BTN_XP + 5
		&& CTRLID_BTN_WP == CTRLID_BTN_XP + 6
		&& CTRLID_BTN_WN == CTRLID_BTN_XP + 7);
	static const UINT _s_nKeys[] =
	{
		VK_NUMPAD6,
		VK_NUMPAD4,
		VK_NUMPAD8,
		VK_NUMPAD2,
		VK_NUMPAD9,
		VK_NUMPAD3,
		VK_NUMPAD7,
		VK_NUMPAD1,
	};

	// ûWᣬWݼ ---- η 2016-12-30
	bool _bEnableW = IsEnableWUpDown();
	if (!_bEnableW && nID_ >= CTRLID_BTN_WP)
	{
		return;
	}

	MSG _msg = { NULL, WM_KEYUP, WPARAM(_s_nKeys[nID_ - CTRLID_BTN_XP]), LPARAM(1) };
	CManualTarget* _pManualTarget = GetManualTarget();
	ASSERT(_pManualTarget);
	_pManualTarget->OnKeyMessage(&_msg);
}

void CMachineControlDlg_Bottom::OnGFOBBtnPushed(UINT nID_)
{
	ASSERT(nID_ >= CTRLID_BTN_GOFORWARD && nID_ <= CTRLID_BTN_GOBACKWARD);

	CControlTarget* _pControlTarget = GetControlTarget();
	ASSERT(_pControlTarget);
	if (_pControlTarget->GetGFOBMode() != 0x00)
	{
		return;
	}

	C_ASSERT(CTRLID_BTN_GOFORWARD == CTRLID_BTN_GOFORWARD + 0
		&& CTRLID_BTN_GOBACKWARD == CTRLID_BTN_GOFORWARD + 1);
	static const UINT _s_nCmdIDs[] =
	{
		IDCMD_CONTROLTARGET_JOGFORWARD,
		IDCMD_CONTROLTARGET_JOGBACKWARD,
	};
	AfxGetMainWnd()->SendMessage(WM_COMMAND, _s_nCmdIDs[nID_ - CTRLID_BTN_GOFORWARD], 0);
}

void CMachineControlDlg_Bottom::OnGFOBBtnUnpushed(UINT nID_)
{
	ASSERT(nID_ >= CTRLID_BTN_GOFORWARD && nID_ <= CTRLID_BTN_GOBACKWARD);

	CControlTarget* _pControlTarget = GetControlTarget();
	ASSERT(_pControlTarget);
	if (_pControlTarget->GetGFOBMode() == 0x00)
	{
		AfxGetMainWnd()->SendMessage(WM_COMMAND, IDCMD_CONTROLTARGET_STOP, 0);
		return;
	}

	C_ASSERT(CTRLID_BTN_GOFORWARD == CTRLID_BTN_GOFORWARD + 0
		&& CTRLID_BTN_GOBACKWARD == CTRLID_BTN_GOFORWARD + 1);
	static const UINT _s_nCmdIDs[] =
	{
		IDCMD_CONTROLTARGET_INCFORWARD,
		IDCMD_CONTROLTARGET_INCBACKWARD,
	};
	AfxGetMainWnd()->SendMessage(WM_COMMAND, _s_nCmdIDs[nID_ - CTRLID_BTN_GOFORWARD], 0);
}

LRESULT CMachineControlDlg_Bottom::OnIdleUpdateCmdUI(WPARAM wParam_, LPARAM lParam_)
{
	static const struct ManualBtnItem
	{
		CButton* pBtnManual;
		DWORD nMask;
	} _s_cManualBtnItems[] = 
	{
		{m_pwndBtnYN,		0x00000001},
		{m_pwndBtnXN,		0x00000002},
		{m_pwndBtnXP,		0x00000004},
		{m_pwndBtnYP,		0x00000008},
		{m_pwndBtnZP,		0x00000010},
		{m_pwndBtnZN,		0x00000020},
		{m_pwndBtnCenter,	0x00000040},
		{m_pwndBtnWP,		0x00000080},
		{m_pwndBtnWN,		0x00000100},
	};

	CManualTarget* _pManualTarget = GetManualTarget();
	if (!_pManualTarget)
	{
		return 0;
	}
	DWORD _ManualKeyState = _pManualTarget->GetManuKeyState();
	
	// Ƿܣֻܼǰģܼ2Wİť ---- η 2016-12-27
	bool _bEnableW = IsEnableWUpDown();
	int _nBtnItems = _bEnableW ? _countof(_s_cManualBtnItems) : _countof(_s_cManualBtnItems) - 2;
	for (int _i = 0; _i < _nBtnItems; _i++)
	{
		if (_ManualKeyState & _s_cManualBtnItems[_i].nMask)
		{
			_s_cManualBtnItems[_i].pBtnManual->SetCheck(TRUE);
		}
		else
			_s_cManualBtnItems[_i].pBtnManual->SetCheck(FALSE);
	}


	// ʵǰ״̬ͰťF3F4£ֻҪһ״̬Ϊ漴ť ---- DingQiang 2014-10-11
	static const struct GOBBtnItem
	{
		UINT nID;
		DWORD nKeyboardMask;
		DWORD nRunningStateMask;
	} _s_cGOBBtnItems[] = 
	{
		{CTRLID_BTN_GOBACKWARD, 0x00000001, 0x00000100},
		{CTRLID_BTN_GOFORWARD, 0x00000002, 0x00000080},
	};

	CControlTarget* _pControlTarget = GetControlTarget();
	CStateManager* _pStateManager = GetStateManager();
	if (!_pControlTarget || !_pStateManager)
	{
		return 0;
	}

	DWORD _GOBKeyState = _pControlTarget->GetGOBKeyState();
	DWORD _nRunningState = 0;
	_pStateManager->GetRunningState(&_nRunningState);

	for (int _i = 0; _i < _countof(_s_cGOBBtnItems); _i++)
	{
		BOOL _bCheck = _nRunningState & _s_cGOBBtnItems[_i].nRunningStateMask;
		_bCheck |= _GOBKeyState & _s_cGOBBtnItems[_i].nKeyboardMask;

		((CButton*)GetDlgItem(_s_cGOBBtnItems[_i].nID))->SetCheck(_bCheck);
	}

	// ¼ӹѡͼΡ ---- ƺ 2016-09-19
	CButton* _pBtnSelMach = (CButton*)GetDlgItem(CTRLID_BTN_MACHSELECTED);
	if (_pBtnSelMach
		&& _pBtnSelMach->IsWindowVisible())
	{
		// ͬ˵ѡ ---- ƺ 2016-09-18
		if (_pStateManager->IsSelectedMach() != (_pBtnSelMach->GetCheck() == BST_CHECKED))
		{
			_pBtnSelMach->SetCheck(_pStateManager->IsSelectedMach() ? BST_CHECKED : BST_UNCHECKED);
		}
	}

	return 1;
}

void CMachineControlDlg_Bottom::OnHScroll(UINT nSBCode_, UINT nPos_, CScrollBar* pScrollBar_)
{

}

// ½ʵʾֵ ---- DingQiang 2012-02-07
void CMachineControlDlg_Bottom::UpdateF()
{
	_BuildFIVMap();

	// ParamManagerжʵĵǰֵ趨ʻϵ
	// ֵΪ׼                                          ----  2012-02-18
	ASSERT(m_pwndSliderSetF);
	int _nIndex = m_pwndSliderSetF->GetPos();
	int _nFrp = 100;
	_UpdateFValue(_nIndex, &_nFrp);
	if (CParamManager* _pParamManager = GetParamManager())
	{
		const CStringA _c_strFrpIdentifier = "SpeedGxx_Frp";
		ParameterValue _FrpParamValue;
		if (_pParamManager->GetParameterValue(_c_strFrpIdentifier, &_FrpParamValue)
			&& _FrpParamValue.nType == ParameterValue::VT_INT)
		{
			_nFrp = _FrpParamValue.iValue;
			_UpdateFIndex(&_nIndex, _nFrp);
		}
	}

	// º򻬶
	ASSERT(m_pwndSliderSetF);
	int _nCurPos_SliderSetF = m_pwndSliderSetF->GetPos();
	int _nNewPos_SliderSetF = min(_nFrp, m_pwndSliderSetF->GetRangeMax());
	if (_nNewPos_SliderSetF != _nCurPos_SliderSetF)
	{
		m_pwndSliderSetF->SetPos(_nNewPos_SliderSetF);
		m_pwndSliderSetF->Invalidate();
	}

	// »ťʾ
	ASSERT(m_pwndSliderF);
	int _nCurPos_SliderF = m_pwndSliderF->GetPos();
	int _nNewPos_SliderF = _nIndex;
	if (m_bShowCurValue)
	{
		double _nSpeed = 0.0;
		if (const CSpeedometerTarget* _pST = GetSpeedometerTarget())
		{
			// ֱXYٶʾ ----  2015-11-25
			_nSpeed = _pST->GetRealSpeedXY() * 60;
		}

		CString _strValue;
		_strValue.Format("%d", (int)_nSpeed);
		CString _strOldInfo;
		m_pwndStcSpeed->GetWindowText(_strOldInfo);
		if (_strValue != _strOldInfo)
		{
			m_pwndSliderF->SetPos((_nSpeed / 10000) * 100);
			m_pwndSliderF->SetSelection(m_pwndSliderF->GetRangeMin(), (_nSpeed / 10000) * 100);
		}
	}
	else
	{
		if (_nNewPos_SliderF != _nCurPos_SliderF)
		{
			m_pwndSliderF->SetPos(_nNewPos_SliderF);
			m_pwndSliderF->SetSelection(m_pwndSliderF->GetRangeMin(), _nNewPos_SliderF);
		}
	}
}

void CMachineControlDlg_Bottom::UpdateP()
{
	CParamManager* _pParamManager = mach::GetParamManager();
	if (!_pParamManager)
	{
		return;
	}
	Parameter _DutyCycle;
	if (!_pParamManager->GetParameter("PWM_DutyCycle", &_DutyCycle))
	{
		return;
	}
	ASSERT(_DutyCycle.Value.nType == ParameterValue::VT_INT);

	// ƹܣ˿ڴʱʾֵΪ0
	bool _bPEnableWhenLightOn = NceGetPrivateProfileString(_T("ControlTarget"), _T("PEnableWhenLightOn")) == _T("1");
	if (_bPEnableWhenLightOn)
	{
		mach::CPortsManager* _pPortsManager = mach::GetPortsManager();
		mach::BitPort _BitPort;
		_pPortsManager->GetBitPort("10018", &_BitPort);
		if (!_BitPort.bValue)
		{
			_DutyCycle.Value.iValue = 0;
		}
	}

	Parameter _RatedPower;
	if (!_pParamManager->GetParameter("GP_LaserRatedPower", &_RatedPower))
	{
		return;
	}
	ASSERT(_RatedPower.Value.nType == ParameterValue::VT_INT);

	CString _strOldInfo;
	m_pwndStcPower->GetWindowText(_strOldInfo);

	CString _strValue;
	_strValue.Format("%d", _DutyCycle.Value.iValue * _RatedPower.Value.iValue / 100);
	if (_strValue != _strOldInfo)
	{
		m_pwndStcPower->SetWindowText(_strValue);
	}

	// º򻬶
	ASSERT(m_pwndSliderSetP);
	int _nCurPos_SliderSetP = m_pwndSliderSetP->GetPos();
	int _nNewPos_SliderSetP = _DutyCycle.Value.iValue;
	if (_nNewPos_SliderSetP != _nCurPos_SliderSetP)
	{
		m_pwndSliderSetP->SetPos(_nNewPos_SliderSetP);
		m_pwndSliderSetP->Invalidate();
	}

	// »ťʾ
	ASSERT(m_pwndSliderP);
	int _nCurPos_SliderP = m_pwndSliderP->GetPos();
	int _nNewPos_SliderP = _DutyCycle.Value.iValue;
	if (_nNewPos_SliderP != _nCurPos_SliderP)
	{
		m_pwndSliderP->SetPos(_nNewPos_SliderP);
		m_pwndSliderP->SetSelection(m_pwndSliderF->GetRangeMin(), _nNewPos_SliderP);
	}
}

void CMachineControlDlg_Bottom::_BuildFHIVMap()
{
	for (int _i = 0; _i <= 10; _i++)
	{
		m_nFHValues[_i] = _i * 0.02;
	}

	for (int _i = 11; _i <= 20; _i++)
	{
		m_nFHValues[_i] = m_nFHValues[10] + (_i - 10) * 0.03;
	}

	for (int _i = 21; _i <= 30; _i++)
	{
		m_nFHValues[_i] = m_nFHValues[20] + (_i - 20) * 0.03;
	}

	for (int _i = 31; _i <= 40; _i++)
	{
		m_nFHValues[_i] = m_nFHValues[30] + (_i - 30) * 0.02;
	}

	for (int _i = 41; _i <= 50; _i++)
	{
		m_nFHValues[_i] = m_nFHValues[40] + (_i - 40) * 0.1;
	}

	for (int _i = 51; _i <= 60; _i++)
	{
		m_nFHValues[_i] = m_nFHValues[50] + (_i - 50) * 0.3;
	}

	for (int _i = 61; _i <= 70; _i++)
	{
		m_nFHValues[_i] = m_nFHValues[60] + (_i - 60) * 0.5;
	}

	for (int _i = 71; _i <= 80; _i++)
	{
		m_nFHValues[_i] = m_nFHValues[70] + (_i - 70) * 0.5;
	}
}

void CMachineControlDlg_Bottom::_UpdateFHValue(int nIndex_, double* pnVaue_)
{
	ASSERT(nIndex_ >= 0 && nIndex_ <= 80);
	*pnVaue_ = m_nFHValues[nIndex_];
	return;
}

void CMachineControlDlg_Bottom::_UpdateFHindex(int* pnIndex_, double nValue_)
{
	ASSERT(nValue_ >= 0);
	for (int i = 0; i < _countof(m_nFHValues); i++)
	{
		if (DOUBLE_EQU(nValue_, m_nFHValues[i]))
		{
			*pnIndex_ = i;
			return;
		}

		if (nValue_ < m_nFHValues[i])
		{
			ASSERT(i > 0);
			*pnIndex_ = i - 1;
			return;
		}
	}
}

void CMachineControlDlg_Bottom::UpdateFH()
{
	CParamManager* _pParamManager = mach::GetParamManager();
	if (!_pParamManager)
	{
		return;
	}
	Parameter _FollowHeight;
	if (!_pParamManager->GetParameter("GP_FollowHeight", &_FollowHeight))
	{
		return;
	}

	CString _strOldInfo;
	m_pwndStcFollowHeight->GetWindowText(_strOldInfo);

	CString _strValue;
	_strValue.Format("%.2f", _FollowHeight.Value.dValue);
	if (_strValue != _strOldInfo)
	{
		m_pwndStcFollowHeight->SetWindowText(_strValue);
	}

	double _nFollowHeigth = (min(_FollowHeight.Value.dValue, m_nArcSliderFHMax));

	int _nIndex;
	_UpdateFHindex(&_nIndex, _nFollowHeigth);

	// º򻬶
	ASSERT(m_pwndSliderSetFH);
	int _nCurPos_SliderSetFH = m_pwndSliderSetFH->GetPos();
	int _nNewPos_SliderSetFH = _nIndex;
	if (_nNewPos_SliderSetFH != _nCurPos_SliderSetFH)
	{
		m_pwndSliderSetFH->SetPos(_nNewPos_SliderSetFH);
		m_pwndSliderSetFH->Invalidate();
	}

	// »ťʾ
	ASSERT(m_pwndSliderFH);
	int _nCurPos_SliderFH = m_pwndSliderFH->GetPos();
	int _nNewPos_SliderFH = _nIndex;
	if (_nNewPos_SliderFH != _nCurPos_SliderFH)
	{
		m_pwndSliderFH->SetPos(_nNewPos_SliderFH);
		m_pwndSliderFH->SetSelection(m_pwndSliderF->GetRangeMin(), _nNewPos_SliderFH);
	}
}

void CMachineControlDlg_Bottom::UpdateManuCenter()
{
	ASSERT(m_pwndBtnCenter);

	// ǰʾĴ ----  2012-02-21
	CString _strOldText;
	m_pwndBtnCenter->GetWindowText(_strOldText);

	// ҪʾĴ ----  2012-02-21
	CString _strNewText;
	CManualTarget* _pManualTarget = GetManualTarget();
	ASSERT(_pManualTarget);
	if (_pManualTarget->IsJogMode() && _pManualTarget->GetJogState())
	{
		_strNewText = _GETCS(s_csRapidJog);
	}
	else if (_pManualTarget->IsJogMode() && !_pManualTarget->GetJogState())
	{
		_strNewText = _GETCS(s_csSlowJog);
	}
	else
	{
		double _nIncDistance = _pManualTarget->GetIncDistance();
		
		if (_nIncDistance >= 1000)
		{
			_strNewText.Format(_T("%.2f"), _nIncDistance);
		}
		else if (_nIncDistance >= 100)
		{
			_strNewText.Format(_T("%.3f"), _nIncDistance);
		}
		else if (_nIncDistance >= 10)
		{
			_strNewText.Format(_T("%.4f"), _nIncDistance);
		}
		else if (_nIncDistance >= 0)
		{
			_strNewText.Format(_T("%.5f"), _nIncDistance);
		}
		_strNewText.TrimRight(_T('0'));
		_strNewText.TrimRight(_T('.'));
		_strNewText += "\nmm";
	}

	//  ----  2012-02-21
	if (_strNewText != _strOldText)
	{
		m_pwndBtnCenter->SetWindowText(_strNewText);
	}
}

void CMachineControlDlg_Bottom::UpdateGFOBInfo()
{
	// 㶯ʱʾ㶯ʾָľ ----  2012-03-10
	CControlTarget* _pControlTarget = GetControlTarget();
	ASSERT(_pControlTarget);
	CString _strGFOBDistance;
	if (_pControlTarget->GetGFOBMode() == 0x01)
	{
		double _nGFOBDistance = _pControlTarget->GetGFOBDistance();
		ASSERT(_nGFOBDistance >= 0);
		_strGFOBDistance.Format(_T("%f"), _nGFOBDistance);
		_strGFOBDistance.TrimRight(_T('0'));
		_strGFOBDistance.TrimRight(_T('.'));
		_strGFOBDistance.AppendFormat("mm");
	}
	else
	{
		ASSERT(_pControlTarget->GetGFOBMode() == 0x00);
		_strGFOBDistance.Format("%s", _GETCS(s_csJOG));
	}

	// Ը ----  2012-03-10
	CString _strOldInfo;
	m_pwndStcGoDistance->GetWindowText(_strOldInfo);
	if (_strGFOBDistance != _strOldInfo)
	{
		m_pwndStcGoDistance->SetWindowText(_strGFOBDistance);
	}
}

void CMachineControlDlg_Bottom::UpdateSpeed()
{
	double _nSpeed = 0.0;
	if (const CSpeedometerTarget* _pST = GetSpeedometerTarget())
	{
		// ֱXYٶʾ ----  2015-11-25
		_nSpeed = _pST->GetRealSpeedXY() * 60;
	}

	CString _strValue;
	_strValue.Format("%d", (int)_nSpeed);
	CString _strOldInfo;
	m_pwndStcSpeed->GetWindowText(_strOldInfo);
	if (_strValue != _strOldInfo)
	{
		m_pwndStcSpeed->SetWindowText(_strValue);
	}
}

void CMachineControlDlg_Bottom::UpdateEnableJogLaser()
{
	CButton* _pwndCheckJogLaser = (CButton*)GetDlgItem(CTRLID_BTN_JOGLASER);
	if (!_pwndCheckJogLaser)
	{
		return;
	}

	bool _bEnable = false;
	CParamManager* _pParamManager = GetParamManager();
	ASSERT(_pParamManager);
	ParameterValue _ParamValue;
	memset(&_ParamValue, 0, sizeof(ParameterValue));
	if(_pParamManager->GetParameterValue("EnableJogLaser", &_ParamValue)
		&& _ParamValue.nType == mach::ParameterValue::VT_BOOL)
	{
		_bEnable = _ParamValue.bValue;
	}
	else
	{
		return;
	}

	bool _bBtnChecked = _pwndCheckJogLaser->GetCheck() == BST_CHECKED ? true : false;
	if (_bEnable != _bBtnChecked)
	{
		_pwndCheckJogLaser->SetCheck(_bEnable ? BST_CHECKED : BST_UNCHECKED);
	}
}
	
void CMachineControlDlg_Bottom::UpdateEnableBoardSupport()
{
	// 嶥
	bool _bBoardSupport = NceGetPrivateProfileString(_T("ControlTarget"), _T("BoardSupport")) == _T("1");
	if (_bBoardSupport)
	{
		CStateManager* _pStateManager = GetStateManager();
		ASSERT(_pStateManager);
		CStateManager::State _nState = CStateManager::Idle;
		BOOL _bEnable = _pStateManager->GetState(&_nState) && _nState == CStateManager::Idle;
		if (m_pwndPortButtons[8]->GetCheck() && _nState == CStateManager::Lock)
		{
			return;
		}
		else
		{
			m_pwndPortButtons[8]->EnableWindow(_bEnable);
		}
	}
}

// Ϊ120ӳ䵽0-ʣ100ΪֱӶӦ100¿Է
//   [0,100] => [0,100]
//   [100,120] => [100,MaxFrp]
//  MaxFrp >= 100
// 100µĲûʲô˵ģ˴Ҫ˵100ϵĲӳ䣺
//   1) MaxFrp=120ⲿָ100һҲ
//      Value = Index
//   2) MaxFrp<120ⲿԷʽֵMaxFrpֵ
//      Value = Index  (when Index <= MaxFrp)
//            = MaxFrp (when Index >= MaxFrp)
//   3) MaxFrp>120ⲿԵָӳ
//      Value = Index * a^(Index - 100)
//       aMaxFrp
//      MaxFrp = 150   =>   150 = 120 * a^(120-100)   =>   a = (1.25)^(0.05)
//                                                        ----  2013-03-26
void CMachineControlDlg_Bottom::_BuildFIVMap()
{
	int _nMaxFrp = m_nFValues[120];
	if (CParamManager* _pParamManager = GetParamManager())
	{
		const CStringA _c_strMaxFrpIdentifier = "MaxFrp";
		ParameterValue _MaxFrpParamValue;
		if (!_pParamManager->GetParameterValue(_c_strMaxFrpIdentifier, &_MaxFrpParamValue)
			|| _MaxFrpParamValue.nType != ParameterValue::VT_INT
			|| _MaxFrpParamValue.iValue == _nMaxFrp)
		{
			// 仯Ÿ
			return;
		}
		_nMaxFrp = _MaxFrpParamValue.iValue;
	}

	C_ASSERT(_countof(m_nFValues) == 121);
	if (_nMaxFrp <= 120)
	{
		for (int _i = 0; _i < _countof(m_nFValues); _i++)
		{
			m_nFValues[_i] = min(_i, _nMaxFrp);
		}
		return;
	}

	C_ASSERT(_countof(m_nFValues) == 121);
	for (int _i = 0; _i <= 100; _i++)
	{
		m_nFValues[_i] = _i;
	}
	double _nA = pow(_nMaxFrp / 120.0, 0.05);
	for (int _i = 101; _i < _countof(m_nFValues); _i++)
	{
		int _nV = (int)(_i * pow(_nA, _i - 100.0) + 0.5);
		m_nFValues[_i] = min(_nV, _nMaxFrp);
	}
}

void CMachineControlDlg_Bottom::_UpdateFValue(int nIndex_, int* pnValue_)
{
	ASSERT(nIndex_ >= 0 && nIndex_ < _countof(m_nFValues) && pnValue_);
	*pnValue_ = m_nFValues[nIndex_];
}

void CMachineControlDlg_Bottom::_UpdateFIndex(int* pnIndex_, int nValue_)
{
	ASSERT(pnIndex_ && *pnIndex_ >= 0 && *pnIndex_ < _countof(m_nFValues));
	if (nValue_ == m_nFValues[*pnIndex_])
	{
		return;
	}

	int _i = 0;
	while (_i < _countof(m_nFValues) && m_nFValues[_i] < nValue_)
	{
		_i++;
	}
	*pnIndex_ = _i;
}

LRESULT CMachineControlDlg_Bottom::OnEndSpeedDlg(WPARAM wParam_, LPARAM lParam_)
{
	m_pSetSpeedDlg->ShowWindow(SW_HIDE);
	DWORD _nManuMode = (DWORD)wParam_;
	union
	{
		LPARAM lValue;
		float fValue;
	} Value;
	Value.lValue = lParam_;
	double _nValue = (float)Value.fValue;

	CManualTarget* _pManualTarget = GetManualTarget();
	ASSERT(_pManualTarget);

	// ֶ ---- С 2013-11-07
	if (_nManuMode == 0)
	{
		_pManualTarget->SetManuMode(0);
		_pManualTarget->SetJogState(false);

		CParamManager* _pParamManager = GetParamManager();
		if (_pParamManager)
		{
			ParameterValue _ParamValue;
			_pParamManager->GetParameterValue("1_0_JVelocityQuick", &_ParamValue);
			if (_nValue > _ParamValue.dValue)
			{
				_ParamValue.dValue = _nValue;
				_pParamManager->SetParameterValue("1_0_JVelocityQuick", &_ParamValue);
				_pParamManager->SetParameterValue("1_0_JVelocity", &_ParamValue);
			}
			else
			{
				_ParamValue.dValue = _nValue;
				_pParamManager->SetParameterValue("1_0_JVelocity", &_ParamValue);
			}
		}
	}
	// ֶ ---- С 2013-11-07
	else if (_nManuMode == 1)
	{
		_pManualTarget->SetManuMode(0);
		_pManualTarget->SetJogState(true);

		CParamManager* _pParamManager = GetParamManager();
		if (_pParamManager)
		{
			ParameterValue _ParamValue;
			_pParamManager->GetParameterValue("1_0_JVelocity", &_ParamValue);
			if (_nValue < _ParamValue.dValue)
			{
				_ParamValue.dValue = _nValue;
				_pParamManager->SetParameterValue("1_0_JVelocity", &_ParamValue);
				_pParamManager->SetParameterValue("1_0_JVelocityQuick", &_ParamValue);
			}
			else
			{
				_ParamValue.dValue = _nValue;
				_pParamManager->SetParameterValue("1_0_JVelocityQuick", &_ParamValue);
			}
		}
	}
	// ò ---- С 2013-11-07
	else if (_nManuMode == 2)
	{
		_pManualTarget->SetManuMode(1);
		_pManualTarget->SetIncDistance(_nValue);
	}

	return TRUE;
}

LRESULT CMachineControlDlg_Bottom::OnEndEditDistance(WPARAM wParam_, LPARAM lParam_)
{
	ASSERT(lParam_);
	CString* _strText = reinterpret_cast<CString*>(lParam_);
	CString _strGetValue = *_strText;
	m_pwndStcGoDistance->ShowWindow(SW_SHOW);
	if (IsValidDate(_strGetValue, "double", 100000, 0., "mm"))
	{
		double _nGetValue = _tstof(_strGetValue);
		_nGetValue = _FormatInputData(_nGetValue);
		CControlTarget* _pControlTarget = GetControlTarget();
		ASSERT(_pControlTarget);
		_pControlTarget->SetGFOBDistance(_nGetValue);
	}

	return TRUE;
}

void CMachineControlDlg_Bottom::OnLButtonDown(UINT nFlags_, CPoint point_)
{
	if (::IsWindow(m_pDistanceEdit->GetSafeHwnd()))
	{
		delete m_pDistanceEdit;
		m_pDistanceEdit = NULL;
	}
	else
		m_pDistanceEdit = NULL;
}

// Ӧ굥ǰʾťϢ100/1200Ϊ磬ǰݣǲģ
// ʽ򵯳༭ɱ༭ǰ˾룬ǵ㶯ģʽӦ󲿷ݣлǰ
// ģʽTrueʾٽϢѭ         ---- DingQiang 2012-07-19
BOOL CMachineControlDlg_Bottom::OnDistanceLButtonDown(CPoint point_)
{
	CControlTarget* _pControlTarget = GetControlTarget();
	if (!_pControlTarget)
	{
		return FALSE;
	}

	CRect _rcGoDistance;
	m_pwndStcGoDistance->GetWindowRect(_rcGoDistance);
	double _nWide = _rcGoDistance.Width() * 0.83;
	double _nDivide = _rcGoDistance.left + _nWide;

	if (point_.x < _nDivide)
	{
		if (_pControlTarget->GetGFOBMode() == 0x00)
		{
			return TRUE;
		}

		if (::IsWindow(m_pDistanceEdit->GetSafeHwnd()))
		{
			// ĿǷֹ༭ѾCreateʱֵťCreateһ ---- DingQiang 2012-07-20
			return FALSE;
		}

		CString _strItemText;
		m_pwndStcGoDistance->GetWindowText(_strItemText);
		CRect _rect(0, 0, 0, 0);
		m_pwndStcGoDistance->GetWindowRect(_rect);

		// newһ༭丸Ϊǰ˾ʾ ---- DingQiang 2012-07-19
		m_pwndStcGoDistance->ScreenToClient(&_rect);
		_rect.top += 7;
		_rect.bottom -= 6;
		_rect.left += 20;
		_rect.right -= 20;
		DWORD _dwStyle;
		_dwStyle = WS_CHILDWINDOW | WS_VISIBLE | WS_BORDER | ES_CENTER | ES_AUTOVSCROLL | ES_NOHIDESEL;
		m_pDistanceEdit = new CEditItem(this, _strItemText);
		m_pDistanceEdit->Create(_dwStyle, _rect, m_pwndStcGoDistance, CTRLID_EDIT_GODISTANCE);
		return TRUE;
	}
	else
	{
		DWORD _nSetMode;
		if (_pControlTarget->GetGFOBMode() == 0x00)
		{
			_nSetMode = 0x01;
		}
		else
			_nSetMode = 0x00;

		_pControlTarget->SetGFOBMode(_nSetMode);
		return FALSE;
	}

	return FALSE;
}

// ǷǺϷ,Сλĸ---- DingQiang 2012-03-07
bool CMachineControlDlg_Bottom::IsValidDate(LPCSTR szInPut_,	// ַ
									 LPCSTR szType_,	// 
									 double nMax_,		// ֵ
									 double nMin_,		// Сֵ
									 LPCSTR szUnit_)	// 뵥λ
{
	int _nNumDots = 0;							// С,ֻһ
	CString _strInPut = szInPut_;
	CString _strUint = szUnit_;
	int _nLength = (int)strlen(_strInPut);		// ַ
	int _nUnitLength = (int)strlen(_strUint);	// ʹõĵλַ
	bool b_ContainUnit = false;					// Ƿλ

	if (0 == _nLength)
	{
		return false;
	}

	// С򷵻false---- DingQiang 2012-03-07
	int _nDotCount = 0;
	for (int _i = 0; _i < _nLength; _i++)
	{
		char _szDot = _strInPut[_i];
		if (_szDot == '.')
		{
			_nDotCount++;
		}
	}

	if (_nDotCount > 1)
	{
		AfxMessageBox(_GETCS(s_csFloatDataError));
		return false;
	}

	// ȼַ_nUnitLengthǷ֣һ
	// Ϻ_nUnitLengthַǷǵλַҲǵλֱַ
	// ӷشϢ顣               ---- DingQiang 2012-03-07
	int _nCheckUint = (_nLength - _nUnitLength) > 0 ? _nLength - _nUnitLength : _nLength;
	for (int _j = _nCheckUint; _j < _nLength; _j++)
	{
		char _szChar = _strInPut[_j];
		if(_szChar < 0 || _szChar > 255)
		{
			AfxMessageBox(_GETCS(s_csFloatDataError));
			return false;
		}
		if (!isdigit(_szChar))
		{
			if (_szChar != '.')
			{
				if (_strUint.Compare(_strInPut.Right(_nUnitLength)) != 0)
				{
					AfxMessageBox(_GETCS(s_csFloatDataError));
					return false;
				}
				else
				{
					b_ContainUnit = true;
				}
			}
		}
	}

	// зַûзȫ---- DingQiang 2012-03-08
	int _nCheckNum = b_ContainUnit ? _nCheckUint : _nLength;
	int _i = 0;
	for (; _i < _nCheckNum; _i++)
	{
		char _c = _strInPut[_i];
		if (!isdigit(_c))
		{
			if (0 == strcmp(szType_, "int"))
			{
				break;
			}
			else if (0 == strcmp(szType_, "double") || 0 == strcmp(szType_, "float"))
			{
				if (_c == '.' && _nNumDots == 0)
				{
					_nNumDots++;
				}
				else
				{
					break;
				}
			}
			else
				ASSERT(false);
		}
	}

	if (_i != _nCheckNum && (strcmp(szType_, "int") == 0))
	{
		AfxMessageBox(_GETCS(s_csIntDataError));
		return false;
	}

	if (_i != _nCheckNum && (strcmp(szType_, "float") == 0 || strcmp(szType_, "double") == 0))
	{
		AfxMessageBox(_GETCS(s_csFloatDataError));
		return false;
	}

	double _nInPut = (double)_tstof(szInPut_);
	if ( _nInPut > nMin_ && _nInPut < nMax_)
	{
		return true;
	}
	else
	{
		CString _strErrorShow;
		_strErrorShow.Format(_GETCS(s_csFloatDataBoundError), nMin_, nMax_);
		AfxMessageBox(_strErrorShow);
		return false;
	}
}

void CMachineControlDlg_Bottom::OnChangeCoorMode()
{
	m_nCoorMode = (m_nCoorMode == 0x00) ? 0x01 : 0x00;
	UpdateMachCoor();
}

// ʽ ---- DingQiang 2012-06-25
static double _FormatInputData(double nInputData_)
{
	ASSERT(nInputData_ >= 0);
	CString _strTemp;
	_strTemp.Format(_T("%f"), nInputData_);

	CString _strOut = _strTemp.Left(6);

	return _tstof(_strOut);
}

// ֶٶ ---- С 2013-11-07
void CMachineControlDlg_Bottom::OnDblClickCenter()
{
	CStateManager* _pStateManager = GetStateManager();
	if (!_pStateManager)
		return;

	CStateManager::State _State = mach::CStateManager::Invalid;
	if (!_pStateManager->GetState(&_State))
	{
		return;
	}

	if (_State != mach::CStateManager::Invalid
		&& _State != mach::CStateManager::Idle
		//&& _State != mach::CStateManager::Lock			// ʱҲ޸ٶȡ
		&& _State != mach::CStateManager::Estop)
	{
		AfxMessageBox(_GETCS(s_csNotInputPrompt));
		return;
	}

	ASSERT(m_pwndBtnCenter && ::IsWindow(m_pwndBtnCenter->m_hWnd));
	CRect _rcBtnCenter;
	m_pwndBtnCenter->GetWindowRect(&_rcBtnCenter);
	((CSetSpeedDlg*)m_pSetSpeedDlg)->SetBasePosition(_rcBtnCenter.TopLeft());
	m_pSetSpeedDlg->ShowWindow(SW_SHOW);
}

LRESULT CMachineControlDlg_Bottom::OnSliderMoving(WPARAM wParam_, LPARAM lParam_)
{
	CParamManager* _pParamManager = mach::GetParamManager();
	if (!_pParamManager)
	{
		ASSERT(FALSE);
		return 0;
	}

	UINT _nCtrlID = (UINT)wParam_;
	int _nIndex = (int)lParam_;
	if (wParam_ == CTRLID_SLD_SETF)
	{
		int _nFrp = 100;
		_UpdateFValue(_nIndex, &_nFrp);

		// ΪȫƣͨCParamManager޸Ĳȫвڴ˴ܲ
		// ǱģȫýԵÿβ ˣ˴
		// ͨһCommandƹȫ顣              ----  2012-08-17
		if (CCommandManager* _pCommandManager = GetCommandManager())
		{
			const CStringA _c_strSetFrpCommand = "SetFrp";
			CStringA _strFrp;
			_strFrp.Format("%d", _nFrp);
			_pCommandManager->Execute(_c_strSetFrpCommand, _strFrp, "LPCSTR");
		}
		if (m_bSliderCtrlG00)
		{
			if (CCommandManager* _pCommandManager = GetCommandManager())
			{
				const CStringA _c_strSetG00FrpCommand = "SetG00Frp";
				CStringA _strFrp;
				_strFrp.Format("%d", _nFrp);
				_pCommandManager->Execute(_c_strSetG00FrpCommand, _strFrp, "LPCSTR");
			}
		}

		UpdateF();
	}

	if (wParam_ == CTRLID_SLD_SETFH)
	{
		double _nValue;
		_UpdateFHValue(_nIndex, &_nValue);
		ParameterValue _Value;
		memset(&_Value, 0, sizeof(ParameterValue));
		_pParamManager->GetParameterValue("ActualSampleLength", &_Value);
		if (_Value.nType != ParameterValue::VT_DOUBLE)
		{
			return 0;
		}
		_nValue = min(_nValue, _Value.dValue);

		if (CCommandManager* _pCommandManager = GetCommandManager())
		{
			const CStringA _c_strSetFHCommand = "SetFollowHeight";
			CStringA _strFH;
			_strFH.Format("%.3f", _nValue);
			_pCommandManager->Execute(_c_strSetFHCommand, _strFH, "LPCSTR");
		}
		UpdateFH();
	}

	if (wParam_ == CTRLID_SLD_SETP)
	{
		if (CCommandManager* _pCommandManager = GetCommandManager())
		{
			const CStringA _c_strSetPowerCommand = "SetDutyCycles";
			CStringA _strPower;
			_strPower.Format("%d", _nIndex);
			_pCommandManager->Execute(_c_strSetPowerCommand, _strPower, "LPCSTR");
		}
		UpdateP();
	}
	return 1;
}

void CMachineControlDlg_Bottom::OnClickMachSelected()
{
	CStateManager* _pStateManager = GetStateManager();
	ASSERT(_pStateManager);
	CStateManager::State _nState = CStateManager::Idle;
	BOOL _bEnable = _pStateManager->GetState(&_nState) && _nState == CStateManager::Idle;
	if (!_bEnable)
		return;

	CButton* _pBtn = (CButton*)GetDlgItem(CTRLID_BTN_MACHSELECTED);
	BOOL _bMachSelected = _pBtn->GetCheck() == BST_CHECKED;
	_bMachSelected = !_bMachSelected;
	m_bSelectMach = _bMachSelected;
	_pStateManager->SetSelectedMach(m_bSelectMach);
	_pBtn->SetCheck(_bMachSelected ? BST_CHECKED : BST_UNCHECKED);
}

void CMachineControlDlg_Bottom::OnClickJogLaser()
{
	bool _bValue = false;
	CParamManager* _pParamManager = GetParamManager();
	ASSERT(_pParamManager);
	ParameterValue _ParamValue;
	memset(&_ParamValue, 0, sizeof(ParameterValue));
	if(_pParamManager->GetParameterValue("EnableJogLaser", &_ParamValue)
		&& _ParamValue.nType == mach::ParameterValue::VT_BOOL)
	{
		_bValue = _ParamValue.bValue;
	}
	else
	{
		ASSERT(FALSE);
		return;
	}

	_ParamValue.bValue = !_bValue;
	_pParamManager->SetParameterValue("EnableJogLaser", &_ParamValue);
	UpdateEnableJogLaser();
}

void CMachineControlDlg_Bottom::OnSelMarkPoint()
{
	// رǵѡ˵ ---- ߿ϼ 2017-05-11
	CRect _rcRect;
	GetDlgItem(CTRLID_BTN_SELMARKPOINT)->GetWindowRect(&_rcRect);
	m_pMenu->TrackPopupMenu(TPM_LEFTBUTTON, _rcRect.right, _rcRect.bottom, this);
}

void CMachineControlDlg_Bottom::OnMarkPointChange(UINT ID_)
{
	// ڱǵ㰴ťʾǰѡıǵindex ---- ߿ϼ 2017-03-14
	UINT _nCurIndex = ID_ - CTRLID_BTN_MARKPOINT1 + 1;
	m_nCurIndex = _nCurIndex;
	CString _strCurIndex;
	_strCurIndex.Format("%u", _nCurIndex);

	// ʹbuttonϲʾ ---- ߿ϼ 2017-03-15
	CString _strShowIndex = _strCurIndex + '\n';
	SetDlgItemText(CTRLID_BTN_SELMARKPOINT, _strShowIndex);

	// ǰѡıǵindexMarkPointTarget ---- ߿ϼ 2017-03-14
	CMarkPointTarget* _pMarkPointTarget = GetMarkPointTarget();
	ASSERT(_pMarkPointTarget);
	_pMarkPointTarget->SetCurMarkIndex(_nCurIndex - 1);
}

void CMachineControlDlg_Bottom::OnClickAutoCyc()
{
	bool _bEnableCyc = false;

	CCycMachiningTarget* _pCycMachingTarget = GetCycMachiningTarget();
	BOOL _bCycEnable= _pCycMachingTarget->GetEnable();
	if(_bCycEnable == TRUE)
	{
		_bEnableCyc = true;
		_pCycMachingTarget->SetEnable(FALSE);
	}
	else
	{
		_bEnableCyc = false;
		_pCycMachingTarget->SetEnable(TRUE);
	}
	UpdateEnableAutoCyc();
}

void CMachineControlDlg_Bottom::UpdateEnableAutoCyc()
{
	CButton* _pwndCheckAutoCyc = (CButton*)GetDlgItem(CTRLID_BTN_AUTOCYC);
	if (!_pwndCheckAutoCyc)
	{
		return;
	}

	bool _bEnableAutoCyc = false;
	CCycMachiningTarget* _pCycMachingTarget = GetCycMachiningTarget();
	BOOL _bCycEnable= _pCycMachingTarget->GetEnable();
	if(_bCycEnable == TRUE)
	{
		_bEnableAutoCyc = true;
	}
	else
	{
		_bEnableAutoCyc = false;
	}

	bool _bBtnChecked = _pwndCheckAutoCyc->GetCheck() == BST_CHECKED ? true : false;
	if (_bEnableAutoCyc != _bBtnChecked)
	{
		_pwndCheckAutoCyc->SetCheck(_bEnableAutoCyc ? BST_CHECKED : BST_UNCHECKED);
	}
}

//ѭӹ  2017-06-22
void CMachineControlDlg_Bottom::OnClickCyc()
{
	bool _bEnableCyc = false;

	CCycMachiningTarget* _pCycMachingTarget = GetCycMachiningTarget();
	BOOL _bCycEnable= _pCycMachingTarget->GetEnable();
	if(_bCycEnable == TRUE)
	{
		_bEnableCyc = true;
		_pCycMachingTarget->SetEnable(FALSE);
	}
	else
	{
		_bEnableCyc = false;
		_pCycMachingTarget->SetEnable(TRUE);
	}

	UpdateEnableCyc();
}

void CMachineControlDlg_Bottom::UpdateEnableCyc()
{
	CButton* _pwndCheckAutoCyc = (CButton*)GetDlgItem(CTRLID_BTN_CYC);
	if (!_pwndCheckAutoCyc)
	{
		return;
	}
	bool _bEnableAutoCyc = false;

	CCycMachiningTarget* _pCycMachingTarget = GetCycMachiningTarget();
	BOOL _bCycEnable= _pCycMachingTarget->GetEnable();
	if(_bCycEnable == TRUE)
	{
		_bEnableAutoCyc = true;
	}
	else
	{
		_bEnableAutoCyc = false;
	}

	bool _bBtnChecked = _pwndCheckAutoCyc->GetCheck() == BST_CHECKED ? true : false;
	if (_bEnableAutoCyc != _bBtnChecked)
	{
		_pwndCheckAutoCyc->SetCheck(_bEnableAutoCyc ? BST_CHECKED : BST_UNCHECKED);
	}
}

//Զ   2017-06-22
void CMachineControlDlg_Bottom::OnClickAutoExchange()
{
	bool _bEnableExchange = false;

	CParamManager* _pParamManager = GetParamManager();
	ASSERT(_pParamManager);
	ParameterValue _ParamValue;
	memset(&_ParamValue, 0, sizeof(ParameterValue));
	if(_pParamManager->GetParameterValue("AutoExchangeTaskEnd", &_ParamValue)
		&& _ParamValue.nType == mach::ParameterValue::VT_INT)
	{
		if(_ParamValue.iValue == 1)
		{
			_bEnableExchange = true;
		}
		else
		{
			ASSERT(_ParamValue.iValue == 0);
			_bEnableExchange = false;
		}
	}
	else
	{
		return;
	}

	// ֱӶϵͳȡ
	if(_bEnableExchange)
	{
		memset(&_ParamValue, 0, sizeof(ParameterValue));
		_ParamValue.nType = ParameterValue::VT_INT;
		_ParamValue.iValue = 0;
		_pParamManager->SetParameterValue("AutoExchangeTaskEnd", &_ParamValue);
	}
	else
	{
		memset(&_ParamValue, 0, sizeof(ParameterValue));
		_ParamValue.nType = ParameterValue::VT_INT;
		_ParamValue.iValue = 1;
		_pParamManager->SetParameterValue("AutoExchangeTaskEnd", &_ParamValue);
	}

	UpdateEnableAutoExchange();
	SendTargetMessage(ID_TARGET_EXCHANGEWORKBENCH, TM_AUTOCYC_CHECK, 0, 0);
}

void CMachineControlDlg_Bottom::UpdateEnableAutoExchange()
{
	CButton* _pwndCheckAutoExchange = (CButton*)GetDlgItem(CTRLID_BTN_AUTOEXCHANGE);
	if (!_pwndCheckAutoExchange)
	{
		return;
	}
	bool _bEnableAutoExchange = false;

	CParamManager* _pParamManager = GetParamManager();
	ASSERT(_pParamManager);
	ParameterValue _ParamValue;
	memset(&_ParamValue, 0, sizeof(ParameterValue));
	if(_pParamManager->GetParameterValue("AutoExchangeTaskEnd", &_ParamValue)
		&& _ParamValue.nType == mach::ParameterValue::VT_INT)
	{
		if(_ParamValue.iValue == 1)
		{
			_bEnableAutoExchange = true;
		}
		else
		{
			ASSERT(_ParamValue.iValue == 0);
			_bEnableAutoExchange = false;
		}
	}
	else
	{
		return;
	}

	bool _bBtnChecked = _pwndCheckAutoExchange->GetCheck() == BST_CHECKED ? true : false;
	if (_bEnableAutoExchange != _bBtnChecked)
	{
		_pwndCheckAutoExchange->SetCheck(_bEnableAutoExchange ? BST_CHECKED : BST_UNCHECKED);
	}
}
