// ************************************************************************** //
// MachineControlDlg.cpp : implementation of the CMachineControlDlg class
// Copyright(c)2011 Naiky Company. All rights reserved.
//
// Abstract:
//   ļʵCMachineControlDlgࡣ
// ********************************************* ----  2011-10-31 ***** //
#include "stdafx.h"
#include "MachineControlDlg.h"
#include "EditItem.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

CS_T s_csRapidJog = _DEFCS(_CSV(18044),
	_CHINESE("")
	_ENGLISH("Rapid\nJog"));
CS_T s_csSlowJog = _DEFCS(_CSV(18045),
	_CHINESE("")
	_ENGLISH("Jog"));
CS_T s_csJOG = _DEFCS(_CSV(18046),
	_CHINESE("㶯")
	_ENGLISH("Jog"));
CS_T s_csLANGUAGE = _DEFCS(_CSV(18047),
	_CHINESE("CHN")
	_ENGLISH("ENG"));
CS_T s_csNotInputPrompt = _DEFCS(_CSV(18048),
	_CHINESE("ϵͳæǰӹ״̬޷޸ĸò")
	_ENGLISH("System is busy, can not change the parameters!"));
CS_T s_csIntDataError = _DEFCS(_CSV(18049),
	_CHINESE("ĲЧֻ룡")
	_ENGLISH("Data error, it should be a positive integer, Please enter again!"));
CS_T s_csFloatDataError = _DEFCS(_CSV(18050),
	_CHINESE("ĲЧ룡")
	_ENGLISH("Data error, it should be a number, Please enter again!"));
CS_T s_csFloatDataBoundError = _DEFCS(_CSV(18051),
	_CHINESE("Χһ%.1f~%.1f֮")
	_ENGLISH("Please enter a number between %f~%f"));

CS_T s_csAXES = _DEFCS(_CSV(18052),
	_CHINESE("")
	_ENGLISH("Axes"));
CS_T s_csMACHINECOORDINATE = _DEFCS(_CSV(18053),
	_CHINESE("е")
	_ENGLISH("MachCoor"));
CS_T s_csWORKPIECECOORDINATE = _DEFCS(_CSV(18054),
	_CHINESE("")
	_ENGLISH("WorkCoor"));

CS_T s_csRESUME = _DEFCS(_CSV(18055),
	_CHINESE("ϵ\n")
	_ENGLISH("Resume"));
CS_T s_csSIMU = _DEFCS(_CSV(18056),
	_CHINESE("")
	_ENGLISH("Simu"));
CS_T s_csDIRRUN = _DEFCS(_CSV(18057),
	_CHINESE("")
	_ENGLISH("DryRun"));
CS_T s_csDIRRUNTEXT = _DEFCS(_CSV(18057),
	_CHINESE("")
	_ENGLISH("Dry Run"));
CS_T s_csSIMUCUTBOUNDRECT = _DEFCS(_CSV(18523),
	_CHINESE("߱߿")
	_ENGLISH("Frame"));
CS_T s_csTipSETWORKORG = _DEFCS(_CSV(18058),
	_CHINESE("ùԭ")
	_ENGLISH("Set Work Zero"));
CS_T s_csTipMOVETOWORKORIGIN = _DEFCS(_CSV(18059),
	_CHINESE("عԭ")
	_ENGLISH("To Work Zero"));
CS_T s_csTipSIMUCUTBOUNDRECT = _DEFCS(_CSV(18060),
	_CHINESE("߱߿")
	_ENGLISH("Frame"));
CS_T s_csTipSTART = _DEFCS(_CSV(18061),
	_CHINESE("ʼ")
	_ENGLISH("Start"));
CS_T s_csTipPAUSE = _DEFCS(_CSV(18062),
	_CHINESE("ͣ")
	_ENGLISH("Pause"));
CS_T s_csTipSTOP = _DEFCS(_CSV(18063),
	_CHINESE("ֹͣ")
	_ENGLISH("Stop"));
CS_T s_csTipRESUME = _DEFCS(_CSV(18063),
	_CHINESE("ϵ")
	_ENGLISH("Resume"));
CS_T s_csTipGoBackward = _DEFCS(_CSV(18064),
	_CHINESE("")
	_ENGLISH("GoBackward"));
CS_T s_csTipGoForward = _DEFCS(_CSV(18065),
	_CHINESE("ǰ")
	_ENGLISH("GoForward"));
CS_T s_csTipFollowSample = _DEFCS(_CSV(18524),
	_CHINESE("Z궨")
	_ENGLISH("Calibrate Z"));
CS_T s_csTipBackAll = _DEFCS(_CSV(18525),
	_CHINESE("ȫػеԭ")
	_ENGLISH("All To Origin"));
CS_T s_csSELECTMACH = _DEFCS(_CSV(18620),
	_CHINESE("ӹѡͼ")
	_ENGLISH("Machine Selected"));
CS_T s_csDistanceSet = _DEFCS(_CSV(18066),
	_CHINESE("ǰ˾趨")
	_ENGLISH("Distance Set"));
CS_T s_szPortNameKey = _DEFCS(_CSV(18067),
	_CHINESE("Port%d_ChnName")
	_ENGLISH("Port%d_EngName"));
CS_T s_szLaserOnWhenJog = _DEFCS(_CSV(18067),
	_CHINESE("㶯ʱ")
	_ENGLISH("Laser ON at Jog"));
CS_T s_szStartSelected = _DEFCS(_CSV(18067),
	_CHINESE("ӹѡͼ")
	_ENGLISH("Start for Selection"));
CS_T s_szAutoExchange = _DEFCS(_CSV(18068),
	_CHINESE("ӹԶ")
	_ENGLISH("Auto Exchange"));
CS_T s_szAutoCyc = _DEFCS(_CSV(18068),
	_CHINESE("ѭӹ")
	_ENGLISH("Cycle Machining"));
CS_T s_szLevel = _DEFCS(_CSV(18067),
	_CHINESE("Уƽ\n")
	_ENGLISH("Top\nCenter"));
CS_T s_szCentering = _DEFCS(_CSV(18067),
	_CHINESE("\n")
	_ENGLISH("Faces\nCenter"));
CS_T s_szMUNU_MARKPOINT1 = _DEFCS(_CSV(18640),
	_CHINESE("ǵ1")
	_ENGLISH("Mark point1"));
CS_T s_szMUNU_MARKPOINT2 = _DEFCS(_CSV(18641),
	_CHINESE("ǵ2")
	_ENGLISH("Mark point2"));
CS_T s_szMUNU_MARKPOINT3 = _DEFCS(_CSV(18642),
	_CHINESE("ǵ3")
	_ENGLISH("Mark point3"));
CS_T s_szMUNU_MARKPOINT4 = _DEFCS(_CSV(18643),
	_CHINESE("ǵ4")
	_ENGLISH("Mark point4"));
CS_T s_szMUNU_MARKPOINT5 = _DEFCS(_CSV(18644),
	_CHINESE("ǵ5")
	_ENGLISH("Mark point5"));
CS_T s_szMUNU_MARKPOINT6 = _DEFCS(_CSV(18645),
	_CHINESE("ǵ6")
	_ENGLISH("Mark point6"));
CS_T s_szMUNU_MARKPOINT7 = _DEFCS(_CSV(18646),
	_CHINESE("ǵ7")
	_ENGLISH("Mark point7"));
CS_T s_szMUNU_MARKPOINT8 = _DEFCS(_CSV(18647),
	_CHINESE("ǵ8")
	_ENGLISH("Mark point8"));
CS_T s_szMUNU_MARK = _DEFCS(_CSV(18647),
	_CHINESE("")
	_ENGLISH("Set Mark"));
CS_T s_szMUNU_BACKMARK = _DEFCS(_CSV(18647),
	_CHINESE("ر")
	_ENGLISH("Go Mark"));
CS_T s_szMUNU_MARKNUM = _DEFCS(_CSV(18647),
	_CHINESE("ǵ")
	_ENGLISH("Mark Point"));
CS_T s_szMUNU_BACKORG = _DEFCS(_CSV(18647),
	_CHINESE("е")
	_ENGLISH("All Origin"));
CS_T s_szMUNU_SETW = _DEFCS(_CSV(18647),
	_CHINESE("")
	_ENGLISH("Set Zero"));
CS_T s_szMUNU_BW = _DEFCS(_CSV(18647),
	_CHINESE("")
	_ENGLISH("To Zero"));
CS_T s_szMUNU_SAMPLE = _DEFCS(_CSV(18647),
	_CHINESE("Z궨")
	_ENGLISH("Calibrate"));
CS_T s_szMUNU_FORWARD = _DEFCS(_CSV(18647),
	_CHINESE("ǰ    ")
	_ENGLISH("Forward     "));
CS_T s_szMUNU_BACK = _DEFCS(_CSV(18647),
	_CHINESE("    ")
	_ENGLISH("    Back"));
CS_T s_csENDACTION = _DEFCS(_CSV(18498),
	_CHINESE("ӹΪ:")
	_ENGLISH("Post-task Actions:"));
CS_T s_csNOMOTION = _DEFCS(_CSV(18498),
	_CHINESE("  ")
	_ENGLISH("  No Motion"));
CS_T s_csBACKFIXPOS = _DEFCS(_CSV(18499),
	_CHINESE("  ع̶")
	_ENGLISH("  Fixed Point"));
CS_T s_csBACKWORKORG = _DEFCS(_CSV(18500),
	_CHINESE("  عԭ")
	_ENGLISH("  Work Origin"));
CS_T s_csBACK1 = _DEFCS(_CSV(18500),
	_CHINESE("  رǵ1")
	_ENGLISH("  Mark Point1"));
CS_T s_csBACK2 = _DEFCS(_CSV(18500),
	_CHINESE("  رǵ2")
	_ENGLISH("  Mark Point2"));
CS_T s_csBACK3 = _DEFCS(_CSV(18500),
	_CHINESE("  رǵ3")
	_ENGLISH("  Mark Point3"));
CS_T s_csBACK4 = _DEFCS(_CSV(18500),
	_CHINESE("  رǵ4")
	_ENGLISH("  Mark Point4"));
CS_T s_csBACK5 = _DEFCS(_CSV(18500),
	_CHINESE("  رǵ5")
	_ENGLISH("  Mark Point5"));
CS_T s_csBACK6 = _DEFCS(_CSV(18500),
	_CHINESE("  رǵ6")
	_ENGLISH("  Mark Point6"));
CS_T s_csBACK7 = _DEFCS(_CSV(18500),
	_CHINESE("  رǵ7")
	_ENGLISH("  Mark Point7"));
CS_T s_csBACK8 = _DEFCS(_CSV(18500),
	_CHINESE("  رǵ8")
	_ENGLISH("  Mark Point8"));
CS_T s_csBLOWAIR = _DEFCS(_CSV(18500),
	_CHINESE(":")
	_ENGLISH("Blow Type:"));
CS_T s_csAIR = _DEFCS(_CSV(18500),
	_CHINESE("  ")
	_ENGLISH("  Air"));
CS_T s_csO2 = _DEFCS(_CSV(18500),
	_CHINESE("  ")
	_ENGLISH("  Oxygen"));
CS_T s_csN2 = _DEFCS(_CSV(18500),
	_CHINESE("  ")
	_ENGLISH("  Nitrogen"));

using namespace mach;
using namespace ncmath;
////////////////////////////////////////////////////////////////////////////////
// CtrlID
enum
{
	CTRLID_BTN_F						= psh1,
	CTRLID_BTN_CENTER,
	CTRLID_BTN_XP,
	CTRLID_BTN_XN,
	CTRLID_BTN_YP,
	CTRLID_BTN_YN,
	CTRLID_BTN_ZP,
	CTRLID_BTN_ZN,
	CTRLID_BTN_WP,
	CTRLID_BTN_WN,
	CTRLID_BTN_GOFORWARD,
	CTRLID_BTN_GOBACKWARD,
	CTRLID_BTN_GODISTANCE,
	CTRLID_BTN_CHANGECOOR,

	CTRLID_STC_AXES					= stc1,
	CTRLID_STC_COOR,
	CTRLID_STC_PORT0,
	CTRLID_STC_PORT1,
	CTRLID_STC_PORT2,
	CTRLID_STC_PORT3,
	CTRLID_STC_PORT4,
	CTRLID_STC_PORT5,
	CTRLID_STC_PORT6,
	CTRLID_STC_PORT7,
	CTRLID_STC_PORT8,
	CTRLID_STC_PORT9,
	CTRLID_STC_PORT10,
	CTRLID_STC_PORT11,
	CTRLID_BTN_PORT0,
	CTRLID_BTN_PORT1,
	CTRLID_BTN_PORT2,
	CTRLID_BTN_PORT3,
	CTRLID_BTN_PORT4,
	CTRLID_BTN_PORT5,
	CTRLID_BTN_PORT6,
	CTRLID_BTN_PORT7,
	CTRLID_BTN_PORT8,
	CTRLID_BTN_PORT9,
	CTRLID_BTN_PORT10,
	CTRLID_BTN_PORT11,

	// ǵ㰴ťͲ˵
	CTRLID_BTN_SELMARKPOINT,
	CTRLID_BTN_MARKPOINT1,
	CTRLID_BTN_MARKPOINT2,
	CTRLID_BTN_MARKPOINT3,
	CTRLID_BTN_MARKPOINT4,
	CTRLID_BTN_MARKPOINT5,
	CTRLID_BTN_MARKPOINT6,
	CTRLID_BTN_MARKPOINT7,
	CTRLID_BTN_MARKPOINT8,

	// ѡťͲ˵
	CTRLID_BTN_SELAIR,
	CTRLID_BTN_SELAIR0,
	CTRLID_BTN_SELN2,
	CTRLID_BTN_SEL02,

	// ťͲ˵
	CTRLID_BTN_ENDACTION,
	CTRLID_BTN_NOMOVE,
	CTRLID_BTN_BACKFIXPOS,
	CTRLID_BTN_BACKWORKORG,
	CTRLID_BTN_BACKMAKPOINT1,
	CTRLID_BTN_BACKMAKPOINT2,
	CTRLID_BTN_BACKMAKPOINT3,
	CTRLID_BTN_BACKMAKPOINT4,
	CTRLID_BTN_BACKMAKPOINT5,
	CTRLID_BTN_BACKMAKPOINT6,
	CTRLID_BTN_BACKMAKPOINT7,
	CTRLID_BTN_BACKMAKPOINT8,

	CTRLID_STC_XVALUE,
	CTRLID_STC_YVALUE,
	CTRLID_STC_ZVALUE,
	CTRLID_STC_SELECTMACH,
	CTRLID_STC_JOGLASER,
	CTRLID_STC_AUTOCYC,
	CTRLID_STC_WVALUE,
	CTRLID_STC_BR,
	CTRLID_STC_BRX,
	CTRLID_STC_BRY,
	CTRLID_STC_BRZ,
	CTRLID_STC_BRW,
	CTRLID_STC_TITLEZ,
	CTRLID_STC_BACKGROUND,
	CTRLID_STC_TITLEX,
	CTRLID_STC_TITLEY,
	CTRLID_STC_F,
	CTRLID_STC_AUTOEXCHANGE,
	CTRLID_STC_DIRRUN,
	CTRLID_SIMULATE,
	CTRLID_STC_SIMUCAT,
	CTRLID_STC_MARK,
	CTRLID_STC_BACKMARK,
	CTRLID_STC_MARKNUM,

	CTRLID_STC_BACKORG,
	CTRLID_STC_SETW,
	CTRLID_STC_BW,
	CTRLID_STC_SAMPLE,
	CTRLID_STC_FORWARD,
	CTRLID_STC_BACK,
	CTRLID_STC_STCAIR,
	CTRLID_STC_STCENDACTION,

	CTRLID_EDIT_GODISTANCE				= edt1,

	CTRLID_SLD_SETF						= ctl1,
	CTRLID_SLD_F,

	CTRLID_CHX_SELECTMACH				= chx1,
	CTRLID_CHX_JOGLASER					= chx2,
	CTRLID_CHX_AUTOCYC					= chx3,
	CTRLID_CHX_AUTOCYCEXCHANGE,
};
////////////////////////////////////////////////////////////////////////////////
// Local function declarations ---- DingQiang 2012-06-25
static double _FormatInputData(double nInputData_);

////////////////////////////////////////////////////////////////////////////////
// CMachineControlDlg
// 
// ֻҪ󣬲Ҫл汾ơ ----  2011-10-31
IMPLEMENT_SERIAL(CMachineControlDlg, CAgileDialog, 0xFFFF)

BEGIN_MESSAGE_MAP(CMachineControlDlg, CAgileDialog)
	ON_WM_HSCROLL()
	ON_WM_LBUTTONDOWN()
	ON_MESSAGE(WM_MYDLGMESSAGE, OnEndSpeedDlg)
	ON_CONTROL_RANGE(BN_PUSHED, CTRLID_BTN_XP, CTRLID_BTN_WN, OnDirectionBtnPushed)
	ON_CONTROL_RANGE(BN_UNPUSHED, CTRLID_BTN_XP, CTRLID_BTN_WN, OnDirectionBtnUnpushed)
	ON_CONTROL_RANGE(BN_PUSHED, CTRLID_BTN_GOFORWARD, CTRLID_BTN_GOBACKWARD, OnGFOBBtnPushed)
	ON_CONTROL_RANGE(BN_UNPUSHED, CTRLID_BTN_GOFORWARD, CTRLID_BTN_GOBACKWARD, OnGFOBBtnUnpushed)
	ON_MESSAGE(WM_IDLEUPDATECMDUI, OnIdleUpdateCmdUI)
	ON_CONTROL(STN_DBLCLK, CTRLID_STC_COOR, OnChangeCoorMode)
	ON_MESSAGE(WM_MYEIDTMESSAGE, OnEndEditDistance)
	ON_COMMAND(CTRLID_BTN_CHANGECOOR, OnChangeCoorMode)
	ON_CONTROL(BN_CLICKED, CTRLID_BTN_CENTER, OnSetManuMode)
	ON_CONTROL(BN_DOUBLECLICKED, CTRLID_BTN_CENTER, OnDblClickCenter)
	ON_MESSAGE(WM_BITMAPSLIDER_MOVING, OnSliderMoving)
	ON_COMMAND(CTRLID_CHX_SELECTMACH, OnSelectMach)
	ON_COMMAND(CTRLID_CHX_JOGLASER, OnJogLaser)
	ON_COMMAND(CTRLID_CHX_AUTOCYC, OnAutoCyc)
	ON_COMMAND(CTRLID_CHX_AUTOCYCEXCHANGE, OnAutoExchange)
	ON_COMMAND(CTRLID_BTN_SELMARKPOINT, OnSelMarkPoint)
	ON_COMMAND(CTRLID_BTN_SELAIR, OnSelBlowAir)
	ON_COMMAND(CTRLID_BTN_ENDACTION, OnSelEndAction)
	ON_COMMAND_RANGE(CTRLID_BTN_MARKPOINT1, CTRLID_BTN_MARKPOINT8, OnMarkPointChange)
	ON_COMMAND_RANGE(CTRLID_BTN_SELAIR0, CTRLID_BTN_SEL02, OnAirChange)
	ON_COMMAND_RANGE(CTRLID_BTN_NOMOVE, CTRLID_BTN_BACKMAKPOINT8, OnEndActionChange)
END_MESSAGE_MAP()

CMachineControlDlg::CMachineControlDlg(CWnd* pParentWnd_/* = NULL*/)
: CMachineControlDlg_Imp(pParentWnd_)
{
	m_pwndSliderF = NULL;
	m_pwndSliderExF = NULL;
	m_pwndBtnF = NULL;
	m_pwndBtnXP = NULL;
	m_pwndBtnXN = NULL;
	m_pwndBtnYP = NULL;
	m_pwndBtnYN = NULL;
	m_pwndBtnZP = NULL;
	m_pwndBtnZN = NULL;
	m_pwndBtnWP = NULL;
	m_pwndBtnWN = NULL;
	m_pwndBtnCenter = NULL;
	m_pwndStcValueX = NULL;
	m_pwndStcValueY = NULL;
	m_pwndStcValueZ = NULL;
	m_pwndStcValueW= NULL;
	m_pSetSpeedDlg = NULL;
	m_pwndSliderSetF = NULL;
	m_pwndSliderSetExF = NULL;
	m_pDistanceEdit = NULL;
	m_pwndRunBtn = NULL;
	m_pwndDirRunBtn = NULL;

	m_pMenuMark = new CMenu;
	m_pMenuMarkPoint = new CMenu;
	m_pMenuAir = new CMenu;

	m_nCurIndex = 1;

	memset(m_pwndPortButtons, 0, sizeof(CPortButton*) * _countof(m_pwndPortButtons));

	m_nCoorMode = 0x00;

	for (int _i = 0; _i < _countof(m_nFValues); _i++)
	{
		m_nFValues[_i] = _i;
	}

	m_strShowAllBKMark = "0";
	m_strBKMarkAttachAxis = "0,1";

	m_bSliderCtrlG00 = NceGetPrivateProfileString(_T("ControlTarget"), _T("SliderCtrlG00"), _T("0")) == _T("1");
	// ͬGXXG00ıʡ ---- ƺ 2016-04-19
	if (m_bSliderCtrlG00)
	{
		if (CParamManager* _pParamManager = GetParamManager())
		{
			int _nFrp = 100;
			ParameterValue _FrpParamValue;
			if (_pParamManager->GetParameterValue("SpeedGxx_Frp", &_FrpParamValue)
				&& _FrpParamValue.nType == ParameterValue::VT_INT)
			{
				_nFrp = _FrpParamValue.iValue;
			}

			if (_pParamManager->GetParameterValue("SpeedG00_Frp", &_FrpParamValue)
				&& _FrpParamValue.nType == ParameterValue::VT_INT)
			{
				_FrpParamValue.iValue = _nFrp;
				bool _bRet = _pParamManager->SetParameterValue("SpeedG00_Frp", &_FrpParamValue);
				ASSERT(_bRet);
			}
		}
	}
	m_bSelectMach = FALSE;
	m_bShowSelectMach = FALSE;
	m_bShowJogLaser = FALSE;
	m_bShowAutoCyc = FALSE;

	// Ƿ÷ ---- DingQiang 2016-08-17
	CString _strEnable = NceGetPrivateProfileString(_T("Tube"), _T("Enable"), _T(""));
	m_bIsTube = _strEnable == _T("True");

	// ǷR2
	CString _strUserStyle = NceGetPrivateProfileString(_T("Theme"), _T("UserStyle"), _T("None"));
	m_bIsR2 = (_strUserStyle == _T("R2"));

	LOAD_PARAM(this, CMachineControlDlg);
}

CMachineControlDlg::~CMachineControlDlg()
{
	if (m_pSetSpeedDlg)
	{
		delete m_pSetSpeedDlg;
		m_pSetSpeedDlg = NULL;
	}

	if (m_pMenuMark)
	{
		delete m_pMenuMark;
		m_pMenuMark = NULL;
	}

	if (m_pMenuMarkPoint)
	{
		delete m_pMenuMarkPoint;
		m_pMenuMarkPoint = NULL;
	}

	if (m_pMenuAir)
	{
		delete m_pMenuAir;
		m_pMenuAir = NULL;
	}

	SAVE_PARAM(this, CMachineControlDlg);
}

BOOL CMachineControlDlg::Create(CWnd* pParentWnd_ /* = NULL */)
{
	// ĴڷΪӴڣԱNcEditorҲϡ ----  2011-10-31
	static struct { DLGTEMPLATE dt; SHORT n1; SHORT n2; SHORT n3; }
	_s_EmptyDialogTemplate = { WS_CHILD };
	return CreateIndirect(&_s_EmptyDialogTemplate.dt, pParentWnd_);
}

void CMachineControlDlg::Update()
{
	UpdateBRFlag();
	UpdateMachCoor();
	UpdateF();
	UpdateManuCenter();
	UpdateGFOBInfo();
	UpdateEnableJogLaser();
	UpdateEnableAutoCyc();
	UpdateEnableAutoExchange();

	if (m_bIsR2)
	{
		UpdateAir();
		UpdateEndAction();
	}

	for (int _i = 0; _i < _countof(m_pwndPortButtons); _i++)
	{
		if (m_pwndPortButtons[_i])
		{
			// ʱ ----  2013-03-11
			m_pwndPortButtons[_i]->Update();
		}
	}
	m_pwndDirRunBtn->Update();
	m_pwndRunBtn->Update();
}

BOOL CMachineControlDlg::OnInitDialog()
{
	__super::OnInitDialog();

	// עȡøؼָ롣 ----  2011-10-31
	RegisterID("stcBackground", CTRLID_STC_BACKGROUND);
	RegisterID("stcTitleX", CTRLID_STC_TITLEX);
	RegisterID("stcTitleY", CTRLID_STC_TITLEY);
	Register("stcCoor", m_pwndStcCoor);
	RegisterID("stcCoor", CTRLID_STC_COOR);
	RegisterID("stcAxes", CTRLID_STC_AXES);
	Register("stcBR", m_pwndStcBR);
	RegisterID("stcBR", CTRLID_STC_BR);
	Register("stcBRX", m_pwndStcBRX);
	RegisterID("stcBRX", CTRLID_STC_BRX);
	Register("stcBRY", m_pwndStcBRY);
	RegisterID("stcBRY", CTRLID_STC_BRY);
	Register("stcBRZ", m_pwndStcBRZ);
	RegisterID("stcBRZ", CTRLID_STC_BRZ);
	Register("stcBRW", m_pwndStcBRW);
	RegisterID("stcBRW", CTRLID_STC_BRW);
	Register("stcXValue", m_pwndStcValueX);
	Register("stcYValue", m_pwndStcValueY);
	Register("stcZValue", m_pwndStcValueZ);
	Register("stcWValue", m_pwndStcValueW);
	Register("stcTitleZ", m_pwndStcTitleZ);
	RegisterID("stcTitleZ", CTRLID_STC_TITLEZ);
	Register("stcTitleW", m_pwndStcTitleW);
	if (m_bIsR2)
	{
		Register("sliderF", m_pwndSliderExF);
	}
	else
	{
		Register("sliderF", m_pwndSliderF);
	}
	RegisterID("sliderF", CTRLID_SLD_F);
	Register("btnF", m_pwndBtnF);
	if (m_bIsR2)
	{
		Register("sliderSetF", m_pwndSliderSetExF);
	}
	else
	{
		Register("sliderSetF", m_pwndSliderSetF);
	}
	RegisterID("sliderSetF", CTRLID_SLD_SETF);
	RegisterID("btnF", CTRLID_BTN_F);
	RegisterID("btnChangCoor", CTRLID_BTN_CHANGECOOR);
	Register("btnChangCoor", m_pwndChangCoor);
	RegisterID("stcXValue", CTRLID_STC_XVALUE);
	RegisterID("stcYValue", CTRLID_STC_YVALUE);
	RegisterID("stcZValue", CTRLID_STC_ZVALUE);
	RegisterID("stcWValue", CTRLID_STC_WVALUE);
	Register("stcF", m_pwndStcF);
	RegisterID("stcF", CTRLID_STC_F);
	Register("stcGoDistance", m_pwndStcGoDistance);
	RegisterID("stcGoDistance", CTRLID_BTN_GODISTANCE);
	Register("btnCenter", m_pwndBtnCenter);
	RegisterID("btnCenter", CTRLID_BTN_CENTER);
	Register("btnXP", m_pwndBtnXP);
	Register("btnXN", m_pwndBtnXN);
	Register("btnYP", m_pwndBtnYP);
	Register("btnYN", m_pwndBtnYN);
	Register("btnZP", m_pwndBtnZP);
	Register("btnZN", m_pwndBtnZN);
	Register("btnWP", m_pwndBtnWP);
	Register("btnWN", m_pwndBtnWN);
	RegisterID("btnXP", CTRLID_BTN_XP);
	RegisterID("btnXN", CTRLID_BTN_XN);
	RegisterID("btnYP", CTRLID_BTN_YP);
	RegisterID("btnYN", CTRLID_BTN_YN);
	RegisterID("btnZP", CTRLID_BTN_ZP);
	RegisterID("btnZN", CTRLID_BTN_ZN);
	RegisterID("btnWP", CTRLID_BTN_WP);
	RegisterID("btnWN", CTRLID_BTN_WN);
	RegisterID("btnGoForward", CTRLID_BTN_GOFORWARD);
	RegisterID("btnGoBackward", CTRLID_BTN_GOBACKWARD);
	RegisterID("stcPort0", CTRLID_STC_PORT0);
	RegisterID("stcPort1", CTRLID_STC_PORT1);
	RegisterID("stcPort2", CTRLID_STC_PORT2);
	RegisterID("stcPort3", CTRLID_STC_PORT3);
	RegisterID("stcPort4", CTRLID_STC_PORT4);
	RegisterID("stcPort5", CTRLID_STC_PORT5);
	RegisterID("stcPort6", CTRLID_STC_PORT6);
	RegisterID("stcPort7", CTRLID_STC_PORT7);
	RegisterID("stcPort8", CTRLID_STC_PORT8);
	RegisterID("stcPort9", CTRLID_STC_PORT9);
	RegisterID("stcPort10", CTRLID_STC_PORT10);
	RegisterID("stcPort11", CTRLID_STC_PORT11);
	RegisterID("btnPort0", CTRLID_BTN_PORT0);
	RegisterID("btnPort1", CTRLID_BTN_PORT1);
	RegisterID("btnPort2", CTRLID_BTN_PORT2);
	RegisterID("btnPort3", CTRLID_BTN_PORT3);
	RegisterID("btnPort4", CTRLID_BTN_PORT4);
	RegisterID("btnPort5", CTRLID_BTN_PORT5);
	RegisterID("btnPort6", CTRLID_BTN_PORT6);
	RegisterID("btnPort7", CTRLID_BTN_PORT7);
	RegisterID("btnPort8", CTRLID_BTN_PORT8);
	RegisterID("btnPort9", CTRLID_BTN_PORT9);
	RegisterID("btnPort10", CTRLID_BTN_PORT10);
	RegisterID("btnPort11", CTRLID_BTN_PORT11);
	Register("btnRun", m_pwndRunBtn);
	Register("btnDirrun", m_pwndDirRunBtn);

	if (m_bIsR2)
	{
		RegisterID("stcForward", CTRLID_STC_FORWARD);
		RegisterID("stcBack", CTRLID_STC_BACK);

		SetDlgItemText(CTRLID_BTN_GOFORWARD, _GETCS(s_szMUNU_FORWARD));
		SetDlgItemText(CTRLID_BTN_GOBACKWARD, _GETCS(s_szMUNU_BACK));
	}

	m_pwndRunBtn->SetMotionEndType(CCycMachiningTarget::TaskEndNormal);
	m_pwndDirRunBtn->SetMotionEndType(CCycMachiningTarget::DryRunEndNormal);

	// PortButton ---- DingQiang 2013-07-23
	for (size_t _i = 0; _i < _countof(m_pwndPortButtons); _i++)
	{
		// ע:xamlûעʧܣӦָΪNULL ---- DingQiang 2013-07-24
		CString _strPortButtonName;
		_strPortButtonName.Format(_T("btnPort%d"), _i);
		Register(_strPortButtonName, m_pwndPortButtons[_i]);

		// ʼؼ ---- DingQiang 2016-07-14
		CString _strPortIndex;
		_strPortIndex.Format(_T("Port%d"), _i);
		if (!m_pwndPortButtons[_i] || !m_pwndPortButtons[_i]->Initialize(_T("ControlTarget"), _strPortIndex))
		{
			continue;
		}

		// ӦĶ˿ ----  2012-07-05
		CString _strDescriptionNameKey;
		_strDescriptionNameKey.Format(_GETCS(s_szPortNameKey), _i);
		CString _strDescriptionName = NceGetPrivateProfileString(_T("ControlTarget"), _strDescriptionNameKey);
		SetDlgItemText(CTRLID_STC_PORT0 + (int)_i, _strDescriptionName);
	}
	// еĻػеԭ־-----2015-02-08
	m_pwndStcBR->ShowWindow(SW_HIDE);
	m_pwndStcBRX->ShowWindow(SW_HIDE);
	m_pwndStcBRY->ShowWindow(SW_HIDE);
	m_pwndStcBRZ->ShowWindow(SW_HIDE);
	if (m_pwndStcBRW)
	{
		m_pwndStcBRW->ShowWindow(SW_HIDE);
	}

	//ãǷʾػеԭ־Լػеԭ
	//ԶʹöģʹĬϵ-----2015-02-08
	CString _strShowAllBKMark = NceGetPrivateProfileString(_T("ControlTarget"), _T("ShowAllBKMark"));
	CString _strBKMarkAttachAxis = NceGetPrivateProfileString(_T("ControlTarget"), _T("BKMarkAttachAxis"));
	if (!_strShowAllBKMark.IsEmpty())
	{
		m_strShowAllBKMark = _strShowAllBKMark;
	}
	if (!_strBKMarkAttachAxis.IsEmpty())
	{
		m_strBKMarkAttachAxis = _strBKMarkAttachAxis;
	}

	//ֻʾһԭ־ʱ----2015-02-08
	if (m_strShowAllBKMark == "0")
	{
		CString _strBKMarkAttachAxis = m_strBKMarkAttachAxis;
		// ֵзǷַֻһַ
		if (_strBKMarkAttachAxis.IsEmpty()
			||_strBKMarkAttachAxis.SpanIncluding(_T(",012")).GetLength() != _strBKMarkAttachAxis.GetLength()
			|| _strBKMarkAttachAxis.GetLength() == 1 && _strBKMarkAttachAxis.FindOneOf(_T("012")) == -1)
		{
			_strBKMarkAttachAxis.Empty();
		}
		m_strVecAxis.clear();
		while(!_strBKMarkAttachAxis.IsEmpty())
		{
			_strBKMarkAttachAxis.TrimLeft(",");
			_strBKMarkAttachAxis.TrimRight(",");
			int _Index = _strBKMarkAttachAxis.Find(",");
			if(_Index == -1)
			{
				m_strVecAxis.push_back(_strBKMarkAttachAxis);
				break;
			}
			m_strVecAxis.push_back( _strBKMarkAttachAxis.Left(_Index));
			_strBKMarkAttachAxis = _strBKMarkAttachAxis.Right(_strBKMarkAttachAxis.GetLength() - _Index);
		}
	}

#define RegisterBtnID(szName_, nID_) {	\
	CAgileImageButton* _pwndBtn = NULL;	\
	Register(szName_, _pwndBtn);		\
	ASSERT(_pwndBtn);					\
	ASSERT(IsCmdID(nID_));				\
	_pwndBtn->SetCmdID(nID_);			\
	}
	RegisterBtnID("btnSetW", IDCMD_CONTROLTARGET_CLEARW);
	RegisterBtnID("btnBW", IDCMD_CONTROLTARGET_BACKW);
	if(!m_bIsR2)
	{
		RegisterBtnID("btnMachSel", IDCMD_CONTROLTARGET_MACHSELECTED);
	}

	// ڷ£ͣťָУƽ߱߿ָ ---- η 2016-11-17
	if (!m_bIsTube)
	{
		RegisterBtnID("btnSimuCut", IDCMD_CONTROLTARGET_SIMUCUT);
		RegisterBtnID("btnPause", IDCMD_CONTROLTARGET_PAUSE);
	}
	else
	{
		RegisterBtnID("btnSimuCut", IDCMD_TUBECTRLTARGET_FINDMIDFOURSIDE);
		RegisterBtnID("btnPause", IDCMD_TUBECTRLTARGET_ADJUSTHORANDFINDMID);
	}

	RegisterBtnID("btnRun", IDCMD_CONTROLTARGET_START);
	RegisterBtnID("btnStop", IDCMD_CONTROLTARGET_STOP);
	RegisterBtnID("btnBreakpointResume", IDCMD_CONTROLTARGET_BREAKPOINTRESUME);
	RegisterBtnID("btnSimulate", IDCMD_CONTROLTARGET_SIMULATE);
	RegisterBtnID("btnDirrun", IDCMD_CONTROLTARGET_DIRRUN);
	CString _strCutBoundText;
	if (NceGetPrivateProfileString(_T("ControlTarget"), _T("ShowSampleBtn")) == _T("1"))
	{
		RegisterBtnID("btnSample", IDCMD_FOLLOWCTRLTARGET_SAMPLE);
		// ߱߿ŵһţťʾ֡ ---- ƺ 2015-09-10
		_strCutBoundText = _GETCS(s_csSIMUCUTBOUNDRECT);
	}
	if (NceGetPrivateProfileString(_T("ControlTarget"), _T("ShowBackOrgBtn")) == _T("1"))
		RegisterBtnID("btnBackOrg", IDCMD_CONTROLTARGET_BACKR);

	if (m_bIsR2)
	{
		RegisterID("stcDirrun", CTRLID_STC_DIRRUN);
		RegisterID("stcSimulate", CTRLID_SIMULATE);
		RegisterID("stcSimuCut", CTRLID_STC_SIMUCAT);
		RegisterID("stcMark", CTRLID_STC_MARK);
		RegisterID("stcBackMark", CTRLID_STC_BACKMARK);
		RegisterID("stcMarkNum", CTRLID_STC_MARKNUM);
		RegisterID("stcBackOrg", CTRLID_STC_BACKORG);
		RegisterID("stcSetW", CTRLID_STC_SETW);
		RegisterID("stcBW", CTRLID_STC_BW);
		RegisterID("stcSample", CTRLID_STC_SAMPLE);
		RegisterID("stcAir", CTRLID_STC_STCAIR);
		RegisterID("stcEndAction", CTRLID_STC_STCENDACTION);

		RegisterBtnID("btnMarkPoint", IDCMD_MARKPOINTTARGET_MARKTHISPOINT);
		RegisterBtnID("btnBackMarkPoint", IDCMD_MARKPOINTTARGET_MOVETOMARKPOINT);
		RegisterID("btnSelectMarkPoint", CTRLID_BTN_SELMARKPOINT);
		RegisterID("btnAir", CTRLID_BTN_SELAIR);
		RegisterID("btnEndAction", CTRLID_BTN_ENDACTION);

		SetDlgItemText(CTRLID_STC_DIRRUN, _GETCS(s_csDIRRUNTEXT));
		SetDlgItemText(CTRLID_SIMULATE, _GETCS(s_csSIMU));
		SetDlgItemText(CTRLID_STC_SIMUCAT, _GETCS(s_csSIMUCUTBOUNDRECT));
		SetDlgItemText(CTRLID_STC_MARK, _GETCS(s_szMUNU_MARK));
		SetDlgItemText(CTRLID_STC_BACKMARK, _GETCS(s_szMUNU_BACKMARK));
		SetDlgItemText(CTRLID_STC_MARKNUM, _GETCS(s_szMUNU_MARKNUM));
		SetDlgItemText(CTRLID_STC_BACKORG, _GETCS(s_szMUNU_BACKORG));
		SetDlgItemText(CTRLID_STC_SETW, _GETCS(s_szMUNU_SETW));
		SetDlgItemText(CTRLID_STC_BW, _GETCS(s_szMUNU_BW));
		SetDlgItemText(CTRLID_STC_SAMPLE, _GETCS(s_szMUNU_SAMPLE));
		SetDlgItemText(CTRLID_STC_STCAIR, _GETCS(s_csBLOWAIR));
		SetDlgItemText(CTRLID_STC_STCENDACTION, _GETCS(s_csENDACTION));
	}
#undef RegisterBtnID

	m_bShowSelectMach = NceGetPrivateProfileString(_T("ControlTarget"), _T("ShowSelectMach")) == _T("1");
	RegisterID("stcMachSelText", CTRLID_STC_SELECTMACH);
	RegisterID("chkMachSel", CTRLID_CHX_SELECTMACH);
	CWnd* _pwndSelectMach_Check = GetDlgItem(CTRLID_CHX_SELECTMACH);
	CWnd* _pwndSelectMach_Static = GetDlgItem(CTRLID_STC_SELECTMACH);
	if (_pwndSelectMach_Check && _pwndSelectMach_Static)
	{
		CStateManager* _pStateManager = GetStateManager();
		if (_pStateManager)
			_pStateManager->SetSelectedMach(m_bSelectMach);

		CButton* _pwndBtn = (CButton*)_pwndSelectMach_Check;
		_pwndBtn->SetCheck(m_bSelectMach ? BST_CHECKED : BST_UNCHECKED);
		_pwndBtn->ShowWindow(m_bShowSelectMach ? SW_SHOWNORMAL : SW_HIDE);

		CWnd* _pWnd = GetDlgItem(IDCMD_CONTROLTARGET_DIRRUN);
		//CFont* _pFont = _pWnd->GetFont();
		//_pwndSelectMach_Static->SetFont(_pFont);
		_pwndSelectMach_Static->SetWindowText(_GETCS(s_csSELECTMACH));
		_pwndSelectMach_Static->ShowWindow(m_bShowSelectMach ? SW_SHOWNORMAL : SW_HIDE);
	}

	m_bShowJogLaser = NceGetPrivateProfileString(_T("ControlTarget"), _T("ShowJogLaser")) == _T("1");
	RegisterID("btnJogWLaser", CTRLID_CHX_JOGLASER);	
	CButton* _pwndBtn2 = (CButton*)GetDlgItem(CTRLID_CHX_JOGLASER);
	RegisterID("chkJogWithLaser", CTRLID_CHX_JOGLASER);
	CButton* _pwndBtnChxJogLaser = (CButton*)GetDlgItem(CTRLID_CHX_JOGLASER);
	if(_pwndBtn2 && _pwndBtnChxJogLaser)
	{
		_pwndBtn2->SetWindowText(_GETCS(s_szLaserOnWhenJog));
		_pwndBtn2->ShowWindow(m_bShowJogLaser ? SW_SHOWNORMAL : SW_HIDE);
		_pwndBtnChxJogLaser->ShowWindow(m_bShowJogLaser ? SW_SHOWNORMAL : SW_HIDE);
	}

	if (m_bIsR2)
	{
		RegisterID("stcJogWithLaser", CTRLID_STC_JOGLASER);
		CWnd* _pwndStatic2 = GetDlgItem(CTRLID_STC_JOGLASER);
		if(_pwndStatic2)
		{
			_pwndStatic2->SetWindowText(_GETCS(s_szLaserOnWhenJog));
			_pwndStatic2->ShowWindow(m_bShowJogLaser ? SW_SHOWNORMAL : SW_HIDE);
		}
	}

	// Զѭ
	m_bShowAutoCyc = NceGetPrivateProfileString(_T("ControlTarget"), _T("ShowAutoCyc")) == _T("1");
	RegisterID("chkAutoCyc", CTRLID_CHX_AUTOCYC);
	RegisterID("stcAutoCyc", CTRLID_STC_AUTOCYC);
	CButton* _pwndBtn3 = (CButton*)GetDlgItem(CTRLID_CHX_AUTOCYC);
	CWnd* _pwndStatic3 = GetDlgItem(CTRLID_STC_AUTOCYC);
	if(_pwndBtn3 && _pwndStatic3)
	{
		_pwndStatic3->SetWindowText(_GETCS(s_szAutoCyc));
		_pwndBtn3->ShowWindow(m_bShowAutoCyc ? SW_SHOWNORMAL : SW_HIDE);
		_pwndStatic3->ShowWindow(m_bShowAutoCyc ? SW_SHOWNORMAL : SW_HIDE);
	}

	// ӹԶ̨
	BOOL _bShowAutoExchange = NceGetPrivateProfileString(_T("ControlTarget"), _T("ShowAutoExchange")) == _T("1");
	if (_bShowAutoExchange)
	{
		RegisterID("chkExchange", CTRLID_CHX_AUTOCYCEXCHANGE);
		RegisterID("stcExchange", CTRLID_STC_AUTOEXCHANGE);
	}
	CButton* _pwndBtn4 = (CButton*)GetDlgItem(CTRLID_CHX_AUTOCYCEXCHANGE);
	CWnd* _pwndStatic4 = GetDlgItem(CTRLID_STC_AUTOEXCHANGE);
	if(_pwndBtn4 && _pwndStatic4)
	{
		_pwndStatic4->SetWindowText(_GETCS(s_szAutoExchange));
		_pwndBtn4->ShowWindow(_bShowAutoExchange ? SW_SHOWNORMAL : SW_HIDE);
		_pwndStatic4->ShowWindow(_bShowAutoExchange ? SW_SHOWNORMAL : SW_HIDE);
	}

	SetDlgItemText(CTRLID_STC_AXES, _GETCS(s_csAXES));
	SetDlgItemText(CTRLID_STC_COOR, m_nCoorMode == 0x00 ? _GETCS(s_csWORKPIECECOORDINATE) : _GETCS(s_csMACHINECOORDINATE));
	SetDlgItemText(IDCMD_CONTROLTARGET_BREAKPOINTRESUME, _T(""));

	SetDlgItemText(IDCMD_CONTROLTARGET_SIMULATE, m_bIsR2 ? _T("") : _GETCS(s_csSIMU));
	SetDlgItemText(IDCMD_CONTROLTARGET_DIRRUN,   m_bIsR2 ? _T("") : _GETCS(s_csDIRRUN));
	SetDlgItemText(IDCMD_CONTROLTARGET_SIMUCUT,  m_bIsR2 ? _T("") : _strCutBoundText);
	SetDlgItemText(IDCMD_TUBECTRLTARGET_FINDMIDFOURSIDE, _GETCS(s_szCentering));
	SetDlgItemText(IDCMD_TUBECTRLTARGET_ADJUSTHORANDFINDMID, _GETCS(s_szLevel));
	if (!m_bIsR2)
	{
		SetDlgItemText(IDCMD_CONTROLTARGET_MACHSELECTED, _GETCS(s_csSELECTMACH));
	}

	// ùʻΧ---- DingQiang 2012-04-28
	if (m_bIsR2)
	{
		m_pwndSliderSetExF->SetCustomerSetSize();
		m_pwndSliderSetExF->SetBitmapChannel( IDB_BMP_CHANNELBACK_R2, IDB_BMP_CHANNELFORE_R2);
		m_pwndSliderSetExF->SetBitmapThumb( IDB_BMP_THUMBNORMAL_R2, IDB_BMP_THUMBPRESS_R2, IDB_BMP_THUMBHOVER_R2);
		m_pwndSliderSetExF->SetRange( 0, 120);
		m_pwndSliderSetExF->SetPos( 0 );
	}
	else
	{
		m_pwndSliderSetF->SetRange(0, 120);
		m_pwndSliderSetF->SetLineSize(5);
		m_pwndSliderSetF->SetPageSize(20);
	}

	// ʾ ----  2011-11-01
	if (m_bIsR2)
	{
		m_pwndSliderExF->SetRange(0, 120);
		m_pwndSliderExF->Init(5, 128, 286, IDB_BMP_ARCSLIDERBK_FEED_R2, RGB(63, 63, 63));
	}
	else
	{
		m_pwndSliderF->SetRange(0, 120);
	}

	// Բΰť뾶Ϊ17px ----  2012-02-21
	ASSERT(m_pwndBtnF);
	if (m_bIsR2)
	{
		m_pwndBtnF->SetShape(::CreateEllipticRgn(0, 0, 31, 31));
	}
	else
	{
		m_pwndBtnF->SetShape(::CreateEllipticRgn(0, 0, 34, 34));
	}

	// ֶļΪԲΰťֶΪԲиɣX-ΪX+Ϊ
	// Y-ΪY+Ϊ
	//   ļ뾶Ϊ34pxԲ⾶Ϊ80pxھΪ40pxΪ
	// 8px
	//   ˴ֵΪһԱȷȫͼ߽
	// иݳݡ                                        ----  2011-11-02
	ASSERT(m_pwndBtnCenter && m_pwndBtnXP && m_pwndBtnXN && m_pwndBtnYP && m_pwndBtnYN);

	if (m_bIsR2)
	{
		m_pwndBtnCenter->SetShape(::CreateEllipticRgn(-1, -1, 72, 72));

		CDC _dc;
		CDC* _pDC = GetDC();
		_dc.CreateCompatibleDC(_pDC);
		ReleaseDC(_pDC);
		_pDC = NULL;

		_dc.BeginPath();
		_dc.MoveTo(135, 21);
		_dc.SetArcDirection(AD_CLOCKWISE);
		_dc.ArcTo(-1, -1, 155, 155, 135, 21, 135, 131);
		_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
		_dc.ArcTo(43, 43, 111, 111, 107, 101, 106, 50);
		_dc.LineTo(135, 21);
		_dc.EndPath();
		CRgn _rgn;
		_rgn.CreateFromPath(&_dc);
		_rgn.OffsetRgn(-105, -13);
		m_pwndBtnXP->SetShape((HRGN)_rgn.Detach());

		_dc.BeginPath();
		_dc.MoveTo(50, 100);
		_dc.SetArcDirection(AD_CLOCKWISE);
		_dc.ArcTo(43, 43, 111, 111, 50, 100, 50, 51);
		_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
		_dc.ArcTo(-2, -2, 154, 154, 19, 21, 19, 131);
		_dc.LineTo(50, 100);
		_dc.EndPath();
		_rgn.CreateFromPath(&_dc);
		_rgn.OffsetRgn(7, -13);
		m_pwndBtnXN->SetShape((HRGN)_rgn.Detach());

		_dc.BeginPath();
		_dc.MoveTo(24, 20);
		_dc.SetArcDirection(AD_CLOCKWISE);
		_dc.ArcTo(-1, -1, 161, 161, 24, 20, 130, 20);
		_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
		_dc.ArcTo(41, 41, 119, 119, 102, 48, 52, 48);
		_dc.LineTo(24, 20);
		_dc.EndPath();
		_rgn.CreateFromPath(&_dc);
		_rgn.OffsetRgn(-24, 7);
		m_pwndBtnYP->SetShape((HRGN)_rgn.Detach());

		_dc.BeginPath();
		_dc.MoveTo(135, 139);
		_dc.SetArcDirection(AD_CLOCKWISE);
		_dc.ArcTo(-1, -1, 161, 161, 135, 139, 25, 139);
		_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
		_dc.ArcTo(41, 41, 119, 119, 25, 139, 135, 139);
		_dc.LineTo(135, 139);
		_dc.EndPath();
		_rgn.CreateFromPath(&_dc);
		_rgn.OffsetRgn(-26, -111);
		m_pwndBtnYN->SetShape((HRGN)_rgn.Detach());
	}
	else
	{
		m_pwndBtnCenter->SetShape(::CreateEllipticRgn(-1, -1, 70, 70));

		CDC _dc;
		CDC* _pDC = GetDC();
		_dc.CreateCompatibleDC(_pDC);
		ReleaseDC(_pDC);
		_pDC = NULL;

		_dc.BeginPath();
		_dc.MoveTo(139, 25);
		_dc.SetArcDirection(AD_CLOCKWISE);
		_dc.ArcTo(-1, -1, 161, 161, 139, 25, 139, 135);
		_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
		_dc.ArcTo(41, 41, 119, 119, 139, 135, 139, 25);
		_dc.LineTo(139, 25);
		_dc.EndPath();
		CRgn _rgn;
		_rgn.CreateFromPath(&_dc);
		_rgn.OffsetRgn(-111, -26);
		m_pwndBtnXP->SetShape((HRGN)_rgn.Detach());

		_dc.BeginPath();
		_dc.MoveTo(21, 135);
		_dc.SetArcDirection(AD_CLOCKWISE);
		_dc.ArcTo(41, 41, 119, 119, 21, 135, 21, 25);
		_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
		_dc.ArcTo(-1, -1, 161, 161, 21, 25, 21, 135);
		_dc.LineTo(21, 135);
		_dc.EndPath();
		_rgn.CreateFromPath(&_dc);
		_rgn.OffsetRgn(0, -26);
		m_pwndBtnXN->SetShape((HRGN)_rgn.Detach());

		_dc.BeginPath();
		_dc.MoveTo(25, 21);
		_dc.SetArcDirection(AD_CLOCKWISE);
		_dc.ArcTo(-1, -1, 161, 161, 25, 21, 135, 21);
		_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
		_dc.ArcTo(41, 41, 119, 119, 135, 21, 25, 21);
		_dc.LineTo(25, 21);
		_dc.EndPath();
		_rgn.CreateFromPath(&_dc);
		_rgn.OffsetRgn(-26, 0);
		m_pwndBtnYP->SetShape((HRGN)_rgn.Detach());

		_dc.BeginPath();
		_dc.MoveTo(135, 139);
		_dc.SetArcDirection(AD_CLOCKWISE);
		_dc.ArcTo(-1, -1, 161, 161, 135, 139, 25, 139);
		_dc.SetArcDirection(AD_COUNTERCLOCKWISE);
		_dc.ArcTo(41, 41, 119, 119, 25, 139, 135, 139);
		_dc.LineTo(135, 139);
		_dc.EndPath();
		_rgn.CreateFromPath(&_dc);
		_rgn.OffsetRgn(-26, -111);
		m_pwndBtnYN->SetShape((HRGN)_rgn.Detach());
	}
	

	m_pSetSpeedDlg = new CSetSpeedDlg(this);
	((CSetSpeedDlg*)m_pSetSpeedDlg)->Create(this);

	m_pwndStcCoor->ModifyStyle(0, SS_NOTIFY);
	m_pwndStcValueX->ModifyStyle(0, SS_NOTIFY);
	m_pwndStcValueY->ModifyStyle(0, SS_NOTIFY);
	m_pwndStcValueZ->ModifyStyle(0, SS_NOTIFY);
	//m_pwndStcValueW->ModifyStyle(0, SS_NOTIFY);

	// һUpdateΪֹһ⣬ʱĽʾ
	// Сһ²ųNcStudio⣬NcEditorû⡣
	// ûвԭֻǾ鷢UpdateһξͺˣǾôɡԺ
	// ޸ġ                          ----  2012-05-02
	Update();

	bool _bEnableZ = IsEnableZUpDown();
	m_pwndBtnZP->EnableWindow(_bEnableZ ? TRUE : FALSE);
	m_pwndBtnZN->EnableWindow(_bEnableZ ? TRUE : FALSE);
	m_pwndBtnZP->ShowWindow(_bEnableZ ? TRUE : FALSE);
	m_pwndBtnZN->ShowWindow(_bEnableZ ? TRUE : FALSE);
	m_pwndStcTitleZ->EnableWindow(_bEnableZ ? TRUE : FALSE);
	m_pwndStcValueZ->EnableWindow(_bEnableZ ? TRUE : FALSE);
	m_pwndStcTitleZ->ShowWindow(_bEnableZ ? TRUE : FALSE);
	m_pwndStcValueZ->ShowWindow(_bEnableZ ? TRUE : FALSE);

	// ҪWҲļѡػ߲
	bool _bEnableW = IsEnableWUpDown();
	if (_bEnableW)
	{
		m_pwndBtnWP->EnableWindow(_bEnableW ? TRUE : FALSE);
		m_pwndBtnWN->EnableWindow(_bEnableW ? TRUE : FALSE);
		m_pwndBtnWP->ShowWindow(_bEnableW ? TRUE : FALSE);
		m_pwndBtnWN->ShowWindow(_bEnableW ? TRUE : FALSE);
		m_pwndStcTitleW->EnableWindow(_bEnableW ? TRUE : FALSE); 
		m_pwndStcValueW->EnableWindow(_bEnableW ? TRUE : FALSE);
		m_pwndStcTitleW->ShowWindow(_bEnableW ? TRUE : FALSE);
		m_pwndStcValueW->ShowWindow(_bEnableW ? TRUE : FALSE);
	}

	// ǵѡťʼ ---- ߿ϼ 2017-03-15
	CString _strCurIndex;
	_strCurIndex.Format("%u", m_nCurIndex);

	// ǵѡ˵
	m_pMenuMark->CreatePopupMenu();
	m_pMenuMark->AppendMenu(MF_STRING, CTRLID_BTN_MARKPOINT1, _GETCS(s_szMUNU_MARKPOINT1));
	m_pMenuMark->AppendMenu(MF_STRING, CTRLID_BTN_MARKPOINT2, _GETCS(s_szMUNU_MARKPOINT2));
	m_pMenuMark->AppendMenu(MF_STRING, CTRLID_BTN_MARKPOINT3, _GETCS(s_szMUNU_MARKPOINT3));
	m_pMenuMark->AppendMenu(MF_STRING, CTRLID_BTN_MARKPOINT4, _GETCS(s_szMUNU_MARKPOINT4));
	m_pMenuMark->AppendMenu(MF_STRING, CTRLID_BTN_MARKPOINT5, _GETCS(s_szMUNU_MARKPOINT5));
	m_pMenuMark->AppendMenu(MF_STRING, CTRLID_BTN_MARKPOINT6, _GETCS(s_szMUNU_MARKPOINT6));
	m_pMenuMark->AppendMenu(MF_STRING, CTRLID_BTN_MARKPOINT7, _GETCS(s_szMUNU_MARKPOINT7));
	m_pMenuMark->AppendMenu(MF_STRING, CTRLID_BTN_MARKPOINT8, _GETCS(s_szMUNU_MARKPOINT8));

	// ӹѡ˵
	m_pMenuMarkPoint->CreatePopupMenu();
	m_pMenuMarkPoint->AppendMenu(MF_STRING, CTRLID_BTN_NOMOVE, _GETCS(s_csNOMOTION));
	m_pMenuMarkPoint->AppendMenu(MF_STRING, CTRLID_BTN_BACKFIXPOS, _GETCS(s_csBACKFIXPOS));
	m_pMenuMarkPoint->AppendMenu(MF_STRING, CTRLID_BTN_BACKWORKORG, _GETCS(s_csBACKWORKORG));
	m_pMenuMarkPoint->AppendMenu(MF_STRING, CTRLID_BTN_BACKMAKPOINT1, _GETCS(s_csBACK1));
	m_pMenuMarkPoint->AppendMenu(MF_STRING, CTRLID_BTN_BACKMAKPOINT2, _GETCS(s_csBACK2));
	m_pMenuMarkPoint->AppendMenu(MF_STRING, CTRLID_BTN_BACKMAKPOINT3, _GETCS(s_csBACK3));
	m_pMenuMarkPoint->AppendMenu(MF_STRING, CTRLID_BTN_BACKMAKPOINT4, _GETCS(s_csBACK4));
	m_pMenuMarkPoint->AppendMenu(MF_STRING, CTRLID_BTN_BACKMAKPOINT5, _GETCS(s_csBACK5));
	m_pMenuMarkPoint->AppendMenu(MF_STRING, CTRLID_BTN_BACKMAKPOINT6, _GETCS(s_csBACK6));
	m_pMenuMarkPoint->AppendMenu(MF_STRING, CTRLID_BTN_BACKMAKPOINT7, _GETCS(s_csBACK7));
	m_pMenuMarkPoint->AppendMenu(MF_STRING, CTRLID_BTN_BACKMAKPOINT8, _GETCS(s_csBACK8));

	// ѡ˵
	m_pMenuAir->CreatePopupMenu();
	m_pMenuAir->AppendMenu(MF_STRING, CTRLID_BTN_SELAIR0, _GETCS(s_csAIR));
	m_pMenuAir->AppendMenu(MF_STRING, CTRLID_BTN_SELN2, _GETCS(s_csN2));
	m_pMenuAir->AppendMenu(MF_STRING, CTRLID_BTN_SEL02, _GETCS(s_csO2));

	// ʾʹbuttonϲʾ ---- ߿ϼ 2017-03-15
	CString _strShowIndex = _strCurIndex + '\n';
	SetDlgItemText(CTRLID_BTN_SELMARKPOINT, _strShowIndex);

	// 
	UpdateAir();

	// ¼ӹΪ
	UpdateEndAction();

	SetMachineCtrlTips();
	return TRUE;
}

void CMachineControlDlg::SetMachineCtrlTips()
{
	m_MachineCtrlTips.Create(this);
	m_MachineCtrlTips.Activate(TRUE);
	m_MachineCtrlTips.SetTipTextColor(RGB(0, 0, 0));
	m_MachineCtrlTips.SetDelayTime(1000);

	m_MachineCtrlTips.AddTool(GetDlgItem(IDCMD_CONTROLTARGET_CLEARW), _GETCS(s_csTipSETWORKORG));
	m_MachineCtrlTips.AddTool(GetDlgItem(IDCMD_CONTROLTARGET_BACKW), _GETCS(s_csTipMOVETOWORKORIGIN));
	m_MachineCtrlTips.AddTool(GetDlgItem(IDCMD_CONTROLTARGET_START), _GETCS(s_csTipSTART));
	if (!m_bIsTube)
	{
		m_MachineCtrlTips.AddTool(GetDlgItem(IDCMD_CONTROLTARGET_PAUSE), _GETCS(s_csTipPAUSE));
	}
	m_MachineCtrlTips.AddTool(GetDlgItem(IDCMD_CONTROLTARGET_STOP), _GETCS(s_csTipSTOP));
	m_MachineCtrlTips.AddTool(GetDlgItem(IDCMD_CONTROLTARGET_BREAKPOINTRESUME), _GETCS(s_csTipRESUME));
	m_MachineCtrlTips.AddTool(GetDlgItem(CTRLID_BTN_GOBACKWARD), _GETCS(s_csTipGoBackward));
	m_MachineCtrlTips.AddTool(GetDlgItem(CTRLID_BTN_GOFORWARD), _GETCS(s_csTipGoForward));
	CWnd* _pwndBtn = GetDlgItem(IDCMD_FOLLOWCTRLTARGET_SAMPLE);
	if (_pwndBtn)
		m_MachineCtrlTips.AddTool(_pwndBtn, _GETCS(s_csTipFollowSample));
	_pwndBtn = GetDlgItem(IDCMD_CONTROLTARGET_BACKR);
	if (_pwndBtn)
		m_MachineCtrlTips.AddTool(_pwndBtn, _GETCS(s_csTipBackAll));
}

bool CMachineControlDlg::IsEnableZUpDown()
{
	CString _strEnableZ = NceGetPrivateProfileString(_T("ControlTarget"), _T("EnableZ"));

	if ("1" == _strEnableZ)
	{
		return true;
	}
	else
	{
		return false;
	}
}

bool CMachineControlDlg::IsEnableWUpDown()
{
	CString _strEnableW = NceGetPrivateProfileString(_T("ControlTarget"), _T("EnableW"));

	if ("1" == _strEnableW)
	{
		return true;
	}
	else
	{
		return false;
	}
}

BOOL CMachineControlDlg::PreTranslateMessage(MSG* pMsg_)
{
	// Ӵ˾ڻʾʾ ---- ׿ 2012.05.17
	m_MachineCtrlTips.RelayEvent(pMsg_);

	// Let go of Keyboard Message => ˴ôмĿģһEnterEsc
	// OnOKOnCancelرմڣǷֹڴʱϵĿݼ
	// Ρ                                            ----  2012-04-08
	if (WM_KEYFIRST <= pMsg_->message && pMsg_->message <= WM_KEYLAST)
	{
		return FALSE;
	}

	if (pMsg_->message == WM_LBUTTONDOWN)
	{
		UINT _nCtrlID = ::GetDlgCtrlID(pMsg_->hwnd);
		if (_nCtrlID == CTRLID_BTN_GODISTANCE)
		{
			if (OnDistanceLButtonDown(pMsg_->pt))
			{
				// returnĻDialogӦϢʱnewı༭
				// ӦOnKillFocus±༭һʧ ---- DingQiang 2012-07-19
				return TRUE;
			}
		}
	}

	if (pMsg_->message == WM_MOUSEMOVE)
	{
		UINT _nCtrlID = ::GetDlgCtrlID(pMsg_->hwnd);
		if (_nCtrlID == CTRLID_STC_XVALUE || _nCtrlID == CTRLID_STC_YVALUE
			|| _nCtrlID == CTRLID_STC_ZVALUE || _nCtrlID == CTRLID_STC_COOR)
		{
			m_pwndChangCoor->SetMouseOn();
		}
		else
			m_pwndChangCoor->SetMouseLeave();
	}

	return __super::PreTranslateMessage(pMsg_);
}

// ֶģʽ ---- С 2013-11-07
void CMachineControlDlg::OnSetManuMode()
{
	DWORD _nBegin = GetTickCount();
	while(true)
	{
		MSG _msg;
		if (::PeekMessage(&_msg, NULL, NULL, NULL, PM_REMOVE))
		{
			::TranslateMessage(&_msg);
			::DispatchMessage(&_msg);

			if (_msg.message == WM_LBUTTONDBLCLK)
			{
				return;
			}
		}

		if (GetTickCount() - _nBegin > 200)
		{
			break;
		}
	}

	static int _s_nManuMode;
	int _nManuMode = _s_nManuMode % 3;

	CManualTarget* _pManualTarget = GetManualTarget();
	ASSERT(_pManualTarget);
	if (_nManuMode == 0)
	{
		_pManualTarget->SetManuMode(0);
		_pManualTarget->SetJogState(false);
	}
	else if (_nManuMode == 1)
	{
		_pManualTarget->SetManuMode(0);
		_pManualTarget->SetJogState(true);
	}
	else if (_nManuMode == 2)
	{
		_pManualTarget->SetManuMode(1);
	}

	_s_nManuMode ++;
}

void CMachineControlDlg::UpdateMachCoor()
{
	// ȸ± ----  2012-07-05
	CString _strNewTitle = m_nCoorMode == 0x00 ? _GETCS(s_csWORKPIECECOORDINATE) : _GETCS(s_csMACHINECOORDINATE);
	CString _strTitle;
	m_pwndStcCoor->GetWindowText(_strTitle);
	if (_strNewTitle != _strTitle)
	{
		m_pwndStcCoor->SetWindowText(_strNewTitle);
	}

	CParamManager* _pParamManager = GetParamManager();
	if (!_pParamManager)
	{
		return;
	}

	// ؼӦؼĲʶһṹ---- DingQiang 2012-01-12
	const struct MachItem
	{
		DWORD nCoorMode;
		CAgileLabel* pwndStcValue;
		CString strIdentifier;
	} _s_MachItems[] =
	{
		{ 0x00, m_pwndStcValueX, "State_Axis0_WorkcoorPos" },
		{ 0x00, m_pwndStcValueY, "State_Axis1_WorkcoorPos" },
		{ 0x00, m_pwndStcValueZ, "State_Axis2_WorkcoorPos" },
		{ 0x00, m_pwndStcValueW, "State_Axis3_WorkcoorPos" },
		{ 0x01, m_pwndStcValueX, "Dyn_Axis0_Pos"},
		{ 0x01, m_pwndStcValueY, "Dyn_Axis1_Pos"},
		{ 0x01, m_pwndStcValueZ, "Dyn_Axis2_Pos"},
		{ 0x01, m_pwndStcValueW, "Dyn_Axis3_Pos"},
	};

	for(int _i = 0; _i < _countof(_s_MachItems); _i++)
	{
		const MachItem& _item = _s_MachItems[_i];
		if (_item.nCoorMode != m_nCoorMode
			|| !_item.pwndStcValue
			|| !_item.pwndStcValue->IsWindowVisible())
		{
			continue;
		}

		ParameterValue _PV;
		if (!_pParamManager->GetParameterValue(_item.strIdentifier, &_PV) || _PV.nType != ParameterValue::VT_DOUBLE)
		{
			ASSERT(FALSE);
			continue;
		}

		CString _strMachCoor;
		_strMachCoor.Format("%.3f", _PV.dValue);
		if (_strMachCoor == "-0.000")
		{
			_strMachCoor = "0.000";
		}

		// ǰº򲻸 ---- DingQiang 2012-01-12
		CString _strBeforeUpdate;
		_item.pwndStcValue->GetWindowText(_strBeforeUpdate);
		if (_strMachCoor != _strBeforeUpdate)
		{
			_s_MachItems[_i].pwndStcValue->SetWindowText(_strMachCoor);
		}
	}
}
// ػеԭ־÷ʽ£
// [ControlTarget]
// ShowAllBKMark=1
// BKMarkAttachAxis=0,1,2
void CMachineControlDlg::UpdateBRFlag()
{
	// ԭ־ؼӦؼĲԼһṹ壬Ժչ-----2015-02-08
	const struct AxisItems
	{
		CAgileImageLabel* pwndStcBR;
		CString strIdentifier;
		CString strIndex;
	} _s_AxisItems[] =
	{
		{ m_pwndStcBRX, "State_Axis0_IsReferenced", "0" },
		{ m_pwndStcBRY, "State_Axis1_IsReferenced", "1" },
		{ m_pwndStcBRZ, "State_Axis2_IsReferenced", "2" },
		{ m_pwndStcBRW, "State_Axis3_IsReferenced", "3" },
	};

	CParamManager* _pParamManager = GetParamManager();
	if(!_pParamManager)
		return;

	//ʾĻػеԭ־ֱʾĻػеԭ־----2015-02-08
	if (m_strShowAllBKMark == _T("1"))
	{
		for(int _i = 0; _i < _countof(_s_AxisItems); _i++)
		{
			const AxisItems& _item = _s_AxisItems[_i];
			ParameterValue _PV;
			memset(&_PV, 0, sizeof(ParameterValue));
			if (!_pParamManager->GetParameterValue(_item.strIdentifier, &_PV) || _PV.nType != ParameterValue::VT_BOOL)
			{
				continue;
			}
			_item.pwndStcBR->ShowWindow(_PV.bValue ? SW_SHOW : SW_HIDE);
		}
	}
	// ʾĻػеԭ־ݹֻʾһػеԭ־----2015-02-08
	else if(m_strShowAllBKMark == _T("0"))
	{
		bool _bIsRef = m_strVecAxis.empty()? false : true;
		for (std::vector<CString>::iterator _it = m_strVecAxis.begin(); _it != m_strVecAxis.end();_it++)
		{
			int _nCount = 0;
			CString _strAxis = *_it;
			for(int _j = 0; _j < _countof(_s_AxisItems); _j++)
			{
				const AxisItems& _item = _s_AxisItems[_j];
				ParameterValue _PV;
				memset(&_PV, 0, sizeof(ParameterValue));
				if (!_pParamManager->GetParameterValue(_item.strIdentifier, &_PV) || _PV.nType != ParameterValue::VT_BOOL)
				{
					ASSERT(FALSE);
					continue;
				}
				if (_item.strIndex == _strAxis)
				{
					_bIsRef &= _PV.bValue;
					break;
				}
				else
				{
					_nCount++;
					continue;
				}
			}
			//ûƥ
			if (_nCount == _countof(_s_AxisItems))
			{
				_bIsRef = false;
			}
		}
		m_pwndStcBR->ShowWindow(_bIsRef ? SW_SHOW : SW_HIDE);
	}
}


void CMachineControlDlg::OnDirectionBtnPushed(UINT nID_)
{
	ASSERT(nID_ >= CTRLID_BTN_XP && nID_ <= CTRLID_BTN_WN);

	// ֶťģɿݼCManualTarget
	C_ASSERT(CTRLID_BTN_XP == CTRLID_BTN_XP + 0
		&& CTRLID_BTN_XN == CTRLID_BTN_XP + 1
		&& CTRLID_BTN_YP == CTRLID_BTN_XP + 2
		&& CTRLID_BTN_YN == CTRLID_BTN_XP + 3
		&& CTRLID_BTN_ZP == CTRLID_BTN_XP + 4
		&& CTRLID_BTN_ZN == CTRLID_BTN_XP + 5
		&& CTRLID_BTN_WP == CTRLID_BTN_XP + 6
		&& CTRLID_BTN_WN == CTRLID_BTN_XP + 7);
	static const UINT _s_nKeys[] =
	{
		VK_NUMPAD6,
		VK_NUMPAD4,
		VK_NUMPAD8,
		VK_NUMPAD2,
		VK_NUMPAD9,
		VK_NUMPAD3,
		VK_NUMPAD7,
		VK_NUMPAD1,
	};

	// ûWᣬWݼ ---- η 2016-12-30
	bool _bEnableW = IsEnableWUpDown();
	if (!_bEnableW && (nID_ == CTRLID_BTN_WP || nID_ == CTRLID_BTN_WN))
	{
		return;
	}

	MSG _msg = { NULL, WM_KEYDOWN, WPARAM(_s_nKeys[nID_ - CTRLID_BTN_XP]), LPARAM(1) };
	CManualTarget* _pManualTarget = GetManualTarget();
	ASSERT(_pManualTarget);
	_pManualTarget->OnKeyMessage(&_msg);
}

void CMachineControlDlg::OnDirectionBtnUnpushed(UINT nID_)
{
	ASSERT(nID_ >= CTRLID_BTN_XP && nID_ <= CTRLID_BTN_WN);

	// ֶťģɿݼCManualTarget
	C_ASSERT(CTRLID_BTN_XP == CTRLID_BTN_XP + 0
		&& CTRLID_BTN_XN == CTRLID_BTN_XP + 1
		&& CTRLID_BTN_YP == CTRLID_BTN_XP + 2
		&& CTRLID_BTN_YN == CTRLID_BTN_XP + 3
		&& CTRLID_BTN_ZP == CTRLID_BTN_XP + 4
		&& CTRLID_BTN_ZN == CTRLID_BTN_XP + 5
		&& CTRLID_BTN_WP == CTRLID_BTN_XP + 6
		&& CTRLID_BTN_WN == CTRLID_BTN_XP + 7);
	static const UINT _s_nKeys[] =
	{
		VK_NUMPAD6,
		VK_NUMPAD4,
		VK_NUMPAD8,
		VK_NUMPAD2,
		VK_NUMPAD9,
		VK_NUMPAD3,
		VK_NUMPAD7,
		VK_NUMPAD1,
	};

	// ûWᣬWݼ ---- η 2016-12-30
	bool _bEnableW = IsEnableWUpDown();
	if (!_bEnableW && nID_ >= CTRLID_BTN_WP)
	{
		return;
	}

	MSG _msg = { NULL, WM_KEYUP, WPARAM(_s_nKeys[nID_ - CTRLID_BTN_XP]), LPARAM(1) };
	CManualTarget* _pManualTarget = GetManualTarget();
	ASSERT(_pManualTarget);
	_pManualTarget->OnKeyMessage(&_msg);
}

void CMachineControlDlg::OnGFOBBtnPushed(UINT nID_)
{
	ASSERT(nID_ >= CTRLID_BTN_GOFORWARD && nID_ <= CTRLID_BTN_GOBACKWARD);

	CControlTarget* _pControlTarget = GetControlTarget();
	ASSERT(_pControlTarget);
	if (_pControlTarget->GetGFOBMode() != 0x00)
	{
		return;
	}

	C_ASSERT(CTRLID_BTN_GOFORWARD == CTRLID_BTN_GOFORWARD + 0
		&& CTRLID_BTN_GOBACKWARD == CTRLID_BTN_GOFORWARD + 1);
	static const UINT _s_nCmdIDs[] =
	{
		IDCMD_CONTROLTARGET_JOGFORWARD,
		IDCMD_CONTROLTARGET_JOGBACKWARD,
	};
	AfxGetMainWnd()->SendMessage(WM_COMMAND, _s_nCmdIDs[nID_ - CTRLID_BTN_GOFORWARD], 0);
}

void CMachineControlDlg::OnGFOBBtnUnpushed(UINT nID_)
{
	ASSERT(nID_ >= CTRLID_BTN_GOFORWARD && nID_ <= CTRLID_BTN_GOBACKWARD);

	CControlTarget* _pControlTarget = GetControlTarget();
	ASSERT(_pControlTarget);
	if (_pControlTarget->GetGFOBMode() == 0x00)
	{
		AfxGetMainWnd()->SendMessage(WM_COMMAND, IDCMD_CONTROLTARGET_STOP, 0);
		return;
	}

	C_ASSERT(CTRLID_BTN_GOFORWARD == CTRLID_BTN_GOFORWARD + 0
		&& CTRLID_BTN_GOBACKWARD == CTRLID_BTN_GOFORWARD + 1);
	static const UINT _s_nCmdIDs[] =
	{
		IDCMD_CONTROLTARGET_INCFORWARD,
		IDCMD_CONTROLTARGET_INCBACKWARD,
	};
	AfxGetMainWnd()->SendMessage(WM_COMMAND, _s_nCmdIDs[nID_ - CTRLID_BTN_GOFORWARD], 0);
}

LRESULT CMachineControlDlg::OnIdleUpdateCmdUI(WPARAM wParam_, LPARAM lParam_)
{
	static const struct ManualBtnItem
	{
		CButton* pBtnManual;
		DWORD nMask;
	} _s_cManualBtnItems[] = 
	{
		{m_pwndBtnYN,		0x00000001},
		{m_pwndBtnXN,		0x00000002},
		{m_pwndBtnXP,		0x00000004},
		{m_pwndBtnYP,		0x00000008},
		{m_pwndBtnZP,		0x00000010},
		{m_pwndBtnZN,		0x00000020},
		{m_pwndBtnCenter,	0x00000040},
		{m_pwndBtnWP,		0x00000080},
		{m_pwndBtnWN,		0x00000100},
	};

	CManualTarget* _pManualTarget = GetManualTarget();
	if (!_pManualTarget)
	{
		return 0;
	}
	DWORD _ManualKeyState = _pManualTarget->GetManuKeyState();
	
	// Ƿܣֻܼǰģܼ2Wİť ---- η 2016-12-27
	int _nBtnItems = m_bIsTube ? _countof(_s_cManualBtnItems) : _countof(_s_cManualBtnItems) - 2;
	for (int _i = 0; _i < _nBtnItems; _i++)
	{
		if (_ManualKeyState & _s_cManualBtnItems[_i].nMask)
		{
			_s_cManualBtnItems[_i].pBtnManual->SetCheck(TRUE);
		}
		else
			_s_cManualBtnItems[_i].pBtnManual->SetCheck(FALSE);
	}


	// ʵǰ״̬ͰťF3F4£ֻҪһ״̬Ϊ漴ť ---- DingQiang 2014-10-11
	static const struct GOBBtnItem
	{
		UINT nID;
		DWORD nKeyboardMask;
		DWORD nRunningStateMask;
	} _s_cGOBBtnItems[] = 
	{
		{CTRLID_BTN_GOBACKWARD, 0x00000001, 0x00000100},
		{CTRLID_BTN_GOFORWARD, 0x00000002, 0x00000080},
	};

	CControlTarget* _pControlTarget = GetControlTarget();
	CStateManager* _pStateManager = GetStateManager();
	if (!_pControlTarget || !_pStateManager)
	{
		return 0;
	}

	DWORD _GOBKeyState = _pControlTarget->GetGOBKeyState();
	DWORD _nRunningState = 0;
	_pStateManager->GetRunningState(&_nRunningState);

	for (int _i = 0; _i < _countof(_s_cGOBBtnItems); _i++)
	{
		BOOL _bCheck = _nRunningState & _s_cGOBBtnItems[_i].nRunningStateMask;
		_bCheck |= _GOBKeyState & _s_cGOBBtnItems[_i].nKeyboardMask;

		((CButton*)GetDlgItem(_s_cGOBBtnItems[_i].nID))->SetCheck(_bCheck);
	}

	CWnd* _pwndSelectMach_Check = GetDlgItem(CTRLID_CHX_SELECTMACH);
	CWnd* _pwndSelectMach_Static = GetDlgItem(CTRLID_STC_SELECTMACH);
	if (_pwndSelectMach_Check
		&& _pwndSelectMach_Static
		&& _pwndSelectMach_Check->IsWindowVisible()
		&& _pwndSelectMach_Static->IsWindowVisible())
	{
		CStateManager::State _nState = CStateManager::Idle;
		BOOL _bEnable = _pStateManager->GetState(&_nState) && _nState == CStateManager::Idle;
		CButton* _pwndChx = (CButton*)_pwndSelectMach_Check;
		if (_pwndChx->IsWindowEnabled() != _bEnable)
			_pwndChx->EnableWindow(_bEnable);
		if (_pwndSelectMach_Static->IsWindowEnabled() != _bEnable)
			_pwndSelectMach_Static->EnableWindow(_bEnable);

		// ͬ˵ѡ ---- ƺ 2016-09-18
		if (_pStateManager->IsSelectedMach() != (_pwndChx->GetCheck() == BST_CHECKED))
		{
			_pwndChx->SetCheck(_pStateManager->IsSelectedMach() ? BST_CHECKED : BST_UNCHECKED);
		}
	}

	return 1;
}

void CMachineControlDlg::OnHScroll(UINT nSBCode_, UINT nPos_, CScrollBar* pScrollBar_)
{
	// ݻֹͣʱλõֵý ---- DingQiang 2012-02-07
	if (pScrollBar_ && (void*)pScrollBar_ == (void*)m_pwndSliderSetF)
	{
		// º򻬶20Ϊûλ ----  2013.07.26
		int _nIndex = m_pwndSliderSetF->GetPos();
		switch(nSBCode_)
		{
		case TB_PAGEDOWN:
			{
				m_pwndSliderSetF->SetPos(20 * (_nIndex / 20));
			}
			break;
		case TB_PAGEUP:
			{
				m_pwndSliderSetF->SetPos(20* ((_nIndex + 19) / 20));
			}
			break;
		default:
			{
				m_pwndSliderSetF->SetPos(_nIndex);
			}
		}

		_nIndex = m_pwndSliderSetF->GetPos();
		int _nFrp = 100;
		_UpdateFValue(_nIndex, &_nFrp);

		// ΪȫƣͨCParamManager޸Ĳȫвڴ˴ܲ
		// ǱģȫýԵÿβ ˣ˴
		// ͨһCommandƹȫ顣              ----  2012-08-17
		if (CCommandManager* _pCommandManager = GetCommandManager())
		{
			const CStringA _c_strSetFrpCommand = "SetFrp";
			CStringA _strFrp;
			_strFrp.Format("%d", _nFrp);
			_pCommandManager->Execute(_c_strSetFrpCommand, _strFrp, "LPCSTR");
		}
		if (m_bSliderCtrlG00)
		{
			if (CCommandManager* _pCommandManager = GetCommandManager())
			{
				const CStringA _c_strSetG00FrpCommand = "SetG00Frp";
				CStringA _strFrp;
				_strFrp.Format("%d", _nFrp);
				_pCommandManager->Execute(_c_strSetG00FrpCommand, _strFrp, "LPCSTR");
			}
		}

		UpdateF();

		// ˢ»β ----  2013.07.26
		m_pwndSliderSetF->Invalidate(FALSE);
	}
}

// ½ʵʾֵ ---- DingQiang 2012-02-07
void CMachineControlDlg::UpdateF()
{
	_BuildFIVMap();

	// ParamManagerжʵĵǰֵ趨ʻϵ
	// ֵΪ׼                                          ----  2012-02-18
	ASSERT(m_pwndSliderSetF || m_pwndSliderSetExF);
	int _nIndex = m_bIsR2 ? m_pwndSliderSetExF->GetPos() : m_pwndSliderSetF->GetPos();
	int _nFrp = 100;
	_UpdateFValue(_nIndex, &_nFrp);
	if (CParamManager* _pParamManager = GetParamManager())
	{
		const CStringA _c_strFrpIdentifier = "SpeedGxx_Frp";
		ParameterValue _FrpParamValue;
		if (_pParamManager->GetParameterValue(_c_strFrpIdentifier, &_FrpParamValue)
			&& _FrpParamValue.nType == ParameterValue::VT_INT)
		{
			_nFrp = _FrpParamValue.iValue;
			_UpdateFIndex(&_nIndex, _nFrp);
		}
	}

	// º򻬶
	if (m_bIsR2)
	{
		// º򻬶
		ASSERT(m_pwndSliderSetExF);
		int _nCurPos_SliderSetF = m_pwndSliderSetExF->GetPos();
		int _nNewPos_SliderSetF = min(_nFrp, m_pwndSliderSetExF->GetRangeMax());
		if (_nNewPos_SliderSetF != _nCurPos_SliderSetF)
		{
			m_pwndSliderSetExF->SetPos(_nNewPos_SliderSetF);
			m_pwndSliderSetExF->Invalidate();
		}

	}
	else
	{
		ASSERT(m_pwndSliderSetF);
		int _nCurPos_SliderSetF = m_pwndSliderSetF->GetPos();
		int _nNewPos_SliderSetF = _nIndex;
		if (_nNewPos_SliderSetF != _nCurPos_SliderSetF)
		{
			m_pwndSliderSetF->SetPos(_nNewPos_SliderSetF);
			m_pwndSliderSetF->Invalidate();
		}
	}

	// »ťʾ
	if (m_bIsR2)
	{
		ASSERT(m_pwndSliderExF);
		int _nCurPos_SliderF = m_pwndSliderExF->GetPos();
		int _nNewPos_SliderF = _nIndex;

		if (_nNewPos_SliderF != _nCurPos_SliderF)
		{
			m_pwndSliderExF->SetPos(_nNewPos_SliderF);
			m_pwndSliderExF->SetSelection(m_pwndSliderExF->GetRangeMin(), _nNewPos_SliderF);
		}
	}
	else
	{
		ASSERT(m_pwndSliderF);
		int _nCurPos_SliderF = m_pwndSliderF->GetPos();
		int _nNewPos_SliderF = _nIndex;

		if (_nNewPos_SliderF != _nCurPos_SliderF)
		{
			m_pwndSliderF->SetPos(_nNewPos_SliderF);
			m_pwndSliderF->SetSelection(m_pwndSliderF->GetRangeMin(), _nNewPos_SliderF);
		}
	}

	// ıʾ
	ASSERT(m_pwndStcF);
	CString _strCurValue_StcF;	// ǰؼڵַ   ---- DingQiang 2012-02-07
	CString _strNewValue_StcF;	// Ҫؼڵַ ---- DingQiang 2012-02-07
	m_pwndStcF->GetWindowText(_strCurValue_StcF);
	_strNewValue_StcF.Format(_T("%d%s"), _nFrp, "%");
	if (_strNewValue_StcF != _strCurValue_StcF)
	{
		m_pwndStcF->SetWindowText(_strNewValue_StcF);
	}
}

void CMachineControlDlg::UpdateManuCenter()
{
	ASSERT(m_pwndBtnCenter);

	// ǰʾĴ ----  2012-02-21
	CString _strOldText;
	m_pwndBtnCenter->GetWindowText(_strOldText);

	// ҪʾĴ ----  2012-02-21
	CString _strNewText;
	CManualTarget* _pManualTarget = GetManualTarget();
	ASSERT(_pManualTarget);
	if (_pManualTarget->IsJogMode() && _pManualTarget->GetJogState())
	{
		_strNewText = _GETCS(s_csRapidJog);
	}
	else if (_pManualTarget->IsJogMode() && !_pManualTarget->GetJogState())
	{
		_strNewText = _GETCS(s_csSlowJog);
	}
	else
	{
		double _nIncDistance = _pManualTarget->GetIncDistance();

		if (_nIncDistance >= 1000)
		{
			_strNewText.Format(_T("%.2f"), _nIncDistance);
		}
		else if (_nIncDistance >= 100)
		{
			_strNewText.Format(_T("%.3f"), _nIncDistance);
		}
		else if (_nIncDistance >= 10)
		{
			_strNewText.Format(_T("%.4f"), _nIncDistance);
		}
		else if (_nIncDistance >= 0)
		{
			_strNewText.Format(_T("%.5f"), _nIncDistance);
		}
		_strNewText.TrimRight(_T('0'));
		_strNewText.TrimRight(_T('.'));
		_strNewText += "\nmm";
	}

	//  ----  2012-02-21
	if (_strNewText != _strOldText)
	{
		m_pwndBtnCenter->SetWindowText(_strNewText);
	}
}

void CMachineControlDlg::UpdateGFOBInfo()
{
	// 㶯ʱʾ㶯ʾָľ ----  2012-03-10
	CControlTarget* _pControlTarget = GetControlTarget();
	ASSERT(_pControlTarget);
	CString _strGFOBDistance;
	if (_pControlTarget->GetGFOBMode() == 0x01)
	{
		double _nGFOBDistance = _pControlTarget->GetGFOBDistance();
		ASSERT(_nGFOBDistance >= 0);
		_strGFOBDistance.Format(_T("%f"), _nGFOBDistance);
		_strGFOBDistance.TrimRight(_T('0'));
		_strGFOBDistance.TrimRight(_T('.'));
		_strGFOBDistance.AppendFormat("mm");
	}
	else
	{
		ASSERT(_pControlTarget->GetGFOBMode() == 0x00);
		_strGFOBDistance.Format("%s", _GETCS(s_csJOG));
	}

	// Ը ----  2012-03-10
	CString _strOldInfo;
	m_pwndStcGoDistance->GetWindowText(_strOldInfo);
	if (_strGFOBDistance != _strOldInfo)
	{
		m_pwndStcGoDistance->SetWindowText(_strGFOBDistance);
	}
}

void CMachineControlDlg::UpdateEnableJogLaser()
{
	CButton* _pwndCheckJogLaser = (CButton*)GetDlgItem(CTRLID_CHX_JOGLASER);
	// TFS#2659: ʹButtonʾ㶯ʱ⣬ʹLabel ---- mayazhan 2017-06-19
	if (!_pwndCheckJogLaser)
	{
		return;
	}

	bool _bEnable = false;
	CParamManager* _pParamManager = GetParamManager();
	ASSERT(_pParamManager);
	ParameterValue _ParamValue;
	memset(&_ParamValue, 0, sizeof(ParameterValue));
	if(_pParamManager->GetParameterValue("EnableJogLaser", &_ParamValue)
		&& _ParamValue.nType == mach::ParameterValue::VT_BOOL)
	{
		_bEnable = _ParamValue.bValue;
	}
	else
	{
		return;
	}

	bool _bBtnChecked = _pwndCheckJogLaser->GetCheck() == BST_CHECKED ? true : false;
	if (_bEnable != _bBtnChecked)
	{
		_pwndCheckJogLaser->SetCheck(_bEnable ? BST_CHECKED : BST_UNCHECKED);
	}
}

void CMachineControlDlg::UpdateEnableAutoCyc()
{
	CButton* _pwndCheckAutoCyc = (CButton*)GetDlgItem(CTRLID_CHX_AUTOCYC);
	CWnd* _pwndStaticAutoCyc = GetDlgItem(CTRLID_STC_AUTOCYC);
	if (!_pwndCheckAutoCyc || !_pwndStaticAutoCyc)
	{
		return;
	}
	bool _bEnableAutoCyc = false;

	CCycMachiningTarget* _pCycMachingTarget = GetCycMachiningTarget();
	BOOL _bCycEnable= _pCycMachingTarget->GetEnable();
	if(_bCycEnable == TRUE)
	{
		_bEnableAutoCyc = true;
	}
	else
	{
		_bEnableAutoCyc = false;
	}

	bool _bBtnChecked = _pwndCheckAutoCyc->GetCheck() == BST_CHECKED ? true : false;
	if (_bEnableAutoCyc != _bBtnChecked)
	{
		_pwndCheckAutoCyc->SetCheck(_bEnableAutoCyc ? BST_CHECKED : BST_UNCHECKED);
	}
}

void CMachineControlDlg::UpdateEnableAutoExchange()
{
	CButton* _pwndCheckAutoExchange = (CButton*)GetDlgItem(CTRLID_CHX_AUTOCYCEXCHANGE);
	CWnd* _pwndStaticAutoExchange = GetDlgItem(CTRLID_STC_AUTOEXCHANGE);
	if (!_pwndCheckAutoExchange || !_pwndStaticAutoExchange)
	{
		return;
	}
	bool _bEnableAutoExchange = false;

	CParamManager* _pParamManager = GetParamManager();
	ASSERT(_pParamManager);
	ParameterValue _ParamValue;
	memset(&_ParamValue, 0, sizeof(ParameterValue));
	if(_pParamManager->GetParameterValue("AutoExchangeTaskEnd", &_ParamValue)
		&& _ParamValue.nType == mach::ParameterValue::VT_INT)
	{
		if(_ParamValue.iValue == 1)
		{
			_bEnableAutoExchange = true;
		}
		else
		{
			ASSERT(_ParamValue.iValue == 0);
			_bEnableAutoExchange = false;
		}
	}
	else
	{
		return;
	}

	bool _bBtnChecked = _pwndCheckAutoExchange->GetCheck() == BST_CHECKED ? true : false;
	if (_bEnableAutoExchange != _bBtnChecked)
	{
		_pwndCheckAutoExchange->SetCheck(_bEnableAutoExchange ? BST_CHECKED : BST_UNCHECKED);
	}
}

void CMachineControlDlg::UpdateAir()
{
	static CString _strBlowType[3] = 
	{	_GETCS(s_csAIR),
		_GETCS(s_csN2),
		_GETCS(s_csO2),
	};
    
	   
	CParamManager* _pParamManager = GetParamManager();
    //-----------ӵĴ--------------------
	if (!_pParamManager)
		return;
	//--------------end------------------------
	ParameterValue _DefaultBlowType;
	_pParamManager->GetParameterValue("GP_DefaultBlowType", &_DefaultBlowType);
	int _nBlowType = _DefaultBlowType.iValue;

	// 
	SetDlgItemText(CTRLID_BTN_SELAIR, _strBlowType[_nBlowType]);
}

void CMachineControlDlg::UpdateEndAction()
{
	static CString _strEndAction[11] = 
	{	_GETCS(s_csNOMOTION),
		_GETCS(s_csBACKFIXPOS),
		_GETCS(s_csBACKWORKORG),
		_GETCS(s_csBACK1),
		_GETCS(s_csBACK2),
		_GETCS(s_csBACK3),
		_GETCS(s_csBACK4),
		_GETCS(s_csBACK5),
		_GETCS(s_csBACK6),
		_GETCS(s_csBACK7),
		_GETCS(s_csBACK8),
	};

	CParamManager* _pParamManager = GetParamManager();
	int _nTaskEndMarkPointIndex = 0;
	ParameterValue _PV;
	memset(&_PV, 0, sizeof(ParameterValue));
	if (_pParamManager
		&& _pParamManager->GetParameterValue("GP_TaskEndAdditionalAction", &_PV)
		&& _PV.nType == ParameterValue::VT_INT)
	{
		_nTaskEndMarkPointIndex = _PV.iValue;
	}

	// Ϊ
	SetDlgItemText(CTRLID_BTN_ENDACTION, _strEndAction[_nTaskEndMarkPointIndex]);
}

// Ϊ120ӳ䵽0-ʣ100ΪֱӶӦ100¿Է
//   [0,100] => [0,100]
//   [100,120] => [100,MaxFrp]
//  MaxFrp >= 100
// 100µĲûʲô˵ģ˴Ҫ˵100ϵĲӳ䣺
//   1) MaxFrp=120ⲿָ100һҲ
//      Value = Index
//   2) MaxFrp<120ⲿԷʽֵMaxFrpֵ
//      Value = Index  (when Index <= MaxFrp)
//            = MaxFrp (when Index >= MaxFrp)
//   3) MaxFrp>120ⲿԵָӳ
//      Value = Index * a^(Index - 100)
//       aMaxFrp
//      MaxFrp = 150   =>   150 = 120 * a^(120-100)   =>   a = (1.25)^(0.05)
//                                                        ----  2013-03-26
void CMachineControlDlg::_BuildFIVMap()
{
	int _nMaxFrp = m_nFValues[120];
	if (CParamManager* _pParamManager = GetParamManager())
	{
		const CStringA _c_strMaxFrpIdentifier = "MaxFrp";
		ParameterValue _MaxFrpParamValue;
		if (!_pParamManager->GetParameterValue(_c_strMaxFrpIdentifier, &_MaxFrpParamValue)
			|| _MaxFrpParamValue.nType != ParameterValue::VT_INT
			|| _MaxFrpParamValue.iValue == _nMaxFrp)
		{
			// 仯Ÿ
			return;
		}
		_nMaxFrp = _MaxFrpParamValue.iValue;
	}

	C_ASSERT(_countof(m_nFValues) == 121);
	if (_nMaxFrp <= 120)
	{
		for (int _i = 0; _i < _countof(m_nFValues); _i++)
		{
			m_nFValues[_i] = min(_i, _nMaxFrp);
		}
		return;
	}

	C_ASSERT(_countof(m_nFValues) == 121);
	for (int _i = 0; _i <= 100; _i++)
	{
		m_nFValues[_i] = _i;
	}
	double _nA = pow(_nMaxFrp / 120.0, 0.05);
	for (int _i = 101; _i < _countof(m_nFValues); _i++)
	{
		int _nV = (int)(_i * pow(_nA, _i - 100.0) + 0.5);
		m_nFValues[_i] = min(_nV, _nMaxFrp);
	}
}

void CMachineControlDlg::_UpdateFValue(int nIndex_, int* pnValue_)
{
	ASSERT(nIndex_ >= 0 && nIndex_ < _countof(m_nFValues) && pnValue_);
	*pnValue_ = m_nFValues[nIndex_];
}

void CMachineControlDlg::_UpdateFIndex(int* pnIndex_, int nValue_)
{
	ASSERT(pnIndex_ && *pnIndex_ >= 0 && *pnIndex_ < _countof(m_nFValues));
	if (nValue_ == m_nFValues[*pnIndex_])
	{
		return;
	}

	int _i = 0;
	while (_i < _countof(m_nFValues) && m_nFValues[_i] < nValue_)
	{
		_i++;
	}
	*pnIndex_ = _i;
}

LRESULT CMachineControlDlg::OnEndSpeedDlg(WPARAM wParam_, LPARAM lParam_)
{
	m_pSetSpeedDlg->ShowWindow(SW_HIDE);
	DWORD _nManuMode = (DWORD)wParam_;
	union
	{
		LPARAM lValue;
		float fValue;
	} Value;
	Value.lValue = lParam_;
	double _nValue = (float)Value.fValue;

	CManualTarget* _pManualTarget = GetManualTarget();
	ASSERT(_pManualTarget);

	// ֶ ---- С 2013-11-07
	if (_nManuMode == 0)
	{
		_pManualTarget->SetManuMode(0);
		_pManualTarget->SetJogState(false);

		CParamManager* _pParamManager = GetParamManager();
		if (_pParamManager)
		{
			ParameterValue _ParamValue;
			_pParamManager->GetParameterValue("1_0_JVelocityQuick", &_ParamValue);
			if (_nValue > _ParamValue.dValue)
			{
				_ParamValue.dValue = _nValue;
				_pParamManager->SetParameterValue("1_0_JVelocityQuick", &_ParamValue);
				_pParamManager->SetParameterValue("1_0_JVelocity", &_ParamValue);
			}
			else
			{
				_ParamValue.dValue = _nValue;
				_pParamManager->SetParameterValue("1_0_JVelocity", &_ParamValue);
			}
		}
	}
	// ֶ ---- С 2013-11-07
	else if (_nManuMode == 1)
	{
		_pManualTarget->SetManuMode(0);
		_pManualTarget->SetJogState(true);

		CParamManager* _pParamManager = GetParamManager();
		if (_pParamManager)
		{
			ParameterValue _ParamValue;
			_pParamManager->GetParameterValue("1_0_JVelocity", &_ParamValue);
			if (_nValue < _ParamValue.dValue)
			{
				_ParamValue.dValue = _nValue;
				_pParamManager->SetParameterValue("1_0_JVelocity", &_ParamValue);
				_pParamManager->SetParameterValue("1_0_JVelocityQuick", &_ParamValue);
			}
			else
			{
				_ParamValue.dValue = _nValue;
				_pParamManager->SetParameterValue("1_0_JVelocityQuick", &_ParamValue);
			}
		}
	}
	// ò ---- С 2013-11-07
	else if (_nManuMode == 2)
	{
		_pManualTarget->SetManuMode(1);
		_pManualTarget->SetIncDistance(_nValue);
	}

	return TRUE;
}

LRESULT CMachineControlDlg::OnEndEditDistance(WPARAM wParam_, LPARAM lParam_)
{
	ASSERT(lParam_);
	CString* _strText = reinterpret_cast<CString*>(lParam_);
	CString _strGetValue = *_strText;
	m_pwndStcGoDistance->ShowWindow(SW_SHOW);
	if (IsValidDate(_strGetValue, "double", 100000, 0., "mm"))
	{
		double _nGetValue = _tstof(_strGetValue);
		_nGetValue = _FormatInputData(_nGetValue);
		CControlTarget* _pControlTarget = GetControlTarget();
		ASSERT(_pControlTarget);
		_pControlTarget->SetGFOBDistance(_nGetValue);
	}

	return TRUE;
}

void CMachineControlDlg::OnLButtonDown(UINT nFlags_, CPoint point_)
{
	if (::IsWindow(m_pDistanceEdit->GetSafeHwnd()))
	{
		delete m_pDistanceEdit;
		m_pDistanceEdit = NULL;
	}
	else
		m_pDistanceEdit = NULL;
}

// Ӧ굥ǰʾťϢ100/1200Ϊ磬ǰݣǲģ
// ʽ򵯳༭ɱ༭ǰ˾룬ǵ㶯ģʽӦ󲿷ݣлǰ
// ģʽTrueʾٽϢѭ         ---- DingQiang 2012-07-19
BOOL CMachineControlDlg::OnDistanceLButtonDown(CPoint point_)
{
	CControlTarget* _pControlTarget = GetControlTarget();
	if (!_pControlTarget)
	{
		return FALSE;
	}

	CRect _rcGoDistance;
	m_pwndStcGoDistance->GetWindowRect(_rcGoDistance);
	double _nWide = _rcGoDistance.Width() * 0.83;
	double _nDivide = _rcGoDistance.left + _nWide;

	if (point_.x < _nDivide)
	{
		if (_pControlTarget->GetGFOBMode() == 0x00)
		{
			return TRUE;
		}

		if (::IsWindow(m_pDistanceEdit->GetSafeHwnd()))
		{
			// ĿǷֹ༭ѾCreateʱֵťCreateһ ---- DingQiang 2012-07-20
			return FALSE;
		}

		CString _strItemText;
		m_pwndStcGoDistance->GetWindowText(_strItemText);
		CRect _rect(0, 0, 0, 0);
		m_pwndStcGoDistance->GetWindowRect(_rect);

		// newһ༭丸Ϊǰ˾ʾ ---- DingQiang 2012-07-19
		m_pwndStcGoDistance->ScreenToClient(&_rect);
		_rect.top += 7;
		_rect.bottom -= 6;
		_rect.left += 20;
		_rect.right -= 20;
		DWORD _dwStyle;
		_dwStyle = WS_CHILDWINDOW | WS_VISIBLE | WS_BORDER | ES_CENTER | ES_AUTOVSCROLL | ES_NOHIDESEL;
		m_pDistanceEdit = new CEditItem(this, _strItemText);
		m_pDistanceEdit->Create(_dwStyle, _rect, m_pwndStcGoDistance, CTRLID_EDIT_GODISTANCE);
		return TRUE;
	}
	else
	{
		DWORD _nSetMode;
		if (_pControlTarget->GetGFOBMode() == 0x00)
		{
			_nSetMode = 0x01;
		}
		else
			_nSetMode = 0x00;

		_pControlTarget->SetGFOBMode(_nSetMode);
		return FALSE;
	}

	return FALSE;
}

// ǷǺϷ,Сλĸ---- DingQiang 2012-03-07
bool CMachineControlDlg::IsValidDate(LPCSTR szInPut_,	// ַ
									 LPCSTR szType_,	// 
									 double nMax_,		// ֵ
									 double nMin_,		// Сֵ
									 LPCSTR szUnit_)	// 뵥λ
{
	int _nNumDots = 0;							// С,ֻһ
	CString _strInPut = szInPut_;
	CString _strUint = szUnit_;
	int _nLength = (int)strlen(_strInPut);		// ַ
	int _nUnitLength = (int)strlen(_strUint);	// ʹõĵλַ
	bool b_ContainUnit = false;					// Ƿλ

	if (0 == _nLength)
	{
		return false;
	}

	// С򷵻false---- DingQiang 2012-03-07
	int _nDotCount = 0;
	for (int _i = 0; _i < _nLength; _i++)
	{
		char _szDot = _strInPut[_i];
		if (_szDot == '.')
		{
			_nDotCount++;
		}
	}

	if (_nDotCount > 1)
	{
		AfxMessageBox(_GETCS(s_csFloatDataError));
		return false;
	}

	// ȼַ_nUnitLengthǷ֣һ
	// Ϻ_nUnitLengthַǷǵλַҲǵλֱַ
	// ӷشϢ顣               ---- DingQiang 2012-03-07
	int _nCheckUint = (_nLength - _nUnitLength) > 0 ? _nLength - _nUnitLength : _nLength;
	for (int _j = _nCheckUint; _j < _nLength; _j++)
	{
		char _szChar = _strInPut[_j];
		if(_szChar < 0 || _szChar > 255)
		{
			AfxMessageBox(_GETCS(s_csFloatDataError));
			return false;
		}
		if (!isdigit(_szChar))
		{
			if (_szChar != '.')
			{
				if (_strUint.Compare(_strInPut.Right(_nUnitLength)) != 0)
				{
					AfxMessageBox(_GETCS(s_csFloatDataError));
					return false;
				}
				else
				{
					b_ContainUnit = true;
				}
			}
		}
	}

	// зַûзȫ---- DingQiang 2012-03-08
	int _nCheckNum = b_ContainUnit ? _nCheckUint : _nLength;
	int _i = 0;
	for (; _i < _nCheckNum; _i++)
	{
		char _c = _strInPut[_i];
		if (!isdigit(_c))
		{
			if (0 == strcmp(szType_, "int"))
			{
				break;
			}
			else if (0 == strcmp(szType_, "double") || 0 == strcmp(szType_, "float"))
			{
				if (_c == '.' && _nNumDots == 0)
				{
					_nNumDots++;
				}
				else
				{
					break;
				}
			}
			else
				ASSERT(false);
		}
	}

	if (_i != _nCheckNum && (strcmp(szType_, "int") == 0))
	{
		AfxMessageBox(_GETCS(s_csIntDataError));
		return false;
	}

	if (_i != _nCheckNum && (strcmp(szType_, "float") == 0 || strcmp(szType_, "double") == 0))
	{
		AfxMessageBox(_GETCS(s_csFloatDataError));
		return false;
	}

	double _nInPut = (double)_tstof(szInPut_);
	if ( _nInPut > nMin_ && _nInPut < nMax_)
	{
		return true;
	}
	else
	{
		CString _strErrorShow;
		_strErrorShow.Format(_GETCS(s_csFloatDataBoundError), nMin_, nMax_);
		AfxMessageBox(_strErrorShow);
		return false;
	}
}

void CMachineControlDlg::OnChangeCoorMode()
{
	m_nCoorMode = (m_nCoorMode == 0x00) ? 0x01 : 0x00;
	UpdateMachCoor();
}

// ʽ ---- DingQiang 2012-06-25
static double _FormatInputData(double nInputData_)
{
	ASSERT(nInputData_ >= 0);
	CString _strTemp;
	_strTemp.Format(_T("%f"), nInputData_);

	CString _strOut = _strTemp.Left(6);

	return _tstof(_strOut);
}

// ֶٶ ---- С 2013-11-07
void CMachineControlDlg::OnDblClickCenter()
{
	CStateManager* _pStateManager = GetStateManager();
	if (!_pStateManager)
		return;

	CStateManager::State _State = mach::CStateManager::Invalid;
	if (!_pStateManager->GetState(&_State))
	{
		return;
	}

	if (_State != mach::CStateManager::Invalid
		&& _State != mach::CStateManager::Idle
		//&& _State != mach::CStateManager::Lock			// ʱҲ޸ٶȡ
		&& _State != mach::CStateManager::Estop)
	{
		AfxMessageBox(_GETCS(s_csNotInputPrompt));
		return;
	}

	ASSERT(m_pwndBtnCenter && ::IsWindow(m_pwndBtnCenter->m_hWnd));
	CRect _rcBtnCenter;
	m_pwndBtnCenter->GetWindowRect(&_rcBtnCenter);
	((CSetSpeedDlg*)m_pSetSpeedDlg)->SetBasePosition(_rcBtnCenter.TopLeft());
	m_pSetSpeedDlg->ShowWindow(SW_SHOW);
}

LRESULT CMachineControlDlg::OnSliderMoving(WPARAM wParam_, LPARAM lParam_)
{
	CParamManager* _pParamManager = mach::GetParamManager();
	if (!_pParamManager)
	{
		ASSERT(FALSE);
		return 0;
	}

	if (!m_bIsR2)
	{
		UINT _nCtrlID = (UINT)wParam_;
		int _nIndex = (int)lParam_;
		if (wParam_ == CTRLID_SLD_SETF)
		{
			int _nFrp = 100;
			_UpdateFValue(_nIndex, &_nFrp);

			// ΪȫƣͨCParamManager޸Ĳȫвڴ˴ܲ
			// ǱģȫýԵÿβ ˣ˴
			// ͨһCommandƹȫ顣              ----  2012-08-17
			if (CCommandManager* _pCommandManager = GetCommandManager())
			{
				const CStringA _c_strSetFrpCommand = "SetFrp";
				CStringA _strFrp;
				_strFrp.Format("%d", _nFrp);
				_pCommandManager->Execute(_c_strSetFrpCommand, _strFrp, "LPCSTR");
			}
			if (m_bSliderCtrlG00)
			{
				if (CCommandManager* _pCommandManager = GetCommandManager())
				{
					const CStringA _c_strSetG00FrpCommand = "SetG00Frp";
					CStringA _strFrp;
					_strFrp.Format("%d", _nFrp);
					_pCommandManager->Execute(_c_strSetG00FrpCommand, _strFrp, "LPCSTR");
				}
			}

			UpdateF();
		}
	}

	// ݻֹͣʱλõֵý ---- DingQiang 2012-02-07
	if (m_bIsR2 && m_pwndSliderSetExF)
	{
		int _nIndex = m_pwndSliderSetExF->GetPos();
		
		if (_nIndex < 105 && _nIndex >= 95)
		{
			m_pwndSliderSetExF->SetPos(100);
		}
		else if(_nIndex < 95)
		{
			m_pwndSliderSetExF->SetPos(5 * (_nIndex / 5));
		}

		_nIndex = m_pwndSliderSetExF->GetPos();
		int _nFrp = 100;
		_UpdateFValue(_nIndex, &_nFrp);

		// ΪȫƣͨCParamManager޸Ĳȫвڴ˴ܲ
		// ǱģȫýԵÿβ ˣ˴
		// ͨһCommandƹȫ顣              ----  2012-08-17
		if (CCommandManager* _pCommandManager = GetCommandManager())
		{
			const CStringA _c_strSetFrpCommand = "SetFrp";
			CStringA _strFrp;
			_strFrp.Format("%d", _nFrp);
			_pCommandManager->Execute(_c_strSetFrpCommand, _strFrp, "LPCSTR");
		}
		if (m_bSliderCtrlG00)
		{
			if (CCommandManager* _pCommandManager = GetCommandManager())
			{
				const CStringA _c_strSetG00FrpCommand = "SetG00Frp";
				CStringA _strFrp;
				_strFrp.Format("%d", _nFrp);
				_pCommandManager->Execute(_c_strSetG00FrpCommand, _strFrp, "LPCSTR");
			}
		}

		UpdateF();

		// ˢ»β ----  2013.07.26
		m_pwndSliderSetExF->Invalidate(FALSE);
	}

	return 1;
}

void CMachineControlDlg::OnSelectMach()
{
	CStateManager* _pStateManager = GetStateManager();
	if (!_pStateManager)
	{
		ASSERT(FALSE);
		return;
	}

	int _nCheck = ((CButton*)GetDlgItem(CTRLID_CHX_SELECTMACH))->GetCheck();
	m_bSelectMach = _nCheck == BST_CHECKED;
	_pStateManager->SetSelectedMach(m_bSelectMach);
	//üӹѡͼǷѡflagCControlTargetͬ----20170712  
	CControlTarget* _pControlTarget = GetControlTarget();
	ASSERT(_pControlTarget);
	_pControlTarget->SetSelectMach(m_bSelectMach);

}

void CMachineControlDlg::OnJogLaser()
{
	bool _bValue = false;
	CParamManager* _pParamManager = GetParamManager();
	ASSERT(_pParamManager);
	ParameterValue _ParamValue;
	memset(&_ParamValue, 0, sizeof(ParameterValue));
	if(_pParamManager->GetParameterValue("EnableJogLaser", &_ParamValue)
		&& _ParamValue.nType == mach::ParameterValue::VT_BOOL)
	{
		_bValue = _ParamValue.bValue;
	}
	else
	{
		ASSERT(FALSE);
		return;
	}

	_ParamValue.bValue = !_bValue;
	_pParamManager->SetParameterValue("EnableJogLaser", &_ParamValue);
	UpdateEnableJogLaser();
}

void CMachineControlDlg::OnAutoExchange()
{
	bool _bEnableExchange = false;

	CParamManager* _pParamManager = GetParamManager();
	ASSERT(_pParamManager);
	ParameterValue _ParamValue;
	memset(&_ParamValue, 0, sizeof(ParameterValue));
	if(_pParamManager->GetParameterValue("AutoExchangeTaskEnd", &_ParamValue)
		&& _ParamValue.nType == mach::ParameterValue::VT_INT)
	{
		if(_ParamValue.iValue == 1)
		{
			_bEnableExchange = true;
		}
		else
		{
			ASSERT(_ParamValue.iValue == 0);
			_bEnableExchange = false;
		}
	}
	else
	{
		return;
	}

	// ֱӶϵͳȡ ---- η 2017-05-08
	if(_bEnableExchange)
	{
		memset(&_ParamValue, 0, sizeof(ParameterValue));
		_ParamValue.nType = ParameterValue::VT_INT;
		_ParamValue.iValue = 0;
		_pParamManager->SetParameterValue("AutoExchangeTaskEnd", &_ParamValue);
	}
	else
	{
		memset(&_ParamValue, 0, sizeof(ParameterValue));
		_ParamValue.nType = ParameterValue::VT_INT;
		_ParamValue.iValue = 1;
		_pParamManager->SetParameterValue("AutoExchangeTaskEnd", &_ParamValue);
	}
	
	UpdateEnableAutoExchange();
	SendTargetMessage(ID_TARGET_EXCHANGEWORKBENCH, TM_AUTOCYC_CHECK, 0, 0);
}

void CMachineControlDlg::OnAutoCyc()
{
	bool _bEnableCyc = false;

	CCycMachiningTarget* _pCycMachingTarget = GetCycMachiningTarget();
	BOOL _bCycEnable= _pCycMachingTarget->GetEnable();
	if(_bCycEnable == TRUE)
	{
		_bEnableCyc = true;
		_pCycMachingTarget->SetEnable(FALSE);
	}
	else
	{
		_bEnableCyc = false;
		_pCycMachingTarget->SetEnable(TRUE);
	}

	UpdateEnableAutoCyc();
}
void CMachineControlDlg::SetSelectMach(bool _bSelectMach)
{
	m_bSelectMach = _bSelectMach;
}

bool CMachineControlDlg::GetSelectMach()
{
	return m_bSelectMach;
}
void CMachineControlDlg::OnSelMarkPoint()
{
	// رǵѡ˵ ---- ߿ϼ 2017-05-11
	CRect _rcRect;
	GetDlgItem(CTRLID_BTN_SELMARKPOINT)->GetWindowRect(&_rcRect);
	m_pMenuMark->TrackPopupMenu(TPM_LEFTBUTTON, _rcRect.right, _rcRect.bottom, this);
}

void CMachineControlDlg::OnSelBlowAir()
{
	// رǵѡ˵ ---- ߿ϼ 2017-05-11
	CRect _rcRect;
	GetDlgItem(CTRLID_BTN_SELAIR)->GetWindowRect(&_rcRect);
	m_pMenuAir->TrackPopupMenu(TPM_LEFTBUTTON, _rcRect.right, _rcRect.bottom, this);
}

void CMachineControlDlg::OnSelEndAction()
{
	// رǵѡ˵ ---- ߿ϼ 2017-05-11
	CRect _rcRect;
	GetDlgItem(CTRLID_BTN_ENDACTION)->GetWindowRect(&_rcRect);
	m_pMenuMarkPoint->TrackPopupMenu(TPM_LEFTBUTTON, _rcRect.right, _rcRect.bottom, this);
}

void CMachineControlDlg::OnMarkPointChange(UINT ID_)
{
	// ڱǵ㰴ťʾǰѡıǵindex ---- ߿ϼ 2017-03-14
	UINT _nCurIndex = ID_ - CTRLID_BTN_MARKPOINT1 + 1;
	m_nCurIndex = _nCurIndex;
	CString _strCurIndex;
	_strCurIndex.Format("%u", _nCurIndex);

	// ʹbuttonϲʾ ---- ߿ϼ 2017-03-15
	CString _strShowIndex = _strCurIndex + '\n';
	SetDlgItemText(CTRLID_BTN_SELMARKPOINT, _strShowIndex);

	// ǰѡıǵindexMarkPointTarget ---- ߿ϼ 2017-03-14
	CMarkPointTarget* _pMarkPointTarget = GetMarkPointTarget();
	ASSERT(_pMarkPointTarget);
	_pMarkPointTarget->SetCurMarkIndex(_nCurIndex - 1);
}

void CMachineControlDlg::OnAirChange(UINT ID_)
{
	// ڱǵ㰴ťʾǰѡıǵindex ---- ߿ϼ 2017-03-14
	int _nCurIndex = ID_ - CTRLID_BTN_SELAIR0;

	CParamManager* _pParamManager = GetParamManager();
	ParameterValue _DefaultBlowType;
	memset(&_DefaultBlowType, 0, sizeof(ParameterValue));
	if (_pParamManager->GetParameterValue("GP_DefaultBlowType", &_DefaultBlowType)
		&& _DefaultBlowType.nType == ParameterValue::VT_INT)
	{
		_DefaultBlowType.iValue = _nCurIndex;
		bool _bRet = _pParamManager->SetParameterValue("GP_DefaultBlowType", &_DefaultBlowType);
		ASSERT(_bRet);
	}
}

void CMachineControlDlg::OnEndActionChange(UINT ID_)
{
	// ڱǵ㰴ťʾǰѡıǵindex ---- ߿ϼ 2017-03-14
	UINT _nCurIndex = ID_ - CTRLID_BTN_NOMOVE;

	// жһͨͼе
	CParamManager* _pParamManager = GetParamManager();

	ParameterValue _PV;
	memset(&_PV, 0, sizeof(ParameterValue));

	if (_pParamManager->GetParameterValue("GP_TaskEndAdditionalAction", &_PV)
		&& _PV.nType == ParameterValue::VT_INT)
	{
		_PV.iValue = _nCurIndex;
		bool _bRet = _pParamManager->SetParameterValue("GP_TaskEndAdditionalAction", &_PV);
		ASSERT(_bRet);
	}
}