// ************************************************************************** //
// NceCommands.cpp : implementation of the NcEditor Extended Commands
// Copyright(c)2012 Naiky Company. All rights reserved.
//
// Abstract:
//   ļʵΪNcEditorչ
// ********************************************* ----  2012-07-24 ***** //
#include "stdafx.h"
#include "IZMotion.h"
#include "IBeginStop.h"
#include "ActionParser.h"
#include "TubeComponent.cpp"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

#ifdef _DEBUG
	#using "mscorlib.dll"
	#using "System.Xml.dll"
	#using ".\\NcStudio\\Debug\\Weihong.MotionControl.Core.dll"
	#using ".\\NcStudio\\Debug\\Weihong.Utility.dll"
	#using ".\\NcStudio\\Debug\\Weihong.Motion.IDE.dll"
	#using ".\\NcStudio\\Debug\\ZFollowSystemUI.dll"
#else
	#using "mscorlib.dll"
	#using "System.Xml.dll"
	#using ".\\NcStudio\\Release\\Weihong.MotionControl.Core.dll"
	#using ".\\NcStudio\\Release\\Weihong.Utility.dll"
	#using ".\\NcStudio\\Release\\Weihong.Motion.IDE.dll"
	#using ".\\NcStudio\\Release\\ZFollowSystemUI.dll"
#endif
using namespace System;
using namespace System::Threading;
using namespace Weihong::MotionControl::Core;
using namespace Weihong::Utility;
using namespace Weihong::Motion::IDE;
using namespace ZFollowSystemUI::Commands;

////////////////////////////////////////////////////////////////////////////////
// Global function declarations ---- ƺ 2013-06-05
// 
namespace NcEditor
{
	extern void _CloseScanCutting();
}
extern bool _SetParameterValue(IParameterNode^ Param_, const mach::ParameterValue* pParamValue_);
extern bool _GetParameterValue(IParameterNode^ Param_, mach::ParameterValue* pParamValue_);
extern bool _GetParameterValue(String^ strParam_, double* pParam_);

////////////////////////////////////////////////////////////////////////////////
// һרͣͣȫֱ ---- ƺ 2015-10-29
// 
static NcEditor::CActionParser g_sPauseActionParser;

////////////////////////////////////////////////////////////////////////////////
// Additional Commands ----  2012-02-04
////////////////////////////////////////////////////////////////////////////////
namespace NcEditor
{
	////////////////////////////////////////////////////////////////////////////
	// ͨòļָҪ޸ĵĲҪĵطָ,
	// ֵͿƹȫļ飬ֱֵSetȥøʽ£
	// <Class Name="NcEditor.CSetParameterCommand" CommandName="SetSrpCommand" Parameter="SpindlePort_Srp"/>
	// ð취һڽ϶ʱڲĿβ⡣---- ƺ 2013-06-06
	// 
	public ref class CSetParameterCommand : public CommandBase
	{
	public:
		CSetParameterCommand()
		{
			m_strParameterName = "";
		}

		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			Xml::XmlElement^ _xmlElement = addInType_->Element;
			m_strParameterName = _xmlElement->GetAttribute("Parameter");

			return __super::Build(addInType_, buildError_);
		}

		virtual bool CanExecute(Object^ parameter_) override
		{
			if (parameter_->GetType()->FullName != "System.String")
			{
				return false;
			}

			IParameterNode^ _ParamNode =
				MCRuntime::Instance != nullptr && MCRuntime::Instance->DataManager != nullptr
				? MCRuntime::Instance->DataManager->GetParaemterNode(m_strParameterName) : nullptr;

			if (_ParamNode == nullptr)
			{
				return false;
			}

			// ֻbool,char,short,int,int64,float,double͵ ---- ƺ 2013-06-06
			mach::ParameterValue _ParameterValue;
			memset(&_ParameterValue, 0, sizeof(mach::ParameterValue));
			if (!_GetParameterValue(_ParamNode, &_ParameterValue))
			{
				return false;
			}

			return true;
		}

		virtual void Execute(Object^ parameter_) override
		{
			IParameterNode^ _ParamNode =
				MCRuntime::Instance != nullptr && MCRuntime::Instance->DataManager != nullptr
				? MCRuntime::Instance->DataManager->GetParaemterNode(m_strParameterName) : nullptr;
			if (_ParamNode == nullptr)
			{
				ASSERT(false);
				return;
			}

			// ַʽĲתΪӦ͵Ĳֵ ---- ƺ 2013-06-06
			mach::ParameterValue _ParameterValue;
			memset(&_ParameterValue, 0, sizeof(mach::ParameterValue));
			_GetParameterValue(_ParamNode, &_ParameterValue);
			String^ _FullName = _ParamNode->Value->GetType()->FullName;
			if (_ParameterValue.nType == mach::ParameterValue::VT_BOOL)
			{
				_ParameterValue.bValue = Convert::ToBoolean(parameter_);
			}
			else if (_ParameterValue.nType == mach::ParameterValue::VT_CHAR)
			{
				_ParameterValue.cValue = Convert::ToByte(parameter_);
			}
			else if (_ParameterValue.nType == mach::ParameterValue::VT_SHORT)
			{
				_ParameterValue.sValue = Convert::ToInt16(parameter_);
			}
			else if (_ParameterValue.nType == mach::ParameterValue::VT_INT)
			{
				_ParameterValue.iValue = Convert::ToInt32(parameter_);
			}
			else if (_ParameterValue.nType == mach::ParameterValue::VT_INT64)
			{
				_ParameterValue.i64Value = Convert::ToInt64(parameter_);
			}
			else if (_ParameterValue.nType == mach::ParameterValue::VT_FLOAT)
			{
				_ParameterValue.fValue = Convert::ToSingle(parameter_);
			}
			else if (_ParameterValue.nType == mach::ParameterValue::VT_DOUBLE)
			{
				_ParameterValue.dValue = Convert::ToDouble(parameter_);
			}

			// ֵSetں ---- ƺ 2013-06-06
			_SetParameterValue(_ParamNode, &_ParameterValue);
		}

	protected:
		// Ҫ޸ĵĲĲ ---- ƺ 2013-06-06
		String^ m_strParameterName;
	};

	////////////////////////////////////////////////////////////////////////////
	// ֶ١
	// 
	public ref class CSetJogTurboCommand : public CommandBase
	{
	public:
		virtual bool CanExecute(Object^ parameter_) override
		{
			IParameterNode^ _ParamNode =
				MCRuntime::Instance != nullptr && MCRuntime::Instance->DataManager != nullptr
				? MCRuntime::Instance->DataManager->GetParaemterNode("ManuSpeedComponent1_IsTurboOn") : nullptr;
			if (_ParamNode == nullptr || _ParamNode->Value->GetType()->FullName != "System.Boolean")
			{
				return false;
			}

			// Ϸֵ"""True""False""Switch" ----  2012-11-17
			if (parameter_->GetType()->FullName != "System.String"
				|| parameter_->ToString() != ""
				&& parameter_->ToString() != "True"
				&& parameter_->ToString() != "False"
				&& parameter_->ToString() != "Switch")
			{
				return false;
			}

			return true;
		}

		virtual void Execute(Object^ parameter_) override
		{
			IParameterNode^ _ParamNode =
				MCRuntime::Instance != nullptr && MCRuntime::Instance->DataManager != nullptr
				? MCRuntime::Instance->DataManager->GetParaemterNode("ManuSpeedComponent1_IsTurboOn") : nullptr;
			if (_ParamNode == nullptr || _ParamNode->Value->GetType()->FullName != "System.Boolean")
			{
				return;
			}

			if (parameter_->GetType()->FullName != "System.String")
			{
				return;
			}

			if (parameter_->ToString() == "")			// Ĭϱʾ
				_ParamNode->Value = true;
			else if (parameter_->ToString() == "True")	// 
				_ParamNode->Value = true;
			else if (parameter_->ToString() == "False")	// ظ
				_ParamNode->Value = false;
			else if (parameter_->ToString() == "Switch")// л
				_ParamNode->Value = !_ParamNode->Value;
			else
				ASSERT(FALSE);

			// ͬͨ1ֶģʽ ---- ƺ 2014-06-25
			_ParamNode =
				MCRuntime::Instance != nullptr && MCRuntime::Instance->DataManager != nullptr
				? MCRuntime::Instance->DataManager->GetParaemterNode("JogMotion1_IsTurboOn") : nullptr;
			if (_ParamNode == nullptr || _ParamNode->Value->GetType()->FullName != "System.Boolean")
			{
				return;
			}

			if (parameter_->GetType()->FullName != "System.String")
			{
				return;
			}

			if (parameter_->ToString() == "")			// Ĭϱʾ
				_ParamNode->Value = true;
			else if (parameter_->ToString() == "True")	// 
				_ParamNode->Value = true;
			else if (parameter_->ToString() == "False")	// ظ
				_ParamNode->Value = false;
			else if (parameter_->ToString() == "Switch")// л
				_ParamNode->Value = !_ParamNode->Value;
			else
				ASSERT(FALSE);

			// ͬͨ2ֶģʽӦķʽȡjogmotion
			// ֱòд̫ ---- DingQiang 2017-02-15
			_ParamNode =
				MCRuntime::Instance != nullptr && MCRuntime::Instance->DataManager != nullptr
				? MCRuntime::Instance->DataManager->GetParaemterNode("JogMotion2_IsTurboOn") : nullptr;
			if (_ParamNode == nullptr || _ParamNode->Value->GetType()->FullName != "System.Boolean")
			{
				return;
			}

			if (parameter_->GetType()->FullName != "System.String")
			{
				return;
			}

			if (parameter_->ToString() == "")			// Ĭϱʾ
				_ParamNode->Value = true;
			else if (parameter_->ToString() == "True")	// 
				_ParamNode->Value = true;
			else if (parameter_->ToString() == "False")	// ظ
				_ParamNode->Value = false;
			else if (parameter_->ToString() == "Switch")// л
				_ParamNode->Value = !_ParamNode->Value;
			else
				ASSERT(FALSE);
		}
	};

	////////////////////////////////////////////////////////////////////////////
	// ֶ
	// 
	public ref class CJogCommand : public CommandBase
	{
	public:
		CJogCommand()
		{
			m_nAxis = -1;
			m_nDir = 0;
			m_strMotionPath = "/Kernel0/Channel0/JogMotion0";
			m_strSpeedParam = "";
		}

		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			Xml::XmlElement^ _xmlElement = addInType_->Element;

			// Axis
			String^ _strAxis = _xmlElement->GetAttribute("Axis");
			if (_strAxis->Equals("0") || _strAxis->Equals("x") || _strAxis->Equals("X"))
				m_nAxis = 0;
			else if (_strAxis->Equals("1") || _strAxis->Equals("y") || _strAxis->Equals("Y"))
				m_nAxis = 1;
			else if (_strAxis->Equals("2") || _strAxis->Equals("z") || _strAxis->Equals("Z"))
				m_nAxis = 2;
			else
				return false;

			// Direction
			String^ _strDir = _xmlElement->GetAttribute("Dir");
			if (_strDir->Equals("N"))
				m_nDir = -1;
			else if (_strDir->Equals("S"))
				m_nDir = 0;
			else if (_strDir->Equals("P"))
				m_nDir = 1;
			else
				return false;

			m_strSpeedParam = _xmlElement->GetAttribute("Speed");

			// Motion
			String^ _strMotionPath = _xmlElement->GetAttribute("Motion");
			if (!_strMotionPath->Equals(""))
				m_strMotionPath = _strMotionPath;
			if (GetJogMotion() == nullptr)
				return false;

			return __super::Build(addInType_, buildError_);
		}

		virtual bool CanExecute(Object^ parameter_) override
		{
			IJogMotion^ _JogMotion = GetJogMotion();
			IAutoReleaseLimit^ _autoReleaseLimitJog = dynamic_cast<IAutoReleaseLimit^>(_JogMotion);
			AbstractMotion^ _Motion = dynamic_cast<AbstractMotion^>(_JogMotion);
			Channel^ _channel = _Motion != nullptr ? _Motion->Owner : nullptr;
			if (_channel == nullptr)
			{
				return false;
			}

			Direction _dir = Direction::Undefined;
			if (m_nDir == -1) _dir = Direction::Negative;
			if (m_nDir == 1) _dir = Direction::Positive;
			if (_channel->ChannelState == ChannelState::Idle
				|| (_channel->ChannelState == ChannelState::Running
				&& _channel->CurrentMotion == _JogMotion)
				|| (_channel->ChannelState == ChannelState::Estop
				&& _autoReleaseLimitJog != nullptr
				&& _autoReleaseLimitJog->CanReleaseLimit(_dir, m_nAxis)))
			{
				return true;
			}

			return false;
		}

		virtual void Execute(Object^ parameter_) override
		{
			TRACE("CJogCommand::Execute => Axis=%d, Dir=%d\n", m_nAxis, m_nDir);

			// ȡֶܲ ----  2012-02-04
			IJogMotion^ _JogMotion = GetJogMotion();
			if (_JogMotion == nullptr)
			{
				TRACE("CJogCommand::Execute => JogMotion Not Found.\n");
				return;
			}

			// ֶ ----  2012-02-04
			if (m_nAxis != 0 && m_nAxis != 1 && m_nAxis != 2
				|| m_nDir != -1 && m_nDir != 0 && m_nDir != 1)
			{
				TRACE("CJogCommand::Execute => ErrorParameter.\n");
				return;
			}

			if (m_nDir == 0 && !_JogMotion->IsEntered)
			{
				TRACE("CJogCommand::Execute => AlreadyStop.\n");
				return;
			}

			if (!_JogMotion->IsEntered && !_JogMotion->Enter())
			{
				TRACE("CJogCommand::Execute => ErrorState.\n");
				return;
			}

			// ٶȲ
			double _nVelocity = 0;
			if (m_strSpeedParam->Length != 0)
			{
				using System::Runtime::InteropServices::Marshal;
				mach::ParameterValue _SpeedValue;
				memset(&_SpeedValue, 0, sizeof(mach::ParameterValue));
				mach::CParamManager* _pParamManager = mach::GetParamManager();
				if (_pParamManager
					&& _pParamManager->GetParameterValue((LPCSTR)(Marshal::StringToHGlobalAnsi(m_strSpeedParam)).ToPointer(), &_SpeedValue)
					&& _SpeedValue.nType == mach::ParameterValue::VT_DOUBLE)
				{
					_nVelocity = _SpeedValue.dValue / 60;
				}
				else
				{
					using System::Runtime::InteropServices::Marshal;
					const char* _szParameter = (const char*)(Marshal::StringToHGlobalAnsi(m_strSpeedParam)).ToPointer();
					if (_szParameter && _szParameter[0])
					{
						_nVelocity = atof(_szParameter);
					}

					Marshal::FreeHGlobal(IntPtr((void*)_szParameter));
				}
			}

			if (_nVelocity > 0.)
			{
				// õٶֵʹõģʹĬϵ ---- DingQiang 2014-12-30
				if (_JogMotion->IsTurboOn)
				{
					if (_nVelocity < _JogMotion->Velocity)
					{
						_JogMotion->Velocity = _nVelocity;
					}
					_JogMotion->VelocityQuick = _nVelocity;
				}
				else
				{
					if (_nVelocity > _JogMotion->VelocityQuick)
					{
						_JogMotion->VelocityQuick = _nVelocity;
					}
					_JogMotion->Velocity = _nVelocity;
				}
			}

			Direction _dir = Direction::Undefined;
			if (m_nDir == -1) _dir = Direction::Negative;
			if (m_nDir == 1) _dir = Direction::Positive;
			_JogMotion->RunAxis(_dir, m_nAxis);
		}

	protected:
		int m_nAxis;					// 0:x; 1:y; 2:z
		int m_nDir;						// -1:Negative; 0-Stop; 1-Positive
		String^ m_strMotionPath;		// MotionPath, Default => /Kernel0/Channel0/JogMotion0
		String^ m_strSpeedParam;		// ٶȲǱ(һֵ,Ҳһ)

		// CSharpлȡIIncreaseMotion ----  2012-02-04
		IJogMotion^ GetJogMotion()
		{
			if (MCRuntime::Instance == nullptr)
			{
				return nullptr;
			}

			return MCRuntime::Instance->GetComponent<IJogMotion^>(m_strMotionPath);
		}
	};

	public ref class CJogCommand_Laser : public CJogCommand
	{
	public:
		CJogCommand_Laser()
		{
			m_strRefBitPort = "";
			m_strEnableParam = "";
			m_nVelocity = 0.0;			// ٶ
			m_nBlowType = 0;			// 
			m_nFollowHeight = 0.0;		// ߶
			m_nFocusPos = 0.0;			// λ
		}

		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			Xml::XmlElement^ _xmlElement = addInType_->Element;

			// Axis
			String^ _strBitPort = _xmlElement->GetAttribute("RefBitPort");
			if (_strBitPort->Length > 0)
			{
				m_strRefBitPort = _strBitPort;
			}

			String^ _strEnableParam = _xmlElement->GetAttribute("EnableParam");
			if (_strEnableParam->Length > 0)
			{
				m_strEnableParam = _strEnableParam;
			}

			return __super::Build(addInType_, buildError_);
		}

		virtual bool CanExecute(Object^ parameter_) override
		{
			return __super::CanExecute(parameter_);
		}

		virtual void Execute(Object^ parameter_) override
		{
			mach::CParamManager* _pParamManager = mach::GetParamManager();
			mach::ParameterValue _EnableParam;
			memset(&_EnableParam, 0, sizeof(mach::ParameterValue));
			_pParamManager->GetParameterValue("EnableJogLaser", &_EnableParam);
			if (_EnableParam.nType == mach::ParameterValue::VT_BOOL && _EnableParam.bValue == true)
			{
				IMCBitPort^ _BitPort = MCRuntime::Instance->GetComponent<AbstractBitPortManager^>("/Kernel0/BitPortManager0")->GetBitPort(m_strRefBitPort);
				ASSERT(_BitPort != nullptr);
				if (m_nDir == 0)
				{
					// ֹͣض˿
					_BitPort->Value = false;
				}
				else
				{
					_BitPort->Value = true;
				}
			}
			else
			{
				__super::Execute(parameter_);
			}
		}
	protected:
		String^ m_strRefBitPort;
		String^ m_strEnableParam;
		double m_nVelocity;			// ٶ
		int m_nBlowType;			// 
		double m_nFollowHeight;		// ߶
		double m_nFocusPos;			// λ
	};

	////////////////////////////////////////////////////////////////////////////
	// ֶ
	// 
	public ref class CIncCommand : public CommandBase
	{
	public:
		CIncCommand()
		{
			m_nAxis = -1;
			m_nDir = 0;
			m_strMotionPath = "/Kernel0/Channel0/IncreaseMotion0";
		}

		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			Xml::XmlElement^ _xmlElement = addInType_->Element;

			// Axis
			String^ _strAxis = _xmlElement->GetAttribute("Axis");
			if (_strAxis->Equals("0") || _strAxis->Equals("x") || _strAxis->Equals("X"))
				m_nAxis = 0;
			else if (_strAxis->Equals("1") || _strAxis->Equals("y") || _strAxis->Equals("Y"))
				m_nAxis = 1;
			else if (_strAxis->Equals("2") || _strAxis->Equals("z") || _strAxis->Equals("Z"))
				m_nAxis = 2;
			else
				return false;

			// Dir
			String^ _strDir = _xmlElement->GetAttribute("Dir");
			if (_strDir->Equals("N"))
				m_nDir = -1;
			else if (_strDir->Equals("S"))
				m_nDir = 0;
			else if (_strDir->Equals("P"))
				m_nDir = 1;
			else
				return false;

			// Motion
			String^ _strMotionPath = _xmlElement->GetAttribute("Motion");
			if (!_strMotionPath->Equals(""))
				m_strMotionPath = _strMotionPath;
			if (GetIncreaseMotion() == nullptr)
				return false;

			return __super::Build(addInType_, buildError_);
		}

		virtual bool CanExecute(Object^ parameter_) override
		{
			IIncreaseMotion^ _IncMotion = GetIncreaseMotion();
			AbstractMotion^ _Motion = dynamic_cast<AbstractMotion^>(_IncMotion);
			Channel^ _channel = _Motion != nullptr ? _Motion->Owner : nullptr;
			if (_channel == nullptr)
			{
				return false;
			}

			// Ѳܿʼ´˶ΪIsBusyͲܿʼ ----  2014-12-23
			// ֮ǰ IsBusy && is not CurrentMotion Ϊʲô
			// ֻҪIsBusyͲӦٿʼ¸˶Ŷԣ͸ĵ
			// CIncParamerCommandͬҲˣ˭ûȫĴģ
			//if (_IncMotion->IsBusy && _channel->CurrentMotion != _IncMotion)
			if (_IncMotion->IsBusy)
			{
				return false;
			}

			ChannelState _state = _channel->ChannelState;
			if (_state == ChannelState::Estop)
			{
				return false;
			}

			return true;
		}

		virtual void Execute(Object^ parameter_) override
		{
			TRACE("CIncCommand::Execute => Axis=%d, Dir=%d\n", m_nAxis, m_nDir);

			// ȡֶܲ ---- ǿ 2012-02-07
			IIncreaseMotion^ _IIncreaseMotion = GetIncreaseMotion();
			if (_IIncreaseMotion == nullptr)
			{
				TRACE("CIncCommand::Execute => IncreaseMotion Not Found.\n");
				return;
			}

			// ȼͷǷȷ ---- ǿ 2012-02-07
			if (m_nAxis != 0 && m_nAxis != 1 && m_nAxis != 2
				|| m_nDir != -1 && m_nDir != 0 && m_nDir != 1)
			{
				TRACE("CIncCommand::Execute => ErrorParameter.\n");
				return;
			}

			//  ----  2012-02-23
			double _nDistance = 0.0;
			if (parameter_ != nullptr && parameter_->GetType()->FullName == "System.String")
			{
				using System::Runtime::InteropServices::Marshal;
				const char* _szParameter = (const char*)(Marshal::StringToHGlobalAnsi(parameter_->ToString())).ToPointer();
				if (_szParameter && _szParameter[0])
				{
					_nDistance = atof(_szParameter);
				}

				Marshal::FreeHGlobal(IntPtr((void*)_szParameter));
			}

			if ((_nDistance < 0.001 || 10e+9 < _nDistance) && m_nDir != 0)
			{
				TRACE("CIncCommand::Execute => ErrorParameter: Distance = %.6f\n", _nDistance);
				return;
			}

			if (m_nDir == 0 && !_IIncreaseMotion->IsEntered)
			{
				TRACE("CIncCommand::Execute => AlreadyStop.\n");
				return;
			}

			// ֶ ---- ǿ 2012-02-07
			if (!_IIncreaseMotion->IsEntered && !_IIncreaseMotion->Enter())
			{
				TRACE("CIncCommand::Execute => ErrorState.\n");
				return;
			}

			_IIncreaseMotion->Distance = _nDistance;
			Direction _dir = Direction::Undefined;
			if (m_nDir == -1) _dir = Direction::Negative;
			if (m_nDir == 1) _dir = Direction::Positive;
			_IIncreaseMotion->RunAxis(_dir, m_nAxis);
		}

	protected:
		int m_nAxis;					// 0-x; 1-y; 2-z
		int m_nDir;						// -1:Negative; 0-Stop; 1-Positive
		String^ m_strMotionPath;		// MotionPath, Default => /Kernel0/Channel0/IncreaseMotion0

		// CSharpлȡIIncreaseMotion ---- ǿ 2012-02-07
		IIncreaseMotion^ GetIncreaseMotion()
		{
			if (MCRuntime::Instance == nullptr)
			{
				return nullptr;
			}

			return MCRuntime::Instance->GetComponent<IIncreaseMotion^>(m_strMotionPath);
		}
	};

	// ԽǶĲ˶ջǵõԳĲ˶
	// ฺѽǶתɻò˶             ---- DingQiang 2016-08-09
	public ref class CIncCommand_Degree : public CommandBase
	{
	public:
		CIncCommand_Degree()
		{
			m_nAxis = -1;
			m_nDir = 0;
			m_strMotionPath = "/Kernel0/Channel0/IncreaseMotion0";
		}

		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			Xml::XmlElement^ _xmlElement = addInType_->Element;

			// Axis
			String^ _strAxis = _xmlElement->GetAttribute("Axis");
			if (_strAxis->Equals("0") || _strAxis->Equals("x") || _strAxis->Equals("X"))
				m_nAxis = 0;
			else if (_strAxis->Equals("1") || _strAxis->Equals("y") || _strAxis->Equals("Y"))
				m_nAxis = 1;
			else if (_strAxis->Equals("2") || _strAxis->Equals("z") || _strAxis->Equals("Z"))
				m_nAxis = 2;
			else
				return false;

			// Dir
			String^ _strDir = _xmlElement->GetAttribute("Dir");
			if (_strDir->Equals("N"))
				m_nDir = -1;
			else if (_strDir->Equals("S"))
				m_nDir = 0;
			else if (_strDir->Equals("P"))
				m_nDir = 1;
			else
				return false;

			// Motion
			String^ _strMotionPath = _xmlElement->GetAttribute("Motion");
			if (!_strMotionPath->Equals(""))
				m_strMotionPath = _strMotionPath;
			if (GetIncreaseMotion() == nullptr)
				return false;

			return __super::Build(addInType_, buildError_);
		}

		virtual bool CanExecute(Object^ parameter_) override
		{
			IIncreaseMotion^ _IncMotion = GetIncreaseMotion();
			AbstractMotion^ _Motion = dynamic_cast<AbstractMotion^>(_IncMotion);
			Channel^ _channel = _Motion != nullptr ? _Motion->Owner : nullptr;
			if (_channel == nullptr)
			{
				return false;
			}

			// Ѳܿʼ´˶ΪIsBusyͲܿʼ ----  2014-12-23
			// ֮ǰ IsBusy && is not CurrentMotion Ϊʲô
			// ֻҪIsBusyͲӦٿʼ¸˶Ŷԣ͸ĵ
			// CIncParamerCommandͬҲˣ˭ûȫĴģ
			//if (_IncMotion->IsBusy && _channel->CurrentMotion != _IncMotion)
			if (_IncMotion->IsBusy)
			{
				return false;
			}

			ChannelState _state = _channel->ChannelState;
			if (_state == ChannelState::Estop)
			{
				return false;
			}

			double _nType;
			bool _bRet = _GetParameterValue("#TubeComponent1_TubeType", &_nType);
			ASSERT(_bRet);
			// ܲΪʱ涯򿪲ִWֶ
			ASSERT(GetAbstractBitPortManager()
				&& GetAbstractBitPortManager()->GetBitPort("SBP.Follow"));
			if (_nType == 1
				&& GetAbstractBitPortManager()->GetBitPort("SBP.Follow")->Value)
			{
				return false;
			}

			return true;
		}

		virtual void Execute(Object^ parameter_) override
		{
			TRACE("CIncCommand::Execute => Axis=%d, Dir=%d\n", m_nAxis, m_nDir);

			// ȡֶܲ ---- ǿ 2012-02-07
			IIncreaseMotion^ _IIncreaseMotion = GetIncreaseMotion();
			if (_IIncreaseMotion == nullptr)
			{
				TRACE("CIncCommand::Execute => IncreaseMotion Not Found.\n");
				return;
			}

			// ȼͷǷȷ ---- ǿ 2012-02-07
			if (m_nAxis != 0 && m_nAxis != 1 && m_nAxis != 2
				|| m_nDir != -1 && m_nDir != 0 && m_nDir != 1)
			{
				TRACE("CIncCommand::Execute => ErrorParameter.\n");
				return;
			}

			//  ----  2012-02-23
			double _nDistance = 0.0;
			if (parameter_ != nullptr && parameter_->GetType()->FullName == "System.String")
			{
				using System::Runtime::InteropServices::Marshal;
				const char* _szParameter = (const char*)(Marshal::StringToHGlobalAnsi(parameter_->ToString())).ToPointer();
				if (_szParameter && _szParameter[0])
				{
					_nDistance = atof(_szParameter);
				}

				Marshal::FreeHGlobal(IntPtr((void*)_szParameter));
			}

			if ((_nDistance < 0.001 || 10e+9 < _nDistance) && m_nDir != 0)
			{
				TRACE("CIncCommand::Execute => ErrorParameter: Distance = %.6f\n", _nDistance);
				return;
			}

			if (m_nDir == 0 && !_IIncreaseMotion->IsEntered)
			{
				TRACE("CIncCommand::Execute => AlreadyStop.\n");
				return;
			}

			// ֶ ---- ǿ 2012-02-07
			if (!_IIncreaseMotion->IsEntered && !_IIncreaseMotion->Enter())
			{
				TRACE("CIncCommand::Execute => ErrorState.\n");
				return;
			}

			// ǰһת ---- DingQiang 2016-08-09
			AbstractMotion^ _AbstractMotion = GetAbstractMotion();
			ASSERT(_AbstractMotion != nullptr);
			AbstractAxis^ _AbstractAxis = _AbstractMotion->Owner->Axes[m_nAxis];
			ASSERT(_AbstractAxis != nullptr && _AbstractAxis->IsRotary);
			MockRotaryAxis^ _MockRotaryAxis = (MockRotaryAxis^)_AbstractAxis;
			ASSERT(_MockRotaryAxis != nullptr);

			// Ƕתɻ ---- DingQiang 2016-08-09
			_IIncreaseMotion->Distance = _MockRotaryAxis->AngleToArc(_nDistance);
			Direction _dir = Direction::Undefined;
			if (m_nDir == -1) _dir = Direction::Negative;
			if (m_nDir == 1) _dir = Direction::Positive;
			_IIncreaseMotion->RunAxis(_dir, m_nAxis);
		}

	protected:
		int m_nAxis;					// 0-x; 1-y; 2-z
		int m_nDir;						// -1:Negative; 0-Stop; 1-Positive
		String^ m_strMotionPath;		// MotionPath, Default => /Kernel0/Channel0/IncreaseMotion0

		// CSharpлȡIIncreaseMotion ---- ǿ 2012-02-07
		IIncreaseMotion^ GetIncreaseMotion()
		{
			if (MCRuntime::Instance == nullptr)
			{
				return nullptr;
			}

			return MCRuntime::Instance->GetComponent<IIncreaseMotion^>(m_strMotionPath);
		}

		AbstractMotion^ GetAbstractMotion()
		{
			if (MCRuntime::Instance == nullptr)
			{
				return nullptr;
			}

			return MCRuntime::Instance->GetComponent<AbstractMotion^>(m_strMotionPath);
		}

		AbstractBitPortManager^ GetAbstractBitPortManager()
		{
			if (MCRuntime::Instance == nullptr)
			{
				return nullptr;
			}

			return MCRuntime::Instance->GetComponent<AbstractBitPortManager^>("/Kernel0/BitPortManager0");
		}
	};

	// תֶ ---- ƺ 2017-04-20
	public ref class CJogCommand_Degree : public CJogCommand
	{
	public:
		virtual bool CanExecute(Object^ parameter_) override
		{
			bool _bCabExecute = __super::CanExecute(parameter_);
			ASSERT(GetAbstractBitPortManager()
				&& GetAbstractBitPortManager()->GetBitPort("SBP.Follow"));
			double _nType;
			bool _bRet = _GetParameterValue("#TubeComponent1_TubeType", &_nType);
			ASSERT(_bRet);
			if (_nType == 1
				&& GetAbstractBitPortManager()->GetBitPort("SBP.Follow")->Value)
			{
				return false;
			}

			return _bCabExecute;
		}

		AbstractBitPortManager^ GetAbstractBitPortManager()
		{
			if (MCRuntime::Instance == nullptr)
			{
				return nullptr;
			}

			return MCRuntime::Instance->GetComponent<AbstractBitPortManager^>("/Kernel0/BitPortManager0");
		}
	};

	// ָٶȵĲCommand ---- DingQiang 2013-09-16
	public ref class CIncParamerCommand : public CommandBase
	{
	public:
		CIncParamerCommand()
		{
			m_nAxis = -1;
			m_nDir = 0;
			m_strMotionPath = "/Kernel0/Channel1/IncreaseMotion1";
			m_strIncParam = "";
			m_strIncVelocity = "";
		}

		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			Xml::XmlElement^ _xmlElement = addInType_->Element;

			// Axis
			String^ _strAxis = _xmlElement->GetAttribute("Axis");
			if (_strAxis->Equals("0") || _strAxis->Equals("x") || _strAxis->Equals("X"))
				m_nAxis = 0;
			else if (_strAxis->Equals("1") || _strAxis->Equals("y") || _strAxis->Equals("Y"))
				m_nAxis = 1;
			else if (_strAxis->Equals("2") || _strAxis->Equals("z") || _strAxis->Equals("Z"))
				m_nAxis = 2;
			else
				return false;

			// Dir
			String^ _strDir = _xmlElement->GetAttribute("Dir");
			if (_strDir->Equals("N"))
				m_nDir = -1;
			else if (_strDir->Equals("S"))
				m_nDir = 0;
			else if (_strDir->Equals("P"))
				m_nDir = 1;
			else
				return false;

			// Inc
			m_strIncParam = _xmlElement->GetAttribute("ParameterInc");
			m_strIncVelocity = _xmlElement->GetAttribute("ParameterVelocity");

			// Motion
			String^ _strMotionPath = _xmlElement->GetAttribute("Motion");
			if (!_strMotionPath->Equals(""))
				m_strMotionPath = _strMotionPath;
			if (GetIncreaseMotion() == nullptr)
				return false;

			return __super::Build(addInType_, buildError_);
		}

		virtual bool CanExecute(Object^ parameter_) override
		{
			IIncreaseMotion^ _IncMotion = GetIncreaseMotion();
			AbstractMotion^ _Motion = dynamic_cast<AbstractMotion^>(_IncMotion);
			Channel^ _channel = _Motion != nullptr ? _Motion->Owner : nullptr;
			if (_channel == nullptr)
			{
				return false;
			}

			// μ CIncCommand::CanExecute ----  2014-12-23
			//if (_IncMotion->IsBusy && _channel->CurrentMotion != _IncMotion)
			if (_IncMotion->IsBusy)
			{
				return false;
			}

			ChannelState _state = _channel->ChannelState;
			if (_state == ChannelState::Estop)
			{
				return false;
			}

			return true;
		}

		virtual void Execute(Object^ parameter_) override
		{
			TRACE("CIncCommand::Execute => Axis=%d, Dir=%d\n", m_nAxis, m_nDir);

			// ȡֶܲ ---- ǿ 2012-02-07
			IIncreaseMotion^ _IIncreaseMotion = GetIncreaseMotion();
			if (_IIncreaseMotion == nullptr)
			{
				TRACE("CIncCommand::Execute => IncreaseMotion Not Found.\n");
				return;
			}

			// ȼͷǷȷ ---- ǿ 2012-02-07
			if (m_nAxis != 0 && m_nAxis != 1 && m_nAxis != 2
				|| m_nDir != -1 && m_nDir != 0 && m_nDir != 1)
			{
				TRACE("CIncCommand::Execute => ErrorParameter.\n");
				return;
			}

			if (m_strIncParam->Equals(""))
			{
				return;
			}

			double _nDistance = 0.0;

			// Ȱķʽò ---- DingQiang 2013-09-05
			IParameterNode^ _ParamNode =
				MCRuntime::Instance != nullptr && MCRuntime::Instance->DataManager != nullptr
				? MCRuntime::Instance->DataManager->GetParaemterNode(m_strIncParam) : nullptr;
			if (_ParamNode != nullptr)
			{
				mach::ParameterValue _ParameterValue;
				memset(&_ParameterValue, 0, sizeof(mach::ParameterValue));
				if (!_GetParameterValue(_ParamNode, &_ParameterValue))
				{
					return;
				}

				ASSERT(_ParameterValue.nType == mach::ParameterValue::VT_DOUBLE);
				_nDistance = _ParameterValue.dValue;
			}
			else
			{
				using System::Runtime::InteropServices::Marshal;
				const char* _szParameter = (const char*)(Marshal::StringToHGlobalAnsi(m_strIncParam)).ToPointer();
				if (_szParameter && _szParameter[0])
				{
					_nDistance = atof(_szParameter);
				}

				Marshal::FreeHGlobal(IntPtr((void*)_szParameter));
			}

			double _nVelocity = 0;
			_ParamNode = MCRuntime::Instance != nullptr && MCRuntime::Instance->DataManager != nullptr
				? MCRuntime::Instance->DataManager->GetParaemterNode(m_strIncVelocity) : nullptr;
			// Ȱķʽٶ ---- DingQiang 2013-09-05
			if (_ParamNode != nullptr)
			{
				mach::ParameterValue _ParameterValue;
				memset(&_ParameterValue, 0, sizeof(mach::ParameterValue));
				if (!_GetParameterValue(_ParamNode, &_ParameterValue))
				{
					return;
				}

				ASSERT(_ParameterValue.nType == mach::ParameterValue::VT_DOUBLE);
				_nVelocity = _ParameterValue.dValue;
			}
			else
			{
				using System::Runtime::InteropServices::Marshal;
				const char* _szParameter = (const char*)(Marshal::StringToHGlobalAnsi(m_strIncVelocity)).ToPointer();
				if (_szParameter && _szParameter[0])
				{
					_nVelocity = atof(_szParameter);
				}

				Marshal::FreeHGlobal(IntPtr((void*)_szParameter));
			}

			if (_nVelocity > 0)
			{
				_IIncreaseMotion->Velocity = _nVelocity / 60;
			}

			if (_nDistance < 0.001 || 10e+9 < _nDistance)
			{
				TRACE("CIncCommand::Execute => ErrorParameter: Distance = %.6f\n", _nDistance);
				return;
			}

			if (m_nDir == 0 && !_IIncreaseMotion->IsEntered)
			{
				TRACE("CIncCommand::Execute => AlreadyStop.\n");
				return;
			}

			// ֶ ---- ǿ 2012-02-07
			if (!_IIncreaseMotion->IsEntered && !_IIncreaseMotion->Enter())
			{
				TRACE("CIncCommand::Execute => ErrorState.\n");
				return;
			}

			_IIncreaseMotion->Distance = _nDistance;
			Direction _dir = Direction::Undefined;
			if (m_nDir == -1) _dir = Direction::Negative;
			if (m_nDir == 1) _dir = Direction::Positive;
			_IIncreaseMotion->RunAxis(_dir, m_nAxis);
		}

	protected:
		int m_nAxis;					// 0-x; 1-y; 2-z
		int m_nDir;						// -1:Negative; 0-Stop; 1-Positive
		String^ m_strMotionPath;		// MotionPath, Default => /Kernel0/Channel0/IncreaseMotion0
		String^ m_strIncParam;			// 
		String^ m_strIncVelocity;		// ٶ

		// CSharpлȡIIncreaseMotion ---- ǿ 2012-02-07
		IIncreaseMotion^ GetIncreaseMotion()
		{
			if (MCRuntime::Instance == nullptr)
			{
				return nullptr;
			}

			return MCRuntime::Instance->GetComponent<IIncreaseMotion^>(m_strMotionPath);
		}
	};

	////////////////////////////////////////////////////////////////////////////
	// ֶͨ ----  2012-07-24
	// 
	public ref class CIncCommand_ViaInterp : public CommandBase
	{
	public:
		CIncCommand_ViaInterp()
		{
			m_nAxis = -1;
			m_nDir = 0;
			m_strSpeedParam = "";
			m_strMotionType = "G01";
		}

		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			// Axis & Dir
			Xml::XmlElement^ _xmlElement = addInType_->Element;
			String^ _strAxis = _xmlElement->GetAttribute("Axis");
			if (_strAxis->Equals("x") || _strAxis->Equals("X"))
				m_nAxis = 0;
			else if (_strAxis->Equals("y") || _strAxis->Equals("Y"))
				m_nAxis = 1;
			else if (_strAxis->Equals("z") || _strAxis->Equals("Z"))
				m_nAxis = 2;
			else
				return false;

			String^ _strDir = _xmlElement->GetAttribute("Dir");
			if (_strDir->Equals("N"))
				m_nDir = -1;
			else if (_strDir->Equals("S"))
				m_nDir = 0;
			else if (_strDir->Equals("P"))
				m_nDir = 1;
			else
				return false;

			m_strSpeedParam = _xmlElement->GetAttribute("Speed");

			// ֶG00G01 ---- DingQiang 2016-10-20
			String^ _strMotionType = _xmlElement->GetAttribute("MotionType");
			if (!String::IsNullOrEmpty(_strMotionType))
			{
				if (String::Compare(_strMotionType, "G00", true) == 0 || String::Compare(_strMotionType, "G01", true) == 0)
				{
					m_strMotionType = _strMotionType;
				}
				else
				{
					ASSERT(FALSE);
					return false;
				}
			}

			return __super::Build(addInType_, buildError_);
		}

		virtual bool CanExecute(Object^ parameter_) override
		{
			bool _bCanExecute = false;
			if (mach::CCommandManager* _pCommandManager = mach::GetCommandManager())
			{
				if (m_nDir == 0)
				{
					_pCommandManager->CanExecute("Stop", &_bCanExecute);
				}
				else
				{
					CStringA _strGCode = _GetGCode(parameter_);
					_pCommandManager->CanExecute("RunGCode", _strGCode, "LPCSTR", &_bCanExecute);
				}
			}

			return _bCanExecute;
		}

		virtual void Execute(Object^ parameter_) override
		{
			TRACE("CIncCommand::Execute => Axis=%d, Dir=%d\n", m_nAxis, m_nDir);

			if (mach::CCommandManager* _pCommandManager = mach::GetCommandManager())
			{
				if (m_nDir == 0)
				{
					_pCommandManager->Execute("Stop");
				}
				else
				{
					CStringA _strGCode = _GetGCode(parameter_);
					_pCommandManager->Execute("RunGCode", _strGCode, "LPCSTR");
				}
			}
		}

	protected:
		int m_nAxis;				// 0-x; 1-y; 2-z
		int m_nDir;					// -1:Negative; 0-Stop; 1-Positive
		String^ m_strSpeedParam;	// ٶȲǱ(һֵ,Ҳһ)
		String^ m_strMotionType;	// ˶ͣĬG01,óG00
		CStringA _GetGCode(Object^ parameter_)
		{
			//  ----  2012-07-24
			double _nDistance = 0.0;
			if (parameter_ != nullptr && parameter_->GetType()->FullName == "System.String")
			{
				using System::Runtime::InteropServices::Marshal;
				const char* _szParameter = (const char*)(Marshal::StringToHGlobalAnsi(parameter_->ToString())).ToPointer();
				if (_szParameter && _szParameter[0])
				{
					_nDistance = atof(_szParameter);
				}

				Marshal::FreeHGlobal(IntPtr((void*)_szParameter));
			}
			ASSERT(_nDistance > 0);

			// ٶȲ
			double _nVelocity = 0;

			if (m_strSpeedParam->Length == 0)
			{
				// ٶ ----  2012-07-24
				mach::ParameterValue _SpeedValue;
				memset(&_SpeedValue, 0, sizeof(mach::ParameterValue));
				mach::CParamManager* _pParamManager = mach::GetParamManager();
				if (!_pParamManager
					|| !_pParamManager->GetParameterValue("SpeedInc", &_SpeedValue)
					|| _SpeedValue.nType != mach::ParameterValue::VT_DOUBLE)
				{
					ASSERT(FALSE);
					return "";
				}
				ASSERT(_SpeedValue.dValue > 0);
				_nVelocity = _SpeedValue.dValue;
			}
			else
			{
				using System::Runtime::InteropServices::Marshal;
				mach::ParameterValue _SpeedValue;
				memset(&_SpeedValue, 0, sizeof(mach::ParameterValue));
				mach::CParamManager* _pParamManager = mach::GetParamManager();
				if (_pParamManager
					&& _pParamManager->GetParameterValue((LPCSTR)(Marshal::StringToHGlobalAnsi(m_strSpeedParam)).ToPointer(), &_SpeedValue)
					&& _SpeedValue.nType == mach::ParameterValue::VT_DOUBLE)
				{
					_nVelocity = _SpeedValue.dValue;
				}
				else
				{
					using System::Runtime::InteropServices::Marshal;
					const char* _szParameter = (const char*)(Marshal::StringToHGlobalAnsi(m_strSpeedParam)).ToPointer();
					if (_szParameter && _szParameter[0])
					{
						_nVelocity = atof(_szParameter);
					}

					Marshal::FreeHGlobal(IntPtr((void*)_szParameter));
				}
			}

			ASSERT(_nVelocity > 0.);

			// GCode ----  2012-07-24
			ASSERT(m_nAxis == 0 || m_nAxis == 1 || m_nAxis == 2);
			ASSERT(m_nDir == -1 || m_nDir == 1);
			static const CStringA _s_strGCodes[] =
			{
				"N01 G905 G91 %s X%f F%d\n",
				"N01 G905 G91 %s Y%f F%d\n",
				"N01 G905 G91 %s Z%f F%d\n",
			};
			CStringA _strGCode;
			_strGCode.Format(_s_strGCodes[m_nAxis], m_strMotionType, m_nDir * _nDistance, int(_nVelocity));
			return _strGCode;
		}
	};

	////////////////////////////////////////////////////////////////////////////
	// ԤĿʼ
	// 
	public ref class TaskStartOrContineCommand_PreAction: public TaskStartOrContineCommand
	{
	public:
		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			// PreAction="OpenPort(OUT11) Delay(200) OpenPort(OIL) Delay(100) OpenPort(SPIN) Delay(60)"
			m_strPreAction = addInType_->Element->GetAttribute("PreAction");
			m_action = gcnew Action<Object^>(this, &TaskStartOrContineCommand_PreAction::Continue);
			return __super::Build(addInType_, buildError_);
		}

		virtual void Execute(Object^ parameter) override
		{	
			if (this->AbstractTaskMotion->Owner->ChannelState == ChannelState::Pausing
				&& GetAbstractBitPortManager()->GetBitPort("SBP.MotionGxx")->Value)
			{
				this->m_action->BeginInvoke(parameter, nullptr, nullptr);
			}
			else
			{
				__super::Execute(parameter);
			}
		}

	protected:
		void Continue(Object^ parameter)
		{
			try
			{
				array<Char>^ _arraySplitChars = {' ', ';', '\t', '\r', '\n'};
				array<String^>^ _arrayActions = m_strPreAction->Split(_arraySplitChars);
				for (int _i = 0; _i < _arrayActions->Length; _i++)
				{
					if (!CanExecute(parameter))
					{
						return;
					}

					String^ _strAction = _arrayActions[_i];
					DoAction(_strAction);
				}
			}
			catch (Exception^ e_)
			{
				MCRuntime::Instance->Application->BeginCall(gcnew Action<Exception^>(this, &TaskStartOrContineCommand_PreAction::ThrowException), gcnew cli::array<Object^> {e_});
			}

			if (__super::CanExecute(parameter))
			{
				__super::Execute(parameter);
			}
		}

		void ThrowException(Exception^ e_)
		{
			throw gcnew Exception(e_->ToString());
		}

		void DoAction(String^ strAction_)
		{
			if (strAction_ == nullptr)
			{
				return;
			}

			array<Char>^ _arrayTrimChars = {'=', '(', ')'};
			if (strAction_->StartsWith("Delay"))
			{
				String^ _strDelayTime = strAction_->Substring(5)->Trim(_arrayTrimChars);
				ASSERT(_strDelayTime->Length > 0);
				int _nDelayMS = 0;
				try
				{
					_nDelayMS = Int32::Parse(_strDelayTime);
				}
				catch (...)
				{
					// ֧#򿪵ķʽ ----  2012-08-29
					ASSERT(_nDelayMS == 0);
					ASSERT(_strDelayTime->Substring(0, 1)->Equals("#"));
					_nDelayMS = GetNamedParameter_Int32(_strDelayTime->Substring(1));
				}

				Thread::Sleep(_nDelayMS);
			}
			else if (strAction_->StartsWith("OpenPort"))
			{
				String^ _strPortIdentifier = strAction_->Substring(8)->Trim(_arrayTrimChars);
				GetAbstractBitPortManager()->GetBitPort(_strPortIdentifier)->Value = true;
			}
			else if (strAction_->StartsWith("ClosePort"))
			{
				String^ _strPortIdentifier = strAction_->Substring(9)->Trim(_arrayTrimChars);
				GetAbstractBitPortManager()->GetBitPort(_strPortIdentifier)->Value = false;
			}
			else if (strAction_->StartsWith("WaitPort"))
			{
				String^ _strWaitItem= strAction_->Substring(8)->Trim(_arrayTrimChars);
				array<String^>^ _arrayParams = _strWaitItem->Split(',');
				if (_arrayParams->Length != 2 && _arrayParams->Length != 3)
				{
					ASSERT(FALSE);
					return;
				}

				ASSERT(_arrayParams[1] == "0" || _arrayParams[1] == "1");
				String^ _strWaitPortIdentifier = _arrayParams[0];
				bool _bWaitState = (_arrayParams[1] != "0");
				int _nWaitTime = 24 * 3600 * 1000; // һΪ޵ȴʱ  ---- DingQiang 2012-10-25
				if (_arrayParams->Length == 3)
				{
					String^ _strWaitTime = _arrayParams[2];
					try
					{
						_nWaitTime = Int32::Parse(_strWaitTime);
					}
					catch (...)
					{
						// ֧#򿪵ķʽ ----  2012-08-29
						ASSERT(_nWaitTime == 24 * 3600 * 1000);
						ASSERT(_strWaitTime->Substring(0, 1)->Equals("#"));
						_nWaitTime = GetNamedParameter_Int32(_strWaitTime->Substring(1));
					}
				}

				IMCBitPort^ _BitPort = GetAbstractBitPortManager()->GetBitPort(_strWaitPortIdentifier);
				if (_BitPort == nullptr)
				{
					ASSERT(FALSE);
					return;
				}

				DWORD _nBeginTime = ::GetTickCount();
				while(true)
				{
					if(_BitPort->Value == _bWaitState)
					{
						break;
					}

					if (::GetTickCount() - _nBeginTime >= (DWORD)_nWaitTime)
					{
						break;
					}

					Thread::Sleep(20);
				}
			}
			else if (strAction_->StartsWith("#"))
			{
				int _nEqualIndex = strAction_->IndexOf("=");
				String^ _strParamName = strAction_->Substring(0, _nEqualIndex)->Trim('#');
				String^ _strValue = strAction_->Substring(_nEqualIndex + 1, strAction_->Length - (_nEqualIndex + 1));
				int _nValue = 0;
				if (_strValue->Substring(0, 1) != "#")
				{
					_nValue = Int32::Parse(_strValue);
				}
				else
				{
					_strValue = _strValue->Trim('#');
					_nValue = GetNamedParameter_Int32(_strValue);
				}

				SetNamedParameter_Int32(_strParamName, _nValue);
			}
		}

		AbstractBitPortManager^ GetAbstractBitPortManager()
		{
			if (MCRuntime::Instance == nullptr)
			{
				return nullptr;
			}

			return MCRuntime::Instance->GetComponent<AbstractBitPortManager^>("/Kernel0/BitPortManager0");
		}

		void SetNamedParameter_Int32(String^ strParamName_, int nValue_)
		{
			// Get Parameter Node ----  2012-08-29
			MCDataManager^ _DataManager =
				MCRuntime::Instance != nullptr
				&& MCRuntime::Instance->DataManager != nullptr
				? MCRuntime::Instance->DataManager : nullptr;
			if (_DataManager == nullptr)
			{
				return;
			}

			IParameterNode^ _ParamNode = _DataManager->GetParaemterNode(strParamName_);
			if (_ParamNode == nullptr)
			{
				return;
			}

			if (_ParamNode->Value->GetType()->FullName == "System.Int32")
			{
				_ParamNode->Value = nValue_;
			}
			else if (_ParamNode->Value->GetType()->FullName == "System.Boolean")
			{
				_ParamNode->Value = safe_cast<bool>(nValue_);
			}
		}

		int GetNamedParameter_Int32(String^ strParamName_)
		{
			// Get Parameter Node ----  2012-08-29
			MCDataManager^ _DataManager =
				MCRuntime::Instance != nullptr
				&& MCRuntime::Instance->DataManager != nullptr
				? MCRuntime::Instance->DataManager : nullptr;
			if (_DataManager == nullptr)
			{
				return 0;
			}

			IParameterNode^ _ParamNode = _DataManager->GetParaemterNode(strParamName_);
			if (_ParamNode == nullptr)
			{
				return 0;
			}

			// Get Parameter Value ----  2012-08-29
			int _nParamValue = 0;
			if (_ParamNode->Value->GetType()->FullName == "System.Int32")
			{
				_nParamValue = safe_cast<int>(_ParamNode->Value);
			}
			else if (_ParamNode->Value->GetType()->FullName == "System.Boolean")
			{
				bool _nValue = safe_cast<bool>(_ParamNode->Value);
				if (_nValue)
				{
					_nParamValue = 1;
				}
				else
				{
					_nParamValue = 0;
				}
			}

			return _nParamValue;
		}

	private:
		Action<Object^>^ m_action;
		String^ m_strPreAction;
	};

	////////////////////////////////////////////////////////////////////////////
	// ԤĿʼԤͨLuaļö
	// ---- ƺ 2015-09-14
	public ref class TaskStartOrContineCommand_PreActionInLua: public TaskStartOrContineCommand
	{
	public:
		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			m_action = gcnew Action<Object^>(this, &TaskStartOrContineCommand_PreActionInLua::Continue);
			m_bContinuing = false;
			m_strZMotionType = addInType_->Element->GetAttribute("ZMotionType");
			return __super::Build(addInType_, buildError_);
		}

		virtual void Execute(Object^ parameter) override
		{
			if (!CanExecute(parameter))
				return;

			AbstractBitPortManager^ _pBitPortManager = GetAbstractBitPortManager();
			IMCBitPort^ _pGxx = _pBitPortManager == nullptr ? nullptr : _pBitPortManager->GetBitPort("SBP.MotionGxx");
			if (this->AbstractTaskMotion->Owner->ChannelState == ChannelState::Pausing
				&& _pGxx && _pGxx->Value)
			{
				this->m_action->BeginInvoke(parameter, nullptr, nullptr);
			}
			else
			{
				__super::Execute(parameter);
			}
		}

	protected:
		void Continue(Object^ parameter)
		{
			if (m_bContinuing)
				return;
			m_bContinuing = true;

			CString _strParam;
			_BuildParam(_strParam);

			CPPLuaState* _pLuaState = GetPPLuaState();
			CString _strContinueAction;
			if (!_pLuaState
				|| !_pLuaState->Lua_GetActionCode(_strParam, "GetContinueActions", &_strContinueAction)
				|| _strContinueAction.IsEmpty())
			{
				ASSERT(FALSE);
			}

			g_sPauseActionParser.Reset();
			g_sPauseActionParser.DoParser(_strContinueAction);
			AbstractBitPortManager^ _pBitPortManager = GetAbstractBitPortManager();
			IMCBitPort^ _pGxx = _pBitPortManager == nullptr ? nullptr : _pBitPortManager->GetBitPort("SBP.MotionGxx");
			while (!g_sPauseActionParser.IsIdle())
			{
				if (!CanExecute(parameter)
					|| _pGxx == nullptr
					|| !_pGxx->Value)
				{
					g_sPauseActionParser.Reset();
					break;
				}
				g_sPauseActionParser.OnStep();
			}

			if (__super::CanExecute(parameter))
			{
				__super::Execute(parameter);
			}

			m_bContinuing = false;
		}

		void _BuildParam(CString& strParam_)
		{
			CString _strParameter;
			if (!GetCurLayerParam(&_strParameter))
			{
				ASSERT(FALSE);
			}
			double _nZMotionType = 0.0;
			if (m_strZMotionType
				&& m_strZMotionType->Length > 0
				&& _GetParameterValue(m_strZMotionType, &_nZMotionType))
			{
				CString _str;
				_str.Format("PunchState=%d", int(_nZMotionType));
				_strParameter.Append(_str);
			}
			strParam_ = _strParameter;
		}

		AbstractBitPortManager^ GetAbstractBitPortManager()
		{
			if (MCRuntime::Instance == nullptr)
			{
				return nullptr;
			}

			return MCRuntime::Instance->GetComponent<AbstractBitPortManager^>("/Kernel0/BitPortManager0");
		}

	private:
		Action<Object^>^ m_action;
		String^ m_strPreAction;
		bool m_bContinuing;
		String^ m_strZMotionType;
	};

	////////////////////////////////////////////////////////////////////////////////
	// кͣ
	// 
	public ref class TaskPauseCommand_PostAction : public TaskPauseCommand
	{
	public:
		TaskPauseCommand_PostAction():m_bPause(false){}
		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			// PostAction="ClosePort(SPIN) ClosePort(OIL) ClosePort(OUT11) OpenPort(OUT12) Delay(300) ClosePort(OUT12)"
			m_strPostAction = addInType_->Element->GetAttribute("PostAction");
			m_action = gcnew Action(this, &TaskPauseCommand_PostAction::Pause);
			return __super::Build(addInType_, buildError_);
		}

		virtual void Execute(Object^ parameter_) override
		{
			// Ϊͣˣֵͨͣ״ָ̬ͣġ ---- ƺ 2014-06-20
			_CloseScanCutting();
			m_bPause = true;
			__super::Execute(parameter_);
		}

	protected:
		virtual void Initialize() override
		{
			__super::Initialize();

			if (this->AbstrackTask != nullptr)
			{
				this->AbstrackTask->Owner->StateChanged += gcnew EventHandler<ChannelStateChangeEventArgs^>(this,&TaskPauseCommand_PostAction::channel_StateChanged);
			}
		}

		void Pause()
		{
			try
			{
				array<Char>^ _arraySplitChars = {' ', ';', '\t', '\r', '\n'};
				array<String^>^ _arrayActions = m_strPostAction->Split(_arraySplitChars);
				for (int _i = 0; _i < _arrayActions->Length; _i++)
				{
					String^ _strAction = _arrayActions[_i];
					DoAction(_strAction);
				}
			}
			catch (Exception^ e_)
			{
				MCRuntime::Instance->Application->BeginCall(gcnew Action<Exception^>(this, &TaskPauseCommand_PostAction::ThrowException), gcnew cli::array<Object^> {e_});
			}
		}

		void ThrowException(Exception^ e_)
		{
			throw gcnew Exception(e_->ToString());
		}

		void DoAction(String^ strAction_)
		{
			if (strAction_ == nullptr)
			{
				return;
			}

			if (this->AbstractTaskMotion != this->AbstractTaskMotion->Owner->CurrentMotion
				|| !GetAbstractBitPortManager()->GetBitPort("SBP.MotionGxx")->Value)
			{
				return;
			}

			array<Char>^ _arrayTrimChars = {'=', '(', ')'};
			if (strAction_->StartsWith("Delay"))
			{
				String^ _strDelayTime = strAction_->Substring(5)->Trim(_arrayTrimChars);
				ASSERT(_strDelayTime->Length > 0);
				int _nDelayMS = 0;
				try
				{
					_nDelayMS = Int32::Parse(_strDelayTime);
				}
				catch (...)
				{
					// ֧#򿪵ķʽ ----  2012-08-29
					ASSERT(_nDelayMS == 0);
					ASSERT(_strDelayTime->Substring(0, 1)->Equals("#"));
					_nDelayMS = GetNamedParameter_Int32(_strDelayTime->Substring(1));
				}

				Thread::Sleep(_nDelayMS);
			}
			else if (strAction_->StartsWith("OpenPort"))
			{
				String^ _strPortIdentifier = strAction_->Substring(8)->Trim(_arrayTrimChars);
				GetAbstractBitPortManager()->GetBitPort(_strPortIdentifier)->Value = true;
			}
			else if (strAction_->StartsWith("ClosePort"))
			{
				String^ _strPortIdentifier = strAction_->Substring(9)->Trim(_arrayTrimChars);
				GetAbstractBitPortManager()->GetBitPort(_strPortIdentifier)->Value = false;
			}
			else if (strAction_->StartsWith("WaitPort"))
			{
				String^ _strWaitItem= strAction_->Substring(8)->Trim(_arrayTrimChars);
				array<String^>^ _arrayParams = _strWaitItem->Split(',');
				if (_arrayParams->Length != 2 && _arrayParams->Length != 3)
				{
					ASSERT(FALSE);
					return;
				}

				ASSERT(_arrayParams[1] == "0" || _arrayParams[1] == "1");
				String^ _strWaitPortIdentifier = _arrayParams[0];
				bool _bWaitState = (_arrayParams[1] != "0");
				int _nWaitTime = 24 * 3600 * 1000; // һΪ޵ȴʱ  ---- DingQiang 2012-10-25
				if (_arrayParams->Length == 3)
				{
					String^ _strWaitTime = _arrayParams[2];
					try
					{
						_nWaitTime = Int32::Parse(_strWaitTime);
					}
					catch (...)
					{
						// ֧#򿪵ķʽ ----  2012-08-29
						ASSERT(_nWaitTime == 24 * 3600 * 1000);
						ASSERT(_strWaitTime->Substring(0, 1)->Equals("#"));
						_nWaitTime = GetNamedParameter_Int32(_strWaitTime->Substring(1));
					}
				}

				IMCBitPort^ _BitPort = GetAbstractBitPortManager()->GetBitPort(_strWaitPortIdentifier);
				if (_BitPort == nullptr)
				{
					ASSERT(FALSE);
					return;
				}

				DWORD _nBeginTime = ::GetTickCount();
				while(true)
				{
					if(_BitPort->Value == _bWaitState)
					{
						break;
					}

					if (::GetTickCount() - _nBeginTime >= (DWORD)_nWaitTime)
					{
						break;
					}

					Thread::Sleep(20);
				}
			}
			else if (strAction_->StartsWith("#"))
			{
				int _nEqualIndex = strAction_->IndexOf("=");
				String^ _strParamName = strAction_->Substring(0, _nEqualIndex)->Trim('#');
				String^ _strValue = strAction_->Substring(_nEqualIndex + 1, strAction_->Length - (_nEqualIndex + 1));
				int _nValue = 0;
				if (_strValue->Substring(0, 1) != "#")
				{
					_nValue = Int32::Parse(_strValue);
				}
				else
				{
					_strValue = _strValue->Trim('#');
					_nValue = GetNamedParameter_Int32(_strValue);
				}

				SetNamedParameter_Int32(_strParamName, _nValue);
			}
		}

		AbstractBitPortManager^ GetAbstractBitPortManager()
		{
			if (MCRuntime::Instance == nullptr)
			{
				return nullptr;
			}

			return MCRuntime::Instance->GetComponent<AbstractBitPortManager^>("/Kernel0/BitPortManager0");
		}

		void SetNamedParameter_Int32(String^ strParamName_, int nValue_)
		{
			// Get Parameter Node ----  2012-08-29
			MCDataManager^ _DataManager =
				MCRuntime::Instance != nullptr
				&& MCRuntime::Instance->DataManager != nullptr
				? MCRuntime::Instance->DataManager : nullptr;
			if (_DataManager == nullptr)
			{
				return;
			}

			IParameterNode^ _ParamNode = _DataManager->GetParaemterNode(strParamName_);
			if (_ParamNode == nullptr)
			{
				return;
			}

			if (_ParamNode->Value->GetType()->FullName == "System.Int32")
			{
				_ParamNode->Value = nValue_;
			}
			else if (_ParamNode->Value->GetType()->FullName == "System.Boolean")
			{
				_ParamNode->Value = safe_cast<bool>(nValue_);
			}
		}

		int GetNamedParameter_Int32(String^ strParamName_)
		{
			// Get Parameter Node ----  2012-08-29
			MCDataManager^ _DataManager =
				MCRuntime::Instance != nullptr
				&& MCRuntime::Instance->DataManager != nullptr
				? MCRuntime::Instance->DataManager : nullptr;
			if (_DataManager == nullptr)
			{
				return 0;
			}

			IParameterNode^ _ParamNode = _DataManager->GetParaemterNode(strParamName_);
			if (_ParamNode == nullptr)
			{
				return 0;
			}

			// Get Parameter Value ----  2012-08-29
			int _nParamValue = 0;
			if (_ParamNode->Value->GetType()->FullName == "System.Int32")
			{
				_nParamValue = safe_cast<int>(_ParamNode->Value);
			}
			else if (_ParamNode->Value->GetType()->FullName == "System.Boolean")
			{
				bool _bValue = safe_cast<bool>(_ParamNode->Value);
				if (_bValue)
				{
					_nParamValue = 1;
				}
				else
				{
					_nParamValue = 0;
				}
			}

			return _nParamValue;
		}

		void channel_StateChanged(Object^ sender_, ChannelStateChangeEventArgs^ e_)
		{
			if (e_->NewState == ChannelState::Running
				|| e_->NewState == ChannelState::Lock
				|| e_->NewState == ChannelState::Estop)
			{
				m_bPause = false;
			}

			if (m_bPause && e_->NewState == ChannelState::Pausing)
			{
				this->m_action->BeginInvoke(nullptr, nullptr);
			}
		}

	private:
		bool m_bPause;					// Ƿֹͣͣ
		Action^ m_action;
		String^ m_strPostAction;
	};

	////////////////////////////////////////////////////////////////////////////////
	// кͣ,ͨluaö
	// ---- ƺ 2015-09-22
	public ref class TaskPauseCommand_PostActionInLua : public TaskPauseCommand
	{
	public:
		TaskPauseCommand_PostActionInLua():m_bPause(false){}
		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			m_action = gcnew Action(this, &TaskPauseCommand_PostActionInLua::Pause);
			m_arrBrachChannels = gcnew array<Channel^>{};
			return __super::Build(addInType_, buildError_);
		}

		virtual void Execute(Object^ parameter_) override
		{
			// Ϊͣˣֵͨͣ״ָ̬ͣġ ---- ƺ 2014-06-20
			m_bPause = true;
			__super::Execute(parameter_);

			// ֹͣͨ˶ ---- ƺ 2016-01-22
			if (m_arrBrachChannels == nullptr)
				return;
			for (int _i = 0; _i < m_arrBrachChannels->Length; _i++)
			{
				Channel^ _chanel = m_arrBrachChannels[_i];
				if (_chanel == nullptr)
					continue;
				IMotion^ _motion = _chanel->CurrentMotion;
				if (_motion != nullptr
					&& _motion->IsEntered
					&& !_motion->IsLeaving)
				{
					_motion->BeginLeave(false,nullptr,nullptr);
				}
			}
		}

	protected:
		virtual void Initialize() override
		{
			__super::Initialize();

			if (this->AbstrackTask != nullptr)
			{
				this->AbstrackTask->Owner->StateChanged += gcnew EventHandler<ChannelStateChangeEventArgs^>(this,&TaskPauseCommand_PostActionInLua::channel_StateChanged);
			}

			for (int _i = 0; _i < 10; _i++)
			{
				String^ _strName = String::Format("BranchChannel{0}", _i);
				Channel^ _channel = this->MCRefComponentManager->GetComponent<Channel^>(_strName);
				if (_channel == nullptr)
					break;
				m_arrBrachChannels->Resize(m_arrBrachChannels, _i + 1);
				m_arrBrachChannels[_i] = _channel;
			}
		}

		void Pause()
		{
			CString _strCurLayerParam;
			if (!GetCurLayerParam(&_strCurLayerParam))
			{
				ASSERT(FALSE);
				return;
			}
			CPPLuaState* _pLuaState = GetPPLuaState();
			if (!_pLuaState)
			{
				ASSERT(FALSE);
				return;
			}

			CString _strContinueAction;
			if (!_pLuaState->Lua_GetActionCode(_strCurLayerParam, "GetPauseActions", &_strContinueAction)
				|| _strContinueAction.IsEmpty())
			{
				ASSERT(FALSE);
				return;
			}

			g_sPauseActionParser.Reset();
			g_sPauseActionParser.DoParser(_strContinueAction);
			while (!g_sPauseActionParser.IsIdle()
				&& GetAbstractBitPortManager()->GetBitPort("SBP.MotionGxx")->Value)
			{
				g_sPauseActionParser.OnStep();
			}
		}

		void channel_StateChanged(Object^ sender_, ChannelStateChangeEventArgs^ e_)
		{
			if (e_->NewState == ChannelState::Running
				|| e_->NewState == ChannelState::Lock
				|| e_->NewState == ChannelState::Estop)
			{
				m_bPause = false;
			}

			if (m_bPause && e_->NewState == ChannelState::Pausing)
			{
				this->m_action->BeginInvoke(nullptr, nullptr);
			}
		}

		AbstractBitPortManager^ GetAbstractBitPortManager()
		{
			if (MCRuntime::Instance == nullptr)
			{
				return nullptr;
			}

			return MCRuntime::Instance->GetComponent<AbstractBitPortManager^>("/Kernel0/BitPortManager0");
		}

	private:
		bool m_bPause;						// Ƿֹͣͣ
		Action^ m_action;					// ͣ
		array<Channel^>^ m_arrBrachChannels;// ͨ
	};

	////////////////////////////////////////////////////////////////////////////////
	// ֹͣȫͨĵǰ˶ ----  2014-12-25
	//
	public ref class SystemStopCommand_AllChannel : public CommandBase
	{
		// ֹͣĲǣ
		// 1ͨ˶ʱ򣬾ֱֹͣͨ˶Ȼͨ˶NextReady˶ֹͣͨ
		// 2ͨû˶ʱֱֹͣͨ˶
		// ԭ
		// 1ΪʲôҪNextReadyΪûһֹֻͨͣͨ˶
		//   ͨû˶ֹͣͨEndָֹͨͣһ˲ɡͨEndָǰǡһͨ
		//	 еͨͼˡҪNextReadyֹͣͨ˶
		// 2Ϊʲôֹͣ߼ÿֱͨBeginLeaveΪܻпֹͣʱһͨ
		//   ֹͣNextReadyִиͨBeginLeaveͬʱֹͣExecuteҲִиͨBeginLeave
		//   ״̬ġ¿ ----  2014-12-31
	public:
		virtual bool CanExecute(Object^ parameter_) override
		{
			bool _bCanExecute = false;
			for (int i = 0;i < m_arrayChannels->Length;i++)
			{
				Channel^ _curChannel = m_arrayChannels[i];
				if(_curChannel != nullptr)
				{
					if (_curChannel->ChannelState == ChannelState::Pausing
						||_curChannel->ChannelState == ChannelState::Running)
					{
						_bCanExecute = true;
					}
				}
			}

			return _bCanExecute;
		}

		virtual void Execute(Object^ parameter_) override
		{
			_CloseScanCutting();
			if (m_IBeginStop != nullptr)
			{
				m_IBeginStop->BeginStop();
			}

			if(m_mainChannel->CurrentMotion != nullptr
				&& m_mainChannel->CurrentMotion->IsEntered
				&& !m_mainChannel->CurrentMotion->IsLeaving)
			{
				// ֹ֮ͣͨһͨNextReadyBeginLeaveͨ ---- ƺ 2015-11-21
				m_mainChannel->CurrentMotion->BeginLeave(false,nullptr,nullptr);
				m_bLeaveBinaryChannel = true;
				return;
			}

			//ֹͣm_mainChannelͨе˶
			for (int i = 0;i < m_arrayChannels->Length;i++)
			{
				IMotion^ _curMotion = m_arrayChannels[i]->CurrentMotion;
				if (_curMotion != nullptr
					&& _curMotion->IsEntered
					&& !_curMotion->IsLeaving)
				{
					if(m_mainChannel->CurrentMotion == _curMotion)
					{
						continue;
					}
					_curMotion->BeginLeave(false,nullptr,nullptr);
				}
			}
		}

	protected:
		virtual void Initialize() override
		{
			m_bLeaveBinaryChannel = false;
			m_arrayChannels = MCRuntime::Instance->CurrentKernel->Channels;
			m_mainChannel = MCRefComponentManager->GetComponent<Channel^>("MainChannel");
			m_IBeginStop = MCRefComponentManager->GetComponent<IBeginStop^>("IBeginStop");
			if(m_mainChannel == nullptr)
			{
				m_mainChannel = m_arrayChannels[0];
			}
			m_mainChannel->CurrentMotionNextReady += gcnew System::EventHandler<MotionNextReadyEventArgs^>(_NextReady);
			__super::Initialize();
		}

	private:
		//ͨ
		static Channel^ m_mainChannel;

		//ͨ
		static array<Channel^>^ m_arrayChannels;

		// ʼֹͣӿ
		IBeginStop^ m_IBeginStop;

		// ͨNextReadyʱǷҪBeginLeaveͨ
		static bool m_bLeaveBinaryChannel = false;

		//һ˶׼¼߼
		static void _NextReady(Object^ sender_, MotionNextReadyEventArgs^ e_)
		{
			if (!m_bLeaveBinaryChannel)
				return;

			//ֹͣm_mainChannelͨе˶
			for (int i = 0;i < m_arrayChannels->Length;i++)
			{
				IMotion^ _curMotion = m_arrayChannels[i]->CurrentMotion;
				if (_curMotion != nullptr
					&& _curMotion->IsEntered
					&& !_curMotion->IsLeaving)
				{
					if( m_mainChannel->CurrentMotion == _curMotion)
					{
						continue;
					}
					_curMotion->BeginLeave(false,nullptr,nullptr);
				}
			}
			m_bLeaveBinaryChannel = false;
		}
	};

	////////////////////////////////////////////////////////////////////////////////
	// ɭϿֹͣֹͣͨ˶涯˶ ---- ƺ 2015-03-24
	//
	public ref class SystemStopCommand_Au3tech : public CommandBase
	{
	public:
		virtual bool CanExecute(Object^ parameter_) override
		{
			bool _bCanExecute = false;
			if (m_mainChannel)
			{
				if (m_mainChannel->ChannelState == ChannelState::Pausing
					|| m_mainChannel->ChannelState == ChannelState::Running)
				{
					_bCanExecute = true;
				}
			}

			mach::CCommandManager* _pCommandManager = mach::GetCommandManager();
			bool _bCanZStop = false;
			if (_pCommandManager && _pCommandManager->CanExecute("ZStop", &_bCanZStop))
			{
				_bCanExecute |= _bCanZStop;
			}

			return _bCanExecute;
		}

		virtual void Execute(Object^ parameter_) override
		{
			// ֹͣͨ˶
			if(m_mainChannel
				&& m_mainChannel->CurrentMotion != nullptr
				&& m_mainChannel->CurrentMotion->IsEntered
				&& !m_mainChannel->CurrentMotion->IsLeaving)
			{
				m_mainChannel->CurrentMotion->BeginLeave(false,nullptr,nullptr);
			}

			//ֹͣɭ涯ǵ˶---- ƺ 2015-03-24
			mach::CCommandManager* _pCommandManager = mach::GetCommandManager();
			if (_pCommandManager)
			{
				_pCommandManager->Execute("ZStop");
			}
		}

	protected:
		virtual void Initialize() override
		{
			m_mainChannel = MCRefComponentManager->GetComponent<Channel^>("MainChannel");
			__super::Initialize();
		}

	private:
		//ͨ
		static Channel^ m_mainChannel;
	};

	////////////////////////////////////////////////////////////////////////////////
	// ϵָʵʱ屾ͨеĳЩᣬ÷ʽ磺
	// ExcludeAxes="1,2"ֻ֮öŸ ---- ƺ 2015-03-12
	public ref class CClearWorkCoorZeroCommand : public GWorkcoorCommandAbstract
	{
	public:
		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			String^ _strAxes = addInType_->Element->GetAttribute("ExcludeAxes");
			array<String^>^ _arrayAxes =_strAxes->Split(',');
			for (int _i = 0; _i < _arrayAxes->Length;_i++)
			{
				String^ _str = _arrayAxes[_i];
				int _nAxis = -1;
				if (INT32::TryParse(_str, _nAxis))
				{
					m_nExcludeAxes->Resize(m_nExcludeAxes, _i + 1);
					m_nExcludeAxes[_i] = _nAxis;
				}
			}

			return __super::Build(addInType_, buildError_);
		}

		virtual void Execute(Object^ parameter) override
		{
			TRACE("WorkcoorClearZeroCommand ---> Begin");
			GWorkcoor^ _pWorkCoor = (GWorkcoor^)Coor;

			if (parameter == nullptr)
			{
				int _nCount = _pWorkCoor->Owner->Axes->Length;
				bool _bCanClear = true;
				for (int _i = 0; _i < _nCount; _i++)
				{
					if (m_nExcludeAxes)
					{
						for (int _j = 0; _j < m_nExcludeAxes->Length; _j++)
						{
							if (m_nExcludeAxes[_j] == _i)
							{
								_bCanClear = false;
								break;
							}
						}
					}

					if (_bCanClear)
						_pWorkCoor->SetWorkcoor(_i, 0);
				}
			}
			else if (parameter != nullptr)
			{
				int _index = -1;
				try
				{
					_index = Convert::ToInt32(parameter);
				}
				catch(...)
				{
					ASSERT(FALSE);
					return;
				}

				if (_index < 0 && _index >= _pWorkCoor->Owner->Axes->Length)
				{
					ASSERT(FALSE);
					return;
				}

				bool _bCanClear = true;
				if (m_nExcludeAxes)
				{
					for (int _j = 0; _j < m_nExcludeAxes->Length; _j++)
					{
						if (m_nExcludeAxes[_j] == _index)
						{
							_bCanClear = false;
							break;
						}
					}
				}

				if (_bCanClear)
					_pWorkCoor->SetWorkcoor(_index, 0);
			}
			TRACE("WorkcoorClearZeroCommand --->Finsh");
		}

	protected:
		array<int>^ m_nExcludeAxes;
	};

	////////////////////////////////////////////////////////////////////////////////
	// ꡢеͬʱ
	public ref class RectTubeClearZeroCommand : public GWorkcoorCommandAbstract
	{
	public:
		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			return __super::Build(addInType_, buildError_);
		}

		virtual void Execute(Object^ parameter) override
		{
			GWorkcoor^ _pWorkCoor = (GWorkcoor^)Coor;
			_pWorkCoor->SetWorkcoor(0, 0);
			_pWorkCoor->SetWorkcoor(1, 0);
			_pWorkCoor->SetWorkcoor(2, 0);
		}
	};

	////////////////////////////////////////////////////////////////////////////////
	// Zߵָеָ ---- ƺ 2015-07-02
	// 
	public ref class CMoveToGivenMachCoor : public CommandBase
	{
	public:
		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			String^ _strMotionPath = addInType_->Element->GetAttribute("MotionPath");
			if (_strMotionPath->Length > 0)
				m_pZMotion = MCRuntime::Instance == nullptr ? nullptr : MCRuntime::Instance->GetComponent<IZMotion^>(_strMotionPath);
			String^ _strCoor = addInType_->Element->GetAttribute("MachCoor");
			if (_strCoor->Length > 0)
				m_strMachCoor = _strCoor;
			String^ _strSpeed = addInType_->Element->GetAttribute("Speed");
			if (_strSpeed->Length > 0)
				m_strSpeed = _strSpeed;

			return __super::Build(addInType_, buildError_);
		}

		virtual bool CanExecute(Object^ parameter_) override
		{
			double _nCoor;
			return m_pZMotion && _GetParam(m_strMachCoor, &_nCoor);
		}
		virtual void Execute(Object^ parameter_) override
		{
			if (!m_pZMotion || m_strMachCoor->Length == 0)
				return;

			double _nMachCoor;
			if (!_GetParam(m_strMachCoor, &_nMachCoor))
				return;
			
			double _nSpeed;
			bool _bRet = _GetParam(m_strSpeed, &_nSpeed);
			_nSpeed = _bRet ? _nSpeed : 150;
			m_pZMotion->MoveToFixPosM(_nMachCoor, _nSpeed);
		}

	protected:
		String^ m_strMachCoor;
		String^ m_strSpeed;
		IZMotion^ m_pZMotion;
		bool _GetParam(String^ strParam_, double* nParam_)
		{
			if (strParam_ == nullptr || strParam_->Length == 0)
				return false;

			// 
			if (strParam_->Substring(0, 1) != "#")
			{
				try
				{
					*nParam_ = Double::Parse(strParam_);
				}
				catch(...)
				{
					return false;
				}
				return true;
			}

			String^ _strParamName = strParam_->Substring(1);
			MCDataManager^ _DataManager =
				MCRuntime::Instance != nullptr
				&& MCRuntime::Instance->DataManager != nullptr
				? MCRuntime::Instance->DataManager : nullptr;
			if (_DataManager == nullptr)
			{
				return false;
			}

			IParameterNode^ _ParamNode = _DataManager->GetParaemterNode(_strParamName);
			if (_ParamNode == nullptr)
			{
				return false;
			}

			// mm/minͳһmm/s ---- ƺ 2015-07-22
			*nParam_ = _ParamNode->Unit == ParameterUnit::VelocityMinute ?
						Double::Parse(_ParamNode->Value->ToString()) / 60.0 : Double::Parse(_ParamNode->Value->ToString());
			return true;
		}
	};

	////////////////////////////////////////////////////////////////////////////////
	// Zָ̧ ---- ƺ 2015-09-28
	// 
	public ref class CZUpDownCommand : public CommandBase
	{
	public:
		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			String^ _strMotionPath = addInType_->Element->GetAttribute("MotionPath");
			if (_strMotionPath->Length > 0)
				m_pZMotion = MCRuntime::Instance == nullptr ? nullptr : MCRuntime::Instance->GetComponent<IZMotion^>(_strMotionPath);
			String^ _strCoor = addInType_->Element->GetAttribute("Distance");
			if (_strCoor->Length > 0)
				m_strDistance = _strCoor;
			String^ _strSpeed = addInType_->Element->GetAttribute("Speed");
			if (_strSpeed->Length > 0)
				m_strSpeed = _strSpeed;

			return __super::Build(addInType_, buildError_);
		}

		virtual bool CanExecute(Object^ parameter_) override
		{
			double _nCoor;
			return m_pZMotion && _GetParam(m_strDistance, &_nCoor);
		}
		virtual void Execute(Object^ parameter_) override
		{
			if (!m_pZMotion || m_strDistance->Length == 0)
				return;

			double _nDistance;
			if (!_GetParam(m_strDistance, &_nDistance))
				return;

			double _nSpeed;
			bool _bRet = _GetParam(m_strSpeed, &_nSpeed);
			_nSpeed = _bRet ? _nSpeed : 150;
			m_pZMotion->MoveGivenDis(_nDistance, _nSpeed);
		}

	protected:
		String^ m_strDistance;
		String^ m_strSpeed;
		IZMotion^ m_pZMotion;
		bool _GetParam(String^ strParam_, double* nParam_)
		{
			if (strParam_ == nullptr || strParam_->Length == 0)
				return false;

			// 
			if (strParam_->Substring(0, 1) != "#")
			{
				try
				{
					*nParam_ = Double::Parse(strParam_);
				}
				catch(...)
				{
					return false;
				}
				return true;
			}

			String^ _strParamName = strParam_->Substring(1);
			MCDataManager^ _DataManager =
				MCRuntime::Instance != nullptr
				&& MCRuntime::Instance->DataManager != nullptr
				? MCRuntime::Instance->DataManager : nullptr;
			if (_DataManager == nullptr)
			{
				return false;
			}

			IParameterNode^ _ParamNode = _DataManager->GetParaemterNode(_strParamName);
			if (_ParamNode == nullptr)
			{
				return false;
			}

			// mm/minͳһmm/s ---- ƺ 2015-07-22
			*nParam_ = _ParamNode->Unit == ParameterUnit::VelocityMinute ?
				Double::Parse(_ParamNode->Value->ToString()) / 60.0 : Double::Parse(_ParamNode->Value->ToString());
			return true;
		}
	};

	////////////////////////////////////////////////////////////////////////////////
	// ܲУƽָݲͬĹܲĵòͬУƽӳУƽ
	// ---- ƺ 2016-12-17
	public ref class CAjustHorizonCommand : public CommandBase
	{
	public:
		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			m_strKeyOfTubeType = addInType_->Element->GetAttribute("TubeType");

			m_strAjustHorCircular = gcnew String(NceGetPrivateProfileString(_T("Tube"), _T("AjustHorCircular")));
			m_strAjustHorRect = gcnew String(NceGetPrivateProfileString(_T("Tube"), _T("AjustHorRect")));
			return __super::Build(addInType_, buildError_);
		}

		virtual bool CanExecute(Object^ parameter_) override
		{
			// ͨ0λͨͨΪʱִУƽ ---- ƺ 2016-12-17
			return MCRuntime::Instance->CurrentKernel->Channels[0]->ChannelState == ChannelState::Idle;
		}

		virtual void Execute(Object^ parameter_) override
		{
			if (String::IsNullOrEmpty(m_strAjustHorCircular)
				|| String::IsNullOrEmpty(m_strAjustHorRect))
				return;

			MCDataManager^ _DataManager =
				MCRuntime::Instance != nullptr
				&& MCRuntime::Instance->DataManager != nullptr
				? MCRuntime::Instance->DataManager : nullptr;
			if (_DataManager == nullptr)
			{
				return;
			}

			IParameterNode^ _ParamNode = _DataManager->GetParaemterNode(m_strKeyOfTubeType);
			if (_ParamNode == nullptr)
			{
				return;
			}
			ASSERT(_ParamNode->Value->GetType()->FullName == "System.Int32");
			int _nTubeType = 0;
			try
			{
				_nTubeType = Int32::Parse(_ParamNode->Value->ToString());
			}
			catch (...)
			{
				ASSERT(FALSE);
				return;
			}

			if (_nTubeType != 0 && _nTubeType != 1)
			{
				ASSERT(FALSE);
				return;
			}

			mach::CCommandManager* _pCommandManager = mach::GetCommandManager();
			if (!_pCommandManager)
				return;

			CStringA _strCode;
			if (_nTubeType == 0)
			{
				_strCode.Format("G65 P\"%s\" L1\n", m_strAjustHorCircular);
			}
			else
			{
				_strCode.Format("G65 P\"%s\" L1\n", m_strAjustHorRect);
			}
			_pCommandManager->Execute("RunGCode", _strCode, "LPCSTR");
		}

	private:
		String^ m_strKeyOfTubeType;

		String^ m_strAjustHorCircular;
		String^ m_strAjustHorRect;
	};

	////////////////////////////////////////////////////////////////////////////////
	// ܲķָڷܷ
	// ---- ƺ 2016-12-17
	public ref class CFindMidCommand : public CommandBase
	{
	public:
		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			m_strKeyOfTubeType = addInType_->Element->GetAttribute("TubeType");

			m_strCodes = gcnew String(NceGetPrivateProfileString(_T("Tube"), _T("FindMidFourSide")));
			return __super::Build(addInType_, buildError_);
		}

		virtual bool CanExecute(Object^ parameter_) override
		{
			// ͨ0λͨͨΪʱִзС ---- ƺ 2016-12-17
			if (MCRuntime::Instance->CurrentKernel->Channels[0]->ChannelState != ChannelState::Idle)
				return false;

			MCDataManager^ _DataManager =
				MCRuntime::Instance != nullptr
				&& MCRuntime::Instance->DataManager != nullptr
				? MCRuntime::Instance->DataManager : nullptr;
			if (_DataManager == nullptr)
			{
				return false;
			}

			IParameterNode^ _ParamNode = _DataManager->GetParaemterNode(m_strKeyOfTubeType);
			if (_ParamNode == nullptr)
			{
				return false;
			}
			ASSERT(_ParamNode->Value->GetType()->FullName == "System.Int32");
			int _nTubeType = 0;
			try
			{
				_nTubeType = Int32::Parse(_ParamNode->Value->ToString());
			}
			catch (...)
			{
				ASSERT(FALSE);
				return false;
			}

			return _nTubeType == 1;
		}

		virtual void Execute(Object^ parameter_) override
		{
			if (String::IsNullOrEmpty(m_strCodes))
				return;

			MCDataManager^ _DataManager =
				MCRuntime::Instance != nullptr
				&& MCRuntime::Instance->DataManager != nullptr
				? MCRuntime::Instance->DataManager : nullptr;
			if (_DataManager == nullptr)
			{
				return;
			}

			IParameterNode^ _ParamNode = _DataManager->GetParaemterNode(m_strKeyOfTubeType);
			if (_ParamNode == nullptr)
			{
				return;
			}
			ASSERT(_ParamNode->Value->GetType()->FullName == "System.Int32");
			int _nTubeType = 0;
			try
			{
				_nTubeType = Int32::Parse(_ParamNode->Value->ToString());
			}
			catch (...)
			{
				ASSERT(FALSE);
				return;
			}

			mach::CCommandManager* _pCommandManager = mach::GetCommandManager();
			if (!_pCommandManager)
				return;

			CStringA _strCode;
			_strCode.Format("G65 P\"%s\" L1\n", m_strCodes);
			_pCommandManager->Execute("RunGCode", _strCode, "LPCSTR");
		}

	private:
		String^ m_strKeyOfTubeType;

		String^ m_strCodes;
	};

	public ref class CCutTubeWorkcoorCommand : public CommandBase
	{
	public:
		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			return __super::Build(addInType_, buildError_);
		}

		virtual bool CanExecute(Object^ parameter_) override
		{
			// ͨ0λͨͨΪʱִзС ---- ƺ 2016-12-17
			if (MCRuntime::Instance->CurrentKernel->Channels[0]->ChannelState != ChannelState::Idle)
				return false;
			return true;
		}

		virtual void Execute(Object^ parameter_) override
		{
			CTubeComponent^ _pTube = MCRefComponentManager->GetComponent<CTubeComponent^>("TubeComponent");
			_pTube->CutWorkcoor();
		}
	};

	////////////////////////////////////////////////////////////////////////////////
	// ѡӹָIDEеѡӹָֻʵӹ
	// дһڷѡӹġ ---- ƺ 2016-09-03
	public ref class CTaskSelectWithoutDlg : public TaskSelectionWithoutDialog
	{
	public:
		virtual bool CanExecute(Object^ parameter) override
		{
			return TaskCommandAbstract::CanExecute(parameter)
				&& this->AbstrackTask->IsIdle
				&& this->AbstrackTask->Owner != nullptr
				&& this->AbstrackTask->Owner->ChannelState == ChannelState::Idle
				&& this->AbstrackTask->CodeFileInformation->IsLoad
				&& (this->AbstrackTask->Owner->IsRefered || !this->IsRefered)
				&& this->AbstractTaskMotion != nullptr
				&& parameter != nullptr
				&& __super::TryConvert((String^)parameter, nullptr);
		}
	};

	////////////////////////////////////////////////////////////////////////////////
	// Wԭ
	// ---- ƺ 2017-05-11
	public ref class CWBackMachineOrgin : public TwoTaskChainCommand
	{
	public:
		virtual bool CanExecute(Object^ parameter) override
		{
			// һִͨͣС ---- ƺ 2017-05-11
			int _nLength = MCRuntime::Instance->CurrentKernel->Channels->Length;
			for (int _i = 0; _i < _nLength; _i++)
			{
				if (MCRuntime::Instance->CurrentKernel->Channels[_i]->ChannelState == ChannelState::Estop)
					return false;
			}
			return __super::CanExecute(parameter);
		}
	};

	////////////////////////////////////////////////////////////////////////////
	// NcEditor(˵һIDCommand) ----  2012-03-01
	// 
	public ref class CNceCommand : public CommandBase
	{
	public:
		CNceCommand() { m_nID = 0; }
		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			Xml::XmlElement^ _xmlElement = addInType_->Element;
			String^ _strID = _xmlElement->GetAttribute("ID");
			m_nID = UInt32::Parse(_strID);
			ASSERT(m_nID > 0);
			return __super::Build(addInType_, buildError_);
		}

		virtual bool CanExecute(Object^ parameter_) override { return true; }
		virtual void Execute(Object^ parameter_) override
		{
			TRACE("CNceCommand::Execute => ID = 0x%08X(%d)\n", m_nID, m_nID);
			AfxGetMainWnd()->SendMessage(WM_COMMAND, m_nID);
		}

	protected:
		UINT m_nID; // ID
	};

	////////////////////////////////////////////////////////////////////////////
	// NcEditor(עֵCommandID͵) ----  2012-03-01
	// 
	public ref class CNceNamedCommand : public CommandBase
	{
	public:
		CNceNamedCommand() { m_strTarget = ""; m_strCommand = ""; }
		virtual bool Build(IAddInType^ addInType_, String^% buildError_) override
		{
			Xml::XmlElement^ _xmlElement = addInType_->Element;
			m_strTarget = _xmlElement->GetAttribute("Target");
			m_strCommand = _xmlElement->GetAttribute("Command");
			ASSERT(!String::IsNullOrEmpty(m_strTarget) && !String::IsNullOrEmpty(m_strCommand));
			return __super::Build(addInType_, buildError_);
		}

		virtual bool CanExecute(Object^ parameter_) override { return true; }
		virtual void Execute(Object^ parameter_) override
		{
			using System::Runtime::InteropServices::Marshal;
			const char* _szTarget = (const char*)(Marshal::StringToHGlobalAnsi(m_strTarget)).ToPointer();
			const char* _szCommand = (const char*)(Marshal::StringToHGlobalAnsi(m_strCommand)).ToPointer();
			ASSERT(_szTarget && _szTarget[0] && _szCommand && _szCommand[0]);
			TRACE("CNceNamedCommand::Execute => Target = %s, Comand = %s\n", _szTarget, _szCommand);
			SendTargetMessage(0/*ID_TARGET_BROADCAST*/, TN_NAMEDCOMMAND, (WPARAM)(PCSTR)_szTarget, (LPARAM)(PCSTR)_szCommand);
			Marshal::FreeHGlobal(IntPtr((void*)_szTarget));
			Marshal::FreeHGlobal(IntPtr((void*)_szCommand));
		}

	protected:
		String^ m_strTarget; // ĿTarget
		String^ m_strCommand; // ע
	};
}
