// ************************************************************************** //
// ThreeSegPunchParamDlg.cpp : implementation of the CThreeSegPunchParamDlg class
// Copyright(c)2014 WeiHong Company. All rights reserved.
//
// Abstract:
//   ļʵCThreeSegPunchParamDlgࡣ
// *********************************************** ---- ƺ 2014-12-14***** //
#include "stdafx.h"
#include "LayerParamDlg.h"

using namespace nce;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CS_T s_szCUTGASNAME = _DEFCS(_CSV(16655),
	_CHINESE("CutGas%d_CHN")
	_ENGLISH("CutGas%d_ENG"));
CS_T s_szTHREESEGPUNCHPARAM = _DEFCS(_CSV(16657),
	_CHINESE("%s-ײ")
	_ENGLISH("%s-Three Segment Paramters"));
CS_T s_szREMARKS = _DEFCS(_CSV(16658),
	_CHINESE("ûע")
	_ENGLISH("Remarks"));

CS_T s_szFIRSTSEG = _DEFCS(_CSV(16659),
	_CHINESE("һ")
	_ENGLISH("1st Segment"));
CS_T s_szFIRSTCURRENT = _DEFCS(_CSV(16660),
	_CHINESE("һ")
	_ENGLISH("Current:"));
CS_T s_szFIRSTFREQU = _DEFCS(_CSV(16661),
	_CHINESE("һƵʣ")
	_ENGLISH("Frequency:"));
CS_T s_szFIRSTPOWER = _DEFCS(_CSV(16662),
	_CHINESE("һʣ")
	_ENGLISH("Power:"));
CS_T s_szFIRSTGAS = _DEFCS(_CSV(16663),
	_CHINESE("һ壺")
	_ENGLISH("Gas:"));
CS_T s_szFIRSTPRESSURE = _DEFCS(_CSV(16664),
	_CHINESE("һѹ")
	_ENGLISH("Pressure:"));
CS_T s_szFIRSTHEIGHT = _DEFCS(_CSV(16665),
	_CHINESE("һ߶ȣ")
	_ENGLISH("Height:"));
CS_T s_szFIRSTDELAY = _DEFCS(_CSV(16666),
	_CHINESE("һʱ")
	_ENGLISH("Delay:"));
CS_T s_szFIRSTSEGFOCUS = _DEFCS(_CSV(16703),
	_CHINESE("һ㣺")
	_ENGLISH("Focus:"));

CS_T s_szSECONDSEG = _DEFCS(_CSV(16667),
	_CHINESE("")
	_ENGLISH("2nd Segment"));
CS_T s_szSECONDCURRENT = _DEFCS(_CSV(16668),
	_CHINESE("")
	_ENGLISH("Current:"));
CS_T s_szSECONDFREQU = _DEFCS(_CSV(16669),
	_CHINESE("Ƶʣ")
	_ENGLISH("Frequency:"));
CS_T s_szSECONDPOWER = _DEFCS(_CSV(16670),
	_CHINESE("ʣ")
	_ENGLISH("Power:"));
CS_T s_szSECONDGAS = _DEFCS(_CSV(16671),
	_CHINESE("壺")
	_ENGLISH("Gas:"));
CS_T s_szSECONDPRESSURE = _DEFCS(_CSV(16672),
	_CHINESE("ѹ")
	_ENGLISH("Pressure:"));
CS_T s_szSECONDHEIGHT = _DEFCS(_CSV(16673),
	_CHINESE("߶ȣ")
	_ENGLISH("Height:"));
CS_T s_szSECONDDELAY = _DEFCS(_CSV(16674),
	_CHINESE("ʱ")
	_ENGLISH("Delay:"));
CS_T s_szSECONDSEGFOCUS = _DEFCS(_CSV(16704),
	_CHINESE("㣺")
	_ENGLISH("Focus:"));

CS_T s_szTHIRDSEG = _DEFCS(_CSV(16675),
	_CHINESE("")
	_ENGLISH("3rd Segment"));
CS_T s_szTHIRDCURRENT = _DEFCS(_CSV(16676),
	_CHINESE("")
	_ENGLISH("Current:"));
CS_T s_szTHIRDFREQU = _DEFCS(_CSV(16677),
	_CHINESE("Ƶʣ")
	_ENGLISH("Frequency:"));
CS_T s_szTHIRDPOWER = _DEFCS(_CSV(16678),
	_CHINESE("ʣ")
	_ENGLISH("Power:"));
CS_T s_szTHIRDGAS = _DEFCS(_CSV(16679),
	_CHINESE("壺")
	_ENGLISH("Gas:"));
CS_T s_szTHIRDPRESSURE = _DEFCS(_CSV(16680),
	_CHINESE("ѹ")
	_ENGLISH("Pressure:"));
CS_T s_szTHIRDHEIGHT = _DEFCS(_CSV(16681),
	_CHINESE("߶ȣ")
	_ENGLISH("Height:"));
CS_T s_szTHIRDDELAY = _DEFCS(_CSV(16682),
	_CHINESE("ʱ")
	_ENGLISH("Delay:"));
CS_T s_szTHIRDSEGFOCUS = _DEFCS(_CSV(16705),
	_CHINESE("㣺")
	_ENGLISH("Focus:"));
CS_T s_csINVALIDINPUT = _DEFCS(_CSV(16750),
	_CHINESE("ʽȷ롣")
	_ENGLISH("The input parameter is invalid, please reset again."));

CS_T s_szPIERCESPEED = _DEFCS(_CSV(16705),
	_CHINESE("ٶȣ")
	_ENGLISH("Increment S:"));
CS_T s_szExtraPuffing= _DEFCS(_CSV(16705),
	_CHINESE("ͣⴵ")
	_ENGLISH("Extra Blow:"));
CS_T s_szSTOPGAS= _DEFCS(_CSV(16705),
	_CHINESE("")
	_ENGLISH("Type:"));
CS_T s_szDLG_LANGUAGE = _DEFCS(_CSV(16739),
	 _CHINESE("CHN")
	 _ENGLISH("ENG"));

static void FormatDoubleParamer(CString& pSrc_)
{
	pSrc_.TrimRight('0');
	if (pSrc_.IsEmpty())
		pSrc_ = _T("0");
	if (pSrc_[pSrc_.GetLength() - 1] == _T('.'))
		pSrc_.Delete(pSrc_.GetLength() - 1);
}
const char c_szSection[] = "ParamGroup";
const char c_szFirstSegGasKey[] = "FirstSegBlowType";
const char c_szSecondSegGasKey[] = "SecondSegBlowType";
const char c_szThirdSegGasKey[] = "ThirdSegBlowType";
const char c_szFirstStopSegGasKey[] = "FirstSegStopBlowType";
const char c_szSecondStopSegGasKey[] = "SecondSegStopBlowType";
const char c_szThirdStopSegGasKey[] = "ThirdSegStopBlowType";
const char c_szFirstSegPunch[] = "FirstSegPunch";
const char c_szSecondSegPunch[] = "SecondSegPunch";
const char c_szThirdSegPunch[] = "ThirdSegPunch";
const char c_szFirstSegConSpeed[] = "FirstSegConEnable";
const char c_szSecondSegConSpeed[] = "SecondSegConEnable";
const char c_szThirdSegConSpeed[] = "ThirdSegConEnable";
const char c_szFirstStopLaserBlow[] = "FirstStopLaserBlowEnable";
const char c_szSecondStopLaserBlow[] = "SecondStopLaserBlowEnable";
const char c_szThirdStopLaserBlow[] = "ThirdStopLaserBlowEnable";
const char c_szThreeSegPunchRemarks[] = "ThreeSegPunchRemarks";

IMPLEMENT_DYNAMIC(CThreeSegPunchParamDlg, CDialog)
BEGIN_MESSAGE_MAP(CThreeSegPunchParamDlg, CDialog)
	ON_CONTROL_RANGE(EN_KILLFOCUS, IDC_EDIT_FIRSTSEGPOWER, IDC_EDIT_THIRDSTOPLASERBLOW, OnKillFocusEdits)
	ON_CONTROL_RANGE(EN_SETFOCUS, IDC_EDIT_FIRSTSEGPOWER, IDC_EDIT_THIRDSTOPLASERBLOW, OnSetFocusEdits)
	ON_CONTROL_RANGE(CBN_SELCHANGE, IDC_COMBO_FIRSTSEGGAS, IDC_COMBO_THIRDSEGGAS, OnSelectGases)
	ON_CONTROL_RANGE(CBN_SELCHANGE, IDC_COMBO_FIRSTSTOPLASERBLOWTYPE, IDC_COMBO_THIRDSTOPLASERBLOWTYPE, OnSelectStopGases)
	ON_COMMAND_RANGE(IDC_CHECK_FIRSTSEG, IDC_CHECK_THIRDSEG, OnClickPunchType)
	ON_COMMAND_RANGE(IDC_CHECK_FIRSTCONPERSPEED, IDC_CHECK_THIRDCONPERSPEED, OnClickEnableConPer)
	ON_COMMAND_RANGE(IDC_CHECK_FIRSTSTOPLASERBLOW, IDC_CHECK_THIRDSTOPLASERBLOW, OnClickEnableCloseLaserBlow)
	ON_CONTROL(EN_KILLFOCUS, IDC_EDIT_THREESEGUSERREMARKS, OnKillFocusRemarks)
END_MESSAGE_MAP()

CThreeSegPunchParamDlg::CThreeSegPunchParamDlg(CParam* pParam_, CWnd* pParent_)
: CDialog(IDD_DLG_THREESEGPUNCHPARAM, pParent_), m_pParam(pParam_)
{
	_BuildEditInfo();

	// ʼЧ ----  2016-07-20
	m_bDataValid = true;
	m_bCancelData = false;

	// ʼи塣÷ʽ
	//	CutGasCount=1
	//	CutGas0_Value=0
	//	CutGas0_CHN=""
	//	CutGas0_ENG="Air"
	// CutGasXX_CHNCutGasXX_ENGӢCutGasXX_ValueǶӦLayerParam.lua
	// BlowTypeTableĵһֵ---- ƺ 2015-02-28
	CString _strCount = NceGetPrivateProfileString(c_szSection, _T("CutGasCount"), "0");
	int _nCount = atoi(_strCount);
	for (int _i = 0; _i < _nCount; _i++)
	{
		CLayerParamDlg::CombItem* _pItem = new CLayerParamDlg::CombItem;
		CString _strKey;
		_strKey.Format(_T("CutGas%d_Value"), _i);
		_pItem->strValue = NceGetPrivateProfileString(c_szSection, _strKey, "");
		_strKey.Format(_GETCS(s_szCUTGASNAME), _i);
		_pItem->strText = NceGetPrivateProfileString(c_szSection, _strKey, "");
		m_vectCombItems.push_back(_pItem);
	}

	// һvector洢ͣⴵ ---- η 2017-04-24
	for (int _i = 0; _i < _nCount; _i++)
	{
		CLayerParamDlg::CombItem* _pItem = new CLayerParamDlg::CombItem;
		CString _strKey;
		_strKey.Format(_T("CutGas%d_Value"), _i);
		_pItem->strValue = NceGetPrivateProfileString(c_szSection, _strKey, "");
		_strKey.Format(_GETCS(s_szCUTGASNAME), _i);
		_pItem->strText = NceGetPrivateProfileString(c_szSection, _strKey, "");
		m_vectCombStopItems.push_back(_pItem);
	}

	m_bEnableFocusCtrl = NceGetPrivateProfileString(_T("FocusControl"), _T("Enable")) == _T("1");
}

CThreeSegPunchParamDlg::~CThreeSegPunchParamDlg()
{
	for (PunchParamList::iterator _it = m_listEdits.begin(); _it != m_listEdits.end(); _it++)
	{
		if (*_it)
			delete (*_it);
	}
	m_listEdits.clear();

	for (CombItemVector::iterator _it = m_vectCombItems.begin(); _it != m_vectCombItems.end(); _it++)
	{
		if (*_it)
			delete (*_it);
	}
	m_vectCombItems.clear();

	for (CombItemVector::iterator _it = m_vectCombStopItems.begin(); _it != m_vectCombStopItems.end(); _it++)
	{
		if (*_it)
			delete (*_it);
	}
	m_vectCombStopItems.clear();
}

BOOL CThreeSegPunchParamDlg::Create(UINT nIDTemplate_, CWnd* pParentWnd_)
{
	::AfxInitRichEdit2();
	return __super::Create(nIDTemplate_,pParentWnd_ );
}

void CThreeSegPunchParamDlg::SetParam(CParam* pParam_)
{
	m_pParam = pParam_;
}

void CThreeSegPunchParamDlg::BuildDefaultParam(nce::CParam* pParam_)
{
	if (!pParam_)
	{
		ASSERT(FALSE);
		return;
	}

	struct DVItem
	{
		CStringA strKey;
		CStringA strDefualtValue;
	};
	DVItem _DVItems[] =
	{
		{"FirstSegPunch", "1"},
		{"SecondSegPunch", "1"},
		{"ThirdSegPunch", "1"},
		{"FirstSegBlowType", "0"},
		{"SecondSegBlowType", "0"},
		{"ThirdSegBlowType", "0"},
		{"FirstSegStopBlowType", "0"},		// ͣⴵ ---- η 2017-04-24
		{"SecondSegStopBlowType", "0"},
		{"ThirdSegStopBlowType", "0"},

		{"FirstSegPower", "100"},
		{"FirstSegFreq", "5000"},
		{"FirstSegDutyCycle", "100"},
		{"FirstSegPressure", "100"},
		{"FirstSegHeight", "10"},
		{"FirstSegDelay", "200"},
		{"FirstSegFocusPos", "0"},

		{"SecondSegPower", "100"},
		{"SecondSegFreq", "5000"},
		{"SecondSegDutyCycle", "100"},
		{"SecondSegPressure", "100"},
		{"SecondSegHeight", "5"},
		{"SecondSegDelay", "200"},
		{"SecondFocusPos", "0"},

		{"ThirdSegPower", "100"},
		{"ThirdSegFreq", "5000"},
		{"ThirdSegDutyCycle", "100"},
		{"ThirdSegPressure", "100"},
		{"ThirdSegHeight", "2"},
		{"ThirdSegDelay", "200"},
		{"ThirdSegFocusPos", "0"},
	};
	for (int _i = 0; _i < _countof(_DVItems); _i++)
	{
		CStringA _strCurValue = pParam_->GetKey(_DVItems[_i].strKey);
		if (_strCurValue.IsEmpty())
			pParam_->SetKey(_DVItems[_i].strKey, _DVItems[_i].strDefualtValue);
	}
}

void CThreeSegPunchParamDlg::Update()
{
	bool _bIsCHN = _GETCS(s_szDLG_LANGUAGE) == "CHN";	// жӢ
	CStringA _strName = _bIsCHN ? m_pParam->GetKey("Name") : m_pParam->GetKey("Name_ENG");
	if (!_strName.IsEmpty() && _strName[0] == '\"') _strName.Delete(0);
	if (!_strName.IsEmpty() && _strName[_strName.GetLength() - 1] == '\"') _strName.Delete(_strName.GetLength() - 1);
	CString _strTitle;
	_strTitle.Format(_GETCS(s_szTHREESEGPUNCHPARAM), _strName);
	CString _strCurrentTitle;
	GetDlgItemText(IDC_STATIC_THREESEGPUNCHPARAM, _strCurrentTitle);
	if (_strTitle != _strCurrentTitle)
	{
		SetDlgItemText(IDC_STATIC_THREESEGPUNCHPARAM, _strTitle);
	}

	// ѡ¡
	struct
	{
		CStringA strParamKey;
		CStringA strParamValue;
		CComboBox* pComb;
	}_Combs[3];
	_Combs[0].strParamKey = c_szFirstSegGasKey;
	_Combs[0].strParamValue = m_pParam->GetKey(c_szFirstSegGasKey);
	_Combs[0].pComb = (CComboBox*)GetDlgItem(IDC_COMBO_FIRSTSEGGAS);
	_Combs[1].strParamKey = c_szSecondSegGasKey;
	_Combs[1].strParamValue = m_pParam->GetKey(c_szSecondSegGasKey);
	_Combs[1].pComb = (CComboBox*)GetDlgItem(IDC_COMBO_SECONDSEGGAS);
	_Combs[2].strParamKey = c_szThirdSegGasKey;
	_Combs[2].strParamValue = m_pParam->GetKey(c_szThirdSegGasKey);
	_Combs[2].pComb = (CComboBox*)GetDlgItem(IDC_COMBO_THIRDSEGGAS);
	for (int _nCombIndex = 0; _nCombIndex < _countof(_Combs); _nCombIndex++)
	{
		int _nIndex = -1;
		for (int _i = 0; _i < (int)m_vectCombItems.size(); _i++)
		{
			if (m_vectCombItems[_i]->strValue == _Combs[_nCombIndex].strParamValue)
			{
				_nIndex = _i;
				break;
			}

			// ûĬõһѡ
			if (_Combs[_nCombIndex].strParamValue.IsEmpty())
			{
				_nIndex = 0;
				m_pParam->SetKey(_Combs[_nCombIndex].strParamKey, m_vectCombItems[0]->strValue);
			}
		}
		if (_Combs[_nCombIndex].pComb->GetCurSel() != _nIndex)
			_Combs[_nCombIndex].pComb->SetCurSel(_nIndex);
	}

	// ͣⴵ嵥 ---- η 2017-04-24
	struct
	{
		CStringA strParamKey;
		CStringA strParamValue;
		CComboBox* pComb;
	}_StopCombs[3];
	_StopCombs[0].strParamKey = c_szFirstStopSegGasKey;
	_StopCombs[0].strParamValue = m_pParam->GetKey(c_szFirstStopSegGasKey);
	_StopCombs[0].pComb = (CComboBox*)GetDlgItem(IDC_COMBO_FIRSTSTOPLASERBLOWTYPE);
	_StopCombs[1].strParamKey = c_szSecondStopSegGasKey;
	_StopCombs[1].strParamValue = m_pParam->GetKey(c_szSecondStopSegGasKey);
	_StopCombs[1].pComb = (CComboBox*)GetDlgItem(IDC_COMBO_SECONDSTOPLASERBLOWTYPE);
	_StopCombs[2].strParamKey = c_szThirdStopSegGasKey;
	_StopCombs[2].strParamValue = m_pParam->GetKey(c_szThirdStopSegGasKey);
	_StopCombs[2].pComb = (CComboBox*)GetDlgItem(IDC_COMBO_THIRDSTOPLASERBLOWTYPE);
	for (int _nCombIndex = 0; _nCombIndex < _countof(_StopCombs); _nCombIndex++)
	{
		int _nIndex = -1;
		for (int _i = 0; _i < (int)m_vectCombStopItems.size(); _i++)
		{
			if (m_vectCombStopItems[_i]->strValue == _StopCombs[_nCombIndex].strParamValue)
			{
				_nIndex = _i;
				break;
			}

			// ûĬõһѡ
			if (_StopCombs[_nCombIndex].strParamValue.IsEmpty())
			{
				_nIndex = 0;
				m_pParam->SetKey(_StopCombs[_nCombIndex].strParamKey, m_vectCombStopItems[0]->strValue);
			}
		}
		if (_StopCombs[_nCombIndex].pComb->GetCurSel() != _nIndex)
			_StopCombs[_nCombIndex].pComb->SetCurSel(_nIndex);
	}

	// ׶¡
	bool _bPunch = m_pParam->GetKey_DBL(c_szFirstSegPunch) == 1;
	CButton* _pwndBtn = (CButton*)GetDlgItem(IDC_CHECK_FIRSTSEG);
	int _nCheck = _bPunch ? BST_CHECKED : BST_UNCHECKED;
	if (_pwndBtn->GetCheck() != _nCheck)
		_pwndBtn->SetCheck(_nCheck);
	GetDlgItem(IDC_STATIC_FIRSTSEGPOWER)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_FIRSTSEGPOWER)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_FIRSTSEGPOWERUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_FIRSTSEGFREQ)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_FIRSTSEGFREQ)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_FIRSTSEGFREQUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_FIRSTSEGDUTYCYCLE)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_FIRSTSEGDUTYCYCLE)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_FIRSTSEGDUTYCYCLEUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_FIRSTSEGPRESSUER)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_FIRSTSEGPRESSUER)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_FIRSTSEGPRESSUERUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_FIRSTSEGGAS)->EnableWindow(_bPunch);
	GetDlgItem(IDC_COMBO_FIRSTSEGGAS)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_FIRSTSEGHEIGHT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_FIRSTSEGHEIGHT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_FIRSTSEGHEIGHTUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_FIRSTSEGELAY)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_FIRSTSEGDELAY)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_FIRSTSEGDELAYUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_FIRSTSEGFOCUS)->EnableWindow(_bPunch && m_bEnableFocusCtrl);
	GetDlgItem(IDC_EDIT_FIRSTSEGFOCUS)->EnableWindow(_bPunch && m_bEnableFocusCtrl);
	GetDlgItem(IDC_STATIC_FIRSTSEGFOCUSUNIT)->EnableWindow(_bPunch && m_bEnableFocusCtrl);
	GetDlgItem(IDC_CHECK_FIRSTCONPERSPEED)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STC_FIRSTCONPERSPEEDUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_CHECK_FIRSTSTOPLASERBLOW)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STC_FIRSTSTOPLASERBLOWUNIT)->EnableWindow(_bPunch);
	bool _bConPer = (int)m_pParam->GetKey_DBL(c_szFirstSegConSpeed) == 1;
	_pwndBtn = (CButton*)GetDlgItem(IDC_CHECK_FIRSTCONPERSPEED);
	_nCheck = _bConPer ? BST_CHECKED : BST_UNCHECKED;
	if (_pwndBtn->GetCheck() != _nCheck)
		_pwndBtn->SetCheck(_nCheck);
	CWnd* _pwndEdit = GetDlgItem(IDC_EDIT_FIRSTCONPERSPEED);
	BOOL _bIsWndEnabled = (!_bConPer || !_bPunch) ? FALSE : TRUE;
	if (_pwndEdit->IsWindowEnabled() != _bIsWndEnabled)
	{
		_pwndEdit->EnableWindow(_bIsWndEnabled);
	}

	bool _bFirstStopLaserBlow = (int)m_pParam->GetKey_DBL(c_szFirstStopLaserBlow) == 1;
	_pwndBtn = (CButton*)GetDlgItem(IDC_CHECK_FIRSTSTOPLASERBLOW);
	_nCheck = _bFirstStopLaserBlow ? BST_CHECKED : BST_UNCHECKED;
	if (_pwndBtn->GetCheck() != _nCheck)
		_pwndBtn->SetCheck(_nCheck);
	_pwndEdit = GetDlgItem(IDC_EDIT_FIRSTSTOPLASERBLOW);
	CWnd* _pwndCombStop = GetDlgItem(IDC_COMBO_FIRSTSTOPLASERBLOWTYPE);
	_bIsWndEnabled = (!_bFirstStopLaserBlow || !_bPunch) ? FALSE : TRUE;
	if (_bIsWndEnabled != _pwndEdit->IsWindowEnabled())
	{
		_pwndEdit->EnableWindow(_bIsWndEnabled);
		_pwndCombStop->EnableWindow(_bIsWndEnabled);
	}

	_bPunch = (int)m_pParam->GetKey_DBL(c_szSecondSegPunch) == 1;
	_pwndBtn = (CButton*)GetDlgItem(IDC_CHECK_SECONDSEG);
	_nCheck = _bPunch ? BST_CHECKED : BST_UNCHECKED;
	if (_pwndBtn->GetCheck() != _nCheck)
		_pwndBtn->SetCheck(_nCheck);
	GetDlgItem(IDC_STATIC_SECONDSEGPOWER)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_SECONDSEGPOWER)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_SECONDSEGPOWERUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_SECONDSEGFREQ)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_SECONDSEGFREQ)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_SECONDSEGFEQUUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_SECONDSEGDUTYCYCLE)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_SECONDSEGDUTYCYCLE)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_SECONDSEGDUTYCYCLEUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_SECONDSEGPRESSUER)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_SECONDSEGPRESSUER)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_SECONDSEGPRESSUERUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_SECONDSEGGAS)->EnableWindow(_bPunch);
	GetDlgItem(IDC_COMBO_SECONDSEGGAS)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_SECONDSEGHEIGHT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_SECONDSEGHEIGHT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_SECONDSEGHEIGHTUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_SECONDSEGDELAY)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_SECONDSEGDELAY)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_SECONDSEGDELAYUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_SECONDSEGFOCUS)->EnableWindow(_bPunch && m_bEnableFocusCtrl);
	GetDlgItem(IDC_EDIT_SECONDSEGFOCUS)->EnableWindow(_bPunch && m_bEnableFocusCtrl);
	GetDlgItem(IDC_STATIC_SECONDSEGFOCUSUNIT)->EnableWindow(_bPunch && m_bEnableFocusCtrl);
	GetDlgItem(IDC_CHECK_SECONDCONPERSPEED)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STC_SECONDCONPERSPEEDUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_CHECK_SECONDSTOPLASERBLOW)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STC_SECONDSTOPLASERBLOWUNIT)->EnableWindow(_bPunch);
	_bConPer = (int)m_pParam->GetKey_DBL(c_szSecondSegConSpeed) == 1;
	_pwndBtn = (CButton*)GetDlgItem(IDC_CHECK_SECONDCONPERSPEED);
	_nCheck = _bConPer ? BST_CHECKED : BST_UNCHECKED;
	if (_pwndBtn->GetCheck() != _nCheck)
		_pwndBtn->SetCheck(_nCheck);
	_pwndEdit = GetDlgItem(IDC_EDIT_SECONDCONPERSPEED);
	_bIsWndEnabled = (!_bConPer || !_bPunch) ? FALSE : TRUE;
	if (_pwndEdit->IsWindowEnabled() != _bIsWndEnabled)
	{
		_pwndEdit->EnableWindow(_bIsWndEnabled);
	}

	bool _bSecondStopLaserBlow = (int)m_pParam->GetKey_DBL(c_szSecondStopLaserBlow) == 1;
	_pwndBtn = (CButton*)GetDlgItem(IDC_CHECK_SECONDSTOPLASERBLOW);
	_nCheck = _bSecondStopLaserBlow ? BST_CHECKED : BST_UNCHECKED;
	if (_pwndBtn->GetCheck() != _nCheck)
		_pwndBtn->SetCheck(_nCheck);
	_pwndEdit = GetDlgItem(IDC_EDIT_SECONDSTOPLASERBLOW);
	_pwndCombStop = GetDlgItem(IDC_COMBO_SECONDSTOPLASERBLOWTYPE);
	_bIsWndEnabled = (!_bSecondStopLaserBlow || !_bPunch) ? FALSE : TRUE;
	if (_pwndEdit->IsWindowEnabled() != _bIsWndEnabled)
	{
		_pwndEdit->EnableWindow(_bIsWndEnabled);
		_pwndCombStop->EnableWindow(_bIsWndEnabled);
	}

	_bPunch = (int)m_pParam->GetKey_DBL(c_szThirdSegPunch) == 1;
	_pwndBtn = (CButton*)GetDlgItem(IDC_CHECK_THIRDSEG);
	_nCheck = _bPunch ? BST_CHECKED : BST_UNCHECKED;
	if (_pwndBtn->GetCheck() != _nCheck)
		_pwndBtn->SetCheck(_nCheck);
	GetDlgItem(IDC_STATIC_THIRDSEGPOWER)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_THIRDSEGPOWER)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_THIRDSEGPOWERUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_THIRDSEGFREQ)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_THIRDSEGFREQ)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_THIRDSEGFREQUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_THIRDSEGDUTYCYCLE)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_THIRDDUTYCYCLE)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_THIRDDUTYCYCLEUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_THIRDSEGPRESSUER)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_THIRDSEGPRESSUER)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_THIRDSEGPRESSUERUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_THIRDSEGGAS)->EnableWindow(_bPunch);
	GetDlgItem(IDC_COMBO_THIRDSEGGAS)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_THIRDSEGHEIGHT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_THIRDSEGHEIGHT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_THIRDSEGHEIGHTUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_THIRDSEGDELAY)->EnableWindow(_bPunch);
	GetDlgItem(IDC_EDIT_THIRDSEGDELAY)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_THIRDSEGDELAYUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STATIC_THIRDSEGFOCUS)->EnableWindow(_bPunch && m_bEnableFocusCtrl);
	GetDlgItem(IDC_EDIT_THIRDSEGFOCUS)->EnableWindow(_bPunch && m_bEnableFocusCtrl);
	GetDlgItem(IDC_STATIC_THIRDSEGFOCUSUNIT)->EnableWindow(_bPunch && m_bEnableFocusCtrl);
	GetDlgItem(IDC_CHECK_THIRDCONPERSPEED)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STC_THIRDCONPERSPEEDUNIT)->EnableWindow(_bPunch);
	GetDlgItem(IDC_CHECK_THIRDSTOPLASERBLOW)->EnableWindow(_bPunch);
	GetDlgItem(IDC_STC_THIRDSTOPLASERBLOWUNIT)->EnableWindow(_bPunch);
	_bConPer = (int)m_pParam->GetKey_DBL(c_szThirdSegConSpeed) == 1;
	_pwndBtn = (CButton*)GetDlgItem(IDC_CHECK_THIRDCONPERSPEED);
	_nCheck = _bConPer ? BST_CHECKED : BST_UNCHECKED;
	if (_pwndBtn->GetCheck() != _nCheck)
		_pwndBtn->SetCheck(_nCheck);
	_pwndEdit = GetDlgItem(IDC_EDIT_THIRDCONPERSPEED);
	_bIsWndEnabled = (!_bConPer || !_bPunch) ? FALSE : TRUE;
	if (_pwndEdit->IsWindowEnabled() != _bIsWndEnabled)
	{
		_pwndEdit->EnableWindow(_bIsWndEnabled);
	}

	bool _bThirdStopLaserBlow = (int)m_pParam->GetKey_DBL(c_szThirdStopLaserBlow) == 1;
	_pwndBtn = (CButton*)GetDlgItem(IDC_CHECK_THIRDSTOPLASERBLOW);
	_nCheck = _bThirdStopLaserBlow ? BST_CHECKED : BST_UNCHECKED;
	if (_pwndBtn->GetCheck() != _nCheck)
		_pwndBtn->SetCheck(_nCheck);
	_pwndEdit = GetDlgItem(IDC_EDIT_THIRDSTOPLASERBLOW);
	_pwndCombStop = GetDlgItem(IDC_COMBO_THIRDSTOPLASERBLOWTYPE);
	if (_pwndEdit->IsWindowEnabled() != (!_bThirdStopLaserBlow || !_bPunch) ? FALSE : TRUE)
	{
		_pwndEdit->EnableWindow((!_bThirdStopLaserBlow || !_bPunch) ? FALSE : TRUE);
		_pwndCombStop->EnableWindow((!_bThirdStopLaserBlow || !_bPunch) ? FALSE : TRUE);
	}

	// ༭¡ ---- ƺ 2015-01-23
	_BuildEditInfo();
	UpDateEdits();

	// עNormativeжӵȥ ---- ƺ 2015-01-23
	CStringA _strRemarks = m_pParam->GetKey(LPSTR(c_szThreeSegPunchRemarks));
	if (!_strRemarks.IsEmpty() && _strRemarks[0] == '\"')
		_strRemarks.Delete(0);
	int _nLength = _strRemarks.GetLength();
	if (_nLength > 0 && _strRemarks[_nLength - 1] == '\"')
		_strRemarks.Delete(_nLength - 1);
	_strRemarks = ReverseNormative(_strRemarks);
	SetDlgItemText(IDC_EDIT_THREESEGUSERREMARKS, _strRemarks);

	CString _strShowStopBlowType = NceGetPrivateProfileString(c_szSection, _T("EnableStopBlowType"), _T("False"));
	bool _bShowStopBlowType = _strShowStopBlowType == _T("True");
	GetDlgItem(IDC_STATIC_FIRSTSTOPLASERBLOWTYPE)->ShowWindow(_bShowStopBlowType ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_COMBO_FIRSTSTOPLASERBLOWTYPE)->ShowWindow(_bShowStopBlowType ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_STATIC_SECONDSTOPLASERBLOWTYPE)->ShowWindow(_bShowStopBlowType ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_COMBO_SECONDSTOPLASERBLOWTYPE)->ShowWindow(_bShowStopBlowType ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_STATIC_THIRDSTOPLASERBLOWTYPE)->ShowWindow(_bShowStopBlowType ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_COMBO_THIRDSTOPLASERBLOWTYPE)->ShowWindow(_bShowStopBlowType ? SW_SHOW : SW_HIDE);
}

void CThreeSegPunchParamDlg::UpDateEdits()
{
	for (PunchParamList::iterator _it = m_listEdits.begin(); _it != m_listEdits.end(); _it++)
	{
		if ((*_it)->nDataType == 0)
		{
			CStringA _strNew;
			_strNew.Format(_T("%d"), (*_it)->iValue);
			CStringA _strOrg;
			GetDlgItemText((*_it)->nID, _strOrg);;
			if (_strOrg != _strNew)
				SetDlgItemText((*_it)->nID, _strNew);
		}
		else
		{
			ASSERT((*_it)->nDataType  == 1);
			CStringA _strNew;
			_strNew.Format(_T("%.3f"), (*_it)->dValue);
			FormatDoubleParamer(_strNew);
			CStringA _strOrg;
			GetDlgItemText((*_it)->nID, _strOrg);;
			if (_strOrg != _strNew)
				SetDlgItemText((*_it)->nID, _strNew);
		}
	}

	CString _strNewUnit = CLayerParamDlg::GetUnitName(CLayerParamDlg::GetCurTimeUnit());
	CString _strOldUnit;
	GetDlgItemText(IDC_STATIC_FIRSTSEGDELAYUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_FIRSTSEGDELAYUNIT, _strNewUnit);
	GetDlgItemText(IDC_STATIC_SECONDSEGDELAYUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_SECONDSEGDELAYUNIT, _strNewUnit);
	GetDlgItemText(IDC_STATIC_THIRDSEGDELAYUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_THIRDSEGDELAYUNIT, _strNewUnit);
	GetDlgItemText(IDC_STC_FIRSTSTOPLASERBLOWUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STC_FIRSTSTOPLASERBLOWUNIT, _strNewUnit);
	GetDlgItemText(IDC_STC_SECONDSTOPLASERBLOWUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STC_SECONDSTOPLASERBLOWUNIT, _strNewUnit);
	GetDlgItemText(IDC_STC_THIRDSTOPLASERBLOWUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STC_THIRDSTOPLASERBLOWUNIT, _strNewUnit);

	// ٶȵλл
	_strNewUnit = CLayerParamDlg::GetUnitName(CLayerParamDlg::GetCurSpeedUnit());
	GetDlgItemText(IDC_STC_FIRSTCONPERSPEEDUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STC_FIRSTCONPERSPEEDUNIT, _strNewUnit);
	GetDlgItemText(IDC_STC_SECONDCONPERSPEEDUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STC_SECONDCONPERSPEEDUNIT, _strNewUnit);
	GetDlgItemText(IDC_STC_THIRDCONPERSPEEDUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STC_THIRDCONPERSPEEDUNIT, _strNewUnit);

	//ѹλл
	_strNewUnit = CLayerParamDlg::GetUnitName(CLayerParamDlg::GetCurPressureUnit());
	GetDlgItemText(IDC_STATIC_FIRSTSEGPRESSUERUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_FIRSTSEGPRESSUERUNIT, _strNewUnit);
	GetDlgItemText(IDC_STATIC_SECONDSEGPRESSUERUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_SECONDSEGPRESSUERUNIT, _strNewUnit);
	GetDlgItemText(IDC_STATIC_THIRDSEGPRESSUERUNIT, _strOldUnit);
	if (_strOldUnit != _strNewUnit)
		SetDlgItemText(IDC_STATIC_THIRDSEGPRESSUERUNIT, _strNewUnit);
}

void CThreeSegPunchParamDlg::DoDataExchange(CDataExchange* pDX_)
{
	//ûȡ ----  2016-07-21
	if (m_bCancelData)
	{
		return;
	}
	__super::DoDataExchange(pDX_);

	for (PunchParamList::iterator _it = m_listEdits.begin(); _it != m_listEdits.end(); _it++)
	{
		// õľͲ¡ ---- ƺ 2015-03-17
		if (!(*_it)->bEnable)
			continue;

		CString _strText = _T("");
		GetDlgItemText((*_it)->nID, _strText);
		if ((*_it)->nDataType == 0)
		{
			DDX_Text(pDX_, (*_it)->nID, (*_it)->iValue);
			DDV_MinMaxInt(pDX_, (*_it)->iValue, int((*_it)->nMinValue), int((*_it)->nMaxValue));
		}
		else
		{
			ASSERT((*_it)->nDataType == 1);
			DDX_Text(pDX_, (*_it)->nID, (*_it)->dValue);
			DDV_MinMaxDouble(pDX_, (*_it)->dValue, (*_it)->nMinValue, (*_it)->nMaxValue);
		}
	}
}

BOOL CThreeSegPunchParamDlg::OnInitDialog()
{
	BOOL _bRet = __super::OnInitDialog();

	CHARFORMAT _cf;
	memset(&_cf, 0, sizeof(CHARFORMAT));
	_cf.cbSize = sizeof(CHARFORMAT);
	_cf.dwMask = CFM_FACE | CFM_OFFSET | CFM_SIZE | CFM_COLOR;
	_cf.yOffset = 0;
	_cf.yHeight = 180;
	_cf.crTextColor = RGB(0, 0, 255);
	strcpy(_cf.szFaceName, "");
	CRichEditCtrl* _pRichEdit = (CRichEditCtrl*)GetDlgItem(IDC_EDIT_THREESEGUSERREMARKS);
	if (!_pRichEdit->SetDefaultCharFormat(_cf))
	{
		ASSERT(FALSE);
	}

	CComboBox* _pCombFirst = (CComboBox*)GetDlgItem(IDC_COMBO_FIRSTSEGGAS);
	CComboBox* _pCombSecond = (CComboBox*)GetDlgItem(IDC_COMBO_SECONDSEGGAS);
	CComboBox* _pCombThird = (CComboBox*)GetDlgItem(IDC_COMBO_THIRDSEGGAS);
	for (int _i = 0; _i < (int)m_vectCombItems.size(); _i++)
	{
		_pCombFirst->InsertString(_i, m_vectCombItems[_i]->strText);
		_pCombSecond->InsertString(_i, m_vectCombItems[_i]->strText);
		_pCombThird->InsertString(_i, m_vectCombItems[_i]->strText);
	}

	// ͣⴵ ---- η 2017-04-24
	CComboBox* _pCombStopFirst = (CComboBox*)GetDlgItem(IDC_COMBO_FIRSTSTOPLASERBLOWTYPE);
	CComboBox* _pCombStopSecond = (CComboBox*)GetDlgItem(IDC_COMBO_SECONDSTOPLASERBLOWTYPE);
	CComboBox* _pCombStopThird = (CComboBox*)GetDlgItem(IDC_COMBO_THIRDSTOPLASERBLOWTYPE);
	for (int _i = 0; _i < (int)m_vectCombStopItems.size(); _i++)
	{
		_pCombStopFirst->InsertString(_i, m_vectCombStopItems[_i]->strText);
		_pCombStopSecond->InsertString(_i, m_vectCombStopItems[_i]->strText);
		_pCombStopThird->InsertString(_i, m_vectCombStopItems[_i]->strText);
	}

	SetText();
	Update();
	UpdateFocusCtrls();

	return _bRet;
}

bool CThreeSegPunchParamDlg::IsInputValid(UINT nID_)
{
	bool _bDataValid = true;
	for (PunchParamList::iterator _it = m_listEdits.begin(); _it != m_listEdits.end(); _it++)
	{
		if ((*_it)->nID != nID_)
			continue;

		m_bDataValid = false;	
		_bDataValid = false;
		bool _bTempDataValid = true;

		// ǷЧ 
		CString _strText = _T("");
		GetDlgItemText((*_it)->nID, _strText);
		if (!IsNumberValid(_strText))
		{
			_bTempDataValid = false;
		}

		if (!_bTempDataValid)
		{
			m_bCancelData = true;
			AfxMessageBox(_GETCS(s_csINVALIDINPUT));
			m_bCancelData = false;
		}

		// ݡ
		if (_bTempDataValid && UpdateData(TRUE))
		{
			m_bDataValid = true;
			_bDataValid = true;
			double _nValue = (*_it)->nDataType == 0 ? (*_it)->iValue : (*_it)->dValue;
			CLayerParamDlg::Units _nCurUnit = CLayerParamDlg::GetCurSpeedUnit();
			if (((*_it)->nUnit == CLayerParamDlg::Speed_INperMin
				|| (*_it)->nUnit == CLayerParamDlg::Speed_MMperMin
				|| (*_it)->nUnit == CLayerParamDlg::Speed_MMperS
				|| (*_it)->nUnit == CLayerParamDlg::Speed_MperMin)
				&& (*_it)->nUnit != _nCurUnit)
			{
				CLayerParamDlg::ConverUnit(_nCurUnit, (*_it)->nUnit, _nValue, _nValue);
			}

			_nCurUnit = CLayerParamDlg::GetCurAccUnit();
			if (((*_it)->nUnit == CLayerParamDlg::Acc_MMperS2
				|| (*_it)->nUnit == CLayerParamDlg::ACC_MperMin2
				|| (*_it)->nUnit == CLayerParamDlg::Acc_10MperS2)
				&& (*_it)->nUnit !=_nCurUnit)
			{
				CLayerParamDlg::ConverUnit(_nCurUnit, (*_it)->nUnit, _nValue, _nValue);
			}

			_nCurUnit = CLayerParamDlg::GetCurTimeUnit();
			if (((*_it)->nUnit == CLayerParamDlg::Time_MS
				|| (*_it)->nUnit == CLayerParamDlg::Time_S)
				&& (*_it)->nUnit != _nCurUnit)
			{
				CLayerParamDlg::ConverUnit(_nCurUnit, (*_it)->nUnit, _nValue, _nValue);
			}

			_nCurUnit = CLayerParamDlg::GetCurPressureUnit();
			if (((*_it)->nUnit == CLayerParamDlg::Pressure_Percent
				|| (*_it)->nUnit == CLayerParamDlg::Pressure_MPa)
				&& (*_it)->nUnit != _nCurUnit)
			{
				CLayerParamDlg::ConverUnit(_nCurUnit, (*_it)->nUnit, _nValue, _nValue);
			}

			if ((*_it)->nInitDataType == 0)
				_nValue = (int)_nValue;

			if (m_pParam->GetKey_DBL((*_it)->strKey) != _nValue)
			{
				m_pParam->SetKey_DBL((*_it)->strKey, _nValue);
			}
		}

		// ʽʾ
		double _nValue = m_pParam->GetKey_DBL((*_it)->strKey);
		CLayerParamDlg::Units _nCurUnit = CLayerParamDlg::GetCurSpeedUnit();
		if (((*_it)->nUnit == CLayerParamDlg::Speed_INperMin
			|| (*_it)->nUnit == CLayerParamDlg::Speed_MMperMin
			|| (*_it)->nUnit == CLayerParamDlg::Speed_MMperS
			|| (*_it)->nUnit == CLayerParamDlg::Speed_MperMin)
			&& (*_it)->nUnit != _nCurUnit)
		{
			CLayerParamDlg::ConverUnit((*_it)->nUnit, _nCurUnit, _nValue, _nValue);
		}

		_nCurUnit = CLayerParamDlg::GetCurAccUnit();
		if (((*_it)->nUnit == CLayerParamDlg::Acc_MMperS2
			|| (*_it)->nUnit == CLayerParamDlg::ACC_MperMin2
			|| (*_it)->nUnit == CLayerParamDlg::Acc_10MperS2)
			&& (*_it)->nUnit !=_nCurUnit)
		{
			CLayerParamDlg::ConverUnit((*_it)->nUnit, _nCurUnit, _nValue, _nValue);
		}

		_nCurUnit = CLayerParamDlg::GetCurTimeUnit();
		if (((*_it)->nUnit == CLayerParamDlg::Time_MS
			|| (*_it)->nUnit == CLayerParamDlg::Time_S)
			&& (*_it)->nUnit != _nCurUnit)
		{
			CLayerParamDlg::ConverUnit((*_it)->nUnit, _nCurUnit, _nValue, _nValue);
		}

		_nCurUnit = CLayerParamDlg::GetCurPressureUnit();
		if (((*_it)->nUnit == CLayerParamDlg::Pressure_Percent
			|| (*_it)->nUnit == CLayerParamDlg::Pressure_MPa)
			&& (*_it)->nUnit != _nCurUnit)
		{
			CLayerParamDlg::ConverUnit((*_it)->nUnit, _nCurUnit, _nValue, _nValue);
		}

		if ((*_it)->nDataType == 0)
		{
			CStringA _str;
			_str.Format("%d", int(_nValue));
			SetDlgItemText((*_it)->nID, _str);
			GetDlgItem((*_it)->nID)->SetFocus();
		}
		else
		{
			CStringA _str;
			_str.Format("%.3f", _nValue);
			FormatDoubleParamer(_str);
			SetDlgItemText((*_it)->nID, _str);
			GetDlgItem((*_it)->nID)->SetFocus();
		}

		break;
	}

	return _bDataValid;
}

void CThreeSegPunchParamDlg::UpdateFocusCtrls()
{
	GetDlgItem(IDC_STATIC_FIRSTSEGFOCUS)->EnableWindow(m_bEnableFocusCtrl);
	GetDlgItem(IDC_EDIT_FIRSTSEGFOCUS)->EnableWindow(m_bEnableFocusCtrl);
	GetDlgItem(IDC_STATIC_FIRSTSEGFOCUSUNIT)->EnableWindow(m_bEnableFocusCtrl);
	GetDlgItem(IDC_STATIC_SECONDSEGFOCUS)->EnableWindow(m_bEnableFocusCtrl);
	GetDlgItem(IDC_EDIT_SECONDSEGFOCUS)->EnableWindow(m_bEnableFocusCtrl);
	GetDlgItem(IDC_STATIC_SECONDSEGFOCUSUNIT)->EnableWindow(m_bEnableFocusCtrl);
	GetDlgItem(IDC_STATIC_THIRDSEGFOCUS)->EnableWindow(m_bEnableFocusCtrl);
	GetDlgItem(IDC_EDIT_THIRDSEGFOCUS)->EnableWindow(m_bEnableFocusCtrl);
	GetDlgItem(IDC_STATIC_THIRDSEGFOCUSUNIT)->EnableWindow(m_bEnableFocusCtrl);
}

bool CThreeSegPunchParamDlg::GetInputValid()
{
	if (this->GetFocus() != NULL)
	{
		if (!IsInputValid(this->GetFocus()->GetDlgCtrlID()))
		{
			return false;
		}
	}

	return true;
}

void CThreeSegPunchParamDlg::InitCancelData()
{
	m_bCancelData = false;
}

void CThreeSegPunchParamDlg::OnOK()
{
}

void CThreeSegPunchParamDlg::OnCancel()
{
	m_bCancelData = true;
}

void CThreeSegPunchParamDlg::_BuildEditInfo()
{
	const CLayerParamDlg::EditInfo _s_Params[] = 
	{
		{"FirstSegConSpeed",		IDC_EDIT_FIRSTCONPERSPEED,		1,	NULL, IsInvalidDouble(m_pParam->GetKey_DBL("FirstSegConSpeed")) ? 5 : m_pParam->GetKey_DBL("FirstSegConSpeed"), 						0.1,		100,	true, CLayerParamDlg::Speed_MMperS, 1},
		{"FirstSegPower",			IDC_EDIT_FIRSTSEGPOWER,		0,	IsInvalidDouble(m_pParam->GetKey_DBL("FirstSegPower")) ? 100 : int(m_pParam->GetKey_DBL("FirstSegPower")), NULL,				0,		100,	true, CLayerParamDlg::Percent, 0},
		{"FirstSegFreq",			IDC_EDIT_FIRSTSEGFREQ,		0,	IsInvalidDouble(m_pParam->GetKey_DBL("FirstSegFreq")) ? 5000 : int(m_pParam->GetKey_DBL("FirstSegFreq")), NULL,					0,		100000,	true, CLayerParamDlg::Frequece, 0},
		{"FirstSegDutyCycle",		IDC_EDIT_FIRSTSEGDUTYCYCLE,	0,	IsInvalidDouble(m_pParam->GetKey_DBL("FirstSegDutyCycle")) ? 100 : int(m_pParam->GetKey_DBL("FirstSegDutyCycle")), NULL,		0,		100,	true, CLayerParamDlg::Percent, 0},
		{"FirstSegPressure",		IDC_EDIT_FIRSTSEGPRESSUER,	1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("FirstSegPressure")) ? 100 : m_pParam->GetKey_DBL("FirstSegPressure"),				0,		100,	true, CLayerParamDlg::Pressure_Percent, 1},
		{"FirstSegHeight",			IDC_EDIT_FIRSTSEGHEIGHT,	1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("FirstSegHeight")) ? 10 : m_pParam->GetKey_DBL("FirstSegHeight"),						0.1,	500,	true, CLayerParamDlg::Length_MM, 1},
		{"FirstSegDelay",			IDC_EDIT_FIRSTSEGDELAY,		1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("FirstSegDelay")) ? 200 : m_pParam->GetKey_DBL("FirstSegDelay"),						0,		100000,	true, CLayerParamDlg::Time_MS, 0},
		{"FirstSegFocusPos",		IDC_EDIT_FIRSTSEGFOCUS,		1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("FirstSegFocusPos")) ? 0 : m_pParam->GetKey_DBL("FirstSegFocusPos"), 					-100,	100,		true, CLayerParamDlg::Length_MM, 1},
		{"FirstStopLaserBlowDelay",	IDC_EDIT_FIRSTSTOPLASERBLOW,1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("FirstStopLaserBlowDelay")) ? 200 : m_pParam->GetKey_DBL("FirstStopLaserBlowDelay"),	0,		100000,	true, CLayerParamDlg::Time_MS, 0},

		{"SecondSegConSpeed",		IDC_EDIT_SECONDCONPERSPEED,		1,	NULL, IsInvalidDouble(m_pParam->GetKey_DBL("SecondSegConSpeed")) ? 5 : m_pParam->GetKey_DBL("SecondSegConSpeed"), 						0.1,		100,	true, CLayerParamDlg::Speed_MMperS, 1},
		{"SecondSegPower",			IDC_EDIT_SECONDSEGPOWER,	0,	IsInvalidDouble(m_pParam->GetKey_DBL("SecondSegPower")) ? 100 : int(m_pParam->GetKey_DBL("SecondSegPower")), NULL,				0,		100,	true, CLayerParamDlg::Percent, 0},
		{"SecondSegFreq",			IDC_EDIT_SECONDSEGFREQ,		0,	IsInvalidDouble(m_pParam->GetKey_DBL("SecondSegFreq")) ? 5000 : int(m_pParam->GetKey_DBL("SecondSegFreq")), NULL,				0,		100000,	true, CLayerParamDlg::Frequece, 0},
		{"SecondSegDutyCycle",		IDC_EDIT_SECONDSEGDUTYCYCLE,0,	IsInvalidDouble(m_pParam->GetKey_DBL("SecondSegDutyCycle")) ? 100 : int(m_pParam->GetKey_DBL("SecondSegDutyCycle")), NULL,		0,		100,	true, CLayerParamDlg::Percent, 0},
		{"SecondSegPressure",		IDC_EDIT_SECONDSEGPRESSUER,	1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("SecondSegPressure")) ? 100 : m_pParam->GetKey_DBL("SecondSegPressure"),				0,		100,	true, CLayerParamDlg::Pressure_Percent, 1},
		{"SecondSegHeight",			IDC_EDIT_SECONDSEGHEIGHT,	1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("SecondSegHeight")) ? 5 : m_pParam->GetKey_DBL("SecondSegHeight"),					0.1,	500,	true, CLayerParamDlg::Length_MM, 1},
		{"SecondSegDelay",			IDC_EDIT_SECONDSEGDELAY,	1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("SecondSegDelay")) ? 200 : m_pParam->GetKey_DBL("SecondSegDelay"),					0,		100000,	true, CLayerParamDlg::Time_MS, 0},
		{"SecondFocusPos",			IDC_EDIT_SECONDSEGFOCUS,	1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("SecondFocusPos")) ? 0 : m_pParam->GetKey_DBL("SecondFocusPos"), 						-100,	100,		true, CLayerParamDlg::Length_MM, 1},
		{"SecondStopLaserBlowDelay",IDC_EDIT_SECONDSTOPLASERBLOW,1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("SecondStopLaserBlowDelay")) ? 200 : m_pParam->GetKey_DBL("SecondStopLaserBlowDelay"),	0,		100000,	true, CLayerParamDlg::Time_MS, 0},

		{"ThirdSegConSpeed",		IDC_EDIT_THIRDCONPERSPEED,		1,	NULL, IsInvalidDouble(m_pParam->GetKey_DBL("ThirdSegConSpeed")) ? 5 : m_pParam->GetKey_DBL("ThirdSegConSpeed"), 						0.1,		100,	true, CLayerParamDlg::Speed_MMperS, 1},
		{"ThirdSegPower",			IDC_EDIT_THIRDSEGPOWER,		0,	IsInvalidDouble(m_pParam->GetKey_DBL("ThirdSegPower")) ? 100 : int(m_pParam->GetKey_DBL("ThirdSegPower")), NULL,				0,		100,	true, CLayerParamDlg::Percent, 0},
		{"ThirdSegFreq",			IDC_EDIT_THIRDSEGFREQ,		0,	IsInvalidDouble(m_pParam->GetKey_DBL("ThirdSegFreq")) ? 5000 : int(m_pParam->GetKey_DBL("ThirdSegFreq")), NULL,					0,		100000,	true, CLayerParamDlg::Frequece, 0},
		{"ThirdSegDutyCycle",		IDC_EDIT_THIRDDUTYCYCLE,	0,	IsInvalidDouble(m_pParam->GetKey_DBL("ThirdSegDutyCycle")) ? 100 : int(m_pParam->GetKey_DBL("ThirdSegDutyCycle")), NULL,		0,		100,	true, CLayerParamDlg::Percent, 0},
		{"ThirdSegPressure",		IDC_EDIT_THIRDSEGPRESSUER,	1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("ThirdSegPressure")) ? 100 : m_pParam->GetKey_DBL("ThirdSegPressure"),				0,		100,	true, CLayerParamDlg::Pressure_Percent, 1},
		{"ThirdSegHeight",			IDC_EDIT_THIRDSEGHEIGHT,	1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("ThirdSegHeight")) ? 2 : m_pParam->GetKey_DBL("ThirdSegHeight"),						0.1,	500,	true, CLayerParamDlg::Length_MM, 1},
		{"ThirdSegDelay",			IDC_EDIT_THIRDSEGDELAY,		1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("ThirdSegDelay")) ? 200 : m_pParam->GetKey_DBL("ThirdSegDelay"), 						0,		100000,	true, CLayerParamDlg::Time_MS, 0},
		{"ThirdSegFocusPos",		IDC_EDIT_THIRDSEGFOCUS,		1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("ThirdSegFocusPos")) ? 0 : m_pParam->GetKey_DBL("ThirdSegFocusPos"), 				-100,	100,		true, CLayerParamDlg::Length_MM, 1},
		{"ThirdStopLaserBlowDelay",	IDC_EDIT_THIRDSTOPLASERBLOW,1,	NULL,IsInvalidDouble(m_pParam->GetKey_DBL("ThirdStopLaserBlowDelay")) ? 200 : m_pParam->GetKey_DBL("ThirdStopLaserBlowDelay"),	0,		100000,	true, CLayerParamDlg::Time_MS, 0},
	};

	if (m_listEdits.empty())
	{
		// ʱȥͷţĵطȥͷֻеһεʱNew
		for (int _i = 0; _i < _countof(_s_Params); _i++)
		{
			CLayerParamDlg::EditInfo* _pInfo = new CLayerParamDlg::EditInfo;
			m_listEdits.push_back(_pInfo);
		}
	}
	else
	{
		ASSERT(m_listEdits.size() == _countof(_s_Params));
	}

	// ʼֵȥ ---- ƺ 2015-08-18
	int _i = 0;
	for (PunchParamList::iterator _it = m_listEdits.begin(); _it != m_listEdits.end(); _it++)
	{
		CLayerParamDlg::EditInfo _item = _s_Params[_i];
		CLayerParamDlg::Units _nCurUnit = CLayerParamDlg::GetCurSpeedUnit();
		if ((_item.nUnit == CLayerParamDlg::Speed_INperMin
			|| _item.nUnit == CLayerParamDlg::Speed_MMperMin
			|| _item.nUnit == CLayerParamDlg::Speed_MMperS
			|| _item.nUnit == CLayerParamDlg::Speed_MperMin)
			&& _item.nUnit != _nCurUnit)
		{
			CLayerParamDlg::ConverUnit(_item.nUnit, _nCurUnit, _s_Params[_i], _item);
		}

		_nCurUnit = CLayerParamDlg::GetCurAccUnit();
		if ((_item.nUnit == CLayerParamDlg::Acc_MMperS2
			|| _item.nUnit == CLayerParamDlg::ACC_MperMin2
			|| _item.nUnit == CLayerParamDlg::Acc_10MperS2)
			&& _item.nUnit !=_nCurUnit)
		{
			CLayerParamDlg::ConverUnit(_item.nUnit, _nCurUnit, _s_Params[_i], _item);
		}

		_nCurUnit = CLayerParamDlg::GetCurTimeUnit();
		if ((_item.nUnit == CLayerParamDlg::Time_MS
			|| _item.nUnit == CLayerParamDlg::Time_S)
			&& _item.nUnit != _nCurUnit)
		{
			CLayerParamDlg::ConverUnit(_item.nUnit, _nCurUnit, _s_Params[_i], _item);
		}

		_nCurUnit = CLayerParamDlg::GetCurPressureUnit();
		if ((_item.nUnit == CLayerParamDlg::Pressure_Percent
			|| _item.nUnit == CLayerParamDlg::Pressure_MPa)
			&& _item.nUnit != _nCurUnit)
		{
			CLayerParamDlg::ConverUnit(_item.nUnit, _nCurUnit, _s_Params[_i], _item);
		}

		(*_it)->strKey = _item.strKey;
		(*_it)->nID = _item.nID;
		(*_it)->nDataType = _item.nDataType;
		(*_it)->iValue = _item.iValue;
		(*_it)->dValue = _item.dValue;
		(*_it)->nMinValue = _item.nMinValue;
		(*_it)->nMaxValue = _item.nMaxValue;
		(*_it)->bEnable = _item.bEnable;
		(*_it)->nUnit = _item.nUnit;
		(*_it)->nInitDataType = _item.nInitDataType;

		double _nValue = _s_Params[_i].nDataType == 0 ? _s_Params[_i].iValue : _s_Params[_i].dValue;
		if (m_pParam->GetKey_DBL(_s_Params[_i].strKey) != _nValue)
			m_pParam->SetKey_DBL(_s_Params[_i].strKey, _nValue);
		_i++;
	}
}

// ǷЧ ----  2016-07-20
bool CThreeSegPunchParamDlg::IsNumberValid(LPCTSTR pszText_)
{
	if (!pszText_)
	{
		return false;
	}

	CString _strText(pszText_);
	if (_strText.IsEmpty())
	{
		return false;
	}

	int _nDotCount = 0;
	for (int _i = 0; _i < _strText.GetLength(); _i++)
	{
		if (_i == 0 && (_strText[_i] == '-' || _strText[_i] == '+'))
		{
			continue;
		}

		if (!isdigit(_strText[_i]) && _strText[_i] != '.')
		{
			return false;
		}

		if (_strText[_i] == '.')
		{
			_nDotCount++;
		}
	}

	if (_nDotCount > 1)
	{
		return false;
	}

	return true;
}

void CThreeSegPunchParamDlg::OnKillFocusEdits(UINT nID_)
{
	//ûȡ ----  2016-07-21
	if (m_bCancelData)
	{
		return;
	}

	for (PunchParamList::iterator _it = m_listEdits.begin(); _it != m_listEdits.end(); _it++)
	{
		if ((*_it)->nID != nID_)
			continue;

		// ҵFocusEdit֤Ч ----  2016-07-20
		m_bDataValid = false;
		bool _bTempDataValid = true;

		// ǷЧ 
		CString _strText = _T("");
		GetDlgItemText((*_it)->nID, _strText);
		if (!IsNumberValid(_strText))
		{
			_bTempDataValid = false;
		}

		// ûбø¡ ---- ƺ 2015-09-18
		for (int _i = 0; _bTempDataValid && (_i < _countof(m_LastTextItems)); _i++)
		{
			if (m_LastTextItems[_i].nID != nID_)
				continue;

			if (m_LastTextItems[_i].strLastText == _strText)
			{
				m_bDataValid = true;
				return;
			}

			break;
		}

		if (!m_bCancelData)
		{
			if(!_bTempDataValid)
			{
				m_bCancelData = true;
				AfxMessageBox(_GETCS(s_csINVALIDINPUT));
				m_bCancelData = false;
			}
		}

		// ݡ
		if (_bTempDataValid && UpdateData(TRUE))
		{
			m_bDataValid = true;
			double _nValue = (*_it)->nDataType == 0 ? (*_it)->iValue : (*_it)->dValue;
			CLayerParamDlg::Units _nCurUnit = CLayerParamDlg::GetCurSpeedUnit();
			if (((*_it)->nUnit == CLayerParamDlg::Speed_INperMin
				|| (*_it)->nUnit == CLayerParamDlg::Speed_MMperMin
				|| (*_it)->nUnit == CLayerParamDlg::Speed_MMperS
				|| (*_it)->nUnit == CLayerParamDlg::Speed_MperMin)
				&& (*_it)->nUnit != _nCurUnit)
			{
				CLayerParamDlg::ConverUnit(_nCurUnit, (*_it)->nUnit, _nValue, _nValue);
			}

			_nCurUnit = CLayerParamDlg::GetCurAccUnit();
			if (((*_it)->nUnit == CLayerParamDlg::Acc_MMperS2
				|| (*_it)->nUnit == CLayerParamDlg::ACC_MperMin2
				|| (*_it)->nUnit == CLayerParamDlg::Acc_10MperS2)
				&& (*_it)->nUnit !=_nCurUnit)
			{
				CLayerParamDlg::ConverUnit(_nCurUnit, (*_it)->nUnit, _nValue, _nValue);
			}

			_nCurUnit = CLayerParamDlg::GetCurTimeUnit();
			if (((*_it)->nUnit == CLayerParamDlg::Time_MS
				|| (*_it)->nUnit == CLayerParamDlg::Time_S)
				&& (*_it)->nUnit != _nCurUnit)
			{
				CLayerParamDlg::ConverUnit(_nCurUnit, (*_it)->nUnit, _nValue, _nValue);
			}

			_nCurUnit = CLayerParamDlg::GetCurPressureUnit();
			if (((*_it)->nUnit == CLayerParamDlg::Pressure_Percent
				|| (*_it)->nUnit == CLayerParamDlg::Pressure_MPa)
				&& (*_it)->nUnit != _nCurUnit)
			{
				CLayerParamDlg::ConverUnit(_nCurUnit, (*_it)->nUnit, _nValue, _nValue);
			}

			if ((*_it)->nInitDataType == 0)
				_nValue = (int)_nValue;

			if (m_pParam->GetKey_DBL((*_it)->strKey) != _nValue)
			{
				m_pParam->SetKey_DBL((*_it)->strKey, _nValue);
			}
		}

		// ʽʾ
		double _nValue = m_pParam->GetKey_DBL((*_it)->strKey);
		CLayerParamDlg::Units _nCurUnit = CLayerParamDlg::GetCurSpeedUnit();
		if (((*_it)->nUnit == CLayerParamDlg::Speed_INperMin
			|| (*_it)->nUnit == CLayerParamDlg::Speed_MMperMin
			|| (*_it)->nUnit == CLayerParamDlg::Speed_MMperS
			|| (*_it)->nUnit == CLayerParamDlg::Speed_MperMin)
			&& (*_it)->nUnit != _nCurUnit)
		{
			CLayerParamDlg::ConverUnit((*_it)->nUnit, _nCurUnit, _nValue, _nValue);
		}

		_nCurUnit = CLayerParamDlg::GetCurAccUnit();
		if (((*_it)->nUnit == CLayerParamDlg::Acc_MMperS2
			|| (*_it)->nUnit == CLayerParamDlg::ACC_MperMin2
			|| (*_it)->nUnit == CLayerParamDlg::Acc_10MperS2)
			&& (*_it)->nUnit !=_nCurUnit)
		{
			CLayerParamDlg::ConverUnit((*_it)->nUnit, _nCurUnit, _nValue, _nValue);
		}

		_nCurUnit = CLayerParamDlg::GetCurTimeUnit();
		if (((*_it)->nUnit == CLayerParamDlg::Time_MS
			|| (*_it)->nUnit == CLayerParamDlg::Time_S)
			&& (*_it)->nUnit != _nCurUnit)
		{
			CLayerParamDlg::ConverUnit((*_it)->nUnit, _nCurUnit, _nValue, _nValue);
		}

		_nCurUnit = CLayerParamDlg::GetCurPressureUnit();
		if (((*_it)->nUnit == CLayerParamDlg::Pressure_Percent
			|| (*_it)->nUnit == CLayerParamDlg::Pressure_MPa)
			&& (*_it)->nUnit != _nCurUnit)
		{
			CLayerParamDlg::ConverUnit((*_it)->nUnit, _nCurUnit, _nValue, _nValue);
		}

		if ((*_it)->nDataType == 0)
		{
			CStringA _str;
			_str.Format("%d", int(_nValue));
			SetDlgItemText((*_it)->nID, _str);
			if (!m_bDataValid)
			{
				GetDlgItem((*_it)->nID)->SetFocus();
			}
		}
		else
		{
			CStringA _str;
			_str.Format("%.3f", _nValue);
			FormatDoubleParamer(_str);
			SetDlgItemText((*_it)->nID, _str);
			if (!m_bDataValid)
			{
				GetDlgItem((*_it)->nID)->SetFocus();
			}
		}

		break;
	}
}

void CThreeSegPunchParamDlg::OnSetFocusEdits(UINT nID_)
{
	ASSERT(_countof(m_LastTextItems) >= 2);
	m_LastTextItems[1].nID = m_LastTextItems[0].nID;
	m_LastTextItems[1].strLastText = m_LastTextItems[0].strLastText;
	m_LastTextItems[0].nID = nID_;
	GetDlgItemText(nID_, m_LastTextItems[0].strLastText);
}

void CThreeSegPunchParamDlg::OnSelectGases(UINT nID_)
{
	if (nID_ != IDC_COMBO_FIRSTSEGGAS
		&& nID_ != IDC_COMBO_SECONDSEGGAS
		&& nID_ != IDC_COMBO_THIRDSEGGAS)
		return;

	CStringA _strKey;
	if (nID_ == IDC_COMBO_FIRSTSEGGAS)
	{
		_strKey = c_szFirstSegGasKey;
	}
	else if (nID_ == IDC_COMBO_SECONDSEGGAS)
	{
		_strKey = c_szSecondSegGasKey;
	}
	else
	{
		_strKey = c_szThirdSegGasKey;
	}

	CComboBox* _pComb = (CComboBox*)GetDlgItem(nID_);
	int _nIndex = _pComb->GetCurSel();
	ASSERT(_nIndex < (int)m_vectCombItems.size());
	if (_nIndex > -1)
		m_pParam->SetKey(_strKey, m_vectCombItems[_nIndex]->strValue);
}

void CThreeSegPunchParamDlg::OnSelectStopGases(UINT nID_)
{
	if (nID_ != IDC_COMBO_FIRSTSTOPLASERBLOWTYPE
		&& nID_ != IDC_COMBO_SECONDSTOPLASERBLOWTYPE
		&& nID_ != IDC_COMBO_THIRDSTOPLASERBLOWTYPE)
		return;

	CStringA _strKey;
	if (nID_ == IDC_COMBO_FIRSTSTOPLASERBLOWTYPE)
	{
		_strKey = c_szFirstStopSegGasKey;
	}
	else if (nID_ == IDC_COMBO_SECONDSTOPLASERBLOWTYPE)
	{
		_strKey = c_szSecondStopSegGasKey;
	}
	else
	{
		ASSERT(nID_ == IDC_COMBO_THIRDSTOPLASERBLOWTYPE);
		_strKey = c_szThirdStopSegGasKey;
	}

	CComboBox* _pComb = (CComboBox*)GetDlgItem(nID_);
	int _nIndex = _pComb->GetCurSel();
	ASSERT(_nIndex < (int)m_vectCombItems.size());
	if (_nIndex > -1)
		m_pParam->SetKey(_strKey, m_vectCombItems[_nIndex]->strValue);
}

void CThreeSegPunchParamDlg::OnClickPunchType(UINT nID_)
{
	if (nID_ != IDC_CHECK_FIRSTSEG
		&& nID_ != IDC_CHECK_SECONDSEG
		&& nID_ != IDC_CHECK_THIRDSEG)
		return;

	CStringA _strKey;
	if (nID_ == IDC_CHECK_FIRSTSEG)
		_strKey = c_szFirstSegPunch;
	else if (nID_ == IDC_CHECK_SECONDSEG)
		_strKey = c_szSecondSegPunch;
	else
		_strKey = c_szThirdSegPunch;
	bool _bPunch = m_pParam->GetKey_DBL(_strKey) == 1;
	_bPunch = !_bPunch;
	m_pParam->SetKey_DBL(_strKey, _bPunch);

	Update();
}

void CThreeSegPunchParamDlg::OnClickEnableConPer(UINT nID_)
{
	if (nID_ != IDC_CHECK_FIRSTCONPERSPEED
		&& nID_ != IDC_CHECK_SECONDCONPERSPEED
		&& nID_ != IDC_CHECK_THIRDCONPERSPEED)
		return;

	CStringA _strKey;
	if (nID_ == IDC_CHECK_FIRSTCONPERSPEED)
		_strKey = c_szFirstSegConSpeed;
	else if (nID_ == IDC_CHECK_SECONDCONPERSPEED)
		_strKey = c_szSecondSegConSpeed;
	else
		_strKey = c_szThirdSegConSpeed;
	bool _bPunch = m_pParam->GetKey_DBL(_strKey) == 1;
	_bPunch = !_bPunch;
	m_pParam->SetKey_DBL(_strKey, _bPunch);

	Update();
}

void CThreeSegPunchParamDlg::OnClickEnableCloseLaserBlow(UINT nID_)
{
	if (nID_ != IDC_CHECK_FIRSTSTOPLASERBLOW
		&& nID_ != IDC_CHECK_SECONDSTOPLASERBLOW
		&& nID_ != IDC_CHECK_THIRDSTOPLASERBLOW)
		return;

	CStringA _strKey;
	if (nID_ == IDC_CHECK_FIRSTSTOPLASERBLOW)
		_strKey = c_szFirstStopLaserBlow;
	else if (nID_ == IDC_CHECK_SECONDSTOPLASERBLOW)
		_strKey = c_szSecondStopLaserBlow;
	else
		_strKey = c_szThirdStopLaserBlow;
	bool _bPunch = m_pParam->GetKey_DBL(_strKey) == 1;
	_bPunch = !_bPunch;
	m_pParam->SetKey_DBL(_strKey, _bPunch);

	Update();
}

void CThreeSegPunchParamDlg::OnKillFocusRemarks()
{
	CStringA _strRemarks;
	GetDlgItem(IDC_EDIT_THREESEGUSERREMARKS)->GetWindowText(_strRemarks);
	_strRemarks = Normative(_strRemarks);

	// עŰΧLuaͰһַչ ---- ƺ 2015-02-04
	_strRemarks.Insert(0, "\"");
	_strRemarks += "\"";

	if (m_pParam->GetKey(LPSTR(c_szThreeSegPunchRemarks)) != _strRemarks)
		m_pParam->SetKey(LPSTR(c_szThreeSegPunchRemarks), _strRemarks);
}

// ûעͼУΪûͼĳһԼַLuaĽ
// ؽ'\\'';''=''\"''\'''\r''\n'ֱ滻ΪASCIIΪ0x160x070x1D0x1E0x1F0x060x10
// PS:0x16 SYSһ豸ָͬеġ
//    0x07 ҲǸ豸
//    0x06 ȷϣҪȫ˫˫ıͨš
//    0x10 ·ת壬紫
//    0x1D0x1E0x1FֱLinxUnixƽ̨AWKıеķ¼ָԪָǶõWindowsġ
//    Ͻ۾磬Ľ滻ַӦûʲôӰ죬ִ󣬷֪¡
// ---- ƺ 2015-02-04
CString CThreeSegPunchParamDlg::Normative(LPCTSTR pszValue_)
{
	CString _strRet(pszValue_);
	_strRet.Replace('\\', 0x16);
	_strRet.Replace(';', 0x07);
	_strRet.Replace('=', 0x1D);
	_strRet.Replace('\"', 0x1E);
	_strRet.Replace('\'', 0x1F);
	_strRet.Replace('\r', 0x06);
	_strRet.Replace('\n', 0x10);
	return _strRet;
}

// 0x160x070x1D0x1E0x1Fֱ滻Ϊ'\\'';''=''\"''\''Normative̡
// ---- ƺ 2015-02-04
CString CThreeSegPunchParamDlg::ReverseNormative(LPCTSTR pszValue_)
{
	CString _strRet(pszValue_);
	_strRet.Replace(0x16, '\\');
	_strRet.Replace(0x07, ';');
	_strRet.Replace(0x1D, '=');
	_strRet.Replace(0x1E, '\"');
	_strRet.Replace(0x1F, '\'');
	_strRet.Replace(0x06, '\r');
	_strRet.Replace(0x10, '\n');
	return _strRet;
}

void CThreeSegPunchParamDlg::SetText()
{
	SetDlgItemText(IDC_CHECK_FIRSTSEG, _GETCS(s_szFIRSTSEG));
	SetDlgItemText(IDC_CHECK_SECONDSEG, _GETCS(s_szSECONDSEG));
	SetDlgItemText(IDC_CHECK_THIRDSEG, _GETCS(s_szTHIRDSEG));

	SetDlgItemText(IDC_CHECK_FIRSTCONPERSPEED, _GETCS(s_szPIERCESPEED));
	SetDlgItemText(IDC_STATIC_FIRSTSEGPOWER, _GETCS(s_szFIRSTCURRENT));
	SetDlgItemText(IDC_STATIC_FIRSTSEGFREQ, _GETCS(s_szFIRSTFREQU));
	SetDlgItemText(IDC_STATIC_FIRSTSEGDUTYCYCLE, _GETCS(s_szFIRSTPOWER));
	SetDlgItemText(IDC_STATIC_FIRSTSEGGAS, _GETCS(s_szFIRSTGAS));
	SetDlgItemText(IDC_STATIC_FIRSTSEGPRESSUER, _GETCS(s_szFIRSTPRESSURE));
	SetDlgItemText(IDC_STATIC_FIRSTSEGHEIGHT, _GETCS(s_szFIRSTHEIGHT));
	SetDlgItemText(IDC_STATIC_FIRSTSEGELAY, _GETCS(s_szFIRSTDELAY));
	SetDlgItemText(IDC_STATIC_FIRSTSEGFOCUS, _GETCS(s_szFIRSTSEGFOCUS));
	SetDlgItemText(IDC_CHECK_FIRSTSTOPLASERBLOW, _GETCS(s_szExtraPuffing));
	SetDlgItemText(IDC_STATIC_FIRSTSTOPLASERBLOWTYPE, _GETCS(s_szSTOPGAS));

	SetDlgItemText(IDC_CHECK_SECONDCONPERSPEED, _GETCS(s_szPIERCESPEED));
	SetDlgItemText(IDC_STATIC_SECONDSEGPOWER, _GETCS(s_szSECONDCURRENT));
	SetDlgItemText(IDC_STATIC_SECONDSEGFREQ, _GETCS(s_szSECONDFREQU));
	SetDlgItemText(IDC_STATIC_SECONDSEGDUTYCYCLE, _GETCS(s_szSECONDPOWER));
	SetDlgItemText(IDC_STATIC_SECONDSEGGAS, _GETCS(s_szSECONDGAS));
	SetDlgItemText(IDC_STATIC_SECONDSEGPRESSUER, _GETCS(s_szSECONDPRESSURE));
	SetDlgItemText(IDC_STATIC_SECONDSEGHEIGHT, _GETCS(s_szSECONDHEIGHT));
	SetDlgItemText(IDC_STATIC_SECONDSEGDELAY, _GETCS(s_szSECONDDELAY));
	SetDlgItemText(IDC_STATIC_SECONDSEGFOCUS, _GETCS(s_szSECONDSEGFOCUS));
	SetDlgItemText(IDC_CHECK_SECONDSTOPLASERBLOW, _GETCS(s_szExtraPuffing));
	SetDlgItemText(IDC_STATIC_SECONDSTOPLASERBLOWTYPE, _GETCS(s_szSTOPGAS));

	SetDlgItemText(IDC_CHECK_THIRDCONPERSPEED, _GETCS(s_szPIERCESPEED));
	SetDlgItemText(IDC_STATIC_THIRDSEGPOWER, _GETCS(s_szTHIRDCURRENT));
	SetDlgItemText(IDC_STATIC_THIRDSEGFREQ, _GETCS(s_szTHIRDFREQU));
	SetDlgItemText(IDC_STATIC_THIRDSEGDUTYCYCLE, _GETCS(s_szTHIRDPOWER));
	SetDlgItemText(IDC_STATIC_THIRDSEGGAS, _GETCS(s_szTHIRDGAS));
	SetDlgItemText(IDC_STATIC_THIRDSEGPRESSUER, _GETCS(s_szTHIRDPRESSURE));
	SetDlgItemText(IDC_STATIC_THIRDSEGHEIGHT, _GETCS(s_szTHIRDHEIGHT));
	SetDlgItemText(IDC_STATIC_THIRDSEGDELAY, _GETCS(s_szTHIRDDELAY));
	SetDlgItemText(IDC_STATIC_THIRDSEGFOCUS, _GETCS(s_szTHIRDSEGFOCUS));
	SetDlgItemText(IDC_CHECK_THIRDSTOPLASERBLOW, _GETCS(s_szExtraPuffing));
	SetDlgItemText(IDC_STATIC_THIRDSTOPLASERBLOWTYPE, _GETCS(s_szSTOPGAS));

	SetDlgItemText(IDC_STATIC_THREESEGUSERREMARKS, _GETCS(s_szREMARKS));
}
